# Interpolations.jl

[![version](https://juliahub.com/docs/Interpolations/version.svg)](https://juliahub.com/ui/Packages/Interpolations/VpKVx)
[![pkgeval](https://juliahub.com/docs/Interpolations/pkgeval.svg)](https://juliahub.com/ui/Packages/Interpolations/VpKVx)
[![Build Status](https://github.com/JuliaMath/Interpolations.jl/actions/workflows/CI.yml/badge.svg?branch=master)](https://github.com/JuliaMath/Interpolations.jl/actions/workflows/CI.yml?query=branch%3Amaster)
[![deps](https://juliahub.com/docs/Interpolations/deps.svg)](https://juliahub.com/ui/Packages/Interpolations/VpKVx?t=2)
[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](http://juliamath.github.io/Interpolations.jl/stable)
[![Latest](https://img.shields.io/badge/docs-latest-blue.svg)](http://juliamath.github.io/Interpolations.jl/latest)

This package implements a variety of interpolation schemes for the
Julia language.  It has the goals of ease-of-use, broad algorithmic
support, and exceptional performance.

Currently this package supports
[B-splines](https://en.wikipedia.org/wiki/B-spline) and also
irregular grids.  The API has been designed with
intent to support more options. Initial support for Lanczos
interpolation was recently added. Pull-requests are more than welcome!
It should be noted that the API may continue to evolve over time.

At the bottom of this page, you can find a "performance shootout"
among these methods (as well as SciPy's `RegularGridInterpolator`).

## Installation

Interpolations.jl can be installed via the following invocation
since it is a registered Julia package.

```julia
using Pkg
Pkg.add("Interpolations")
```

## Example Usage
Create a grid `xs` and an array `A` of values to be interpolated
```julia
xs = 1:0.2:5
A = log.(xs)
```
Create linear interpolation object without extrapolation
```julia
interp_linear = linear_interpolation(xs, A)
interp_linear(3) # exactly log(3)
interp_linear(3.1) # approximately log(3.1)
interp_linear(0.9) # outside grid: error
```
Create linear interpolation object with extrapolation
```julia
interp_linear_extrap = linear_interpolation(xs, A,extrapolation_bc=Line()) 
interp_linear_extrap(0.9) # outside grid: linear extrapolation
```

### Other Examples

More examples, such as plotting and cubic interpolation, can be found at the [convenience constructions](docs/src/convenience-construction.md#example-with-plotsjl) documentation.

![interpolation plot example](docs/src/assets/plotsjl_interpolation_example.png)

## Other Interpolation Packages

Other interpolation packages for Julia include:

- [ApproXD.jl](https://github.com/floswald/ApproXD.jl) implements B-spline and linear interpolation in Julia.
- [BarycentricInterpolation.jl](https://github.com/dawbarton/BarycentricInterpolation.jl) implements the Barycentric formula for polynomial interpolation on equispaced points and Chebyshev points of the first and second kind.
- [BasicInterpolators.jl](https://github.com/markmbaum/BasicInterpolators.jl) provides a collection of common interpolation recipes for basic applications.
- [BSplineKit.jl](https://github.com/jipolanco/BSplineKit.jl) offers tools for B-spline based Galerkin and collocation methods, including for interpolation and approximation.
- [Curves.jl](https://github.com/lungben/Curves.jl) supports log-interpolation via immutable `Curve` objects.
- [DataInterpolations.jl](https://github.com/PumasAI/DataInterpolations.jl) is a library for performing interpolations of one-dimensional data.
- [Dierckx.jl](https://github.com/kbarbary/Dierckx.jl) is a wrapper for the dierckx Fortran library, which also underlies `scipy.interpolate`.
- [DIVAnd.jl](https://github.com/gher-ulg/DIVAnd.jl) for N-dimensional smoothing interpolation. 
- [FastChebInterp.jl](https://github.com/stevengj/FastChebInterp.jl) does fast multidimensional Chebyshev interpolation on a hypercube using separable grid of interpolation points.
- [FEMBasis.jl](https://github.com/JuliaFEM/FEMBasis.jl) contains interpolation routines for standard finite element function spaces.
- [FineShift.jl](https://github.com/emmt/FineShift.jl) does fast sub-sample shifting of multidimensional arrays.
- [FourierTools.jl](https://github.com/bionanoimaging/FourierTools.jl) includes sinc interpolation for up and down sampling.
- [GeoStats.jl](https://github.com/JuliaEarth/GeoStats.jl) provides interpolation and simulation methods over complex 2D and 3D meshes.
- [GridInterpolations.jl](https://github.com/sisl/GridInterpolations.jl) performs multivariate interpolation on a rectilinear grid.
- [InterpolationKernels.jl](https://github.com/emmt/InterpolationKernels.jl) provides a library of interpolation kernels.
- [KissSmoothing.jl](https://github.com/francescoalemanno/KissSmoothing.jl) implements denoising and a Radial Basis Function estimation procedure.
- [LinearInterpolations.jl](https://github.com/jw3126/LinearInterpolations.jl) allows for interpolation using weighted averages allowing probability distributions, rotations, and other Lie groups to be interpolated.
- [LinearInterpolators.jl](https://github.com/emmt/LinearInterpolators.jl) provides linear interpolation methods for Julia based on InterpolationKernels.jl, above.
- [LocalFunctionApproximation.jl](https://github.com/sisl/LocalFunctionApproximation.jl) provides local function approximators that interpolates a scalar-valued function across a vector space.
- [NaturalNeighbours.jl](https://github.com/DanielVandH/NaturalNeighbours.jl) provides natural neighbour interpolation methods for scattered two-dimensional point sets, with support for derivative generation.
- [PCHIPInterpolation.jl](https://github.com/gerlero/PCHIPInterpolation.jl) for monotonic interpolation.
- [PiecewiseLinearApprox.jl](https://github.com/RJDennis/PiecewiseLinearApprox.jl) performs piecewise linear interpolation over an arbitrary number of dimensions.
- [ScatteredInterpolation.jl](https://github.com/eljungsk/ScatteredInterpolation.jl) interpolates scattered data in arbitrary dimensions.

Some of these packages support methods that `Interpolations` does not,
so if you can't find what you need here, check one of them or submit a
pull request here.

If you would like to list a registered package that is related to interpolation, please create a Github issue.


## Performance shootout

In the `perf` directory, you can find a script that tests
interpolation with several different packages.  We consider
interpolation in 1, 2, 3, and 4 dimensions, with orders 0
(`Constant`), 1 (`Linear`), and 2 (`Quadratic`).  Methods include
Interpolations `BSpline` (`IBSpline`) and `Gridded` (`IGridded`),
methods from the [Grid.jl](https://github.com/timholy/Grid.jl)
package, methods from the
[Dierckx.jl](https://github.com/kbarbary/Dierckx.jl) package, methods
from the
[GridInterpolations.jl](https://github.com/sisl/GridInterpolations.jl)
package (`GI`), methods from the
[ApproXD.jl](https://github.com/floswald/ApproXD.jl) package, and
methods from SciPy's `RegularGridInterpolator` accessed via `PyCall`
(`Py`).  All methods
are tested using an `Array` with approximately `10^6` elements, and
the interpolation task is simply to visit each grid point.

First, let's look at the two B-spline algorithms, `IBspline` and
`Grid`.  Here's a plot of the "construction time," the amount of time
it takes to initialize an interpolation object (smaller is better):

![construction](perf/constructionB.png)

The construction time is negligible until you get to second order
(quadratic); that's because quadratic is the lowest order requiring
the solution of tridiagonal systems upon construction.  The solvers
used by Interpolations are much faster than the approach taken in
Grid.

Now let's examine the interpolation performance.  Here we'll measure
"throughput", the number of interpolations performed per second
(larger is better):

![throughput](perf/rateB.png)

Once again, Interpolations wins on every test, by a factor that ranges
from 7 to 13.

Now let's look at the "gridded" methods that allow irregular spacing
along each axis.  For some of these, we compare interpolation performance in
both "vectorized" form `itp[xvector, yvector]` and in "scalar" form
`for y in yvector, x in xvector; val = itp[x,y]; end`.

First, construction time (smaller is better):

![construction](perf/constructionG.png)

Missing dots indicate cases that were not tested, or not supported by
the package.  (For construction, differences between "vec" and
"scalar" are just noise, since no interpolation is performed during
construction.)  The only package that takes appreciable construction
time is Dierckx.

And here's "throughput" (larger is better). To ensure we can see the
wide range of scales, here we use "square-root" scaling of the y-axis:

![throughput](perf/rateG.png)

For 1d, the "Dierckx scalar" and "GI" tests were interrupted because
they ran more than 20 seconds (far longer than any other test).  Both
performed much better in 2d, interestingly.  You can see that
Interpolations wins in every case, sometimes by a very large margin.

## Development Status

This package is being maintained but not actively developed. Maintenance is
focused on fixing bugs and issues with the current code base. New features are
welcome via pull requests and will be reviewed and released in a timely fashion.

If you would like to become involved in maintenance or active development of
the package please feel free to get in touch via a Github issue.

This package follows semantic version in that documented features should not
break without changing the minor version.

See the [news](NEWS.md) for details on how to update between breaking releases,
indicated by changes in minor versions.

## Contributing

Work is very much in progress, but help is always welcome. If you want to help out but don't know where to start, take a look at issue [#5 - our feature wishlist](https://github.com/JuliaMath/Interpolations.jl/issues/5) =) There is also some [developer documentation](http://juliamath.github.io/Interpolations.jl/latest/devdocs/) that may help you understand how things work internally.

Contributions in any form are appreciated, but the best pull requests come with tests!

This directory contains files that facilitate the composition of Interpolations.jl with other julia packages.

To add extra code that is loaded using Requires.jl create a new file named after the package of interest and then
modify `__init__` in Interpolations.jl with a `@require` statement to include the file.

using Test
using Interpolations
using Interpolations: KnotRange

"""
    @test_knots kiter T expect

Generate test sets for testing the knot iterator `kiter`. Following checks are
performed:
- `typeof(kiter)` is `T` if 1D or `ProductIterator` wrapping `T` if ND
- `IteratorEltype` and `eltype` behavior matches expected
- `IteratorSize`, `length` and `size` are matches expected
- Iterated contents match (Checks all if bounded, otherwise the first 100)
"""
macro test_knots(itersym, type, expect...)
    # 1D vs ND Checks
    if length(expect) > 1
        refExpr = :( Iterators.product($(expect...)) )
        knotTypeExpr = :( Tuple{ eltype.(($(expect...),))... } )
        typecheckExpr = quote
            @test typeof($itersym) <: Iterators.ProductIterator
            @test typeof($itersym.iterators) <: Tuple{$type, $type}
        end
        sizecheckExpr = :( @test size($itersym) == size(ref) )

        # Expect HasShape{N} for ND Iterators
        IteratorSizeExpr = :( Base.HasShape{$(length(expect))}() )

        # Content Check for 1D array of tuples
        IterEqCheck = :( all(map( (x,y) -> (all∘map)(≈, x, y), kiter, kref )))
    else
        refExpr = expect[1]
        knotTypeExpr = :( eltype($refExpr) )
        typecheckExpr = :( @test (<:)(typeof($itersym), $type) )

        # Check size using length to avoid issues with reference not defining a
        # suitable size method
        sizecheckExpr = :( @test size($itersym) == (length(ref),) )

        # Expect a IteratorSize of HasLength for 1D iterators
        IteratorSizeExpr = :( Base.HasLength() )

        # Content Check for 1D arrays
        IterEqCheck = :( kiter ≈ kref )
    end

    # Check Type-stability if v > 1.2
    @static if VERSION >= v"1.2"
        # Check Type-stability using inferred
        type_stability_checks = quote
            @testset "type stability" begin
                iteratetype = Union{Nothing, knotType}
                y = @inferred iteratetype iterate($itersym)
                if y !== nothing
                    @test_nowarn @inferred iteratetype iterate($itersym, y[2])
                end
                isBounded && @test_nowarn @inferred Integer length($itersym)
                @test_nowarn @inferred Type eltype($itersym)
            end
        end
    else
        # Skip Type-stability checks as @inferred AllowedTypes is Undefined
        type_stability_checks = :()
    end

    # Build test_knots tests
    quote
        local $itersym = $(esc(itersym))    # Local knot iterator for testing
        knotType = $(esc(knotTypeExpr))     # Insert Expr to get knot eltype
        ref = $(esc(refExpr))               # Build reference iterator

        # If the reference size is "SizeUnknown" treat as IsInfinite
        # Some iterators are quick to assume SizeUnknown
        isBounded = Base.IteratorSize(ref) != Base.IsInfinite() &&
                    Base.IteratorSize(ref) != Base.SizeUnknown()

        # Insert Type checks defined earlier
        @testset "typechecks" begin $typecheckExpr end

        # Check Eltype matches reference iterator
        # Relax type check (ie. <: instead of ==) as some iterators are quick to
        # assume "Any" -> Prevents errors caused by ref's type being off
        # This is okay, as we check that collected eltypes match exactly later
        @testset "eltype checks" begin
            @test Base.IteratorEltype($itersym) == Base.HasEltype()
            @test eltype($itersym) <: knotType
        end

        # Check that IteratorSize matches reference and iff bounded check that
        # length matches as well
        # Size check is defined by $sizecheckExpr to avoid issues with Undefined
        # size methods for 1D reference iterators
        @testset "IteratorSize, length and size checks" begin
            if isBounded
                @test Base.IteratorSize($itersym) == $IteratorSizeExpr
                @test length($itersym) == length(ref)
                $sizecheckExpr
            else
                @test Base.IteratorSize($itersym) == Base.IsInfinite()
            end
        end

        # Check that the contents of the knot iterator matches the reference
        # iterator
        @testset "check contents" begin
            if isBounded
                kiter = collect($itersym)
                kref = collect(ref)
            else
                kiter = collect(Iterators.take($itersym, 100))
                kref = collect(Iterators.take(ref, 100))
            end
            # Test Iterator Results
            @test typeof(kiter) <: AbstractArray
            @test eltype(kiter) == eltype(kref)
            @test length(kiter) == length(kref)
            @test size(kiter) == size(kref)
            @test $IterEqCheck
        end

        # Type stability -> Check that methods are type suitable
        $type_stability_checks
    end
end

"""
    knot_ref(seq, etp)
    knot_ref(seq, etp; start, stop)

Dumb but correct construction of a reference knot iterator for a boundary condition
of etp.

If `start` is specified, will skip knots until `start < k` using Iterator.filter
If `stop` is specified, will iterate until `stop <= k` and return an array
"""
knot_ref(seq, etp; start=nothing, stop=nothing) = knot_ref(seq, etp, start, stop)
function knot_ref(seq, etp, start::Number, ::Nothing)
    # Drop items less than start -> Dispatch to generate sequence
    Iterators.filter(x -> start < x, knot_ref(seq, etp))
end
function knot_ref(seq, etp, start, stop::Number)
    # Collect items until `k < stop` is false -> Then return ref
    # Dispatch to handle remaining arguments
    ref = Vector{eltype(seq)}()
    for k ∈ knot_ref(seq, etp, start, nothing)
        if k < stop
            push!(ref, k)
        else
            break
        end
    end
    ref
end

knot_ref(seq, etp, ::Nothing, ::Nothing) = knot_ref(seq, etp)

knot_ref(seq, ::Interpolations.BoundaryCondition) = seq

function knot_ref(seq, ::Periodic)
    Δ = diff(seq)
    iter = Iterators.flatten((first(seq), Iterators.cycle(Δ)))
    @static if VERSION >= v"1.5"
        Iterators.accumulate(+, iter)
    else
        # Generate 200 samples (2x factor on testing done by @test_knots)
        # Then wrap with cycle to get IteratorSize === IsInfinite
        # TODO: Remove when Julia v1 is no longer supported
        ref = Iterators.take(iter, 200) |> collect |> cumsum |> Iterators.cycle
    end
end

function knot_ref(seq, ::Reflect)
    Δ = diff(seq)
    Δ = vcat(Δ, reverse(Δ))
    iter = Iterators.flatten((first(seq), Iterators.cycle(Δ)))
    @static if VERSION >= v"1.5"
        Iterators.accumulate(+, iter)
    else
        # Generate 200 samples (2x factor on testing done by @test_knots)
        # Then wrap with cycle to get IteratorSize === IsInfinite
        # TODO: Remove when Julia v1 is no longer supported
        ref = Iterators.take(iter, 200) |> collect |> cumsum |> Iterators.cycle
    end
end

@testset "knot_ref" begin
    x = [1.0, 1.5, 1.75, 2.0]
    # Non-Repeating Knots
    @testset "knot_ref for $etp" for etp ∈ [Line(), Flat(), Throw()]
        @test knot_ref(x, etp) == x
        @test knot_ref(x, etp; start=1.2) |> collect == x[2:end]
        @test knot_ref(x, etp; stop=1.8) |> collect == x[1:end-1]
        @test knot_ref(x, etp; start=1.2, stop=1.8) |> collect == x[2:end-1]
    end
    # Check knot_ref for Periodic against expect knots
    @testset "knot_ref for Periodic" begin
        ref = [
            1.0, 1.5, 1.75, 2.0, 2.5, 2.75, 3.0, 3.5, 3.75, 4.0, 4.5, 4.75,
            5.0, 5.5, 5.75, 6.0, 6.5, 6.75, 7.0, 7.5, 7.75, 8.0, 8.5, 8.75,
            9.0, 9.5, 9.75, 10.0, 10.5, 10.75, 11.0, 11.5, 11.75, 12.0
        ]
        @test knot_ref(x, Periodic(), start=2) |> x -> Iterators.take(x, 10) |> collect == ref[5:14]
        @test knot_ref(x, Periodic(); start=1.0, stop=12.0) == ref[2:end-1]
        @test knot_ref(x, Periodic(); start=2.3, stop=11.0) == ref[2.3 .< ref .< 11.0]
   end
    # Check knot_ref for Reflect against expect knots
    @testset "knot_ref for Reflect" begin
        ref = [
            1.0, 1.5, 1.75, 2.0, 2.25, 2.5, 3.0, 3.5, 3.75, 4.0, 4.25, 4.5,
            5.0, 5.5, 5.75, 6.0, 6.25, 6.5, 7.0, 7.5, 7.75, 8.0, 8.25, 8.5,
            9.0, 9.5, 9.75, 10.0, 10.25, 10.5, 11.0, 11.5, 11.75, 12.0
        ]
        @test knot_ref(x, Reflect(), start=2) |> x -> Iterators.take(x, 10) |> collect == ref[5:14]
        @test knot_ref(x, Reflect(); start=1.0, stop=12.0) == ref[2:end-1]
        @test knot_ref(x, Reflect(); start=2.3, stop=11.0) == ref[2.3 .< ref .< 11.0]
    end
end

# Unit Tests for Base.IteratorEltype and Base.IteratorSize methods (Type Info Only)
@testset "iterate - interface" begin
    import Interpolations.KnotIterator
    # Eletype is known iff type parameter is provided
    @test Base.IteratorEltype(KnotIterator) == Base.EltypeUnknown()
    @test eltype(KnotIterator) == Any
    @test Base.IteratorEltype(KnotIterator{Int}) == Base.HasEltype()
    @test eltype(KnotIterator{Int}) == Int
    @test Base.IteratorEltype(KnotIterator{Int,Flat}) == Base.HasEltype()
    @test eltype(KnotIterator{Int}) == Int

    # If missing ET type parameter -> SizeUnknown, as could be HasLength or
    # IsInfinite
    @test Base.IteratorSize(KnotIterator) == Base.SizeUnknown()
    @test Base.IteratorSize(KnotIterator{Int}) == Base.SizeUnknown()
    @test Base.IteratorSize(KnotIterator{Int,Flat}) == Base.HasLength()
end

# Iterator Interface for KnotRange
@testset "KnotRange - iterate interface" begin
    import Interpolations.KnotRange
    # Eletype is known iff type parameter is provided
    @test Base.IteratorEltype(KnotRange) == Base.EltypeUnknown()
    @test eltype(KnotRange) == Any
    @test Base.IteratorEltype(KnotRange{Int}) == Base.HasEltype()
    @test eltype(KnotRange{Int}) == Int
    @test Base.IteratorEltype(KnotRange{Int,Base.UnitRange}) == Base.HasEltype()
    @test eltype(KnotRange{Int,Base.UnitRange}) == Int
    @test Base.IteratorEltype(KnotRange{Int,Iterators.Count}) == Base.HasEltype()
    @test eltype(KnotRange{Int,Iterators.Count}) == Int

    # If missing Range type parameter -> SizeUnknown, as could be HasLength or
    # IsInfinite
    @test Base.IteratorSize(KnotRange) == Base.SizeUnknown()
    @test Base.IteratorSize(KnotRange{Int}) == Base.SizeUnknown()
    @test Base.IteratorSize(KnotRange{Int,Base.UnitRange}) == Base.HasLength()
    @test Base.IteratorSize(KnotRange{Int,Iterators.Count}) == Base.IsInfinite()
end

# eltype units tests of KnotIterator / KnotRange
@testset "iterate - eltype" for T ∈ [ Int, Float64, Any ]
    x = convert(Vector{T}, collect(1:5))
    itp = linear_interpolation(x, x.^2)
    kiter = knots(itp)
    @test Base.IteratorEltype(typeof(kiter)) == Base.HasEltype()
    @test typeof(kiter) <: Interpolations.KnotIterator{T}
    @test eltype(kiter) == T

    krange = knotsbetween(itp; start=1.2, stop=3.4)
    @test Base.IteratorEltype(krange) == Base.HasEltype()
    @test typeof(krange) <: Interpolations.KnotRange{T}
    @test eltype(krange) == T
end

# size/length units tests for KnotIterator
@testset "iterate - size - directional"  begin
    ExtrapBC = [Throw(), Flat(), Periodic(), Reflect()]
    @testset "RevBC: $RevBC, FwdBC: $FwdBC" for FwdBC ∈ ExtrapBC, RevBC ∈ ExtrapBC
        etp = linear_interpolation(1:10, rand(10),
            extrapolation_bc=((RevBC, FwdBC),)
        )
        kiter = knots(etp)
        @test typeof(kiter) <: Interpolations.KnotIterator
        ktype = KnotIterator{Int, Tuple{typeof(RevBC), typeof(FwdBC)}}
        @test typeof(kiter) == ktype

        @test_knots kiter KnotIterator knot_ref(1:10, FwdBC)

        if typeof(FwdBC) <: Union{Periodic, Reflect}
            @test Base.IteratorSize(kiter) == Base.IsInfinite()
            @test_throws MethodError length(kiter)
            @test_throws MethodError size(kiter)
        else
            @test Base.IteratorSize(kiter) == Base.HasLength()
            @test length(kiter) == 10
            @test size(kiter) == (10,)
        end
    end
end

# Unit Tests for 1D Interpolations
@testset "iterate - 1d interpolation" begin
    itp = interpolate(1:5, BSpline(Linear()))
    kiter = knots(itp)

    # Single axis -> KnotIterator
    @test typeof(kiter) <: Interpolations.KnotIterator

    # Check size, length and eltype
    @test Base.IteratorSize(kiter) === Base.HasLength()
    @test length(kiter) == 5
    @test size(kiter) == (5,)
    @test Base.IteratorEltype(kiter) == Base.HasEltype()
    @test eltype(kiter) <: Int

    # Check contents
    @test collect(kiter) == [1, 2, 3, 4, 5]

    @test_knots kiter KnotIterator 1:5

    # Sample for loop
    kout = []
    for (k,) ∈ kiter
        push!(kout, k)
    end
    @test kout == collect(kiter)
end

# Unit Test for 2D Interpolations
@testset "iterate - 2d interpolation" begin
    itp = interpolate(rand(3,3), BSpline(Constant()))
    kiter = knots(itp)

    # 2D iterator -> ProductIterator wrapping KnotIterators
    @test typeof(kiter) <: Iterators.ProductIterator
    @test eltype(kiter.iterators) <: Interpolations.KnotIterator

    # Check size, length and eltype
    @test Base.IteratorSize(kiter) == Base.HasShape{2}()
    @test length(kiter) == 9
    @test size(kiter) == (3, 3)
    @test Base.IteratorEltype(kiter) == Base.HasEltype()
    @test eltype(kiter) <: Tuple{Int, Int}

    # Collect knots and check again
    k = collect(kiter)
    @test length(k) == 9
    @test size(k) == (3,3)
    @test eltype(k) <: Tuple{Int, Int}
    @test k == Iterators.product(1:3, 1:3) |> collect

    @test_knots kiter KnotIterator 1:3 1:3

    # Sample for loop
    kout = []
    for (kx, ky) ∈ kiter
        push!(kout, (kx, ky))
    end
    @test kout == Iterators.product(1:3, 1:3) |> collect |> vec

end

# Unit Tests for 1D extrapolations
@testset "1D - iterate - $itp" for itp ∈ [ BSpline(Constant()) ]
    x = 1.0:5.0
    itp = interpolate(x.^2, itp)
    @test typeof(itp) <: AbstractInterpolation
    kiter = knots(itp)

    # Checkout construction before proceeding
    @test_knots kiter KnotIterator 1:5

    # Non-repeating Knots -> Should iterate over once and be done
    @testset "extrapolation - $etp" for etp ∈ [ Throw(), Flat(), Line()]
        extrp = extrapolate(itp, etp)
        kiter = knots(extrp)
        @test_knots kiter KnotIterator knot_ref(1:5, etp)
    end

    # Repeating Knots -> Should Iterate indefinitely
    @testset "extrapolation - Periodic" begin
        extrp = extrapolate(itp, Periodic())
        k = knots(extrp)
        @test_knots k KnotIterator knot_ref(1:5, Periodic())

        # Check that knots maps to the correct inbound knot
        k10 = Iterators.take(k, 10) |> collect
        @test extrp.(k10) ≈ vcat(x[1:end-1].^2, x[1:end-1].^2, x[1:2].^2)
    end
    @testset "extrapolation - Reflect" begin
        extrp = extrapolate(itp, Reflect())
        k = knots(extrp)
        @test_knots k KnotIterator knot_ref(1:5, Reflect())


        # Check that knots maps to the correct inbound knot
        k10 = Iterators.take(k, 10) |> collect
        @test k10 ≈ collect(1:10)
        @test extrp.(k10) ≈ vcat(x.^2, reverse(x[1:end - 1].^2), x[2].^2)
    end
end

# Unit tests for iteration on an uneven grid - Periodic
# Knots should repeat indefinitely with the first and last knots being co-located
@testset "iterate - uneven - Periodic" begin
    x = [1.0, 1.3, 2.4, 3.2, 4.0]
    etp = linear_interpolation(x, x.^2, extrapolation_bc=Periodic())
    kiter = knots(etp)
    @test_knots kiter KnotIterator knot_ref(x, Periodic())

    # Check that knots maps to the correct inbound knot
    k = Iterators.take(kiter, 10) |> collect
    @test k == [1.0, 1.3, 2.4, 3.2, 4.0, 4.3, 5.4, 6.2, 7.0, 7.3]
    @test etp.(k) ≈ vcat(x[1:end-1], x[1:end-1], x[1:2]).^2
end

# Unit tests for iteration on an uneven grid - Reflect
@testset "iterate - uneven - Reflect" begin
    x = [1.0, 1.3, 2.4, 3.2, 4.0]
    etp = linear_interpolation(x, x.^2, extrapolation_bc=Reflect())
    kiter = knots(etp)
    @test_knots kiter KnotIterator knot_ref(x, Reflect())

    # Check that knots maps to the correct inbound knot
    k = Iterators.take(kiter, 10) |> collect
    @test k == [1.0, 1.3, 2.4, 3.2, 4.0, 4.8, 5.6, 6.7, 7.0, 7.3]
    @test etp.(k) ≈ vcat(x, reverse(x[1:end - 1]), x[2]).^2
end

# Unit tests for 2D iteration with directional boundary conditions that are
# bounded (ie. knots do not repeat indefinitely)
@testset "2D - iteration - bounded - $bc" for bc ∈ [Line(), (Throw(), Line())]
    etp = linear_interpolation(([1, 2, 3], [1, 2, 3]), rand(3, 3);
        extrapolation_bc=(Throw(), bc)
    )
    kiter = knots(etp)
    @test_knots kiter KnotIterator 1:3 1:3
end

# Unit tests for 2D iteration with directional boundary conditions that are
# unbounded (ie. knots do repeat indefinitely)
@testset "2D - iteration - Unbounded - $bc" for bc ∈ [Periodic(), (Throw(), Periodic())]
    etp = linear_interpolation(([1, 2, 3], [1, 2, 3]), rand(3, 3);
        extrapolation_bc=(Line(), bc)
    )
    kiter = knots(etp)
    @test_knots kiter KnotIterator 1:3 Iterators.countfrom(1)
end

@testset "knotsbetween - interpolate - 1D" begin
    itp = interpolate(rand(10), BSpline(Linear()))
    @testset "start and stop" begin
        krange = knotsbetween(itp; start=2.1, stop=6.2)
        @test_knots krange KnotRange 3:6
    end
    @testset "start" begin
        krange = knotsbetween(itp; start=3.2)
        @test_knots krange KnotRange 4:10
    end
    @testset "stop" begin
        krange = knotsbetween(itp; stop=8.2)
        @test_knots krange KnotRange 1:8
    end
end

@testset "knotsbetween - interpolate - 2D" begin
    itp = interpolate(rand(10, 10), BSpline(Constant()))
    @testset "start and stop" begin
        krange = knotsbetween(itp; start=(2.1, -1.2), stop=(7.2, 7.8))
        @test_knots krange Interpolations.KnotRange 3:7 1:7
    end
    @testset "start" begin
        krange = knotsbetween(itp; start=(-2, 3.2))
        k1, next = iterate(krange)
        @test k1 == (1, 4)
        @test_knots krange Interpolations.KnotRange 1:10 4:10
    end
    @testset "stop" begin
        krange = knotsbetween(itp; stop=(10, 8.2))
        k1, next = iterate(krange)
        @test k1 == (1, 1)
        @test_knots krange Interpolations.KnotRange 1:9 1:8
    end
end

@testset "knotsbetween - extrapolate - 1D - $etp" for etp ∈ [Throw(), Flat(), Line()]
    x = [1.0, 1.5, 1.75, 2.0]
    etp = linear_interpolation(x, x.^2, extrapolation_bc=etp)
    @testset "start and stop" begin
        krange = knotsbetween(etp; start=0.0, stop=4.2)
        @test_knots krange KnotRange [1.0, 1.5, 1.75, 2.0]
    end
    @testset "start" begin
        krange = knotsbetween(etp; start=1.2)
        @test_knots krange KnotRange [1.5, 1.75, 2.0]
    end
    @testset "stop" begin
        krange = knotsbetween(etp; start=1.2)
        @test_knots krange KnotRange [1.5, 1.75, 2.0]
    end
    @testset "empty iterator" begin
        krange = knotsbetween(etp; start=3)
        @test_knots krange KnotRange Float64[]

        krange = knotsbetween(etp; stop=1.0)
        @test_knots krange KnotRange Float64[]
    end
end

macro test_knot_idx(f, iter, start, state, knot)
    quote
        # Wrap in @testset to get debug info on failure
        local $iter = $(esc(iter))
        @testset "$($f)($($iter)), $($start)) -> $($knot), $($state)" begin
            # Check that state does correspond to knot
            knot = first(iterate($iter, $state))
            @test knot == $knot

            # Check that f(start) -> state
            state = $f($iter, $start)
            @test state == $state
        end
    end
end

@testset "_knot_start/stop - Periodic" begin
    x = [1.0, 1.5, 1.75, 2.0]
    etp = linear_interpolation(x, x.^2, extrapolation_bc=Periodic())
    krange = knotsbetween(etp; stop = 10)
    using Interpolations: nextknotidx, priorknotidx

    @test_knot_idx(nextknotidx, krange, -2.1, -8, -2.0)
    @test_knot_idx(nextknotidx, krange, 0.4, -1, 0.5)
    @test_knot_idx(nextknotidx, krange, 0.7, 0, 0.75)
    @test_knot_idx(nextknotidx, krange, 0.8, 1, 1.0)
    @test_knot_idx(nextknotidx, krange, 1.0, 2, 1.5)
    @test_knot_idx(nextknotidx, krange, 1.5, 3, 1.75)
    @test_knot_idx(nextknotidx, krange, 2.3, 5, 2.5)

    @test_knot_idx(priorknotidx, krange, 0.4, -2, 0.0)
    @test_knot_idx(priorknotidx, krange, 0.7, -1, 0.5)
    @test_knot_idx(priorknotidx, krange, 0.8, 0, 0.75)
    @test_knot_idx(priorknotidx, krange, 1.0, 0, 0.75)
    @test_knot_idx(priorknotidx, krange, 1.5, 1, 1.0)
    @test_knot_idx(priorknotidx, krange, 2.0, 3, 1.75)
    @test_knot_idx(priorknotidx, krange, 2.3, 4, 2.0)
end

@testset "_knot_start/stop - Reflect" begin
    x = [1.0, 1.5, 1.75, 2.0]
    etp = linear_interpolation(x, x.^2, extrapolation_bc=Reflect())
    krange = knotsbetween(etp; stop = 10)
    using Interpolations: nextknotidx, priorknotidx

    @test_knot_idx(nextknotidx, krange, -2.1, -8, -2.0)
    @test_knot_idx(nextknotidx, krange, 0.2, -1, 0.25)
    @test_knot_idx(nextknotidx, krange, 1.6, 3, 1.75)
    @test_knot_idx(nextknotidx, krange, 3.75, 10, 4.0)
    @test_knot_idx(nextknotidx, krange, 5.4, 14, 5.5)

    @test_knot_idx(priorknotidx, krange, 0.4, -1, 0.25)
    @test_knot_idx(priorknotidx, krange, 0.7, 0, 0.5)
    @test_knot_idx(priorknotidx, krange, 4.3, 11, 4.25)
    @test_knot_idx(priorknotidx, krange, 6.3, 17, 6.25)
    @test_knot_idx(priorknotidx, krange, 1.5, 1, 1.0)
    @test_knot_idx(priorknotidx, krange, 8.2, 22, 8.0)
    @test_knot_idx(priorknotidx, krange, 10.0, 27, 9.75)
end

@testset "knotsbetween - extrapolate - 1D - Periodic" begin
    x = [1.0, 1.5, 1.75, 2.0]
    etp = linear_interpolation(x, x.^2, extrapolation_bc=Periodic())
    @testset "start and stop" begin
        krange = knotsbetween(etp; start=0.0, stop=4.2)
        expect = knot_ref([0.5, 0.75, 1.0, 1.5], Periodic(); stop=4.2)
        @test_knots krange KnotRange expect
        @test all(0.0 .< collect(krange) .< 4.2)
    end
    @testset "start" begin
        krange = knotsbetween(etp; start=3.2)
        expect = knot_ref([3.5, 3.75, 4.0, 4.5], Periodic())
        @test_knots krange KnotRange expect
    end
    @testset "stop" begin
        krange = knotsbetween(etp; stop=4.8)
        expect = knot_ref([1.0, 1.5, 1.75, 2.0], Periodic(); stop=4.8)
        @test_knots krange KnotRange expect
        @test all(collect(krange) .< 4.8)
    end
    @testset "empty iterator" begin
        krange = knotsbetween(etp; start=1, stop=1)
        @test_knots krange KnotRange Float64[]
    end
end

@testset "knotsbetween - extrapolate - 1D - Reflect" begin
    x = [1.0, 1.5, 1.75, 2.0]
    etp = linear_interpolation(x, x.^2, extrapolation_bc=Reflect())
    @testset "start and stop" begin
        krange = knotsbetween(etp; start=0.0, stop=4.2)
        expect = knot_ref([-1.0, -0.5, -0.25, 0.0], Reflect(); start=0.0, stop=4.2)
        @test_knots krange KnotRange expect
        @test all(0.0 .< collect(krange) .< 4.2)
    end
    @testset "start" begin
        krange = knotsbetween(etp; start=3.2)
        expect = knot_ref([3.0, 3.5, 3.75, 4.0], Reflect(); start=3.2)
        @test_knots krange KnotRange expect
    end
    @testset "stop" begin
        krange = knotsbetween(etp; stop=4.8)
        expect = knot_ref([1.0, 1.5, 1.75, 2.0], Reflect(); stop=4.8)
        @test_knots krange KnotRange expect
        @test all(collect(krange) .< 4.8)
    end
    @testset "empty iterator" begin
        krange = knotsbetween(etp; start=1, stop=1)
        @test_knots krange KnotRange Float64[]
    end
end

@testset "knotsbetween - empty iterator" begin
    x = [1.0, 1.5, 1.75, 2.0]
    etp = linear_interpolation(x, x.^2)
    @testset "start is out of bounds" begin
        krange = knotsbetween(etp; start=2.0)
        @test_knots krange KnotRange Float64[]
    end
    @testset "start and stop and out of bounds" begin
        krange = knotsbetween(etp; start=-10, stop=0)
        @test_knots krange KnotRange Float64[]
    end
    @testset "stop is less than start" begin
        krange = knotsbetween(etp; start=1.8, stop=1.1)
        @test_knots krange KnotRange Float64[]
    end
end

@testset "knotsbetween - missing start and stop" begin
    @testset "1D Case" begin
        x = [1.0, 1.5, 1.75, 2.0]
        etp = linear_interpolation(x, x.^2)
        @test_throws ArgumentError knotsbetween(etp)
        @test_throws ArgumentError knotsbetween(etp; start=nothing, stop=nothing)
    end
    @testset "2D case" begin
        etp = linear_interpolation((1:3, 1:3), rand(3,3))
        @test_throws ArgumentError knotsbetween(etp)
        @test_throws ArgumentError knotsbetween(etp; start=(nothing, 1), stop=(nothing, 2))
    end
end

@testset "KnotIterator - Out of Bound Knots" begin
    x = [1.0, 1.5, 1.75, 2.0]
    @testset "NonRepeating Knots - $etp}" for etp ∈ [Flat(), Line(), Throw()]
        etp = linear_interpolation(x, x.^2, extrapolation_bc=etp)
        kiter = knots(etp)

        # Check that Bounds errors are thrown
        @test_throws BoundsError kiter[0]
        @test kiter[1] == x[1]
        @test kiter[kiter.nknots] == x[end]
        @test_throws BoundsError kiter[kiter.nknots+1]
    end
    @testset "Repeating Knots - $etp" for etp ∈ [Periodic(), Reflect()]
        etp = linear_interpolation(x, x.^2, extrapolation_bc=etp)
        kiter = knots(etp)

        # Check that Bounds errors are not thrown
        @test_nowarn kiter[0]
        @test kiter[1] == x[1]
        @test kiter[kiter.nknots] == x[end]
        @test_nowarn kiter[kiter.nknots+1]
    end
end

using Unitful

@testset "Unitful scaled interpolation" begin
    # Abstract range
    Xs = (0:.2:5)u"m"
    Ys = Xs .^ 2
    sitp = scale(interpolate(Ys, BSpline(Quadratic(Free(OnGrid())))), Xs)
    @test sitp.((0:1:3)u"cm") ≈ ((0:1:3)u"cm") .^ 2

    # Step Range
    Xss = (0:5)u"m"
    Yss = Float64.(Xss .^ 2)
    sitp = scale(interpolate(Yss, BSpline(Quadratic(Free(OnGrid())))), Xss)
    @test sitp((0:1:3)u"cm") ≈ ((0:1:3)u"cm") .^ 2

end

using Plots
using Interpolations

pyplot()

x = [0.0, 0.2, 0.5, 0.6, 0.9, 1.0]
y = [10.0, 0.0, -5.0, 10.0, -8.0, -2.0]
grid = 0.0:0.002:1.0

itypes = [LinearMonotonicInterpolation(),
    FiniteDifferenceMonotonicInterpolation(),
    CardinalMonotonicInterpolation(0.0),
    CardinalMonotonicInterpolation(0.5),
    CardinalMonotonicInterpolation(1.0),
    AkimaMonotonicInterpolation(),
    FritschCarlsonMonotonicInterpolation(),
    FritschButlandMonotonicInterpolation(),
    SteffenMonotonicInterpolation()
    ]

scatter(x, y, label = "data")
for itype in itypes
    itp = interpolate(x, y, itype)
    plot!([x for x in grid], [itp(x) for x in grid], label = string(itype))
end
gui()

@testset "Constant" begin
    # Instantiation
    N1 = 10
    A1 = rand(Float64, N1) * 100
    A2 = rand(Float64, N1, N1) * 100
    A3 = rand(Float64, N1, N1, N1) * 100

    @testset "constructor" begin
        @test Constant() == Constant{Nearest}()
        for T in (Nearest, Previous, Next)
            it = Constant{T}()
            @test it isa Constant{T}
            it = T |> Constant
            @test it isa Constant{T}
        end
    end

    @testset "Constant{Nearest}" begin
        for (constructor, copier) in ((interpolate, x -> x), (interpolate!, copy))
            isinplace = constructor == interpolate!
            itp1 = @inferred(constructor(copier(A1), BSpline(Constant())))
            itp2 = @inferred(constructor(copier(A2), BSpline(Constant())))
            itp3 = @inferred(constructor(copier(A3), BSpline(Constant())))

            @test parent(itp1) === itp1.coefs
            @test Interpolations.lbounds(itp1) == (1,)
            @test Interpolations.ubounds(itp1) == (N1,)

            # Evaluation on provided data points
            for (itp, A) in ((itp1, A1), (itp2, A2), (itp3, A3))
                check_axes(itp, A, isinplace)
                check_inbounds_values(itp, A)
                check_oob(itp)
                can_eval_near_boundaries(itp)
            end

            # Evaluation between data points (tests constancy)
            for i in 2:N1 - 1
                @test A1[i] == itp1(i + .3) == itp1(i - .3)
            end
            # 2D
            for i in 2:N1 - 1, j in 2:N1 - 1
                @test A2[i,j] == itp2(i + .4, j - .3) == itp2(i - .4, j + .3)
            end
            # 3D
            for i in 2:N1 - 1, j in 2:N1 - 1, k in 2:N1 - 1
                @test A3[i,j,k] == itp3(i + .4, j - .3, k + .1) == itp3(i + .4, j - .3, k + .2)
            end
        end
    end

    @testset "Constant{Previous}" begin
        for (constructor, copier) in ((interpolate, x -> x), (interpolate!, copy))
            isinplace = constructor == interpolate!
            itp1 = @inferred(constructor(copier(A1), BSpline(Constant{Previous}())))
            itp2 = @inferred(constructor(copier(A2), BSpline(Constant{Previous}())))
            itp3 = @inferred(constructor(copier(A3), BSpline(Constant{Previous}())))

            @test parent(itp1) === itp1.coefs
            @test Interpolations.lbounds(itp1) == (1,)
            @test Interpolations.ubounds(itp1) == (N1,)

            # Evaluation on provided data points
            for (itp, A) in ((itp1, A1), (itp2, A2), (itp3, A3))
                check_axes(itp, A, isinplace)
                check_inbounds_values(itp, A)
                check_oob(itp)
                can_eval_near_boundaries(itp)
            end

            # Evaluation between data points (tests constancy)
            for i in 2:N1 - 1
                @test A1[i] == itp1(i + .3) == itp1(i + .6) 
                @test A1[i - 1] == itp1(i - .3) == itp1(i - .6)
            end
            # 2D
            for i in 2:N1 - 1, j in 2:N1 - 1
                @test A2[i,j - 1] == itp2(i + .4, j - .3) == itp2(i + .4, j - .6)
            end
            # 3D
            for i in 2:N1 - 1, j in 2:N1 - 1, k in 2:N1 - 1
                @test A3[i,j - 1,k] == itp3(i + .4, j - .3, k + .1) == itp3(i + .4, j - .3, k + .2)
            end
        end
    end

    @testset "Constant{Next}" begin
        for (constructor, copier) in ((interpolate, x -> x), (interpolate!, copy))
            isinplace = constructor == interpolate!
            itp1 = @inferred(constructor(copier(A1), BSpline(Constant{Next}())))
            itp2 = @inferred(constructor(copier(A2), BSpline(Constant{Next}())))
            itp3 = @inferred(constructor(copier(A3), BSpline(Constant{Next}())))

            @test parent(itp1) === itp1.coefs
            @test Interpolations.lbounds(itp1) == (1,)
            @test Interpolations.ubounds(itp1) == (N1,)

            # Evaluation on provided data points
            for (itp, A) in ((itp1, A1), (itp2, A2), (itp3, A3))
                check_axes(itp, A, isinplace)
                check_inbounds_values(itp, A)
                check_oob(itp)
                can_eval_near_boundaries(itp)
            end

            # Evaluation between data points (tests constancy)
            for i in 2:N1 - 1
                @test A1[i + 1] == itp1(i + .3) == itp1(i + .6) 
                @test A1[i] == itp1(i - .3) == itp1(i - .6)
            end
            # 2D
            for i in 2:N1 - 1, j in 2:N1 - 1
                @test A2[i + 1,j] == itp2(i + .4, j - .3) == itp2(i + .4, j - .6)
            end
            # 3D
            for i in 2:N1 - 1, j in 2:N1 - 1, k in 2:N1 - 1
                @test A3[i + 1,j,k + 1] == itp3(i + .4, j - .3, k + .1) == itp3(i + .4, j - .3, k + .2)
            end
        end
    end

    @testset "Constant periodic" begin
        # Constructors
        @test Constant() === Constant(Throw(OnGrid())) === Constant{Nearest,Throw{OnGrid}}()
        @test Constant() isa Constant{Nearest,Throw{OnGrid}}
        @test Constant(Periodic()) === Constant(Periodic(OnCell())) === Constant{Nearest,Periodic{OnCell}}()
        @test Constant(Periodic()) isa Constant{Nearest,Periodic{OnCell}}
        for T in (Nearest, Previous, Next)
            it = Constant{T}()
            @test it isa Constant{T, Throw{OnGrid}}
            @test "$it" == "Constant{$T}()"
            it = Constant{T}(Periodic())
            @test it isa Constant{T, Periodic{OnCell}}
            @test "$it" == "Constant{$T}(Periodic(OnCell()))"
        end

        for (constructor, copier) in ((interpolate, x -> x), (interpolate!, copy))
            isinplace = constructor == interpolate!
            itp_periodic = @inferred(constructor(copier(A1), BSpline(Constant(Periodic()))))
            itp_previous = @inferred(constructor(copier(A1), BSpline(Constant{Previous}(Periodic()))))
            itp_next = @inferred(constructor(copier(A1), BSpline(Constant{Next}(Periodic()))))

            for itp in (itp_periodic, itp_previous, itp_next)
                @test parent(itp) === itp.coefs
                @test all(Interpolations.lbounds(itp) .≈ (0.5,))
                @test all(Interpolations.ubounds(itp) .≈ (N1 + 0.5,))

                check_axes(itp, A1, isinplace)
                check_inbounds_values(itp, A1)
                check_oob(itp)
                can_eval_near_boundaries(itp)
            end

            # Evaluation between data points (tests constancy)
            for i in 2:N1-1
                @test A1[i] == itp_periodic(i + .3) == itp_periodic(i - .3)
                @test A1[i] == itp_previous(i + .3) == itp_previous(i + .6)
                @test A1[i - 1] == itp_previous(i - .3) == itp_previous(i - .6)
                @test A1[i + 1] == itp_next(i + .3) == itp_next(i + .6)
                @test A1[i] == itp_next(i - .3) == itp_next(i - .6)
            end

            # Evaluation between data points in [0.5, 1.5], [N1 - 0.5, N1 + 0.5].
            @test A1[1] == itp_periodic(1 - .3) == itp_periodic(1 + .3)
            @test A1[N1] == itp_periodic(N1 - .3) == itp_periodic(N1 + .3)
            @test A1[1] == itp_previous(1 + .3)
            @test A1[N1] == itp_previous(N1 + .3) == itp_previous(1 - .3)
            @test A1[1] == itp_next(1 - .3) == itp_next(N1 + .3)
            @test A1[N1] == itp_next(N1 - .3)
        end
    end
end

using JLArrays, Adapt
JLArrays.allowscalar(false)

@testset "1d GPU Interpolation" begin
    A_x = 1.0:2.0:40.0
    A = [log(x) for x in A_x]
    itp = interpolate(A, BSpline(Cubic(Line(OnGrid()))))
    jlitp = jl(itp)
    idx = 2.0:0.17:19.0
    jlidx = jl(collect(idx))
    @test itp.(idx) == collect(jlitp.(idx)) == collect(jlitp.(jlidx))
    @test gradient.(Ref(itp), idx) ==
        collect(gradient.(Ref(jlitp), idx)) ==
        collect(gradient.(Ref(jlitp), jlidx))

    sitp = scale(itp, A_x)
    jlsitp = jl(sitp)
    idx = 1.0:0.4:39.0
    jlidx = jl(collect(idx))
    @test sitp.(idx) == collect(jlsitp.(idx)) == collect(jlsitp.(jlidx))
    @test gradient.(Ref(sitp), idx) ==
        collect(gradient.(Ref(jlsitp), idx)) ==
        collect(gradient.(Ref(jlsitp), jlidx))


    esitp = extrapolate(sitp, Flat())
    jlesitp = jl(esitp)
    idx = -1.0:0.84:41.0
    jlidx = jl(collect(idx))
    @test esitp.(idx) == collect(jlesitp.(idx)) == collect(jlesitp.(jlidx))
    @test gradient.(Ref(esitp), idx) ==
        collect(gradient.(Ref(jlesitp), idx)) ==
        collect(gradient.(Ref(jlesitp), jlidx))
end

@testset "2d GPU Interpolation" begin
    A_x = 1.0:2.0:40.0
    A = [log(x + y) for x in A_x, y in 1.0:2.0:40.0]
    itp = interpolate(A, (BSpline(Cubic(Line(OnGrid()))), BSpline(Linear())))
    jlitp = jl(itp)
    idx = 2.0:0.17:19.0
    jlidx = jl(collect(idx))
    @test itp.(idx, idx') == collect(jlitp.(idx, idx')) == collect(jlitp.(jlidx, jlidx'))
    @test gradient.(Ref(itp), idx, idx') ==
        collect(gradient.(Ref(jlitp), idx, idx')) ==
        collect(gradient.(Ref(jlitp), jlidx, jlidx'))
    @test hessian.(Ref(itp), idx, idx') ==
        collect(hessian.(Ref(jlitp), idx, idx')) ==
        collect(hessian.(Ref(jlitp), jlidx, jlidx'))

    sitp = scale(itp, A_x, A_x)
    jlsitp = jl(sitp)
    idx = 1.0:0.4:39.0
    jlidx = jl(collect(idx))
    @test sitp.(idx, idx') == collect(jlsitp.(idx, idx')) == collect(jlsitp.(jlidx, jlidx'))
    @test gradient.(Ref(sitp), idx, idx') ==
        collect(gradient.(Ref(jlsitp), idx, idx')) ==
        collect(gradient.(Ref(jlsitp), jlidx, jlidx'))
    @test hessian.(Ref(sitp), idx, idx') ==
        collect(hessian.(Ref(jlsitp), idx, idx')) ==
        collect(hessian.(Ref(jlsitp), jlidx, jlidx'))

    esitp = extrapolate(sitp, Flat())
    jlesitp = jl(esitp)
    idx = -1.0:0.84:41.0
    jlidx = jl(collect(idx))
    @test esitp.(idx, idx') == collect(jlesitp.(idx, idx')) == collect(jlesitp.(jlidx, jlidx'))
    # gradient for `extrapolation` is currently broken under CUDA
    @test gradient.(Ref(esitp), idx, idx') ==
        collect(gradient.(Ref(jlesitp), idx, idx')) ==
        collect(gradient.(Ref(jlesitp), jlidx, jlidx'))
end

@testset "Lanczos on gpu" begin
    X = 1:100
    X = [X; reverse(X)[2:end]]
    for N = 2:4
        itp = interpolate(X, Lanczos(N))
        @test itp.(X) == collect(jl(itp).(jl(X)))
    end
    itp = interpolate(X, Lanczos4OpenCV())
    @test itp.(X) == collect(jl(itp).(jl(X)))
end

@testset "Gridded on gpu" begin
    itp1 = interpolate(Vector.((-1.0:0.02:1.0, -1.0:0.02:1.0)), randn(101, 101), Gridded(Linear()))
    itp2 = interpolate((-1.0:0.02:1.0, -1.0:0.02:1.0), randn(101, 101), Gridded(Linear()))
    idx = -1.0:0.01:1.0
    jlidx = jl(collect(idx))
    @test itp1.(idx, idx') == collect(jl(itp1).(idx, idx')) == collect(jl(itp1).(jlidx, jlidx'))
    @test itp2.(idx, idx') == collect(jl(itp2).(idx, idx')) == collect(jl(itp2).(jlidx, jlidx'))
end

@testset "eltype after adaption" begin
    A_x = 1.0:2.0:40.0
    A = [log(x) for x in A_x]
    itp = interpolate(A, BSpline(Cubic(Line(OnGrid()))))
    @test eltype(adapt(Array{Float32}, itp)) === Float32
    @test eltype(adapt(Array{Real}, itp)) === Float64
    @test eltype(adapt(Array{Float32}, scale(itp, A_x))) === Float32
    @test eltype(adapt(Array{Float32}, extrapolate(scale(itp, A_x), Flat()))) === Float32
    itp = interpolate((-1:0.2:1, -1:0.2:1), randn(11, 11), Gridded(Linear()))
    @test eltype(adapt(Array{Float32}, itp)) === Float32
    itp = interpolate((1.0:0.0, 1.:0.), randn(0, 0), Gridded(Linear()))
    @test eltype(adapt(Array{Real}, itp)) isa DataType # we don't care the result
end

struct Cubic{BC<:BoundaryCondition} <: DegreeBC{3}
    bc::BC
end

(deg::Cubic)(gt::GridType) = Cubic(deg.bc(gt))
# Default constructor to match cubic_spline_interpolation
Cubic() = Cubic(Line(OnGrid()))

"""
    Cubic(bc::BoundaryCondition)

Indicate that the corresponding axis should use cubic interpolation.

# Extended help

Assuming uniform knots with spacing 1, the `i`th piece of cubic spline
implemented here is defined as follows.

    y_i(x) = cm p(x-i) + c q(x-i) + cp q(1- (x-i)) + cpp p(1 - (x-i))

where

    p(δx) = 1/6 * (1-δx)^3
    q(δx) = 2/3 - δx^2 + 1/2 δx^3

and the values `cX` for `X ∈ {m, _, p, pp}` are the pre-filtered coefficients.

For future reference, this expands out to the following polynomial:

    y_i(x) = 1/6 cm (1+i-x)^3 + c (2/3 - (x-i)^2 + 1/2 (x-i)^3) +
             cp (2/3 - (1+i-x)^2 + 1/2 (1+i-x)^3) + 1/6 cpp (x-i)^3

When we derive boundary conditions we will use derivatives `y_0'(x)` and
`y_0''(x)`
"""
Cubic

function positions(deg::Cubic, ax, x)
    # floorbounds adds a half at the lower bound
    xf = floorbounds(x, ax)
    xf -= ifelse(xf > last(ax)-1, oneunit(xf), zero(xf))
    δx = x - xf
    expand_index(deg, fast_trunc(Int, xf), ax, δx), δx
end

# Issue 419: Incorrect results near boundary with BSpline(Cubic(Periodic(OnCell()))))
# For Periodic positions, just use modrange. No bound-based modifications.
function positions(deg::Cubic{<:Periodic}, ax, x)
    # We do not use floorbounds because we do not want to add a half at
    # the lowerbound to round up.
    xf = floor(x)
    # We do not subtract one at the highest position as for non-Periodic Cubic
    δx = x - xf
    expand_index(deg, fast_trunc(Int, xf), ax, δx), δx
end

expand_index(::Cubic{BC}, xi::Number, ax::AbstractUnitRange, δx) where BC = xi-1
expand_index(::Cubic{Periodic{GT}}, xi::Number, ax::AbstractUnitRange, δx) where GT<:GridType =
    (modrange(xi-1, ax), modrange(xi, ax), modrange(xi+1, ax), modrange(xi+2, ax))

function value_weights(::Cubic, δx)
    x3, xcomp3 = cub(δx), cub(1-δx)
    (SimpleRatio(1,6) * xcomp3,
     SimpleRatio(2,3) - sqr(δx) + SimpleRatio(1,2)*x3,
     SimpleRatio(2,3) - sqr(1-δx) + SimpleRatio(1,2)*xcomp3,
     SimpleRatio(1,6) * x3)
end

function gradient_weights(::Cubic, δx)
    x2, xcomp2 = sqr(δx), sqr(1-δx)
    (-SimpleRatio(1,2) * xcomp2,
     -2*δx + SimpleRatio(3,2)*x2,
     +2*(1-δx) - SimpleRatio(3,2)*xcomp2,
     SimpleRatio(1,2) * x2)
end

hessian_weights(::Cubic, δx) = (1-δx, 3*δx-2, 3*(1-δx)-2, δx)


# ------------ #
# Prefiltering #
# ------------ #

padded_axis(ax::AbstractUnitRange, ::BSpline{<:Cubic}) = first(ax)-1:last(ax)+1
padded_axis(ax::AbstractUnitRange, ::BSpline{Cubic{Periodic{GT}}}) where GT<:GridType = ax

# # Due to padding we can extend the bounds
# lbound(ax, ::BSpline{Cubic{BC}}, ::OnGrid) where BC = first(ax) - 0.5
# ubound(ax, ::BSpline{Cubic{BC}}, ::OnGrid) where BC = last(ax) + 0.5

"""
`Cubic`: continuity in function value, first and second derivatives yields

    2/3 1/6
    1/6 2/3 1/6
        1/6 2/3 1/6
           ⋱  ⋱   ⋱
"""
function inner_system_diags(::Type{T}, n::Int, ::Cubic) where {T}
    du = fill(convert(T, SimpleRatio(1, 6)), n-1)
    d = fill(convert(T, SimpleRatio(2, 3)), n)
    dl = copy(du)
    dl, d, du
end

"""
`Cubic{Flat}` `OnGrid` amounts to setting `y_1'(x) = 0` at `x = 1`.
Applying this condition yields

    -cm + cp = 0
"""
function prefiltering_system(::Type{T}, ::Type{TC}, n::Int,
                             degree::Cubic{Flat{OnGrid}}) where {T,TC}
    dl, d, du = inner_system_diags(T, n, degree)
    d[1] = d[end] = -oneunit(T)
    du[1] = dl[end] = zero(T)

    # Now Woodbury correction to set `[1, 3], [n, n-2] ==> 1`
    specs = WoodburyMatrices.sparse_factors(T, n, (1, 3, oneunit(T)), (n, n-2, oneunit(T)))

    Woodbury(lut!(dl, d, du), specs...), zeros(TC, n)
end

"""
`Cubic{Flat}`, `OnCell` amounts to setting `y_1'(x) = 0` at `x = 1/2`.
Applying this condition yields

    -9/8 cm + 11/8 c - 3/8 cp + 1/8 cpp = 0

or, equivalently,

    -9 cm + 11 c -3 cp + 1 cpp = 0

(Note that we use `y_1'(x)` although it is strictly not valid in this domain; if we
were to use `y_0'(x)` we would have to introduce new coefficients, so that would not
close the system. Instead, we extend the outermost polynomial for an extra half-cell.)
"""
function prefiltering_system(::Type{T}, ::Type{TC}, n::Int,
                             degree::Cubic{Flat{OnCell}}) where {T,TC}
    dl, d, du = inner_system_diags(T,n,degree)
    d[1] = d[end] = -9
    du[1] = dl[end] = 11

    # now need Woodbury correction to set :
    #    - [1, 3] and [n, n-2] ==> -3
    #    - [1, 4] and [n, n-3] ==> 1
    specs = WoodburyMatrices.sparse_factors(T, n,
                                  (1, 3, T(-3)),
                                  (n, n-2, T(-3)),
                                  (1, 4, oneunit(T)),
                                  (n, n-3, oneunit(T))
                                  )

    Woodbury(lut!(dl, d, du), specs...), zeros(TC, n)
end

"""
`Cubic{Line}` `OnCell` amounts to setting `y_1''(x) = 0` at `x = 1/2`.
Applying this condition yields

    3 cm -7 c + 5 cp -1 cpp = 0

(Note that we use `y_1'(x)` although it is strictly not valid in this domain; if we
were to use `y_0'(x)` we would have to introduce new coefficients, so that would not
close the system. Instead, we extend the outermost polynomial for an extra half-cell.)
"""
function prefiltering_system(::Type{T}, ::Type{TC}, n::Int,
                             degree::Cubic{Line{OnCell}}) where {T,TC}
    dl,d,du = inner_system_diags(T,n,degree)
    d[1] = d[end] = 3
    du[1] = dl[end] = -7

    # now need Woodbury correction to set :
    #    - [1, 3] and [n, n-2] ==> -3
    #    - [1, 4] and [n, n-3] ==> 1
    specs = WoodburyMatrices.sparse_factors(T, n,
                                  (1, 3, T(5)),
                                  (n, n-2, T(5)),
                                  (1, 4, -oneunit(T)),
                                  (n, n-3, -oneunit(T))
                                  )

    Woodbury(lut!(dl, d, du), specs...), zeros(TC, n)
end

"""
`Cubic{Line}` `OnGrid` amounts to setting `y_1''(x) = 0` at `x = 1`. Applying this
condition gives:

    1 cm -2 c + 1 cp = 0
"""
function prefiltering_system(::Type{T}, ::Type{TC}, n::Int,
                             degree::Cubic{Line{OnGrid}}) where {T,TC}
    dl,d,du = inner_system_diags(T,n,degree)
    d[1] = d[end] = 1
    du[1] = dl[end] = -2

    # now need Woodbury correction to set :
    #    - [1, 3] and [n, n-2] ==> 1
    specs = WoodburyMatrices.sparse_factors(T, n,
                                  (1, 3, oneunit(T)),
                                  (n, n-2, oneunit(T)),
                                  )

    Woodbury(lut!(dl, d, du), specs...), zeros(TC, n)
end

"""
`Cubic{Periodic}` `OnGrid` closes the system by looking at the coefficients themselves
as periodic, yielding

    c0 = c(N+1)

where `N` is the number of data points.
"""
function prefiltering_system(::Type{T}, ::Type{TC}, n::Int,
                             degree::Cubic{<:Periodic}) where {T,TC}
    dl, d, du = inner_system_diags(T,n,degree)

    specs = WoodburyMatrices.sparse_factors(T, n,
                                  (1, n, du[1]),
                                  (n, 1, dl[end])
                                  )

    Woodbury(lut!(dl, d, du), specs...), zeros(TC, n)
end

"""
`Cubic{Free}` `OnGrid` and `Cubic{Free}` `OnCell` amount to requiring an extra
continuous derivative at the second-to-last cell boundary; this means
`y_1'''(2) = y_2'''(2)`, yielding

    1 cm -3 c + 3 cp -1 cpp = 0
"""
function prefiltering_system(::Type{T}, ::Type{TC}, n::Int,
                             degree::Cubic{<:Free}) where {T,TC}
    dl, d, du = inner_system_diags(T,n,degree)

    specs = WoodburyMatrices.sparse_factors(T, n,
                                  (1, n, du[1]),
                                  (n, 1, dl[end])
                                  )

    Woodbury(lut!(dl, d, du), specs...), zeros(TC, n)
end

using Test, Interpolations, LinearAlgebra, ForwardDiff

@testset "Hessians" begin
    nx = 5
    k = 2pi/(nx-1)
    f1(x) = sin(k*(x-3) - 1)
    A1 = Float64[f1(x) for x in 1:nx]
    h1 = Array{Float64}(undef, 1, 1)
    A2 = rand(Float64, nx, nx) * 100
    h2 = Array{Float64}(undef, 2, 2)

    for (A, h) in ((A1, h1), (A2, h2))
        for itp in (interpolate(A, BSpline(Constant())),
                    interpolate(A, BSpline(Linear())))
            if ndims(A) == 1
                # Hessian of Constant and Linear should always be 0 in 1d
                for x in InterpolationTestUtils.thirds(axes(A))
                    @test all(iszero, @inferred(Interpolations.hessian(itp, x...)))
                    @test all(iszero, @inferred(Interpolations.hessian!(h, itp, x...)))
                end
            else
                check_hessian(itp, h)
            end
        end

        for BC in (Flat,Line,Free,Periodic,Reflect,Natural), GT in (OnGrid, OnCell)
            itp = interpolate(A, BSpline(Quadratic(BC(GT()))))
            check_hessian(itp, h)
            I = first(eachindex(itp))
            @test Interpolations.hessian(itp, I) == Interpolations.hessian(itp, Tuple(I)...)
        end

        for BC in (Line, Flat, Free, Periodic), GT in (OnGrid, OnCell)
            itp = interpolate(A, BSpline(Cubic(BC(GT()))))
            check_hessian(itp, h)
        end
    end

    itp = interpolate(A2, (BSpline(Quadratic(Flat(OnCell()))), NoInterp()))
    v = A2[:, 2]
    itpcol = interpolate(v, BSpline(Quadratic(Flat(OnCell()))))
    @test @inferred(Interpolations.hessian(itp, 3.2, 2)) == @inferred(Interpolations.hessian(itpcol, 3.2))

    itp = interpolate(A2, (BSpline(Quadratic(Periodic(OnGrid()))), NoInterp()))
    itpcol = interpolate(v, BSpline(Quadratic(Periodic(OnGrid()))))
    @test @inferred(Interpolations.hessian(itp, 1.0, 2)) == @inferred(Interpolations.hessian(itpcol, 1.0))

    @testset "Monotonic" begin
        x = [0.0, 0.2, 0.5, 0.6, 0.9, 1.0]
        ys = [[-3.0, 0.0, 5.0, 10.0, 18.0, 22.0],
              [10.0, 0.0, -5.0, 10.0, -8.0, -2.0]]
        grid = 0.0:0.1:1.0

        itypes = [LinearMonotonicInterpolation(),
            FiniteDifferenceMonotonicInterpolation(),
            CardinalMonotonicInterpolation(0.0),
            CardinalMonotonicInterpolation(0.5),
            CardinalMonotonicInterpolation(1.0),
            AkimaMonotonicInterpolation(),
            FritschCarlsonMonotonicInterpolation(),
            FritschButlandMonotonicInterpolation(),
            SteffenMonotonicInterpolation()]

        for y in ys
            for it in itypes
                itp = interpolate(x, y, it)
                for t in grid
                    hessval = ForwardDiff.hessian(u -> itp(u[1]), [t])[1, 1]
                    @test Interpolations.hessian1(itp, t) ≈ hessval atol = 1.e-12
                    @test Interpolations.hessian(itp, t)[1] ≈ hessval atol = 1.e-12
                end
            end
        end
    end
end

using Gadfly, DataFrames

i = indexin([Float64], [eltypes...])[1]
tconstr = tconstr[:,:,i]
teval = teval[:,:,i]

# Convert to dataframes, and for teval use points/second
dim = ones(Int,size(tconstr,1))*(1:size(tconstr,2))'
namelist = collect(take(cycle(testnames), length(dim)))
ordlist =  collect(take(cycle(testord), length(dim)))
dfconstr = DataFrame(t = vec(tconstr), name = namelist, ord = ordlist, dim = vec(dim))
dfeval   = DataFrame(rate = vec((10^6) ./ teval), name = namelist, ord = ordlist, dim = vec(dim))

flagBspline = (dfconstr[:name] .== "IBSpline") | (dfconstr[:name] .== "Grid")
dfBconstr = dfconstr[flagBspline, :]
dfBeval   = dfeval[flagBspline, :]
dfGconstr = dfconstr[!flagBspline, :]
dfGeval   = dfeval[!flagBspline, :]

yscale = Scale.y_continuous

# Plot the B-spline methods
plotsize = (6inch, 8inch)
set_default_plot_size(plotsize...)
pBc = plot(dfBconstr, xgroup="dim", ygroup="ord", x="name", y="t", Geom.subplot_grid(Geom.point), yscale, Guide.ylabel("Time (s) by order"))
draw(PNG("constructionB.png", plotsize...), pBc)

pBr = plot(dfBeval, xgroup="dim", ygroup="ord", x="name", y="rate", Geom.subplot_grid(Geom.point), yscale, Guide.ylabel("Throughput (pts/s) by order"))
draw(PNG("rateB.png", plotsize...), pBr)

# Plot the gridded methods
plotsize = (10inch, 8inch)
set_default_plot_size(plotsize...)

pGc = plot(dfGconstr, xgroup="dim", ygroup="ord", x="name", y="t", Geom.subplot_grid(Geom.point), yscale, Guide.ylabel("Time (s) by order"))
draw(PNG("constructionG.png", plotsize...), pGc)

pGr = plot(dfGeval, xgroup="dim", ygroup="ord", x="name", y="rate", Geom.subplot_grid(Geom.point), Scale.y_sqrt, Guide.ylabel("Throughput (pts/s) by order"))
draw(PNG("rateG.png", plotsize...), pGr)

using BenchmarkTools, Base.Cartesian
using Interpolations

const suite = BenchmarkGroup()

suite["bsplines"] = BenchmarkGroup()
for bspline in ["constant", "linear", "quadratic", "cubic"]
    suite["bsplines"][bspline] = BenchmarkGroup()
end

# To evaluate at fractional positions without any "unnecessary"
# overhead, safer to use Base.Cartesian
@generated function sumvalues(itp::AbstractInterpolation{T,N}, inds) where {T,N}
    quote
        @nexprs $N d->inds_d = inds[d]
        s = zero(eltype(itp))
        @inbounds @nloops $N i d->inds_d begin
            s += @ncall($N, itp, i)
        end
        s
    end
end

function sumvalues_indices(itp)
    inds = axes(itp)
    n = Int(round(10^(3/ndims(itp))))
    ntuple(d->collect(range(first(inds[d])+0.001, stop=last(inds[d])-0.001, length=n)), ndims(itp))
end

strip_prefix(str::AbstractString) = replace(str, "Interpolations."=>"")
benchstr(::Type{T}) where {T<:Interpolations.GridType} = strip_prefix(string(T))

benchstr(::Type{<:Constant}) = "Constant()"
benchstr(::Type{Linear}) = "Linear()"
benchstr(::Type{Quadratic{BC}}, ::Type{GT}) where {BC<:Interpolations.BoundaryCondition,GT<:Interpolations.GridType} =
    string("Quadratic(", strip_prefix(string(BC)), "(", strip_prefix(string(GT)), "()))")
benchstr(::Type{Cubic{BC}}, ::Type{GT}) where {BC<:Interpolations.BoundaryCondition,GT<:Interpolations.GridType} =
    string("Cubic(", strip_prefix(string(BC)), "(", strip_prefix(string(GT)), "()))")

groupstr(::Type{<:Constant}) = "constant"
groupstr(::Type{Linear}) = "linear"
groupstr(::Type{Quadratic}) = "quadratic"
groupstr(::Type{Cubic}) = "cubic"


for A in (collect(Float64, 1:3),
          reshape(collect(Float64, 1:9), 3, 3),
          reshape(collect(Float64, 1:27), 3, 3, 3))
    # Constant & Linear
    for D in (Constant, Linear)
        gstr = groupstr(D)
        Ac = copy(A)
        idstr = string(ndims(A), "d_", benchstr(D), '_', benchstr(OnGrid))
        suite["bsplines"][gstr][string(idstr, "_construct")] =
            @benchmarkable interpolate($Ac, BSpline($D()))
        itp = interpolate(copy(A), BSpline(D()))
        inds = sumvalues_indices(itp)
        suite["bsplines"][gstr][string(idstr, "_use")] =
            @benchmarkable sumvalues($itp, $inds)
    end
    # Quadratic
    gstr = groupstr(Quadratic)
    for BC in (Flat,Line,Free,Periodic,Reflect,Natural), GT in (OnGrid, OnCell)
        Ac = copy(A)
        idstr = string(ndims(A), "d_", benchstr(Quadratic{BC}, GT))
        suite["bsplines"][gstr][string(idstr, "_construct")] =
            @benchmarkable interpolate($Ac, BSpline(Quadratic($BC($GT()))))
        itp = interpolate(copy(A), BSpline(Quadratic(BC(GT()))))
        inds = sumvalues_indices(itp)
        suite["bsplines"][gstr][string(idstr, "_use")] =
            @benchmarkable sumvalues($itp, $inds)
    end
    for BC in (InPlace,InPlaceQ)
        Ac = copy(A)
        idstr = string(ndims(A), "d_", benchstr(Quadratic{BC}, OnCell))
        suite["bsplines"][gstr][string(idstr, "_construct")] =
            @benchmarkable interpolate!($Ac, BSpline(Quadratic($BC(OnCell()))))
        itp = interpolate!(copy(A), BSpline(Quadratic(BC(OnCell()))))
        inds = sumvalues_indices(itp)
        suite["bsplines"][gstr][string(idstr, "_use")] =
            @benchmarkable sumvalues($itp, $inds)
    end
    # Cubic
    gstr = groupstr(Cubic)
    for BC in (Flat,Line,Free,Periodic), GT in (OnGrid, OnCell)
        Ac = copy(A)
        idstr = string(ndims(A), "d_", benchstr(Cubic{BC}, GT))
        suite["bsplines"][gstr][string(idstr, "_construct")] =
            @benchmarkable interpolate($Ac, BSpline(Cubic($BC($GT()))))
        itp = interpolate(copy(A), BSpline(Cubic(BC(GT()))))
        inds = sumvalues_indices(itp)
        suite["bsplines"][gstr][string(idstr, "_use")] =
            @benchmarkable sumvalues($itp, $inds)
    end
end

paramspath = joinpath(dirname(@__FILE__), "params.json")

if isfile(paramspath)
    loadparams!(suite, BenchmarkTools.load(paramspath)[1], :evals);
else
    @info "Tuning suite (this may take a while)"
    tune!(suite)
    BenchmarkTools.save(paramspath, params(suite));
end

# To run the benchmarks:
# results = run(suite, verbose = true, seconds = 1)
# BenchmarkTools.save(filename, results)

function Base.showarg(io::IO, A::BSplineInterpolation{T,N,TW,ST}, toplevel) where {T,N,TW,ST}
    print(io, "interpolate(")
    Base.showarg(io, A.coefs, false)
    print(io, ", ")
    show(io, itpflag(A))
    if toplevel
        print(io, ") with element type ",T)
    else
        print(io, ')')
    end
end

function Base.showarg(io::IO, A::GriddedInterpolation{T,N,TC,ST,K}, toplevel) where {T,N,TC,ST,K}
    print(io, "interpolate(")
    _showknots(io, A.knots)
    print(io, ", ")
    Base.showarg(io, A.coefs, false)
    print(io, ", ")
    show(io, itpflag(A))
    if toplevel
        print(io, ") with element type ",T)
    else
        print(io, ')')
    end
end

_showknots(io, A) = Base.showarg(io, A, false)
function _showknots(io, tup::NTuple{N,Any}) where N
    print(io, '(')
    for (i, A) in enumerate(tup)
        if A isa AbstractRange
            show(io, A)
        else
            Base.showarg(io, A, false)
        end
        i < N && print(io, ',')
    end
    N == 1 && print(io, ',')
    print(io, ')')
end

function Base.showarg(io::IO, A::ScaledInterpolation{T}, toplevel) where {T}
    print(io, "scale(")
    Base.showarg(io, A.itp, false)
    print(io, ", ", A.ranges, ')')
    if toplevel
        print(io, " with element type ",T)
    end
end

function Base.showarg(io::IO, A::MonotonicInterpolation{T, TCoeffs, Tel, Type, K}, toplevel) where {T, TCoeffs, Tel, Type, K}
    print(io, "interpolate(")
    _showknots(io, A.knots)
    print(io, ", ")
    Base.showarg(io, A.A, false)
    print(io, ", ")
    show(io, A.it)
    if toplevel
        print(io, ") with element type ",T)
    else
        print(io, ')')
    end
end

function Base.showarg(io::IO, A::Extrapolation{T,N,TI,IT,ET}, toplevel) where {T,N,TI,IT,ET}
    print(io, "extrapolate(")
    Base.showarg(io, A.itp, false)
    print(io, ", ")
    show(io, etpflag(A))
    print(io, ')')
    if toplevel
        print(io, " with element type ",T)
    end
end

function Base.showarg(io::IO, A::FilledExtrapolation{T,N,TI,IT}, toplevel) where {T,N,TI,IT}
    print(io, "extrapolate(")
    Base.showarg(io, A.itp, false)
    print(io, ", ", A.fillvalue, ')')
    if toplevel
        print(io, " with element type ",T)
    end
end

"""
    show_ranged(io, X, knots)

A replacement for the default array-`show` for types that may not have the canonical evaluation points.
`rngs` is the tuple of knots along each axis.
"""
function show_ranged(io::IO, X, knots)
    summary(io, X)
    isempty(X) && return
    print(io, ":")
    if !(haskey(io, :compact)) && length(axes(X, 2)) > 1
        io = IOContext(io, :compact => true)
    end
    if get(io, :limit, false) && eltype(X) === Method
        io = IOContext(io, :limit => false)
    end
    if get(io, :limit, false) && (displaysize(io))[1] - 4 <= 0
        return print(io, " …")
    else
        println(io)
    end
    io = IOContext(io, :typeinfo => eltype(X))
    Base.print_array(io, [X(x...) for x in Iterators.product(knots...)])
end

getknots(X::BSplineInterpolation)   = axes(X)
getknots(X::ScaledInterpolation)    = X.ranges
getknots(X::GriddedInterpolation)   = X.knots
getknots(X::AbstractExtrapolation)  = getknots(parent(X))
getknots(X::MonotonicInterpolation) = (X.knots,)

Base.show(io::IO, ::MIME{Symbol("text/plain")}, X::ScaledInterpolation)    = show_ranged(io, X, getknots(X))
Base.show(io::IO, ::MIME{Symbol("text/plain")}, X::GriddedInterpolation)   = show_ranged(io, X, getknots(X))
Base.show(io::IO, ::MIME{Symbol("text/plain")}, X::AbstractExtrapolation)  = show_ranged(io, X, getknots(X))
Base.show(io::IO, ::MIME{Symbol("text/plain")}, X::MonotonicInterpolation) = show_ranged(io, X, getknots(X))

# these are called by show(X)
Base.show(io::IO, X::ScaledInterpolation)    = show_ranged(io, X, getknots(X))
Base.show(io::IO, X::GriddedInterpolation)   = show_ranged(io, X, getknots(X))
Base.show(io::IO, X::AbstractExtrapolation)  = show_ranged(io, X, getknots(X))
Base.show(io::IO, X::MonotonicInterpolation) = show_ranged(io, X, getknots(X))

using Interpolations
#using DataFrames, Gadfly

f(x) = sin(2pi * (x-1) / 10)
dfs = Array{DataFrame}(0)
xrange = .5:.1:11.5

for (i,it) in enumerate((
    BSpline(Constant()),
    BSpline(Linear()),
    BSpline(Quadratic(Free()))
    ))
    itp = interpolate(f(1:11), it, OnCell())
    push!(dfs, DataFrame(x=xrange,y=[itp[x]+(i-1)*3 for x in xrange],t="$it"))
end

push!(dfs, DataFrame(x=xrange, y=f(xrange),t="Data"))
df = vcat(dfs)
#display(plot(df,x=:x,y=:y,color=:t,Geom.path,Guide.colorkey("Dataset")))
    

using Test
using Interpolations
using Unitful
@testset "Monotonic" begin
    xa = [[0.0, 0.2, 0.5, 0.6, 0.9, 1.0],
          [0.0, 0.2, 0.5, 0.6, 0.9, 1.0]u"s"]
    y = [(true, [-3.0, 0.0, 5.0, 10.0, 18.0, 22.0]),
         (false, [10.0, 0.0, -5.0, 10.0, -8.0, -2.0]),
         (false, [10.0, 0.0, -5.0, 10.0, -8.0, -2.0]u"m"),
         (true, [-3.0, 0.0, 5.0, 10.0, 18.0, 22.0]u"m")]

    # second item indicates if interpolating function can overshoot
    # for non-monotonic data
    itypes = [(LinearMonotonicInterpolation(), false),
        (FiniteDifferenceMonotonicInterpolation(), true),
        (CardinalMonotonicInterpolation(0.0), true),
        (CardinalMonotonicInterpolation(0.5), true),
        (CardinalMonotonicInterpolation(1.0), false),
        (AkimaMonotonicInterpolation(), true),
        (FritschCarlsonMonotonicInterpolation(), true),
        (FritschButlandMonotonicInterpolation(), false),
        (SteffenMonotonicInterpolation(), false)]

    for (it, overshoot) in itypes
        for yi in 1:length(y), x in xa
            monotonic, ys = y[yi]
            itp = interpolate(x, ys, it)
            for j in 1:6
                # checking values at nodes
                @test itp(x[j]) ≈ ys[j] rtol = 1.e-15 atol = 1.e-14*unit(first(ys))

                # checking overshoot for non-monotonic data
                # and monotonicity for monotonic data
                if !monotonic && overshoot
                    continue
                end
                if j < 6
                    r = range(x[j], stop = x[j+1], length = 100)
                    for k in 1:length(r)-1
                        @test (ys[j+1] - ys[j]) * (itp(r[k+1]) - itp(r[k])) >= zero(first(ys)^2)
                    end
                end
            end
            extFlatItp = extrapolate(itp, Flat())
            @test extFlatItp(x[1]-oneunit(x[1])) ≈ itp(x[1])
            @test extFlatItp(x[end]+oneunit(x[1])) ≈ itp(x[end])
            extThrowItp = extrapolate(itp, Throw())
            @test_throws BoundsError extThrowItp(x[1]-oneunit(x[1]))
            @test_throws BoundsError extThrowItp(x[end]+oneunit(x[1]))
            extLineItp = extrapolate(itp, Line())
            @test extLineItp(x[1]-oneunit(x[1])) ≈ itp(x[1]) - Interpolations.gradient1(itp, x[1])*oneunit(x[1])
            @test extLineItp(x[end]+oneunit(x[1])) ≈ itp(x[end]) + Interpolations.gradient1(itp, x[end])*oneunit(x[1])
            extReflectItp = extrapolate(itp, Reflect())
            @test extReflectItp(x[1]-0.1*oneunit(x[1])) ≈ itp(x[1]+0.1*oneunit(x[1]))
            @test extReflectItp(x[end]+0.1*oneunit(x[1])) ≈ itp(x[end]-0.1*oneunit(x[1]))
            extPeriodicItp = extrapolate(itp, Periodic())
            @test extPeriodicItp(x[1]-0.1*oneunit(x[1])) ≈ itp(x[end]-0.1*oneunit(x[1]))
            @test extPeriodicItp(x[end]+0.1*oneunit(x[1])) ≈ itp(x[1]+0.1*oneunit(x[1]))
        end
    end

    # fail tests
    xWrong = [0.0, 1.0, -5.0, 3.0]
    y2 = [1.0, 2.0, 3.0, 4.0]
    y3 = [-3.0 0.0 5.0 10.0 18.0 22.0]

    for (it, overshoot) in itypes, x in xa
        @test_throws ErrorException interpolate(xWrong, y2, it)
        @test_throws DimensionMismatch interpolate(x, y2, it)
        @test_throws MethodError interpolate(x, y3, it)
    end

    # Issue 535
    struct MyArray
        a::Vector{Real} # Not recommended
    end
    x = 1:5
    y = MyArray(
        map(1:5) do x
            x + rand()
        end
    )
    interp = interpolate(
        x,
        y.a,
        FritschCarlsonMonotonicInterpolation()
    )
    @test interp.(x) ≈ y.a
end

using Interpolations, DualNumbers, Test, LinearAlgebra

@testset "ScalingDimspecTests" begin
    xs = -pi:(2pi/10):pi-2pi/10
    ys = -2:.1:2
    f(x,y) = sin(x) * y^2

    itp = interpolate(Float64[f(x,y) for x in xs, y in ys], (BSpline(Quadratic(Periodic(OnGrid()))), BSpline(Linear())))
    sitp = scale(itp, xs, ys)

    for (ix,x) in enumerate(xs), (iy,y) in enumerate(ys)
        @test ≈(sitp(x,y),f(x,y),atol=sqrt(eps(1.0)))

        g = Interpolations.gradient(sitp, x, y)
        fx = epsilon(sitp(dual(x,1), dual(y,0)))
        fy = epsilon(sitp(dual(x,0), dual(y,1)))

        @test ≈(g[1],fx,atol=sqrt(eps(1.0)))
        @test ≈(g[2],fy,atol=sqrt(eps(1.0)))
    end
end

struct Extrapolation{T,N,ITPT,IT,ET} <: AbstractExtrapolation{T,N,ITPT,IT}
    itp::ITPT
    et::ET
end

function Base.:(==)(o1::Extrapolation, o2::Extrapolation)
    o1.et == o2.et &&
    o1.itp == o2.itp
end

Base.parent(A::Extrapolation) = A.itp
itpflag(etp::Extrapolation) = itpflag(etp.itp)

# DimSpec{Flag} is not enough for extrapolation dispatch, since we allow nested tuples
# However, no tuples should be nested deeper than this; the first level is for different
# schemes in different dimensions, and the second level is for different schemes in
# different directions.
const ExtrapDimSpec = Union{BoundaryCondition,Tuple{Vararg{Union{BoundaryCondition,NTuple{2,BoundaryCondition}}}}}

etptype(::Extrapolation{T,N,ITPT,IT,ET}) where {T,N,ITPT,IT,ET} = ET
etpflag(etp::Extrapolation{T,N,ITPT,IT,ET}) where {T,N,ITPT,IT,ET} = etp.et

BoundsCheckStyle(etp::AbstractExtrapolation) = CheckWillPass()

"""
`extrapolate(itp, scheme)` adds extrapolation behavior to an interpolation object, according to the provided scheme.

The scheme can take any of these values:

* `Throw` - throws a BoundsError for out-of-bounds indices
* `Flat` - for constant extrapolation, taking the closest in-bounds value
* `Line` - linear extrapolation (the wrapped interpolation object must support gradient)
* `Reflect` - reflecting extrapolation (indices must support `mod`)
* `Periodic` - periodic extrapolation (indices must support `mod`)

You can also combine schemes in tuples. For example, the scheme `(Line(), Flat())` will use linear extrapolation in the first dimension, and constant in the second.

Finally, you can specify different extrapolation behavior in different direction. `((Line(),Flat()), Flat())` will extrapolate linearly in the first dimension if the index is too small, but use constant etrapolation if it is too large, and always use constant extrapolation in the second dimension.
"""
extrapolate(itp::AbstractInterpolation{T,N,IT}, et::ET) where {T,N,IT,ET<:ExtrapDimSpec} =
    Extrapolation{T,N,typeof(itp),IT,ET}(itp, et)

count_interp_dims(::Type{<:Extrapolation{T,N,ITPT}}, n) where {T,N,ITPT} = count_interp_dims(ITPT, n)

@propagate_inbounds function (etp::Extrapolation{T,N})(x::Vararg{Number,N}) where {T,N}
    itp = parent(etp)
    eflag = etpflag(etp)
    xs = inbounds_position(eflag, bounds(itp), x, etp, x)
    itpval = @inbounds(itp(xs...))
    ((xs == x) & allisreal(x)) && return itpval
    g = @inbounds gradient(itp, xs...)
    extrapolate_value(eflag, skip_flagged_nointerp(itp, x), skip_flagged_nointerp(itp, xs), Tuple(g), itpval)
end
@inline function (etp::Extrapolation{T,N})(x::Vararg{Union{Number,AbstractVector},N}) where {T,N}
    # The eltype of the args may change the return type
    Tret = promote_type(T, eltype.(x)...)
    # Only allow concrete return types
    Tret = isconcretetype(Tret) ? Tret : T
    ret = zeros(Tret, shape(x...))
    for (i, y) in zip(eachindex(ret), Iterators.product(x...))
        ret[i] = etp(y...)
    end
    return ret
end

@inline function gradient(etp::AbstractExtrapolation{T,N}, x::Vararg{Number,N}) where {T,N}
    itp = parent(etp)
    if checkbounds(Bool, itp, x...)
        gradient(itp, x...)
    else
        eflag = tcollect(etpflag, etp)
        xs = inbounds_position(eflag, bounds(itp), x, etp, x)
        g = @inbounds gradient(itp, xs...)
        skipni = Base.Fix1(skip_flagged_nointerp, itp)
        SVector(map(extrapolate_gradient, skipni(eflag), skipni(x), skipni(xs), Tuple(g)))
    end
end

@inline function hessian(etp::AbstractExtrapolation{T,N}, x::Vararg{Number,N}) where {T,N}
    itp = parent(etp)
    if checkbounds(Bool, itp, x...)
        hessian(itp, x...)
    else
        error("extrapolation of hessian not yet implemented")
        # # copied from gradient above, with obvious modifications
        # # but final part is missing
        # eflag = tcollect(etpflag, etp)
        # xs = inbounds_position(eflag, bounds(itp), x, etp, x)
        # h = @inbounds hessian(itp, xs...)
        # skipni = t->skip_flagged_nointerp(itp, t)
        # # not sure if it should be just h here instead of Tuple(h)
        # # extrapolate_hessian needs to be written
        # # SVector is likely also wrong here
        # SVector(extrapolate_hessian.(skipni(eflag), skipni(x), skipni(xs), Tuple(h)))
    end
end

checkbounds(::Bool, ::AbstractExtrapolation, I...) = true

# The last two arguments are just for error-reporting
function inbounds_position(eflag, bounds, x, etp, xN)
    item = inbounds_index(getfirst(eflag), bounds[1], x[1], etp, xN)
    (item, inbounds_position(getrest(eflag), Base.tail(bounds), Base.tail(x), etp, xN)...)
end
inbounds_position(::Any, ::Tuple{}, ::Tuple{}, etp, xN) = ()

# By default, convert all calls to 2-sided calls
inbounds_index(flag::Flag, bounds, x, etp, xN) = inbounds_index((flag, flag), bounds, x, etp, xN)
# But some one-sided calls can be handled more efficiently that way
function inbounds_index(::Throw, (l,u), x, etp, xN)
    @boundscheck(l <= x <= u || Base.throw_boundserror(etp, xN))
    x
end
inbounds_index(::Periodic, (l,u), x, etp, xN) = periodic(x, l, u)
inbounds_index(::Reflect, (l,u), x, etp, xN) = reflect(x, l, u)

# Left-then-right implementations
function inbounds_index((flagl,flagu)::Tuple{Throw,Flag}, (l,u), x, etp, xN)
    @boundscheck(l <= x || Base.throw_boundserror(etp, xN))
    inbounds_index((nothing,flagu), (l,u), x, etp, xN)
end
function inbounds_index((flagl,flagu)::Tuple{Nothing,Throw}, (l,u), x, etp, xN)
    @boundscheck(x <= u || Base.throw_boundserror(etp, xN))
    x
end

function inbounds_index((flagl,flagu)::Tuple{Union{Flat,Line},Flag}, (l,u), x, etp, xN)
    inbounds_index((nothing,flagu), (l,u), maxp(l,x), etp, xN)
end
function inbounds_index((flagl,flagu)::Tuple{Nothing,Union{Flat,Line}}, (l,u), x, etp, xN)
    minp(x,u)
end

function inbounds_index((flagl,flagu)::Tuple{Periodic,Flag}, (l,u), x, etp, xN)
    inbounds_index((nothing,flagu), (l,u), periodic(x, l, u), etp, xN)
end
function inbounds_index((flagl,flagu)::Tuple{Nothing,Periodic}, (l,u), x, etp, xN)
    periodic(x, l, u)
end

function inbounds_index((flagl,flagu)::Tuple{Reflect,Flag}, (l,u), x, etp, xN)
    inbounds_index((nothing,flagu), (l,u), reflect(x, l, u), etp, xN)
end
function inbounds_index((flagl,flagu)::Tuple{Nothing,Reflect}, (l,u), x, etp, xN)
    reflect(x, l, u)
end

minp(a::T, b::T) where T = min(a, b)
minp(a, b) = min(promote(a, b)...)
maxp(a::T, b::T) where T = max(a, b)
maxp(a, b) = max(promote(a, b)...)

function reflect(y, l, u)
    yr = mod(y - l, 2(u-l)) + l
    return ifelse(yr > u, 2u-yr, yr)
end

periodic(y, l, u) = mod(y-l, u-l) + l


@inline function extrapolate_value(eflag, x, xs, g, val)
    val = extrapolate_axis(getfirst(eflag), x[1], xs[1], g[1], val)
    extrapolate_value(getrest(eflag), Base.tail(x), Base.tail(xs), Base.tail(g), val)
end
extrapolate_value(::Any, ::Tuple{}, ::Tuple{}, ::Tuple{}, val) = val

extrapolate_axis(::Flag, x, xs, g, val) = val
extrapolate_axis(::Line, x, xs, g, val) = val + (x-xs)*g

extrapolate_axis((flagl,flagu)::Tuple{Flag,Flag}, x, xs, g, val) =
    extrapolate_axis((nothing,flagu), x, xs, g, val)
extrapolate_axis((flagl,flagu)::Tuple{Nothing,Flag}, x, xs, g, val) = val

extrapolate_axis((flagl,flagu)::Tuple{Line, Flag}, x, xs, g, val) =
    extrapolate_axis((nothing,flagu), x, xs, g, ifelse(x < xs, val + (x-xs)*g, val))
extrapolate_axis((flagl,flagu)::Tuple{Nothing, Line}, x, xs, g, val) =
    ifelse(x > xs, val + (x-xs)*g, val)

extrapolate_gradient(::Flat, x, xs, g) = ifelse(x==xs, g, zero(g))
extrapolate_gradient(::Flag, x, xs, g) = g

include("filled.jl")

module OnGridTests

using Interpolations, Test

nx, ny, nz = 10, 8, 9
xg, yg, zg = 1:nx, 1:ny, 1:nz

f1(x) = sin(2pi/nx * (x-1))
f2(x,y) = f1(x) * cos(4pi/ny * (y-1))
f3(x,y,z) = f2(x,y) * log(z)

simpledegs = (Linear,Constant)
bcdegs = (Quadratic,)
gridbehvs = (OnCell,OnGrid)
bcs = (Flat,Line,Free,Periodic,Reflect)

function OneD()
    println("Testing evaluation on grid and boundary in 1D...")
    for deg in simpledegs, gb in gridbehvs
        fg = Float64[f1(x) for x in xg]

        itp = Interpolation(fg, deg(gb()), ExtrapError())

        for i in xg
            @test ≈(itp[i],fg[i],atol=sqrt(eps()))
        end

        if gb == OnCell
            for xb in [.5, nx+.5]
                itp[xb] # if we're out of bounds, this throws
            end
        end
    end

    for deg in bcdegs, gb in gridbehvs, bc in bcs
        fg = Float64[f1(x) for x in xg]

        itp = Interpolation(fg, deg(bc(),gb()), ExtrapError())

        for i in xg
            @test ≈(itp[i],fg[i],atol=sqrt(eps()))
        end

        if gb == OnCell
            for xb in [.5, nx+.5]
                itp[xb]
            end
        end
    end
end

function TwoD()
    println("Testing evaluation on grid and boundary in 2D...")
    for deg in simpledegs, gb in gridbehvs
        fg = Float64[f2(x,y) for x in xg, y in yg]
        itp = Interpolation(fg, deg(gb()), ExtrapError())

        for i in xg, j in yg
            @test ≈(itp[i,j],fg[i,j],atol=sqrt(eps()))
        end

        if gb == OnCell
            for xb in [.5, nx+.5], yb in [.5,ny+.5]
                itp[xb,yb]
            end
        end
    end

    for deg in bcdegs, gb in gridbehvs, bc in bcs
        fg = Float64[f2(x,y) for x in xg, y in yg]
        itp = Interpolation(fg, deg(bc(),gb()), ExtrapError())

        for i in xg, j in yg
            @test ≈(itp[i,j],fg[i,j],atol=sqrt(eps()))
        end

        if gb == OnCell
            for xb in [.5, nx+.5], yb in [.5,ny+.5]
                itp[xb,yb]
            end
        end
    end
end

function ThreeD()
    println("Testing evaluation on grid and boundary in 3D...")
    for deg in simpledegs, gb in gridbehvs
        fg = Float64[f3(x,y,z) for x in xg, y in yg, z in zg]
        itp = Interpolation(fg, deg(gb()), ExtrapError())

        for i in xg, j in yg, k in zg
            @test ≈(itp[i,j,k],fg[i,j,k],atol=sqrt(eps()))
        end

        if gb == OnCell
            for xb in [.5, nx+.5], yb in [.5,ny+.5], zb in [.5, nz+.5]
                itp[xb,yb,zb]
            end
        end
    end

    for deg in bcdegs, gb in gridbehvs, bc in bcs
        fg = Float64[f3(x,y,z) for x in xg, y in yg, z in zg]
        itp = Interpolation(fg, deg(bc(),gb()), ExtrapError())

        for i in xg, j in yg, k in zg
            @test ≈(itp[i,j,k],fg[i,j,k],atol=sqrt(eps()))
        end

        if gb == OnCell
            for xb in [.5, nx+.5], yb in [.5,ny+.5], zb in [.5, nz+.5]
                itp[xb,yb,zb]
            end
        end
    end
end

OneD()
TwoD()
ThreeD()

end

using Documenter, Interpolations
makedocs(
sitename="Interpolations.jl",
modules=[Interpolations],
format=Documenter.HTML(prettyurls = get(ENV, "CI", nothing)=="true"),
pages=["Home" => "index.md",
        "Convenience Constructors" => "convenience-construction.md",
        "General usage" => "interpolations.md",
        "Interpolation algorithms" => "control.md",
        "Extrapolation" => "extrapolation.md",
        "Knot Iteration" => "iterate.md",
        "Developer documentation" => "devdocs.md",
        "Library" => "api.md",
        "News and Changes" => "NEWS.md",
        "Other Interpolation Packages" => "other_packages.md",
],
strict=true,
)

deploydocs(repo="github.com/JuliaMath/Interpolations.jl.git",
            push_preview=true)

export rrule
"""
    ChainRulesCore.rrule(itp::AbstractInterpolation, x...)

ChainRulesCore.jl `rrule` for integration with automatic differentiation libraries.
Note that it gives the gradient only with respect to the evaluation point `x`,
and not the data inside `itp`.
"""
function ChainRulesCore.rrule(itp::AbstractInterpolation, x...)
    y = itp(x...)
    function interpolate_pullback(Δy)
        nope = ChainRulesCore.@not_implemented "`Interpolations.gradient` does not calculate a gradient with respect to the original data, only the evaluation point"
        (nope, (sum(Δy .* g) for g in Interpolations.gradient(itp, x...))...)
    end
    y, interpolate_pullback
end

using Interpolations, Test

@testset "LinearTests" begin
    front(r::AbstractUnitRange) = first(r):last(r)-1
    front(r::AbstractRange) = range(first(r), step=step(r), length=length(r)-1)

    for D in (Constant, Linear)
        for constructor in (interpolate, interpolate!)
            isinplace = constructor == interpolate!
            ## 1D
            a = rand(5)
            knots = (range(1, stop=length(a), length=length(a)),)
            itp = @inferred(constructor(knots, a, Gridded(D())))
            @inferred(itp(2))
            @inferred(itp(CartesianIndex(2)))
            for i = 1:length(a)
                @test itp(i) ≈ a[i]
                @test itp(CartesianIndex(i)) ≈ a[i]
            end
            @inferred(itp(knots...))
            @test itp(knots...) ≈ a
            # compare scalar indexing and vector indexing
            x = front(knots[1] .+ 0.1)
            v = itp(x)
            for i = 1:length(x)
                @test v[i] ≈ itp(x[i])
            end
            x = [2.3,2.2]   # non-increasing order
            v = itp(x)
            for i = 1:length(x)
                @test v[i] ≈ itp(x[i])
            end
            # compare against BSpline
            itpb = @inferred(constructor(a, BSpline(D())))
            for x in range(1.1, stop=4.9, length=101)
                @test itp(x) ≈ itpb(x)
            end

            knots = (range(0.0, stop=1.0, length=length(a)),)
            itp = @inferred(constructor(knots, a, Gridded(D())))
            @test itp([0.1, 0.2, 0.3]) == [itp(0.1), itp(0.2), itp(0.3)]

            ## 2D
            A = rand(6,5)
            knots = (range(1, stop=size(A,1), length=size(A,1)), range(1, stop=size(A,2), length=size(A,2)))
            itp = @inferred(constructor(knots, A, Gridded(D())))
            isinplace && @test parent(itp) === A
            @inferred(itp(2, 2))
            @inferred(itp(CartesianIndex((2,2))))
            for j = 2:size(A,2)-1, i = 2:size(A,1)-1
                @test itp(i,j) ≈ A[i,j]
                @test itp(CartesianIndex((i,j))) ≈ A[i,j]
            end
            @test itp(knots...) ≈ A
            @inferred(itp(knots...))
            # compare scalar indexing and vector indexing
            x, y = front(knots[1] .+ 0.1), front(knots[2] .+ 0.6)
            v = itp(x,y)
            for j = 1:length(y), i = 1:length(x)
                @test v[i,j] ≈ itp(x[i],y[j])
            end
            # check the fallback vector indexing
            x = [2.3,2.2]   # non-increasing order
            y = [3.5,2.8]
            v = itp(x,y)
            for j = 1:length(y), i = 1:length(x)
                @test v[i,j] ≈ itp(x[i],y[j])
            end
            # compare against BSpline
            itpb = @inferred(constructor(A, BSpline(D())))
            for x in range(1.1, stop=5.9, length=101), y in range(1.1, stop=4.9, length=101)
                @test itp(x,y) ≈ itpb(x,y)
            end

            A = rand(8,20)
            knots = ([x^2 for x = 1:8], [0.2y for y = 1:20])
            itp = constructor(knots, A, Gridded(D()))
            @test itp(4,1.2) ≈ A[2,6]
        end
    end

    # issue #248
    itp = interpolate((1001:1005,), 1:5, Gridded(Linear()))
    @test itp(1002) ≈ 2

    # issue #255
    itp = interpolate(([1,2,3],), [1.0f0, 2.0f0, 1.0f0], Gridded(Linear()))
    @test itp(2) === 2.0f0
    @test itp(2.0) === 2.0
    @test itp(2.0f0) === 2.0f0

    # trailing 1s, issue #301
    @test itp(1.8, 1) == itp(1.8)

    # issue #395
    knots = ([0.0,0.0,1.0],) # not unique
    # Further discussion determined this should be a warning rather than an error
    # https://github.com/JuliaMath/Interpolations.jl/commit/318ebc88ca1fc084754f3c741266537f901a3310
    knots_not_unique_warning = "Duplicated knots were deduplicated. Use Interpolations.deduplicate_knots!(knots) explicitly to avoid this warning."
    @test_logs (:warn, knots_not_unique_warning) interpolate(knots, [1.0, 1.1, 2.0], Gridded(Linear()))

    # knot deduplication, issue #467, PR #468
    duplicated_knots = [1.0, 1.0, 1.0, nextfloat(1.0), nextfloat(1.0)]
    successive_knots_warning = "Successive repeated knots detected. Consider using `move_knots` keyword to Interpolations.deduplicate_knots!"
    @test_logs (:warn, successive_knots_warning) Interpolations.deduplicate_knots!(duplicated_knots)
    @test allunique(duplicated_knots)

    # inplace gridded interpolation, issue #495
    knots = ([0., 1.],)
    y = view([1., 2.], :)
    f1 = interpolate(knots, y, Gridded(Linear()))
    f2 = interpolate!(knots, y, Gridded(Linear()))
    y .= 0
    @test f1(0.5) ≈ 1.5
    @test f2(0.5) ≈ 0
end

export ScaledInterpolation, eachvalue

import Base: iterate

struct ScaledInterpolation{T,N,ITPT,IT,RT} <: AbstractInterpolationWrapper{T,N,ITPT,IT}
    itp::ITPT
    ranges::RT
end

function Base.:(==)(o1::ScaledInterpolation, o2::ScaledInterpolation)
    o1.ranges == o2.ranges &&
    o1.itp == o2.itp
end

Base.parent(A::ScaledInterpolation) = A.itp
count_interp_dims(::Type{<:ScaledInterpolation{T,N,ITPT}}, n) where {T,N,ITPT} = count_interp_dims(ITPT, n)
BoundsCheckStyle(sitp::ScaledInterpolation) = BoundsCheckStyle(sitp.itp)
coefficients(A::ScaledInterpolation) = coefficients(A.itp)

"""
`scale(itp, xs, ys, ...)` scales an existing interpolation object to allow for indexing using other coordinate axes than unit ranges, by wrapping the interpolation object and transforming the indices from the provided axes onto unit ranges upon indexing.

The parameters `xs` etc must be either ranges or linspaces, and there must be one coordinate range/linspace for each dimension of the interpolation object.

For every `NoInterp` dimension of the interpolation object, the range must be exactly `1:size(itp, d)`.
"""
function scale(itp::AbstractInterpolation{T,N,IT}, ranges::Vararg{AbstractRange,N}) where {T,N,IT}
    check_ranges(itpflag(itp), axes(itp), ranges)
    ScaledInterpolation{T,N,typeof(itp),IT,typeof(ranges)}(itp, ranges)
end
scale(itp::AbstractInterpolation{T,N,IT}, ranges::NTuple{N, <:AbstractRange}) where {T,N,IT} = scale(itp, ranges...)

function check_ranges(flags, axs, ranges)
    check_range(getfirst(flags), axs[1], ranges[1])
    check_range(ranges[1])
    check_ranges(getrest(flags), Base.tail(axs), Base.tail(ranges))
end
check_ranges(::Any, ::Tuple{}, ::Tuple{}) = nothing

check_range(::NoInterp, ax, r) = ax == r || throw(ArgumentError("The range $r did not equal the corresponding axis of the interpolation object $ax"))
check_range(::Any, ax, r) = length(ax) == length(r) || throw(ArgumentError("The range $r is incommensurate with the corresponding axis $ax"))
check_range(r::AbstractRange) = step(r) > zero(eltype(r)) || throw(ArgumentError("The range $r is in decreasing order; only ranges with positive steps are supported by scale()."))

# With regards to size and [], ScaledInterpolation behaves like the underlying interpolation object
size(sitp::ScaledInterpolation) = size(sitp.itp)
axes(sitp::ScaledInterpolation) = axes(sitp.itp)

itpflag(sitp::ScaledInterpolation) = itpflag(sitp.itp)

@propagate_inbounds function Base.getindex(sitp::ScaledInterpolation{T,N}, i::Vararg{Int,N}) where {T,N}
    sitp.itp[i...]
end

lbounds(sitp::ScaledInterpolation) = _lbounds(sitp.ranges, itpflag(sitp.itp))
ubounds(sitp::ScaledInterpolation) = _ubounds(sitp.ranges, itpflag(sitp.itp))

boundstep(r::StepRange) = r.step / 2
boundstep(r::UnitRange) = 1//2
"""
Returns *half* the width of one step of the range.

This function is used to calculate the upper and lower bounds of `OnCell` interpolation objects.
""" boundstep

lbound(ax::AbstractRange, ::DegreeBC, ::OnCell) = first(ax) - boundstep(ax)
ubound(ax::AbstractRange, ::DegreeBC, ::OnCell) = last(ax) + boundstep(ax)
lbound(ax::AbstractRange, ::DegreeBC, ::OnGrid) = first(ax)
ubound(ax::AbstractRange, ::DegreeBC, ::OnGrid) = last(ax)

# For (), we scale the evaluation point
@propagate_inbounds function (sitp::ScaledInterpolation{T,N})(xs::Vararg{Number,N}) where {T,N}
    @boundscheck (checkbounds(Bool, sitp, xs...) || Base.throw_boundserror(sitp, xs))
    xl = maybe_clamp(sitp.itp, coordslookup(itpflag(sitp.itp), sitp.ranges, xs))
    @inbounds sitp.itp(xl...)
end
@propagate_inbounds function (itp::ScaledInterpolation{T,N})(x::Vararg{Number,M}) where {T,M,N}
    inds, trailing = split_trailing(itp, x)
    @boundscheck (check1(trailing) || Base.throw_boundserror(itp, x))
    @assert length(inds) == N
    itp(inds...)
end
@inline function (sitp::ScaledInterpolation)(x::Vararg{UnexpandedIndexTypes})
    xis = to_indices(sitp, x)
    xis == x && error("evaluation not supported for ScaledInterpolation at positions $x")
    sitp(xis...)
end

(sitp::ScaledInterpolation{T,1})(x::Number, y::Int) where {T} = y == 1 ? sitp(x) : Base.throw_boundserror(sitp, (x, y))

@inline function (itp::ScaledInterpolation{T,N})(x::Vararg{Union{Number,AbstractVector},N}) where {T,N}
    [itp(i...) for i in Iterators.product(x...)]
end

@inline function coordslookup(flags, ranges, xs)
    item = coordlookup(getfirst(flags), ranges[1], xs[1])
    (item, coordslookup(getrest(flags), Base.tail(ranges), Base.tail(xs))...)
end
coordslookup(::Any, ::Tuple{}, ::Tuple{}) = ()

coordlookup(::NoInterp, r, i) = i
coordlookup(::Flag, r, x) = coordlookup(r, x)

coordlookup(r::AbstractUnitRange, x) = (x - first(r))/oneunit(eltype(r)) + one(eltype(r))
# coordlookup(i::Bool, r::AbstractRange, x) = i ? coordlookup(r, x) : convert(typeof(coordlookup(r,x)), x)
coordlookup(r::StepRange, x) = (x - r.start) / r.step + one(eltype(r))

coordlookup(r::AbstractRange, x) = (x - first(r)) / step(r) + one(eltype(r))
boundstep(r::AbstractRange) = 0.5*step(r)
rescale_gradient(r::AbstractRange, g) = g / step(r)

basetype(::Type{ScaledInterpolation{T,N,ITPT,IT,RT}}) where {T,N,ITPT,IT,RT} = ITPT
basetype(sitp::ScaledInterpolation) = basetype(typeof(sitp))


@propagate_inbounds function gradient(sitp::ScaledInterpolation{T,N}, xs::Vararg{Number,N}) where {T,N}
    @boundscheck (checkbounds(Bool, sitp, xs...) || Base.throw_boundserror(sitp, xs))
    xl = maybe_clamp(sitp.itp, coordslookup(itpflag(sitp.itp), sitp.ranges, xs))
    g = gradient(sitp.itp, xl...)
    SVector(rescale_gradient_components(itpflag(sitp.itp), sitp.ranges, Tuple(g)))
end

function rescale_gradient_components(flags, ranges, g)
    if getfirst(flags) isa NoInterp
        return rescale_gradient_components(getrest(flags), Base.tail(ranges), g)    # don't consume a coordinate of g
    else
        item = rescale_gradient(ranges[1], g[1])
        return (item, rescale_gradient_components(getrest(flags), Base.tail(ranges), Base.tail(g))...)
    end
end
rescale_gradient_components(flags, ::Tuple{}, ::Tuple{}) = ()

rescale_gradient(r::StepRange, g) = g / r.step
rescale_gradient(r::UnitRange, g) = g

"""
`rescale_gradient(r::AbstractRange)`

Implements the chain rule dy/dx = dy/du * du/dx for use when calculating gradients with scaled interpolation objects.
""" rescale_gradient

@propagate_inbounds function hessian(sitp::ScaledInterpolation{T,N}, xs::Vararg{Number,N}) where {T,N}
    @boundscheck (checkbounds(Bool, sitp, xs...) || Base.throw_boundserror(sitp, xs))
    xl = maybe_clamp(sitp.itp, coordslookup(itpflag(sitp.itp), sitp.ranges, xs))
    h = hessian(sitp.itp, xl...)
    return rescale_hessian_components(itpflag(sitp.itp), sitp.ranges, h)
end

function rescale_hessian_components(flags, ranges, h)
    steps = SVector(get_steps(flags, ranges))
    return h ./ (steps .* steps')
end

function get_steps(flags, ranges)
    if getfirst(flags) isa NoInterp
        return get_steps(getrest(flags), Base.tail(ranges))
    else
        item = step(ranges[1])
        return (item, get_steps(getrest(flags), Base.tail(ranges))...)
    end
end
get_steps(flags, ::Tuple{}) = ()

### Iteration

struct ScaledIterator{SITPT,CI,WIS}
    sitp::SITPT   # ScaledInterpolation object
    ci::CI        # the CartesianIndices object
    wis::WIS      # WeightedIndex vectors
    breaks1::Vector{Int}   # breaks along dimension 1 where new evaluations must occur
end

Base.IteratorSize(::Type{ScaledIterator{SITPT,CI,WIS}}) where {SITPT,CI<:CartesianIndices{N},WIS} where N = Base.HasShape{N}()
Base.axes(iter::ScaledIterator) = axes(iter.ci)
Base.size(iter::ScaledIterator) = size(iter.ci)

struct ScaledIterState{N,V,D}
    cistate::CartesianIndex{N}
    ibreak::Int
    cached_evaluations::NTuple{D,V}
end

function eachvalue(sitp::ScaledInterpolation{T,N}) where {T,N}
    itps = tcollect(itpflag, sitp.itp)
    newaxes = map(r->Base.Slice(ceil(Int, first(r)):floor(Int, last(r))), sitp.ranges)
    wis = dimension_wis(value_weights, itps, axes(sitp.itp), newaxes, sitp.ranges)
    wis1 = wis[1]
    i1 = first(axes(wis1, 1))
    breaks1 = [i1]
    for i in Iterators.drop(axes(wis1, 1), 1)
        if indexes(wis1[i]) != indexes(wis1[i-1])
            push!(breaks1, i)
        end
    end
    push!(breaks1, last(axes(wis1, 1))+1)
    ScaledIterator(sitp, CartesianIndices(newaxes), wis, breaks1)
end

function dimension_wis(f::F, itps, axs, newaxes, ranges) where F
    itpflag, ax, nax, r = itps[1], axs[1], newaxes[1], ranges[1]
    function makewi(x)
        pos, coefs = weightedindex_parts((f,), itpflag, ax, coordlookup(r, x))
        maybe_weightedindex(pos, coefs[1])
    end
    (makewi.(nax), dimension_wis(f, Base.tail(itps), Base.tail(axs), Base.tail(newaxes), Base.tail(ranges))...)
end
dimension_wis(f, ::Tuple{}, ::Tuple{}, ::Tuple{}, ::Tuple{}) = ()

function Base.iterate(iter::ScaledIterator)
    ret = iterate(iter.ci)
    ret === nothing && return nothing
    item, cistate = ret
    wis = getindex.(iter.wis, Tuple(item))
    ces = cache_evaluations(InterpGetindex(iter.sitp), indexes(wis[1]), weights(wis[1]), Base.tail(wis))
    return _reduce(+, weights(wis[1]).*ces), ScaledIterState(cistate, firstindex(iter.breaks1), ces)
end

function Base.iterate(iter::ScaledIterator, state)
    ret = iterate(iter.ci, state.cistate)
    ret === nothing && return nothing
    item, cistate = ret
    i1 = item[1]
    isnext1 = i1 == state.cistate[1]+1
    if isnext1 && i1 < iter.breaks1[state.ibreak+1]
        # We can use the previously cached values
        wis1 = iter.wis[1][i1]
        return _reduce(+, weights(wis1).*state.cached_evaluations), ScaledIterState(cistate, state.ibreak, state.cached_evaluations)
    end
    # Re-evaluate. We're being a bit lazy here: in some cases, some of the cached values could be reused
    wis = getindex.(iter.wis, Tuple(item))
    ces = cache_evaluations(InterpGetindex(iter.sitp), indexes(wis[1]), weights(wis[1]), Base.tail(wis))
    return _reduce(+, weights(wis[1]).*ces), ScaledIterState(cistate, isnext1 ? state.ibreak+1 : firstindex(iter.breaks1), ces)
end

_reduce(op, list) = op(list[1], _reduce(op, Base.tail(list)))
_reduce(op, list::Tuple{Any}) = list[1]
_reduce(op, list::Tuple{}) = error("cannot reduce an empty list")

# We use weights only as a ruler to determine when we are done
cache_evaluations(coefs, i::Int, weights, rest) = (coefs[i, rest...], cache_evaluations(coefs, i+1, Base.tail(weights), rest)...)
cache_evaluations(coefs, indexes, weights, rest) = (coefs[indexes[1], rest...], cache_evaluations(coefs, Base.tail(indexes), Base.tail(weights), rest)...)
cache_evaluations(coefs, ::Int, ::Tuple{}, rest) = ()
cache_evaluations(coefs, ::Any, ::Tuple{}, rest) = ()

ssize(sitp::ScaledInterpolation{T,N}) where {T,N} = map(r->round(Int, last(r)-first(r)+1), sitp.ranges)::NTuple{N,Int}

export Gridded

struct Gridded{D<:Degree} <: InterpolationType
    degree::D
end

function Base.show(io::IO, g::Gridded)
    print(io, "Gridded(")
    show(io, degree(g))
    print(io, ')')
end

const GridIndex{T} = Union{AbstractVector{T}, Tuple}

# Note: the term "knots" is probably misused, these are more properly "nodes"

struct GriddedInterpolation{T,N,TCoefs,IT<:DimSpec{Gridded},K<:Tuple{Vararg{AbstractVector}}} <: AbstractInterpolation{T,N,IT}
    knots::K
    coefs::TCoefs
    it::IT
end

function Base.:(==)(o1::GriddedInterpolation, o2::GriddedInterpolation)
    o1.it == o2.it &&
    o1.knots == o2.knots &&
    o1.coefs == o2.coefs
end

"""
    GriddedInterpolation(typeOfWeights::Type{<:Real},
                         knots::NTuple{N, Union{ AbstractVector{T}, Tuple } },
                         array::AbstractArray{Tel,N},
                         interpolationType::DimSpec{<:Gridded})

    Construct a GriddedInterpolation for generic knots from an AbstractArray
"""
function GriddedInterpolation(::Type{TWeights}, knots::NTuple{N,GridIndex}, A::AbstractArray{Tel,N}, it::IT) where {N,Tel,TWeights<:Real,IT<:DimSpec{Gridded}}
    isconcretetype(IT) || error("The b-spline type must be a leaf type (was $IT)")

    check_gridded(it, knots, axes(A))
    c = zero(TWeights)
    if isempty(A)
        T = Base.promote_op(*, typeof(c), eltype(A))
    else
        T = typeof(c * first(A))
    end
    GriddedInterpolation{T,N,typeof(A),IT,typeof(knots)}(knots, A, it)
end

"""
    GriddedInterpolation(typeOfWeights::Type{<:Real},
                         knots::NTuple{N, AbstractUnitRange },
                         array::AbstractArray{TCoefs,N},
                         interpolationType::DimSpec{<:Gridded})

    Construct a GriddedInterpolation for generic knots from an AbstractUnitRange.

    AbstractUnitRanges are collected to an Array to not confuse bound calculations (See Issue #398)
"""
function GriddedInterpolation(tw::Type{TWeights}, knots::NTuple{N,AbstractUnitRange}, A::AbstractArray{TCoefs,N}, it::IT) where {N,TCoefs,TWeights<:Real,IT<:DimSpec{Gridded}}
    # Fix Issue 398: Ensure that gridded_*bounds is used by converting
    # AbstractUnitRange to a non-AbstractUnitRange AbstractVector
    GriddedInterpolation(tw, collect.(knots), A, it)
end

@inline function check_gridded(itpflag, knots, axs)
    flag, ax1, k1 = getfirst(itpflag), axs[1], knots[1]
    if flag isa NoInterp
        k1 == ax1 || error("for NoInterp knot vector should be $ax1, got $k1")
    else
        axes(k1, 1) == ax1 || throw(DimensionMismatch("knot vectors must have the same axes as the corresponding dimension of the array"))
    end
    degree(flag) isa Union{NoInterp,Constant,Linear} || error("only Linear, Constant, and NoInterp supported, got $flag")
    length(k1) == 1 && error("dimensions of length 1 not yet supported")  # FIXME
    if issorted(k1) 
        if !allunique(k1)
            @warn "Duplicated knots were deduplicated. Use Interpolations.deduplicate_knots!(knots) explicitly to avoid this warning." k1
            deduplicate_knots!(k1)
        end
    else
        error("knot-vectors must be unique and sorted in increasing order")
    end
    check_gridded(getrest(itpflag), Base.tail(knots), Base.tail(axs))
end
check_gridded(::Any, ::Tuple{}, ::Tuple{}) = nothing
degree(flag::Gridded) = flag.degree

"""
    Interpolations.deduplicate_knots!(knots; move_knots = false)

    Makes knots unique by incrementing repeated but otherwise sorted knots using `nextfloat`.
    If keyword `move_knots` is true, then `nextfloat` will be applied successively until knots
    are unique. Otherwise, a warning will be issued.

    # Example

    ```jldoctest
    julia> knots = [-8.0, 0.0, 20.0, 20.0]
    4-element Vector{Float64}:
    -8.0
    0.0
    20.0
    20.0

    julia> Interpolations.deduplicate_knots!(knots)
    4-element Vector{Float64}:
    -8.0
    0.0
    20.0
    20.000000000000004

    julia> Interpolations.deduplicate_knots!([1.0, 1.0, 1.0, nextfloat(1.0), nextfloat(1.0)]; move_knots = true)
    5-element Vector{Float64}:
    1.0
    1.0000000000000002
    1.0000000000000004
    1.0000000000000007
    1.0000000000000009
    ```
"""
function deduplicate_knots!(knots; move_knots::Bool = false)
    last_knot = first(knots)
    for i = eachindex(knots)
        if i == 1
            continue
        end
        if knots[i] == last_knot || (move_knots && (@inbounds knots[i] <= knots[i-1]))
            @inbounds knots[i] = nextfloat(knots[i-1])
        elseif @inbounds knots[i] <= knots[i-1] 
            @warn "Successive repeated knots detected. Consider using `move_knots` keyword to Interpolations.deduplicate_knots!" last_knot knots[i-1] knots[i]
            @inbounds knots[i] = nextfloat(knots[i-1])
            move_knots = true
        else
            last_knot = @inbounds knots[i]
        end
    end
    knots
end

Base.parent(A::GriddedInterpolation) = A.coefs
coefficients(A::GriddedInterpolation) = A.coefs

size(A::GriddedInterpolation) = size(A.coefs)
axes(A::GriddedInterpolation) = axes(A.coefs)

itpflag(A::GriddedInterpolation) = A.it

function interpolate(::Type{TWeights}, ::Type{TCoefs}, knots::NTuple{N,GridIndex}, A::AbstractArray{Tel,N}, it::IT) where {TWeights,TCoefs,Tel,N,IT<:DimSpec{Gridded}}
    GriddedInterpolation(TWeights, knots, copy(A), it)
end
"""
    itp = interpolate((nodes1, nodes2, ...), A, interpmode)

Interpolate an array `A` on a non-uniform but rectangular grid specified by the given `nodes`,
in the mode determined by `interpmode`.

`interpmode` may be one of

- `NoInterp()`
- `Gridded(Constant())`
- `Gridded(Linear())`

It may also be a tuple of such values, if you want to use different interpolation schemes along each axis.
"""
function interpolate(knots::NTuple{N,GridIndex}, A::AbstractArray{Tel,N}, it::IT) where {Tel,N,IT<:DimSpec{Gridded}}
    interpolate(tweight(A), tcoef(A), knots, A, it)
end

interpolate!(::Type{TWeights}, knots::NTuple{N,GridIndex}, A::AbstractArray{Tel,N}, it::IT) where {TWeights,Tel,N,IT<:DimSpec{Gridded}} =
    GriddedInterpolation(TWeights, knots, A, it)
function interpolate!(knots::NTuple{N,GridIndex}, A::AbstractArray{Tel,N}, it::IT) where {Tel,N,IT<:DimSpec{Gridded}}
    interpolate!(tweight(A), knots, A, it)
end

lbounds(itp::GriddedInterpolation) = first.(itp.knots)
ubounds(itp::GriddedInterpolation) = last.(itp.knots)
lbound(ax::AbstractVector, gr::Gridded)   = lbound(ax, degree(gr))
ubound(ax::AbstractVector, gr::Gridded)   = ubound(ax, degree(gr))

include("indexing.jl")

using Zygote
@testset "ChainRulesCore" begin
    # 1D example
    x = 1:10
    y = sin.(x)

    # Simple test that rrules give equivalent results to internal gradient function

    itp = interpolate(y,BSpline(Linear()))

    if VERSION ≥ v"1.3"
        @test Zygote.gradient(itp, 1) == Tuple(Interpolations.gradient(itp, 1))
    else
        @test_skip Zygote.gradient(itp, 1) == Tuple(Interpolations.gradient(itp, 1))
    end

    # 2D example
    x2 = [i*j for i=1:5, j=1:5]
    y2 = sin.(x2)

    itp2 = interpolate(y2, BSpline(Cubic(Line(OnGrid()))))

    if VERSION ≥ v"1.3"
        @test Zygote.gradient(itp2,1,2) == Tuple(Interpolations.gradient(itp2,1,2))
    else
        @test_skip Zygote.gradient(itp2,1,2) == Tuple(Interpolations.gradient(itp2,1,2))
    end

    # Matrix-valued
    y=[[[0 0; 0 0]] [[1 2; 0 0]];
       [[0 0; 3 4]] [[1 2; 3 4]]]
    itp_m = interpolate(y, BSpline(Linear()))
    if VERSION ≥ v"1.3"
        @test Zygote.jacobian(itp_m, 1,1) == Tuple((x->[x...]).(Interpolations.gradient(itp_m, 1,1)))
    else
        @test_skip Zygote.jacobian(itp_m, 1,1) == Tuple((x->[x...]).(Interpolations.gradient(itp_m, 1,1)))
    end

end

@testset "Regularization" begin
    for (constructor, copier) in ((interpolate, identity), (interpolate!, copy))
        isinplace = constructor == interpolate!
        f0(x) = sin((x-3)*2pi/9 - 1)
        f1(x) = 1.0 + 0.1*x + 0.01*x^2 + 0.001*x^3

        xmax = 10
        xi = range(0, stop=xmax, length=11)
        xfine = range(0, stop=xmax, length=101)

        A0 = f0.(xi)
        A1 = f1.(xi)

        for (yi, f) in ((A0, f0), (A1, f1)), λ in (0.01, 100), k in (1, 2, 3, 4)
            it = @inferred(interpolate(yi, BSpline(Cubic(Line(OnCell()))), λ, k))
            itt = @inferred(scale(it, xi))
            
            if f === f0
                if λ == 0.01
                    # test that interpolation of the interpolating points is close to expected data
                    for x in [2, 3, 6, 7]
                        @test f(x) ≈ itt(x) atol=0.01
                    end
                elseif λ == 100
                    # test that interpolation of the interpolating points is far from expected data
                    for x in [2, 3, 6, 7]
                        @test !(isapprox(f(x), itt(x); atol=0.1))
                    end
                end
            
            elseif f === f1
                if k==4
                    for x in xfine
                        # test that interpolation is close to expected data when
                        # the smoothing order is higher than the polynomial order
                        @test f(x) ≈ itt(x) atol=0.1
                    end
                end
            end
        end

        # Check fallback to no regularization for λ=0
        itp1  = @inferred(constructor(copier(A0), BSpline(Cubic(Line(OnGrid()))), 0, 1))
        itp1p = @inferred(constructor(copier(A0), BSpline(Cubic(Line(OnGrid())))))
        @test itp1 == itp1p


        f2(x, y) = sin(x/10)*cos(y/6)
        xmax2, ymax2 = 30, 10
        A2 = Float64[f2(x, y) for x in 1:xmax2, y in 1:ymax2]

        # Check fallback to no regularization for non Vectors
        itp2  = @inferred(constructor(copier(A2), BSpline(Cubic(Line(OnGrid()))), 1, 1))
        itp2p = @inferred(constructor(copier(A2), BSpline(Cubic(Line(OnGrid())))))
        @test itp2 == itp2p
    end
end

using Interpolations, Test

@testset "==" begin

    # issue #333
    knots = ([1,1.2],)
    vals = [1.0, 2.0]
    scheme = Gridded(Linear())
    itp = interpolate(knots, vals , scheme)
    @test itp == itp
    @test itp == deepcopy(itp)
    @test itp != interpolate(([1,1.3],), vals, scheme)
    @test itp != interpolate(knots, [1.0, 3.0], scheme)
    @test itp != interpolate(knots, vals, Gridded(Constant()))

    scheme = BSpline(Quadratic(Reflect(OnCell())))
    vals = [1.0, 2.0]
    itp = interpolate(vals, scheme)
    @test itp == itp
    @test itp == deepcopy(itp)
    @test itp != interpolate(vals, BSpline(Linear()))
    @test itp != interpolate(randn(2), scheme)

    vals = rand(Float64, 2,3)
    itp1 = interpolate(vals, BSpline(Quadratic(Flat(OnGrid()))))
    itp2 = interpolate(Float64.(vals), BSpline(Quadratic(Flat(OnGrid()))))
    @test itp1 == itp2
end

@testset "Core" begin
    A = reshape([0], 1, 1, 1, 1, 1)
    IA = Interpolations.InterpGetindex(A)
    wis = ntuple(d->Interpolations.WeightedAdjIndex(1, (1,)), ndims(A))
    @test @inferred(IA[wis...]) === 0
    wis = ntuple(d->Interpolations.WeightedAdjIndex(1, (1.0,)), ndims(A))
    @test @inferred(IA[wis...]) === 0.0
    wis = ntuple(d->Interpolations.WeightedArbIndex((1,), (1,)), ndims(A))
    @test @inferred(IA[wis...]) === 0
    wis = ntuple(d->Interpolations.WeightedArbIndex((1,), (1.0,)), ndims(A))
    @test @inferred(IA[wis...]) === 0.0
    wis = ntuple(d->Interpolations.WeightedArbIndex((1,1), (1,0)), ndims(A))
    @test @inferred(IA[wis...]) === 0
    wis = ntuple(d->Interpolations.WeightedArbIndex((1,1), (1.0,0.0)), ndims(A))
    @test @inferred(IA[wis...]) === 0.0

    wi = Interpolations.WeightedAdjIndex(2, (0.2, 0.8))
    @test wi*2 === Interpolations.WeightedAdjIndex(2, (0.4, 1.6))
    @test wi/2 === Interpolations.WeightedAdjIndex(2, (0.1, 0.4))
    @test Interpolations.indextuple(wi) == (2, 3)
    wi = Interpolations.WeightedArbIndex((2, -1), (0.2, 0.8))
    @test wi*2 === Interpolations.WeightedArbIndex((2, -1), (0.4, 1.6))
    @test wi/2 === Interpolations.WeightedArbIndex((2, -1), (0.1, 0.4))
    @test Interpolations.indextuple(wi) == (2, -1)
end

@testset "Hash" begin
    # Issue 339: Base.hash accesses out-of-bound indexes due to AbstractArray interface
    # Relevant to Distributed computing
    xr = collect(0.0:1.0:5.0)
    yr = collect(1.0:1.0:6.0)
    itp = interpolate((xr,),yr,Gridded(Linear()))
    # using Distributed
    # addprocs(2)
    # @everywhere begin
    #    using Interpolations
    #    callitp(itp, x) = itp(x)
    # end
    # r = remotecall(callitp, 2, itp, 1.2)
    # fetch(r) # 2.2
    @test hash(itp) != 0
    etp = linear_interpolation([2, 3], [4, 5])
    @test hash(etp.itp) != 0
    @test hash(etp) != 0
end

@testset "BasicInferability" begin
    itp = cubic_spline_interpolation(1:3, randn(3))
    @test (@inferred Interpolations.itptype(itp)) == BSpline{Cubic{Line{OnGrid}}}
    @test (@inferred eltype(itp)) == Float64
    @test (@inferred ndims(itp)) == 1
end

using Interpolations, Test

@testset "ScalingWithExtrapTests" begin

    xs = range(-5, stop=5, length=10)
    ys = map(sin, xs)

    function run_tests(sut::Interpolations.AbstractInterpolation{T,N,IT}, itp, ::OnGrid) where {T,N,IT}
        for x in xs
            @test ≈(sut(x),sin(x),atol=sqrt(eps(sin(x))))
        end
        @test sut(-5) == sut(-5.1) == sut(-15.8) == sut(-Inf) == itp(1)
        @test sut(5) == sut(5.1) == sut(15.8) == sut(Inf) == itp[end]
    end

    function run_tests(sut::Interpolations.AbstractInterpolation{T,N,IT}, itp, ::OnCell) where {T,N,IT}
        halfcell = (xs[2] - xs[1]) / 2
        itps, axs = Interpolations.itpinfo(itp)
        for x in (5 + halfcell, 5 + 1.1halfcell, 15.8, Inf)
            @test sut(-x) == itp(Interpolations.lbound(axs[1], itps[1]))
            @test sut(x) == itp(Interpolations.ubound(axs[1], itps[1]))
        end
    end

    run_tests(sut, itp) = run_tests(sut, itp, Interpolations.degree(Interpolations.itpflag(itp)).bc.gt)

    for GT in (OnGrid, OnCell)
        itp = interpolate(ys, BSpline(Quadratic(Flat(GT()))))

        # Test extrapolating, then scaling
        eitp = extrapolate(itp, Flat())
        seitp = scale(eitp, xs)
        run_tests(seitp, itp)

        # Test scaling, then extrapolating
        sitp = scale(itp, xs)
        esitp = extrapolate(sitp, Flat())
        run_tests(esitp, itp)
    end

end

struct MyInterp{T,N,A<:AbstractArray{T,N}}
    data::A
end

@inline (itp::MyInterp{T,N})(i::Vararg{<:Number,N}) where {T,N} = expand(itp, i)

@inline function expand(itp::MyInterp, ipre::Tuple{Vararg{Number,L}}, ipost::Vararg{Integer,M}) where {L,M}  # force specialization
    ifront, ilast = Base.front(ipre), ipre[end]
    im, ip = floor(ilast), ceil(ilast)
    return (ip - ilast)*expand(itp, ifront, unsafe_trunc(Int, im), ipost...) +
           (ilast - im)*expand(itp, ifront, unsafe_trunc(Int, ip), ipost...)
end

@inline expand(itp::MyInterp, ::Tuple{}, ipost::Vararg{Integer,N}) where N =
    @inbounds itp.data[CartesianIndex(ipost)]

### Primary evaluation entry points (itp(x...), gradient(itp, x...), and hessian(itp, x...))

itpinfo(itp) = (tcollect(itpflag, itp), axes(itp))

@inline function (itp::BSplineInterpolation{T,N})(x::Vararg{Number,N}) where {T,N}
    @boundscheck (checkbounds(Bool, itp, x...) || Base.throw_boundserror(itp, x))
    wis = weightedindexes((value_weights,), itpinfo(itp)..., x)
    InterpGetindex(itp)[wis...]
end
@propagate_inbounds function (itp::BSplineInterpolation{T,N})(x::Vararg{Number,M}) where {T,M,N}
    inds, trailing = split_trailing(itp, x)
    @boundscheck (check1(trailing) || Base.throw_boundserror(itp, x))
    @assert length(inds) == N
    itp(inds...)
end
@inline function (itp::BSplineInterpolation{T,N})(x::Vararg{Union{Number,AbstractVector},N}) where {T,N}
    @boundscheck (checkbounds(Bool, itp, x...) || Base.throw_boundserror(itp, x))
    itps = tcollect(itpflag, itp)
    wis = dimension_wis(value_weights, itps, axes(itp), x)
    coefs = InterpGetindex(itp)
    ret = [coefs[i...] for i in Iterators.product(wis...)]
    reshape(ret, shape(wis...))
end

@propagate_inbounds function gradient(itp::BSplineInterpolation{T,N}, x::Vararg{Number,N}) where {T,N}
    @boundscheck checkbounds(Bool, itp, x...) || Base.throw_boundserror(itp, x)
    wis = weightedindexes((value_weights, gradient_weights), itpinfo(itp)..., x)
    return SVector(_gradient(InterpGetindex(itp), wis...))   # work around #311
end
@inline _gradient(coefs, inds, moreinds...) = (coefs[inds...], _gradient(coefs, moreinds...)...)
_gradient(coefs) = ()

@propagate_inbounds function gradient!(dest, itp::BSplineInterpolation{T,N}, x::Vararg{Number,N}) where {T,N}
    dest .= gradient(itp, x...)
end

@propagate_inbounds function hessian(itp::BSplineInterpolation{T,N}, x::Vararg{Number,N}) where {T,N}
    @boundscheck checkbounds(Bool, itp, x...) || Base.throw_boundserror(itp, x)
    wis = weightedindexes((value_weights, gradient_weights, hessian_weights), itpinfo(itp)..., x)
    symmatrix(map(inds->InterpGetindex(itp)[inds...], wis))
end
@propagate_inbounds function hessian!(dest, itp::BSplineInterpolation{T,N}, x::Vararg{Number,N}) where {T,N}
    dest .= hessian(itp, x...)
end

# Leftovers from AbstractInterpolation
@inline function (itp::BSplineInterpolation)(x::Vararg{UnexpandedIndexTypes})
    itp(to_indices(itp, x)...)
end
@inline function (itp::BSplineInterpolation)(x::Vararg{ExpandedIndexTypes})
    itp.(Iterators.product(x...))
end

"""
    weightedindexes(fs, itpflags, nodes, xs)

Compute `WeightedIndex` values for evaluation at the position `xs...`.
`fs` is a function or tuple of functions indicating the types of index required,
typically `value_weights`, `gradient_weights`, and/or `hessian_weights`.
`itpflags` and `nodes` can be obtained from `itpinfo(itp)...`.

See the "developer documentation" for further information.
"""
@inline function weightedindexes(fs::F, itpflags::NTuple{N,Flag}, knots::NTuple{N,AbstractVector}, xs::NTuple{N,Number}) where {F,N}
    # parts = map((flag, knotvec, x)->weightedindex_parts(fs, flag, knotvec, x), itpflags, knots, xs)
    parts = map3argf(weightedindex_parts, fs, itpflags, knots, xs)
    weightedindexes(parts...)
end
# This is a force-inlined version of map((flag, knotvec, x)->g(fs, flag, knotvec, x), itpflags, knots, xs)
@inline map3argf(g::G, fs::F, itpflags, knots, xs) where {G,F} =
    (g(fs, itpflags[1], knots[1], xs[1]), map3argf(g, fs, Base.tail(itpflags), Base.tail(knots), Base.tail(xs))...)
map3argf(g::G, fs::F, ::Tuple{}, ::Tuple{}, ::Tuple{}) where {G,F} = ()

weightedindexes(i::Vararg{Int,N}) where N = i  # the all-NoInterp case

const PositionCoefs{P,C} = NamedTuple{(:position,:coefs),Tuple{P,C}}
const ValueParts{P,W} = PositionCoefs{P,Tuple{W}}
@inline weightedindexes(parts::Vararg{Union{Int,ValueParts},N}) where N =
    map(maybe_weightedindex, map(positions, parts), map(valuecoefs, parts))
maybe_weightedindex(i::Integer, _::Integer) = Int(i)
maybe_weightedindex(pos, coefs::Tuple) = WeightedIndex(pos, coefs)

positions(i::Int) = i
valuecoefs(i::Int) = i
gradcoefs(i::Int) = i
hesscoefs(i::Int) = i
positions(t::PositionCoefs) = t.position
valuecoefs(t::PositionCoefs) = t.coefs[1]
gradcoefs(t::PositionCoefs) = t.coefs[2]
hesscoefs(t::PositionCoefs) = t.coefs[3]

const GradParts{P,W1,W2} = PositionCoefs{P,Tuple{W1,W2}}
function weightedindexes(parts::Vararg{Union{Int,GradParts},N}) where N
    # Create (wis1, wis2, ...) where wisn is used to evaluate the gradient along the nth *chosen* dimension
    # Example: if itp is a 3d interpolation of form (Linear, NoInterp, Quadratic) then we will return
    #    (gwi1, i2, wi3), (wi1, i2, gwi3)
    # where wik are value-coefficient WeightedIndexes along dimension k
    #       gwik are gradient-coefficient WeightedIndexes along dimension k
    #       i2 is the integer index along dimension 2
    # These will result in a 2-vector gradient.
    # TODO: check whether this is inferrable
    slot_substitute(parts, map(positions, parts), map(valuecoefs, parts), map(gradcoefs, parts))
end

# Skip over NoInterp dimensions
slot_substitute(kind::Tuple{Int,Vararg{Any}}, p, v, g) = slot_substitute(Base.tail(kind), p, v, g)
# Substitute the dth dimension's gradient coefs for the remaining coefs
slot_substitute(kind, p, v, g) = (map(maybe_weightedindex, p, substitute_ruled(v, kind, g)), slot_substitute(Base.tail(kind), p, v, g)...)
# Termination
slot_substitute(kind::Tuple{}, p, v, g) = ()

const HessParts{P,W1,W2,W3} = PositionCoefs{P,Tuple{W1,W2,W3}}
function weightedindexes(parts::Vararg{Union{Int,HessParts},N}) where N
    # Create (wis1, wis2, ...) where wisn is used to evaluate the nth *chosen* hessian component
    # Example: if itp is a 3d interpolation of form (Linear, NoInterp, Quadratic) then we will return
    #    (hwi1, i2, wi3), (gwi1, i2, gwi3), (wi1, i2, hwi3)
    # where wik are value-coefficient WeightedIndexes along dimension k
    #       gwik are 1st-derivative WeightedIndexes along dimension k
    #       hwik are 2nd-derivative WeightedIndexes along dimension k
    #       i2 is just the index along dimension 2
    # These will result in a 2x2 hessian [hc1 hc2; hc2 hc3] where
    #    hc1 = coefs[hwi1, i2, wi3]
    #    hc2 = coefs[gwi1, i2, gwi3]
    #    hc3 = coefs[wi1,  i2, hwi3]
    slot_substitute(parts, map(positions, parts), map(valuecoefs, parts), map(gradcoefs, parts), map(hesscoefs, parts))
end
# Substitute the dth dimension's gradient coefs for the remaining coefs, column by column
slot_substitute(kind::Tuple, p, v, g, h) = (_column(kind, kind, p, v, g, h)..., slot_substitute(Base.tail(kind), p, v, g, h)...)
slot_substitute(::Tuple{}, p, v, g, h) = ()
# inner: calulate a single column
function _column(kind1::K, kind2::K, p, v, g, h) where {K<:Tuple}
    ss = substitute_ruled(v, kind1, h)
    (map(maybe_weightedindex, p, ss), _column(Base.tail(kind1), kind2, p, v, g, h)...)
end
function _column(kind1::Tuple, kind2::Tuple, p, v, g, h)
    ss = substitute_ruled(substitute_ruled(v, kind1, g), kind2, g)
    (map(maybe_weightedindex, p, ss), _column(Base.tail(kind1), kind2, p, v, g, h)...)
end
_column(::Tuple{}, ::Tuple, p, v, g, h) = ()
# Skip over NoInterp dimensions
slot_substitute(kind::Tuple{Int,Vararg{Any}}, p, v, g, h) = slot_substitute(Base.tail(kind), p, v, g, h)
_column(kind1::Tuple{Int,Vararg{Any}}, kind2::Tuple, p, v, g, h) =
    _column(Base.tail(kind1), kind2, p, v, g, h)

weightedindex_parts(fs::F, itpflag::BSpline, ax, x) where F =
    weightedindex_parts(fs, degree(itpflag), ax, x)

function weightedindex_parts(fs::F, deg::Degree, ax::AbstractUnitRange{<:Integer}, x) where F
    pos, δx = positions(deg, ax,  x)
    (position=pos, coefs=fmap(fs, deg, δx))
end


# there is a Heisenbug, when Base.promote_op is inlined into getindex_return_type
# thats why we use this @noinline fence
@noinline _promote_mul(a,b) = Base.promote_op(*, a, b)

@noinline function getindex_return_type(::Type{BSplineInterpolation{T,N,TCoefs,IT,Axs}}, argtypes::Tuple) where {T,N,TCoefs,IT<:DimSpec{BSpline},Axs}
    reduce(_promote_mul, eltype(TCoefs), argtypes)
end

function getindex_return_type(::Type{BSplineInterpolation{T,N,TCoefs,IT,Axs}}, ::Type{I}) where {T,N,TCoefs,IT<:DimSpec{BSpline},Axs,I}
    _promote_mul(eltype(TCoefs), I)
end

# This handles round-towards-the-middle for points on half-integer edges
roundbounds(x::Integer, bounds::Tuple{Real,Real}) = x
roundbounds(x::Integer, bounds::AbstractUnitRange) = x
roundbounds(x::Number, bounds::Tuple{Real,Real}) = _roundbounds(x, bounds)
roundbounds(x::Number, bounds::AbstractUnitRange) = _roundbounds(x, bounds)
function _roundbounds(x::Number, bounds::Union{Tuple{Real,Real}, AbstractUnitRange})
    l, u = first(bounds), last(bounds)
    h = half(x)
    xh = x+h
    ifelse(x < u+half(u), floor(xh), ceil(xh)-1)
end

floorbounds(x::Integer, ax::Tuple{Real,Real}) = x
floorbounds(x::Integer, ax::AbstractUnitRange) = x
floorbounds(x, ax::Tuple{Real,Real}) = _floorbounds(x, ax)
floorbounds(x, ax::AbstractUnitRange) = _floorbounds(x, ax)
function _floorbounds(x, ax::Union{Tuple{Real,Real}, AbstractUnitRange})
    l = first(ax)
    h = half(x)
    ifelse(x < l, floor(x+h), floor(x+zero(h)))
end

ceilbounds(x::Integer, ax::Tuple{Real,Real}) = x
ceilbounds(x::Integer, ax::AbstractUnitRange) = x
ceilbounds(x, ax::Tuple{Real,Real}) = _ceilbounds(x, ax)
ceilbounds(x, ax::AbstractUnitRange) = _ceilbounds(x, ax)
function _ceilbounds(x, ax::Union{Tuple{Real,Real}, AbstractUnitRange})
    u = last(ax)
    h = half(x)
    ifelse(x > u, ceil(x+h), ceil(x+zero(h)))
end

half(x) = oneunit(x)/2

symmatrix(h::NTuple{1,Any}) = SMatrix{1,1}(h)
symmatrix(h::NTuple{3,Any}) = SMatrix{2,2}((h[1], h[2], h[2], h[3]))
symmatrix(h::NTuple{6,Any}) = SMatrix{3,3}((h[1], h[2], h[3], h[2], h[4], h[5], h[3], h[5], h[6]))
function symmatrix(h::NTuple{L,Any}) where L
    N = symsize(Val(L))
    l = MMatrix{N,N,Int}(undef)
    l[:,1] = 1:N
    idx = N
    for j = 2:N, i = 1:N
        if i < j
            l[i,j] = l[j,i]
        else
            l[i,j] = (idx+=1)
        end
    end
    if @generated
        hexprs = [:(h[$i]) for i in vec(l)]
        :(SMatrix{$N,$N}($(hexprs...,)))
    else
        SMatrix{N,N}(h[i] for i in l)
    end
end

# Use @generated to force const propagation
@generated function symsize(::Val{L}) where L
    N = floor(Int, sqrt(2L))
    (N*(N+1))÷2 == L || error("$L must be equal to N*(N+1)/2 (N = $N)")
    return :($N)
end

# convenience copnstructors for constant / linear / cubic spline interpolations
# 1D version
constant_interpolation(range::AbstractRange, vs::AbstractVector; extrapolation_bc = Throw()) =
    extrapolate(scale(interpolate(vs, BSpline(Constant())), range), extrapolation_bc)
constant_interpolation(range::AbstractVector, vs::AbstractVector; extrapolation_bc = Throw()) =
    extrapolate(interpolate((range, ), vs, Gridded(Constant())), extrapolation_bc)
linear_interpolation(range::AbstractRange, vs::AbstractVector; extrapolation_bc = Throw()) =
    extrapolate(scale(interpolate(vs, BSpline(Linear())), range), extrapolation_bc)
linear_interpolation(range::AbstractVector, vs::AbstractVector; extrapolation_bc = Throw()) =
    extrapolate(interpolate((range, ), vs, Gridded(Linear())), extrapolation_bc)
cubic_spline_interpolation(range::AbstractRange, vs::AbstractVector;
                         bc = Line(OnGrid()), extrapolation_bc = Throw()) =
    extrapolate(scale(interpolate(vs, BSpline(Cubic(bc))), range), extrapolation_bc)

# multivariate versions
constant_interpolation(ranges::NTuple{N,AbstractRange}, vs::AbstractArray{T,N};
                    extrapolation_bc = Throw()) where {N,T} =
    extrapolate(scale(interpolate(vs, BSpline(Constant())), ranges...), extrapolation_bc)
constant_interpolation(ranges::NTuple{N,AbstractVector}, vs::AbstractArray{T,N};
                    extrapolation_bc = Throw()) where {N,T} =
    extrapolate(interpolate(ranges, vs, Gridded(Constant())), extrapolation_bc)
linear_interpolation(ranges::NTuple{N,AbstractRange}, vs::AbstractArray{T,N};
                    extrapolation_bc = Throw()) where {N,T} =
    extrapolate(scale(interpolate(vs, BSpline(Linear())), ranges...), extrapolation_bc)
linear_interpolation(ranges::NTuple{N,AbstractVector}, vs::AbstractArray{T,N};
                    extrapolation_bc = Throw()) where {N,T} =
    extrapolate(interpolate(ranges, vs, Gridded(Linear())), extrapolation_bc)
cubic_spline_interpolation(ranges::NTuple{N,AbstractRange}, vs::AbstractArray{T,N};
                         bc = Line(OnGrid()), extrapolation_bc = Throw()) where {N,T} =
    extrapolate(scale(interpolate(vs, BSpline(Cubic(bc))), ranges...), extrapolation_bc)

"""
    etp = linear_interpolation(knots, A; extrapolation_bc=Throw())

A shorthand for one of the following.
* `extrapolate(scale(interpolate(A, BSpline(Linear())), knots), extrapolation_bc)`
* `extrapolate(interpolate(knots, A, Gridded(Linear())), extrapolation_bc)`,
depending on whether `knots` are ranges or vectors.

Consider using `interpolate`, `scale`, or `extrapolate` explicitly as needed
rather than using this convenience constructor. Performance will improve
without scaling or extrapolation.
"""
linear_interpolation

"""
    etp = constant_interpolation(knots, A; extrapolation_bc=Throw())

A shorthand for `extrapolate(interpolate(knots, A, scheme), extrapolation_bc)`,
where `scheme` is either `BSpline(Constant())` or `Gridded(Constant())` depending on whether
`knots` are ranges or vectors.

Consider using `interpolate` or `extrapolate` explicitly as needed
rather than using this convenience constructor. Performance will improve
without extrapolation.
"""
constant_interpolation

"""
    etp = cubic_spline_interpolation(knots, A; bc=Line(OnGrid()), extrapolation_bc=Throw())

A shorthand for `extrapolate(scale(interpolate(A, BSpline(Cubic(bc))),knots), extrapolation_bc)`.

Consider using `interpolate`, `scale`, or `extrapolate` explicitly as needed
rather than using this convenience constructor. Performance will improve
without scaling or extrapolation.
"""
cubic_spline_interpolation

using Test
using Interpolations

@testset "Pipes" begin
    for BC in (Throw, Flat, Line, Free, Reflect, InPlace, InPlaceQ, Periodic)
        for GT in (OnGrid, OnCell)
            @test BC(GT) == BC(GT())
            @test BC{GT}(GT) == BC{GT}(GT())
            @test GT |> BC == BC(GT())
            for D in (Cubic, Quadratic)
                @test GT |> BC |> D == D(BC(GT()))
                @test GT |> BC |> D{BC{GT}} == D(BC(GT()))
                @test D{BC}(BC) == D{BC}(BC())
            end
        end
        @test Linear(Throw{OnGrid}) == Linear(Throw{OnGrid}())
    end
    @test BSpline() == BSpline(Linear())
    @test_throws ArgumentError Cubic{Throw}(Flat)
    @test_throws ArgumentError Quadratic{Throw}(Flat)
end

using DualNumbers
using Interpolations
using Test

@testset "Extrapolation" begin

    f(x) = sin((x-3)*2pi/9 - 1)
    xmax = 10
    A = Float64[f(x) for x in 1:xmax]

    itpg = interpolate(A, BSpline(Linear()))

    etpg = extrapolate(itpg, Flat())
    @test typeof(etpg) <: AbstractExtrapolation

    @test etpg(-3) == etpg(-4.5) == etpg(0.9) == etpg(1.0) == A[1]
    @test etpg(10.1) == etpg(11) == etpg(148.298452) == A[end]

    etpf = @inferred(extrapolate(itpg, NaN))
    @test typeof(etpf) <: Interpolations.FilledExtrapolation
    @test parent(etpf) === itpg

    @test @inferred(size(etpf)) == (xmax,)
    @test isnan(@inferred(etpf(-2.5)))
    @test isnan(etpf(0.999))
    @test @inferred(etpf(1)) ≈ f(1)
    @test etpf(10) ≈ f(10)
    @test isnan(@inferred(etpf(10.001)))

    @test etpf(2.5,1) == etpf(2.5)   # for show method
    @test_throws BoundsError etpf(2.5,2)
    @test_throws BoundsError etpf(2.5,2,1)

    x =  @inferred(etpf(dual(-2.5,1)))
    @test isa(x, Dual)

    etpl = extrapolate(itpg, Line())
    k_lo = A[2] - A[1]
    x_lo = -3.2
    @test etpl(x_lo) ≈ A[1] + k_lo * (x_lo - 1)
    k_hi = A[end] - A[end-1]
    x_hi = xmax + 5.7
    @test etpl(x_hi) ≈ A[end] + k_hi * (x_hi - xmax)


    xmax, ymax = 8,8
    g(x, y) = (x^2 + 3x - 8) * (-2y^2 + y + 1)

    itp2g = interpolate(Float64[g(x,y) for x in 1:xmax, y in 1:ymax], (BSpline(Quadratic(Free(OnGrid()))), BSpline(Linear())))
    etp2g = extrapolate(itp2g, (Line(), Flat()))

    @test @inferred(etp2g(-0.5,4)) ≈ itp2g(1,4) - 1.5 * epsilon(etp2g(dual(1,1),4))
    @test @inferred(etp2g(5,100)) ≈ itp2g(5,ymax)

    etp2ud = extrapolate(itp2g, ((Line(), Flat()), Flat()))
    @test @inferred(etp2ud(-0.5,4)) ≈ itp2g(1,4) - 1.5 * epsilon(etp2g(dual(1,1),4))
    @test @inferred(etp2ud(5, -4)) == etp2ud(5,1)
    @test @inferred(etp2ud(100, 4)) == etp2ud(8,4)
    @test @inferred(etp2ud(-.5, 100)) == itp2g(1,8) - 1.5 * epsilon(etp2g(dual(1,1),8))

    etp2ll = extrapolate(itp2g, Line())
    @test @inferred(etp2ll(-0.5,100)) ≈ (itp2g(1,8) - 1.5 * epsilon(etp2ll(dual(1,1),8))) + (100 - 8) * epsilon(etp2ll(1,dual(8,1)))

    # Allow element types that don't support conversion to Int (#87):
    etp87g = extrapolate(interpolate([1.0im, 2.0im, 3.0im], BSpline(Linear())), 0.0im)
    @test @inferred(etp87g(1)) == 1.0im
    @test @inferred(etp87g(1.5)) == 1.5im
    @test @inferred(etp87g(0.75)) == 0.0im
    @test @inferred(etp87g(3.25)) == 0.0im

    # Make sure it works with Gridded too
    etp100g = extrapolate(interpolate(([10;20],),[100;110], Gridded(Linear())), Flat())
    @test @inferred(etp100g(5)) == 100
    @test @inferred(etp100g(15)) == 105
    @test @inferred(etp100g(25)) == 110
    # issue #178
    a = randn(10,10) + im*rand(10,10)
    etp = @inferred(extrapolate(interpolate((1:10, 1:10), a, Gridded(Linear())), 0.0))
    @test @inferred(etp(-1,0)) === 0.0+0.0im

    # check all extrapolations work with vectorized indexing
    for E in [0,Flat(),Line(),Periodic(),Reflect()]
        @test (@inferred(extrapolate(interpolate([0,0],BSpline(Linear())),E))([1.2, 1.8, 3.1])) == [0,0,0]
    end

    # Issue #156
    F     = *(collect(1.0:10.0), collect(1:4)')
    itp   = interpolate(F, (BSpline(Linear()), NoInterp()));
    itps   = scale(itp, 1:10, 1:4)
    itpe   = extrapolate(itps, (Line(), Throw()))
    @test itpe(10.1, 1) ≈ 10.1
    @test_throws BoundsError itpe(9.9, 0)

    # Issue #232
    targeterr = ArgumentError("cannot create a filled extrapolation with a type Line, use a value of this type instead (e.g., Line())")
    @test_throws targeterr extrapolate(itp, Line)

    # Issue #244
    xs = range(1e-2, stop = 8.3, length = 3)
    ys = sort(rand(3))
    itp = linear_interpolation(xs, ys, extrapolation_bc = Flat())
    @test itp(8.3) ≈ ys[end]

    # Issue #288
    etp = extrapolate(interpolate(collect(1:12), NoInterp()) , 0)
    @test etp(0:23) == [0:12; zeros(Int, 11)]

    include("type-stability.jl")
    include("non1.jl")
    include("periodic.jl")
end

mutable struct FilledExtrapolation{T,N,ITP<:AbstractInterpolation,IT,FT} <: AbstractExtrapolation{T,N,ITP,IT}
    itp::ITP
    fillvalue::FT
end

function Base.:(==)(o1::FilledExtrapolation, o2::FilledExtrapolation)
    o1.fillvalue == o2.fillvalue &&
    o1.itp == o2.itp
end

function FilledExtrapolation(itp::AbstractInterpolation{T,N,IT}, fillvalue) where {T,N,IT}
    Te = promote_type(T,typeof(fillvalue))
    FilledExtrapolation{Te,N,typeof(itp),IT,typeof(fillvalue)}(itp, fillvalue)
end

@noinline FilledExtrapolation(itp::AbstractInterpolation{T,N,IT}, ::Type{F}) where {T,N,IT,F} =
    throw(ArgumentError("cannot create a filled extrapolation with a type $F, use a value of this type instead (e.g., $F(0))"))
@noinline FilledExtrapolation(itp::AbstractInterpolation{T,N,IT}, ::Type{F}) where {T,N,IT,F<:BoundaryCondition} =
    throw(ArgumentError("cannot create a filled extrapolation with a type $F, use a value of this type instead (e.g., $F())"))

Base.parent(A::FilledExtrapolation) = A.itp
etpflag(A::FilledExtrapolation) = A.fillvalue
itpflag(A::FilledExtrapolation) = itpflag(A.itp)

"""
`extrapolate(itp, fillvalue)` creates an extrapolation object that returns the `fillvalue` any time the indexes in `itp(x1,x2,...)` are out-of-bounds.
"""
extrapolate(itp::AbstractInterpolation{T,N,IT}, fillvalue) where {T,N,IT} = FilledExtrapolation(itp, fillvalue)

@inline function (etp::FilledExtrapolation{T,N})(x::Vararg{Number,N}) where {T,N}
    itp = parent(etp)
    coefs = coefficients(itp)
    Tret = promote_type(eltype(coefs), typeof.(x)...,T)
    if checkbounds(Bool, itp, x...)
        @inbounds itp(x...)
    else
        convert(Tret, etp.fillvalue)
    end
end
@inline function (etp::FilledExtrapolation{T,N})(args::Vararg{Number,M}) where {T,M,N}
    inds, trailing = Base.IteratorsMD.split(args, Val(N))
    @boundscheck all(x->x==1, trailing) || Base.throw_boundserror(etp, args)
    @assert length(inds) == N
    etp(inds...)
end
@inline function (etp::FilledExtrapolation{T,N})(x::Vararg{Union{Number,AbstractVector},N}) where {T,N}
    itp = parent(etp)
    Tret = typeof(lispyprod(zero(T), x...))
    ret = fill(convert(Tret, etp.fillvalue), shape(x...))
    axsib = inbounds(itp, x...)
    any(isempty, axsib) && return ret
    xib = getindex.(x, axsib)
    getindex!(view(ret, keepvectors(axsib...)...), itp, xib...)
    return ret
end

@inline function Interpolations.gradient(etp::FilledExtrapolation{T, N, ITP}, x::Vararg{Number, N}) where {T,N,ITP}
    itp = parent(etp)
    check_type() = Base._return_type(gradient, Tuple{ITP, map(typeof, x)...})
    if checkbounds(Bool, itp, x...)
        gradient(itp, x...)
    else
        ptype = eltype(check_type())
        return zeros(SVector{ndims(etp), ptype})
    end
end

expand_index_resid_etp(deg, fillvalue, (l, u), x, etp::FilledExtrapolation, xN) =
    (l <= x <= u || Base.throw_boundserror(etp, xN))

# expand_etp_valueE(fv::FT, etp::FilledExtrapolation{T,N,ITP,IT,FT}, x) where {T,N,ITP,IT,FT} = fv
# expand_etp_gradientE(fv::FT, etp::FilledExtrapolation{T,N,ITP,IT,FT}, x) where {T,N,ITP,IT,FT} =
#     zero(SVector{N,FT})
# expand_etp_hessianE(fv::FT, etp::FilledExtrapolation{T,N,ITP,IT,FT}, x) where {T,N,ITP,IT,FT} =
#     zero(Matrix{N,N,FT})

using Interpolations, Test, ForwardDiff

@testset "Issues" begin
    @testset "issue 34" begin
        A = rand(1:20, 100, 100)

        # In #34, this incantation throws
        itp = interpolate(A, BSpline(Quadratic(Flat(OnCell()))))
        # Sanity check that not only don't throw, but actually interpolate
        for i in 1:size(A,1), j in 1:size(A,2)
            @test itp[i,j] ≈ A[i,j]
        end
    end

    @testset "issue 129" begin
        xy = [3z+2y for z in range(0.0,stop=1,length=10),y in 0:0.2:1]
        itp = interpolate((1:10,1:6),xy,(Gridded(Linear()),NoInterp()))
        @test itp(3.3,1:6) == [itp(3.3,i) for i = 1:6]
        sitp = scale(itp ,range(0.0,stop=1.0,length=10),1:6)
        @test sitp(0.8,1:6) == [sitp(0.8,i) for i = 1:6]
    end

    @testset "issue 151" begin
        V = zeros(10,10,10,10)
        interpV = interpolate(V, BSpline(Cubic(Line(OnGrid()))))
        @test ndims(interpV) == 4
    end

    @testset "issue 158" begin
        A_x = 1.:2.:40.
        A = [log(x) for x in A_x]
        itp = interpolate(A, BSpline(Cubic(Line(OnGrid()))))
        sitp = scale(itp, A_x)
        @test_throws BoundsError sitp(42.0)
        @test_throws BoundsError sitp([3.0,42.0])
    end

    @testset "issue 165" begin
        V0 = Array{Float64, 2}(undef, 5, 6)
        yGrid = range(-1.0,stop= 1.0,length= 5)
        bGrid = range(2.0, stop=3.0, length=6)
        iV = scale(interpolate(V0, BSpline(Cubic(Line(OnCell())))), yGrid, bGrid)
        @test iV isa Interpolations.AbstractInterpolation
    end

    @testset "issue 191" begin
        function eff(p, thing)
            out = p[1] *  p[2]
            return out
        end
        function GradientWrapper(func, p, thing)
            f(x) = func(x, thing)
            return ForwardDiff.gradient(f,p)
        end
        io = IOBuffer()
        println(io, "Start.")
        n = 40
        z = [i * j for i in 1:n, j in 1:n]
        itp = interpolate(z, BSpline(Cubic(Natural(OnGrid()))))
        p = [5.0, 6.0]
        test = [itp, itp]
        println(io, "Using type $(typeof(test))")
        println(io, "Calling the derivative directly:")
        f(x) = eff(x,test)
        println(io, ForwardDiff.gradient(f, p))
        println(io, "Calling the wrapper:")
        println(io, GradientWrapper(eff, p, test))
        test = Array{Any}(undef, 2)
        test[1] = itp
        test[2] = itp
        println(io, "Using type $(typeof(test))")
        println(io, "Calling the derivative directly:")
        g(x) = eff(x, test)
        println(io, ForwardDiff.gradient(g, p))
        println(io, "Calling the wrapper:")
        println(io, GradientWrapper(eff, p, test))
        test = Array{AbstractInterpolation}(undef, 2)
        test[1] = itp
        test[2] = itp
        println(io, "Using type $(typeof(test))")
        println(io, "Calling the derivative directly:")
        h(x) = eff(x, test)
        println(io, ForwardDiff.gradient(h, p))
        println(io, "Calling the wrapper -- this fails:")
        println(io, GradientWrapper(eff, p, test))
        println(io, "Done.")
        str = String(take!(io))
        @test endswith(str, "Done.\n")
    end

    @testset "issue 200" begin
        grid = range(0, stop=2.0, length=10)
        vals = [-exp(-x) for x in grid]
        itp = interpolate(vals, BSpline(Cubic(Line(OnGrid()))))
        sitp = scale(itp, grid)
        s = sitp(0.0)
        @test sitp([0.0, 0.0]) == [s, s]
    end

    @testset "issue 202" begin
        xs = 1:10
        itp = scale(interpolate(zeros(10), BSpline(Cubic(Periodic(OnGrid())))), xs)
        extp = extrapolate(itp, Periodic())
        @test Interpolations.gradient(extp, 2.) == [0.0]
        @test_throws ErrorException Interpolations.gradient(extp, 2.0, 2.0)

        # The issue title says 3d, so let's try a 3d case
        A = (0.2.*(1:3)) .* (0.3.*(1:3))' .* reshape(0.4.*(1:3), 1, 1, 3)
        itp = interpolate(A, BSpline(Linear()))
        etp = extrapolate(itp, Line())
        @test Interpolations.gradient(etp, 2, 2, 2) ≈ [0.2*0.6*0.8, 0.4*0.3*0.8, 0.4*0.6*0.4]
        @test Interpolations.gradient(etp, 10, 2, 2) ≈ [0.2*0.6*0.8, 0.6*0.3*0.8, 0.6*0.6*0.4]
        @test Interpolations.gradient(etp, 2, 10, 2) ≈ [0.2*0.9*0.8, 0.4*0.3*0.8, 0.4*0.9*0.4]
        @test Interpolations.gradient(etp, 2, 2, 10) ≈ [0.2*0.6*1.2, 0.4*0.3*1.2, 0.4*0.6*0.4]
    end

    @testset "issue 213" begin
        function build_itp()
            A_x = 1.0:2.0:40.0
            A = A_x.^2
            knots = (A_x,)
            interpolate(knots, A, Gridded(Linear()))
        end
        function itp_test(x::AbstractVector)
            itp = build_itp()
            return itp(x...)
        end

        j = ForwardDiff.gradient(itp_test, [2.0])
        @test j ≈ Interpolations.gradient(build_itp(), 2.0)
    end

    @testset "issue 335" begin
        function build_itp()
            A_x = 1:5
            A = A_x
            knots = (A_x,)
            linear_interpolation(knots, A, extrapolation_bc=Line())
        end
        function itp_test(x::AbstractVector)
            itp = build_itp()
            return itp(x...)
        end

        @test ForwardDiff.gradient(itp_test, [1.0]) ≈ Interpolations.gradient(build_itp(), 1.0)
        @test ForwardDiff.gradient(itp_test, [5.0]) ≈ Interpolations.gradient(build_itp(), 5.0)
    end
    @testset "issue 430" begin
        mat1 = rand(Float64, 64, 64)
        itp = linear_interpolation((1:64, 1:64,), mat1)
        function itp_test(x::AbstractVector)
            return itp(x...)
        end
        @test ForwardDiff.gradient(itp_test, [1.0, 1.0]) ≈ Interpolations.gradient(itp, 1.0, 1.0)
        @test ForwardDiff.gradient(itp_test, [3.0, 2.0]) ≈ Interpolations.gradient(itp, 3.0, 2.0)
    end
    @testset "issue 469" begin
        # We have different inference result on different version.
        max_dim = isdefined(Base, :Any32) ? 7 : 5
        for dims in 3:max_dim
            A = zeros(Float64, ntuple(_ -> 5, dims))
            itp = interpolate(A, BSpline(Quadratic(Reflect(OnCell()))))
            @test (@inferred Interpolations.hessian(itp, ntuple(_ -> 1.0, dims)...)) == zeros(dims,dims)
        end
        @test Interpolations.symsize(Val(36)) == 8
        @test Interpolations.symsize(Val(45)) == 9
        @test_throws ErrorException Interpolations.symsize(Val(2))
        @test_throws ErrorException Interpolations.symsize(Val(33))
    end
    @testset "issue 509" begin
        @eval struct CPUITP{T,N} <: AbstractInterpolation{T,N,NTuple{N,NoInterp}} end
        @test Broadcast.BroadcastStyle(CPUITP{Int,2}) == Broadcast.BroadcastStyle(Matrix{Int})
        # example in #509
        percentile_values = [0.0, 0.01, 0.1, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0, 10.0, 20.0, 30.0, 40.0, 50.0, 60.0, 70.0, 80.0, 90.0, 91.0, 92.0, 93.0, 94.0, 95.0, 96.0, 97.0, 98.0, 99.0, 99.9, 99.99, 100.0]
        y = sort(randn(length(percentile_values)))
        itp_cdf = extrapolate(interpolate(y, percentile_values, SteffenMonotonicInterpolation()), Flat())
        t = -3.0:0.01:3.0
        @test itp_cdf.(t) isa Vector{Float64}
    end
end

"""
     CubicHermite
     
This type is purposely left undocumented since the interface is expected to radically change in order to make it conform to the `AbstractInterpolation` interface. Consider this API to be highly unstable and non-public, and that breaking changes to this code could be made in a point release.
"""
struct CubicHermite
    xs::Vector{Float64}
    ys::Vector{Float64}
    dydxs::Vector{Float64}
    function CubicHermite(xs, ys, dydxs)
        if length(xs) < 2
            throw(
                DomainError(
                    "There must be at least two samples in the domain of the CubicHermite interpolator.",
                ),
            )
        end
        x = xs[1]
        for i = 2:length(xs)
            if xs[i] ≤ x
                throw(DomainError("The list of abscissas must be strictly increasing."))
            end
            x = xs[i]
        end
        if (length(xs) != length(ys) || length(ys) != length(dydxs))
            throw(
                DomainError(
                    "There must be exactly the same number of abscissas as ordinates and derivatives.",
                ),
            )
        end
        new(xs, ys, dydxs)
    end
end

function (ch::CubicHermite)(x::Float64)::Float64
    if x ≤ ch.xs[1]
        if x == ch.xs[1]
            return ch.ys[1]
        end
        throw(
            DomainError(
                "Requested abscissas $x is less than the minimum value of the domain of the interpolator.",
            ),
        )
    end

    if x ≥ last(ch.xs)
        if x == last(ch.xs)
            return last(ch.ys)
        end
        throw(
            DomainError(
                "Requested abscissa $x is greater than the maximum value of the domain of the interpolator.",
            ),
        )
    end
    # searchsorted is convenient but it is a little too general for this usecase.
    # We have asserted that the xs's are strictly increasing.
    # Ostensibly there is another function that could do this more cleanly.
    urange = searchsorted(ch.xs, x)
    # urange.start exceeds urange.stop in this case which again indicates that searchsorted is not quite the right tool for this job:
    i = urange.stop
    x1 = ch.xs[i]
    x2 = ch.xs[i+1]
    @assert x1 ≤ x ≤ x2
    h = x2 - x1
    y1 = ch.ys[i]
    y2 = ch.ys[i+1]

    dydx1 = ch.dydxs[i]
    dydx2 = ch.dydxs[i+1]
    # Corless, A Graduate Introduction to Numerical Methods, equation 14.10:
    c1 = (2x - 3x1 + x2) * (x - x2) * (x - x2) / (h * h * h)
    c2 = -(2x - 3x2 + x1) * (x - x1) * (x - x1) / (h * h * h)
    d1 = (x - x1) * (x - x2) * (x - x2) / (h * h)
    d2 = (x - x2) * (x - x1) * (x - x1) / (h * h)
    c1 * y1 + c2 * y2 + d1 * dydx1 + d2 * dydx2
end

function gradient(ch::CubicHermite, x::Float64)::Float64
    if x ≤ ch.xs[1]
        if x == ch.xs[1]
            return ch.dydxs[1]
        end
        throw(
            DomainError(
                "Requested abscissas $x is less than the minimum value of the domain of the interpolator.",
            ),
        )
    end

    if x ≥ last(ch.xs)
        if x == last(ch.xs)
            return last(ch.dydxs)
        end
        throw(
            DomainError(
                "Requested abscissa $x is greater than the maximum value of the domain of the interpolator.",
            ),
        )
    end
    urange = searchsorted(ch.xs, x)
    i = urange.stop
    x1 = ch.xs[i]
    x2 = ch.xs[i+1]
    @assert x1 ≤ x ≤ x2
    h = x2 - x1
    y1 = ch.ys[i]
    y2 = ch.ys[i+1]

    dydx1 = ch.dydxs[i]
    dydx2 = ch.dydxs[i+1]
    # Corless, A Graduate Introduction to Numerical Methods, equation 14.11:
    c1 = 6 * (x - x2) * (x - x1) / (h * h * h)
    d1 = (x - x2) * (3x - 2x1 - x2) / (h * h)
    d2 = (x - x1) * (3x - 2x2 - x1) / (h * h)
    c1 * (y1 - y2) + d1 * dydx1 + d2 * dydx2
end

function hessian(ch::CubicHermite, x::Float64)::Float64
    if x < ch.xs[1]
        throw(
            DomainError(
                "Requested abscissas $x is less than the minimum value of the domain of the interpolator.",
            ),
        )
    end

    if x ≥ last(ch.xs)
        if x == last(ch.xs)
            h = ch.xs[end] - ch.xs[end-1]
            c1 = 6 / (h * h)
            d1 = 2 / h
            d2 = 4 / h
            return c1 * (ch.ys[end-1] - ch.ys[end]) +
                   d1 * ch.dydxs[end-1] +
                   d2 * ch.dydxs[end]
        end
        throw(
            DomainError(
                "Requested abscissa $x is greater than the maximum value of the domain of the interpolator.",
            ),
        )
    end
    urange = searchsorted(ch.xs, x)
    i = urange.stop
    x1 = ch.xs[i]
    x2 = ch.xs[i+1]
    @assert x1 ≤ x ≤ x2
    h = x2 - x1
    y1 = ch.ys[i]
    y2 = ch.ys[i+1]

    dydx1 = ch.dydxs[i]
    dydx2 = ch.dydxs[i+1]
    # Corless, A Graduate Introduction to Numerical Methods, equation 14.12:
    c1 = 6 * (2x - x1 - x2) / (h * h * h)
    d1 = 2 * (3x - 2x2 - x1) / (h * h)
    d2 = 2 * (3x - 2x1 - x2) / (h * h)
    c1 * (y1 - y2) + d1 * dydx1 + d2 * dydx2
end


export CubicHermite
export gradient
export hessian

padded_axes(axs, it::InterpolationType) = (ax->padded_axis(ax, it)).(axs)
padded_axes(axs::NTuple{N,AbstractUnitRange}, it::NTuple{N,InterpolationType}) where N =
    padded_axis.(axs, it)

padded_similar(::Type{TC}, inds::Tuple{Vararg{Base.OneTo{Int}}}) where TC = Array{TC}(undef, length.(inds))
padded_similar(::Type{TC}, inds) where TC = OffsetArray{TC}(undef, inds)

# Narrow ax by the amount that axpad is larger
padinset(ax::AbstractUnitRange, axpad) = 2*first(ax)-first(axpad):2*last(ax)-last(axpad)
function padinset(ax::Base.OneTo, axpad::Base.OneTo)
    # We don't have any types that pad asymmetrically. Therefore if they both start at 1,
    # they must be the same
    @assert ax == axpad
    return ax
end

ct!(coefs, indscp, A, indsA) = copyto!(coefs, CartesianIndices(indscp), A, CartesianIndices(indsA))

copy_with_padding(A, it) = copy_with_padding(eltype(A), A, it)
function copy_with_padding(::Type{TC}, A, it::DimSpec{InterpolationType}) where {TC}
    indsA = axes(A)
    indspad = padded_axes(indsA, it)
    coefs = padded_similar(TC, indspad)
    if indspad == indsA
        coefs = copyto!(coefs, A)
    else
        fill!(coefs, zero(TC))
        ct!(coefs, indsA, A, indsA)
    end
    coefs
end

prefilter!(::Type{TWeights}, A::AbstractArray, ::BSpline{D}, ::GridType) where {TWeights,D<:Union{Constant,Linear}} = A

function prefilter(
    ::Type{TWeights}, ::Type{TC}, A::AbstractArray,
    it::Union{BSpline,Tuple{Vararg{Union{BSpline,NoInterp}}}}
    ) where {TWeights,TC}
    ret = copy_with_padding(TC, A, it)
    prefilter!(TWeights, ret, it)
end

function prefilter(
    ::Type{TWeights}, ::Type{TC}, A::AbstractArray,
    it::Union{BSpline,Tuple{Vararg{Union{BSpline,NoInterp}}}},
    λ::Real, k::Int
    ) where {TWeights,TC}
    ret = copy_with_padding(TC, A, it)
    prefilter!(TWeights, ret, it, λ, k)
end

function prefilter!(
    ::Type{TWeights}, ret::TCoefs, it::BSpline
    ) where {TWeights,TCoefs<:AbstractArray}
    sz = size(ret)
    first = true
    for dim in 1:ndims(ret)
        M, b = prefiltering_system(TWeights, eltype(TCoefs), sz[dim], degree(it))
        A_ldiv_B_md!(popwrapper(ret), M, popwrapper(ret), dim, b)
    end
    ret
end

function diffop(::Type{TWeights}, n::Int, k::Int) where {TWeights}
    D = spdiagm(0 => ones(TWeights,n))
    for i in 1:k
        D = diff(D; dims=1)
    end
    ## TODO: Normalize by n?
    D' * D
end
diffop(n::Int, k::Int) = diffop(Float64, n, k)
### TODO: add compiled constructor for most common operators of order k=1,2


function prefilter!(
    ::Type{TWeights}, ret::TCoefs, it::BSpline, λ::Real, k::Int
    ) where {TWeights,TCoefs<:AbstractArray}

    sz = size(ret)

    # Test if regularizing is allowed
    fallback = if ndims(ret) > 1
        @warn "Smooth BSpline only available for Vectors, fallback to non-smoothed"
        true
    elseif λ < 0
        @warn "Smooth BSpline require a non-negative λ, fallback to non-smoothed: $(λ)"
        true
    elseif λ == 0
        true
    else
        false
    end
    
    if fallback
        return prefilter!(TWeights, ret, it)
    end

    M, b = prefiltering_system(TWeights, eltype(TCoefs), sz[1], degree(it))
    ## Solve with regularization
    # Convert to dense Matrix because `*(Woodbury{Adjoint}, Woodbury)` is not defined
    Mt = Matrix(M)'
    Q = diffop(TWeights, sz[1], k)
    K = cholesky(Mt * Matrix(M) + λ * Q)
    B = Mt * popwrapper(ret)
    ldiv!(popwrapper(ret), K, B)

    ret
end

function prefilter!(
    ::Type{TWeights}, ret::TCoefs, its::Tuple{Vararg{Union{BSpline,NoInterp}}}
    ) where {TWeights,TCoefs<:AbstractArray}
    sz = size(ret)
    for dim in 1:ndims(ret)
        it = iextract(its, dim)
        if it != NoInterp
            M, b = prefiltering_system(TWeights, eltype(TCoefs), sz[dim], degree(it))
            if M != nothing
                A_ldiv_B_md!(popwrapper(ret), M, popwrapper(ret), dim, b)
            end
        end
    end
    ret
end

prefiltering_system(::Any, ::Any, ::Any, ::Any) = nothing, nothing

popwrapper(A) = A
popwrapper(A::OffsetArray) = A.parent

"""
    M, b = prefiltering_system{T,TC,GT<:GridType,D<:Degree}m(::T, ::Type{TC}, n::Int, ::Type{D}, ::Type{GT})

Given element types (`T`, `TC`) and interpolation scheme
(`GT`, `D`) as well the number of rows in the data input (`n`), compute the
system used to prefilter spline coefficients. Boundary conditions determine the
values on the first and last rows.

Some of these boundary conditions require that these rows have off-tridiagonal
elements (e.g the `[1,3]` element of the matrix). To maintain the efficiency of
solving tridiagonal systems, the [Woodbury matrix identity](https://en.wikipedia.org/wiki/Woodbury_matrix_identity)
is used to add additional elements off the main 3 diagonals.

The filtered coefficients are given by solving the equation system

    M * c = v + b

where `c` are the sought coefficients, and `v` are the data points.
"""
prefiltering_system

"""
    dl, d, du = inner_system_diags{T,IT}(::Type{T}, n::Int, ::Type{IT})

Helper function to generate the prefiltering equation system: generates the diagonals
for a `n`-by-`n` tridiagonal matrix with eltype `T` corresponding to the interpolation
type `IT`.

`dl`, `d`, and `du` are intended to be used e.g. as in `M = Tridiagonal(dl, d, du)`
"""
inner_system_diags

module ConvenienceConstructorTests

using Interpolations
using Test
using Base.Cartesian

# unit test setup
XMIN = 2
XMAX = 10
YMIN = 1
YMAX = 8
ΔX = .1
ΔY = .5
XLEN = convert(Integer, floor((XMAX - XMIN)/ΔX) + 1)
YLEN = convert(Integer, floor((YMAX - YMIN)/ΔY) + 1)

@testset "1d-interpolations" begin
    @testset "1d-regular-grids" begin
        xs = XMIN:ΔX:XMAX
        f(x) = log(x)
        A = [f(x) for x in xs]
        interp = linear_interpolation(xs, A) # using convenience constructor
        interp_full = extrapolate(scale(interpolate(A, BSpline(Linear())), xs), Throw()) # using full constructor

        @test typeof(interp) == typeof(interp_full)
        @test interp(XMIN) ≈ f(XMIN)
        @test interp(XMAX) ≈ f(XMAX)
        @test interp(XMIN + ΔX) ≈ f(XMIN + ΔX)
        @test interp(XMAX - ΔX) ≈ f(XMAX - ΔX)
        @test interp(XMIN + ΔX / 2) ≈ f(XMIN + ΔX / 2) atol=.1
        @test_throws BoundsError interp(XMIN - ΔX / 2)
        @test_throws BoundsError interp(XMAX + ΔX / 2)
    end
    
    @testset "1d-regular-grids-constant" begin
        xs = XMIN:ΔX:XMAX
        f(x) = log(x)
        A = [f(x) for x in xs]
        interp = constant_interpolation(xs, A) # using convenience constructor
        interp_full = extrapolate(scale(interpolate(A, BSpline(Constant())), xs), Throw()) # using full constructor

        @test typeof(interp) == typeof(interp_full)
        @test interp(XMIN) ≈ f(XMIN)
        @test interp(XMAX) ≈ f(XMAX)
        @test interp(XMIN + ΔX) ≈ f(XMIN + ΔX)
        @test interp(XMAX - ΔX) ≈ f(XMAX - ΔX)
        @test interp(XMIN + ΔX / 2) ≈ f(XMIN + ΔX / 2) atol=.1
        @test_throws BoundsError interp(XMIN - ΔX / 2)
        @test_throws BoundsError interp(XMAX + ΔX / 2)

        # Check deprecated usage
        interp = ConstantInterpolation(xs, A; extrapolation_bc = Throw()) # using convenience constructor
        interp_full = extrapolate(scale(interpolate(A, BSpline(Constant())), xs), Throw()) # using full constructor

        @test typeof(interp) == typeof(interp_full)
        @test interp(XMIN) ≈ f(XMIN)
        @test interp(XMAX) ≈ f(XMAX)
        @test interp(XMIN + ΔX) ≈ f(XMIN + ΔX)
        @test interp(XMAX - ΔX) ≈ f(XMAX - ΔX)
        @test interp(XMIN + ΔX / 2) ≈ f(XMIN + ΔX / 2) atol=.1
        @test_throws BoundsError interp(XMIN - ΔX / 2)
        @test_throws BoundsError interp(XMAX + ΔX / 2)
    end

    @testset "1d-regular-grids-cubic" begin
        xs = XMIN:ΔX:XMAX
        f(x) = log(x)
        A = [f(x) for x in xs]
        interp = cubic_spline_interpolation(xs, A)
        interp_full = extrapolate(scale(interpolate(A, BSpline(Cubic(Line(OnGrid())))), xs), Throw())

        @test typeof(interp) == typeof(interp_full)
        @test interp(XMIN) ≈ f(XMIN)
        @test interp(XMAX) ≈ f(XMAX)
        @test interp(XMIN + ΔX) ≈ f(XMIN + ΔX)
        @test interp(XMAX - ΔX) ≈ f(XMAX - ΔX)
        @test interp(XMIN + ΔX / 2) ≈ f(XMIN + ΔX / 2) atol=.1
        @test_throws BoundsError interp(XMIN - ΔX / 2)
        @test_throws BoundsError interp(XMAX + ΔX / 2)

        #  Check deprecated usage
        interp = CubicSplineInterpolation(xs, A; extrapolation_bc = Throw())
        interp_full = extrapolate(scale(interpolate(A, BSpline(Cubic(Line(OnGrid())))), xs), Throw())

        @test typeof(interp) == typeof(interp_full)
        @test interp(XMIN) ≈ f(XMIN)
        @test interp(XMAX) ≈ f(XMAX)
        @test interp(XMIN + ΔX) ≈ f(XMIN + ΔX)
        @test interp(XMAX - ΔX) ≈ f(XMAX - ΔX)
        @test interp(XMIN + ΔX / 2) ≈ f(XMIN + ΔX / 2) atol=.1
        @test_throws BoundsError interp(XMIN - ΔX / 2)
        @test_throws BoundsError interp(XMAX + ΔX / 2)
    end

    @testset "1d-irregular-grids" begin
        xs = [x^2 for x in XMIN:ΔX:XMAX]
        xmin = xs[1]
        xmax = xs[XLEN]
        f(x) = log(x)
        A = [f(x) for x in xs]
        interp = linear_interpolation(xs, A)
        interp_full = extrapolate(interpolate((xs, ), A, Gridded(Linear())), Throw())

        @test typeof(interp) == typeof(interp_full)
        @test interp(xmin) ≈ f(xmin)
        @test interp(xmax) ≈ f(xmax)
        @test interp(xs[2]) ≈ f(xs[2])
        @test interp(xmin + ΔX / 2) ≈ f(xmin + ΔX / 2) atol=.1
        @test_throws BoundsError interp(xmin - ΔX / 2)
        @test_throws BoundsError interp(xmax + ΔX / 2)
    end
    
    @testset "1d-irregular-grids-constant" begin
        xs = [x^2 for x in XMIN:ΔX:XMAX]
        xmin = xs[1]
        xmax = xs[XLEN]
        f(x) = log(x)
        A = [f(x) for x in xs]
        interp = constant_interpolation(xs, A)
        interp_full = extrapolate(interpolate((xs, ), A, Gridded(Constant())), Throw())

        @test typeof(interp) == typeof(interp_full)
        @test interp(xmin) ≈ f(xmin)
        @test interp(xmax) ≈ f(xmax)
        @test interp(xs[2]) ≈ f(xs[2])
        @test interp(xmin + ΔX / 2) ≈ f(xmin + ΔX / 2) atol=.1
        @test_throws BoundsError interp(xmin - ΔX / 2)
        @test_throws BoundsError interp(xmax + ΔX / 2)
    end

    @testset "1d-handling-extrapolation" begin
        xs = XMIN:ΔX:XMAX
        f(x) = log(x)
        A = [f(x) for x in xs]
        ΔA_l = A[2] - A[1]
        ΔA_h = A[end] - A[end - 1]
        x_lower = XMIN - ΔX
        x_higher = XMAX + ΔX

        extrap = linear_interpolation(xs, A, extrapolation_bc = Line())
        extrap_full = extrapolate(scale(interpolate(A, BSpline(Linear())), xs), Line())

        @test typeof(extrap) == typeof(extrap_full)
        @test extrap(x_lower) ≈ A[1] - ΔA_l
        @test extrap(x_higher) ≈ A[end] + ΔA_h

        # Check deprecated usage
        extrap = LinearInterpolation(xs, A, extrapolation_bc = Line())
        extrap_full = extrapolate(scale(interpolate(A, BSpline(Linear())), xs), Line())

        @test typeof(extrap) == typeof(extrap_full)
        @test extrap(x_lower) ≈ A[1] - ΔA_l
        @test extrap(x_higher) ≈ A[end] + ΔA_h
    end
end

@testset "2d-interpolations" begin
    @testset "2d-regular-grids" begin
        xs = XMIN:ΔX:XMAX
        ys = YMIN:ΔY:YMAX
        f(x, y) = log(x+y)
        A = [f(x,y) for x in xs, y in ys]
        interp = linear_interpolation((xs, ys), A)
        interp_full = extrapolate(scale(interpolate(A, BSpline(Linear())), xs, ys), Throw())

        @test typeof(interp) == typeof(interp_full)
        @test interp(XMIN,YMIN) ≈ f(XMIN,YMIN)
        @test interp(XMIN,YMAX) ≈ f(XMIN,YMAX)
        @test interp(XMAX,YMIN) ≈ f(XMAX,YMIN)
        @test interp(XMAX,YMAX) ≈ f(XMAX,YMAX)
        @test interp(XMIN + ΔX,YMIN) ≈ f(XMIN + ΔX,YMIN)
        @test interp(XMIN,YMIN + ΔY) ≈ f(XMIN,YMIN + ΔY)
        @test interp(XMIN + ΔX,YMIN + ΔY) ≈ f(XMIN + ΔX,YMIN + ΔY)
        @test interp(XMIN + ΔX / 2,YMIN + ΔY / 2) ≈ f(XMIN + ΔX / 2,YMIN + ΔY / 2) atol=.1
        @test_throws BoundsError interp(XMIN - ΔX / 2,YMIN - ΔY / 2)
        @test_throws BoundsError interp(XMIN - ΔX / 2,YMIN + ΔY / 2)
        @test_throws BoundsError interp(XMIN + ΔX / 2,YMIN - ΔY / 2)
        @test_throws BoundsError interp(XMAX + ΔX / 2,YMAX + ΔY / 2)
    end
    
    @testset "2d-regular-grids-constant" begin
        xs = XMIN:ΔX:XMAX
        ys = YMIN:ΔY:YMAX
        f(x, y) = log(x+y)
        A = [f(x,y) for x in xs, y in ys]
        interp = constant_interpolation((xs, ys), A)
        interp_full = extrapolate(scale(interpolate(A, BSpline(Constant())), xs, ys), Throw())

        @test typeof(interp) == typeof(interp_full)
        @test interp(XMIN,YMIN) ≈ f(XMIN,YMIN)
        @test interp(XMIN,YMAX) ≈ f(XMIN,YMAX)
        @test interp(XMAX,YMIN) ≈ f(XMAX,YMIN)
        @test interp(XMAX,YMAX) ≈ f(XMAX,YMAX)
        @test interp(XMIN + ΔX,YMIN) ≈ f(XMIN + ΔX,YMIN)
        @test interp(XMIN,YMIN + ΔY) ≈ f(XMIN,YMIN + ΔY)
        @test interp(XMIN + ΔX,YMIN + ΔY) ≈ f(XMIN + ΔX,YMIN + ΔY)
        @test interp(XMIN + ΔX / 2,YMIN + ΔY / 2) ≈ f(XMIN + ΔX / 2,YMIN + ΔY / 2) atol=.1
        @test_throws BoundsError interp(XMIN - ΔX / 2,YMIN - ΔY / 2)
        @test_throws BoundsError interp(XMIN - ΔX / 2,YMIN + ΔY / 2)
        @test_throws BoundsError interp(XMIN + ΔX / 2,YMIN - ΔY / 2)
        @test_throws BoundsError interp(XMAX + ΔX / 2,YMAX + ΔY / 2)
    end

    @testset "2d-regular-grids-cubic" begin
        xs = XMIN:ΔX:XMAX
        ys = YMIN:ΔY:YMAX
        f(x, y) = log(x+y)
        A = [f(x,y) for x in xs, y in ys]
        interp = cubic_spline_interpolation((xs, ys), A)
        interp_full = extrapolate(scale(interpolate(A, BSpline(Cubic(Line(OnGrid())))), xs, ys), Throw())

        @test typeof(interp) == typeof(interp_full)
        @test interp(XMIN,YMIN) ≈ f(XMIN,YMIN)
        @test interp(XMIN,YMAX) ≈ f(XMIN,YMAX)
        @test interp(XMAX,YMIN) ≈ f(XMAX,YMIN)
        @test interp(XMAX,YMAX) ≈ f(XMAX,YMAX)
        @test interp(XMIN + ΔX,YMIN) ≈ f(XMIN + ΔX,YMIN)
        @test interp(XMIN,YMIN + ΔY) ≈ f(XMIN,YMIN + ΔY)
        @test interp(XMIN + ΔX,YMIN + ΔY) ≈ f(XMIN + ΔX,YMIN + ΔY)
        @test interp(XMIN + ΔX / 2,YMIN + ΔY / 2) ≈ f(XMIN + ΔX / 2,YMIN + ΔY / 2) atol=.1
        @test_throws BoundsError interp(XMIN - ΔX / 2,YMIN - ΔY / 2)
        @test_throws BoundsError interp(XMIN - ΔX / 2,YMIN + ΔY / 2)
        @test_throws BoundsError interp(XMIN + ΔX / 2,YMIN - ΔY / 2)
        @test_throws BoundsError interp(XMAX + ΔX / 2,YMAX + ΔY / 2)
    end

    @testset "2d-irregular-grids" begin
        xs = [x^2 for x in XMIN:ΔX:XMAX]
        ys = [y^2 for y in YMIN:ΔY:YMAX]
        xmin = xs[1]
        xmax = xs[XLEN]
        ymin = ys[1]
        ymax = ys[YLEN]
        f(x, y) = log(x+y)
        A = [f(x,y) for x in xs, y in ys]
        interp = linear_interpolation((xs, ys), A)
        interp_full = extrapolate(interpolate((xs, ys), A, Gridded(Linear())), Throw())

        @test typeof(interp) == typeof(interp_full)
        @test interp(xmin,ymin) ≈ f(xmin,ymin)
        @test interp(xmin,ymax) ≈ f(xmin,ymax)
        @test interp(xmax,ymin) ≈ f(xmax,ymin)
        @test interp(xmax,ymax) ≈ f(xmax,ymax)
        @test interp(xs[2],ymin) ≈ f(xs[2],ymin)
        @test interp(xmin,ys[2]) ≈ f(xmin,ys[2])
        @test interp(xs[2],ys[2]) ≈ f(xs[2],ys[2])
        @test interp(xmin + ΔX / 2,ymin + ΔY / 2) ≈ f(xmin + ΔX / 2,ymin + ΔY / 2) atol=.1
        @test_throws BoundsError interp(xmin - ΔX / 2,ymin - ΔY / 2)
        @test_throws BoundsError interp(xmin - ΔX / 2,ymin + ΔY / 2)
        @test_throws BoundsError interp(xmin + ΔX / 2,ymin - ΔY / 2)
        @test_throws BoundsError interp(xmax + ΔX / 2,ymax + ΔY / 2)
    end
    
    @testset "2d-irregular-grids-constant" begin
        xs = [x^2 for x in XMIN:ΔX:XMAX]
        ys = [y^2 for y in YMIN:ΔY:YMAX]
        xmin = xs[1]
        xmax = xs[XLEN]
        ymin = ys[1]
        ymax = ys[YLEN]
        f(x, y) = log(x+y)
        A = [f(x,y) for x in xs, y in ys]
        interp = constant_interpolation((xs, ys), A)
        interp_full = extrapolate(interpolate((xs, ys), A, Gridded(Constant())), Throw())

        @test typeof(interp) == typeof(interp_full)
        @test interp(xmin,ymin) ≈ f(xmin,ymin)
        @test interp(xmin,ymax) ≈ f(xmin,ymax)
        @test interp(xmax,ymin) ≈ f(xmax,ymin)
        @test interp(xmax,ymax) ≈ f(xmax,ymax)
        @test interp(xs[2],ymin) ≈ f(xs[2],ymin)
        @test interp(xmin,ys[2]) ≈ f(xmin,ys[2])
        @test interp(xs[2],ys[2]) ≈ f(xs[2],ys[2])
        @test interp(xmin + ΔX / 2,ymin + ΔY / 2) ≈ f(xmin + ΔX / 2,ymin + ΔY / 2) atol=.1
        @test_throws BoundsError interp(xmin - ΔX / 2,ymin - ΔY / 2)
        @test_throws BoundsError interp(xmin - ΔX / 2,ymin + ΔY / 2)
        @test_throws BoundsError interp(xmin + ΔX / 2,ymin - ΔY / 2)
        @test_throws BoundsError interp(xmax + ΔX / 2,ymax + ΔY / 2)
    end

    @testset "2d-handling-extrapolation" begin
        xs = XMIN:ΔX:XMAX
        ys = YMIN:ΔY:YMAX
        f(x, y) = log(x+y)
        A = [f(x,y) for x in xs, y in ys]
        ΔA_l = A[2, 1] - A[1, 1]
        ΔA_h = A[end, end] - A[end - 1, end]
        x_lower = XMIN - ΔX
        x_higher = XMAX + ΔX
        y_lower = YMIN - ΔY
        y_higher = YMAX + ΔY

        extrap = linear_interpolation((xs, ys), A, extrapolation_bc = (Line(), Flat()))
        extrap_full = extrapolate(scale(interpolate(A, BSpline(Linear())), xs, ys), (Line(), Flat()))

        @test typeof(extrap) == typeof(extrap_full)
        @test extrap(x_lower, y_lower) ≈ A[1, 1] - ΔA_l
        @test extrap(x_higher, y_higher) ≈ A[end, end] + ΔA_h

        # Check deprecated usage
        extrap = LinearInterpolation((xs, ys), A, extrapolation_bc = (Line(), Flat()))
        extrap_full = extrapolate(scale(interpolate(A, BSpline(Linear())), xs, ys), (Line(), Flat()))

        @test typeof(extrap) == typeof(extrap_full)
        @test extrap(x_lower, y_lower) ≈ A[1, 1] - ΔA_l
        @test extrap(x_higher, y_higher) ≈ A[end, end] + ΔA_h
    end

    @testset "issue #230" begin # at least, I think this is what issue #230 is really about
        f(x,y) = log(x+y)
        xs = 1:5
        ys = 2:0.1:5
        A = [f(x,y) for x in xs, y in ys]
        itp = linear_interpolation((xs, ys), A)
        for (i, j) in zip(Iterators.product(xs, ys), eachindex(A))
            @test itp(i...) ≈ A[j]
        end
    end
end

end

module VisualTests

using Gadfly, Interpolations
const nx = 10
xg = 1:nx
xf = -1.2nx:.1:3.3nx

f1(x) = sin(2pi/nx * (x-1))

y1 = f1.(xg)

p = plot()

if true

Btypes = (Periodic, Flat, Line, Free, Reflect)
Gtypes = (OnCell, OnGrid)
degrees = (
    Constant(), Linear(),
    [Quadratic(T(G())) for T in Btypes, G in Gtypes]...,
    [Cubic(T(G())) for T in Btypes[1:end-1], G in Gtypes]...,  # no Reflect for Cubic
)
Etypes = (Flat, Line, Reflect, Periodic)

for deg in degrees, ET in Etypes
    itp = extrapolate(interpolate(y1, BSpline(deg)), ET())

    stuff = Any[]

    push!(stuff, layer(x=xg,y=y1,Geom.point,Theme(default_color=colorant"green")))
    push!(stuff, layer(x=xf,y=[itp[x] for x in xf],Geom.path,Theme(point_size=2px)))
    title = "$deg, $(nameof(ET))"
    push!(stuff, Guide.title(title))
    display(plot(stuff...))
end

nx = 10
xg = 1:nx
ny = 6
yg = 1:ny

f2(x,y) = sin(2pi/nx * (x-1)) * cos(2pi/ny * (y-1))
zg = f2.(xg, yg')

xf = -1:.1:nx+1
yf = -1:.1:ny+1

itp2 = extrapolate(interpolate(zg, BSpline(Quadratic(Flat(OnCell())))), Line())

display(plot(
    layer(x=xf,y=yf,z=[itp2[x,y] for x in xf, y in yf], Geom.contour),
    Guide.title("Quadratic(Flat(OnCell)), Line")
))

end

end

@testset "Quadratic" begin
    for (constructor, copier) in ((interpolate, x->x), (interpolate!, copy))
        isinplace = constructor == interpolate!
        f(x) = sin((x-3)*2pi/9 - 1)
        xmax = 10
        A = Float64[f(x) for x in 1:xmax]
        for BC in (Flat,Line,Free,Periodic,Reflect,Natural), GT in (OnGrid, OnCell)
            itp1 = @inferred(constructor(copier(A), BSpline(Quadratic(BC(GT())))))
            ax1 = axes(itp1)[1]
            @test Interpolations.lbounds(itp1) == (GT == OnGrid ? (first(ax1),) : (first(ax1) - 0.5,))
            @test Interpolations.ubounds(itp1) == (GT == OnGrid ? (last(ax1),) : (last(ax1) + 0.5,))
            @test_throws ArgumentError parent(itp1)
            check_axes(itp1, A, isinplace)
            check_inbounds_values(itp1, A)
            check_oob(itp1)
            can_eval_near_boundaries(itp1)

            # test that inner region is close to data
            for x in 3.1:.2:8.1
                @test f(x) ≈ itp1(x) atol=abs(0.1 * f(x))
            end
        end

        f(x,y) = sin(x/10)*cos(y/6)
        xmax, ymax = 30,10
        A = Float64[f(x,y) for x in 1:xmax, y in 1:ymax]

        # test that inner region is close to data
        for BC in (Flat,Line,Free,Periodic,Reflect,Natural), GT in (OnGrid, OnCell)
            itp2 = @inferred(constructor(copier(A), BSpline(Quadratic(BC(GT())))))
            check_axes(itp2, A, isinplace)
            check_inbounds_values(itp2, A)
            check_oob(itp2)
            can_eval_near_boundaries(itp2)

            for x in 3.1:.2:xmax-3, y in 3.1:2:ymax-3
                @test f(x,y) ≈ itp2(x,y) atol=abs(0.1 * f(x,y))
            end
        end
    end

    # Test default constructor
    itp_type = Quadratic |> BSpline
    itp = interpolate(1:5, itp_type)
    @test itp(1:0.5:5) ≈ 1:0.5:5

    # InPlace
    let
        f(x) = sin((x-3)*2pi/9 - 1)
        xmax = 10
        A = Float64[f(x) for x in 1:xmax]
        itp1 = interpolate!(copy(A), BSpline(Quadratic(InPlace(OnCell()))))
        @test axes(itp1) == axes(A)
        check_inbounds_values(itp1, A)

        f(x,y) = sin(x/10)*cos(y/6)
        xmax, ymax = 30,10
        A = Float64[f(x,y) for x in 1:xmax, y in 1:ymax]
        itp2 = interpolate!(copy(A), BSpline(Quadratic(InPlace(OnCell()))))
        @test axes(itp2) == axes(A)
        check_inbounds_values(itp2, A)
    end
end

@testset "NoInterp" begin
    a = reshape(1:12, 3, 4)
    ai = interpolate(a, NoInterp())
    @test eltype(ai) == Int
    check_axes(ai, a)
    check_inbounds_values(ai, a)
    check_oob(ai)
    @test_throws InexactError ai(2.2, 2)
    @test_throws InexactError ai(2, 2.2)

    # ae = extrapolate(ai, NaN)
    # @test eltype(ae) == Float64
    # @test ae[1,1] === 1.0
    # @test ae[0,1] === NaN
    # @test_throws InexactError ae(1.5,2)
end

@testset "Stability of mixtrue with NoInterp and Interp" begin
    A = zeros(Float64, 5, 5, 5, 5, 5, 5, 5)
    st = BSpline(Quadratic(Reflect(OnCell()))), NoInterp(),
         BSpline(Linear()), NoInterp(),
         BSpline(Quadratic()), NoInterp(),
         BSpline(Quadratic(Reflect(OnCell())))
    itp = interpolate(A, st)
    @test (@inferred Interpolations.hessian(itp, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0)) == zeros(4,4)
    @test (@inferred Interpolations.gradient(itp, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0)) == zeros(4)
    @test (@inferred itp(1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0)) == 0
end

module Linear1DTests
println("Testing Linear interpolation in 1D...")
using Interpolations, Test

f(x) = sin((x-3)*2pi/9 - 1)
xmax = 10

A = Float64[f(x) for x in 1:xmax]

## ExtrapError

itp1 = Interpolation(A, Linear(OnGrid()), ExtrapError())

for x in 1:.2:xmax
    @test ≈(f(x),itp1[x],atol=abs(0.1 * f(x)))
end

@test_throws BoundsError itp1[-3]
@test_throws BoundsError itp1[xmax+.1]

## ExtrapNaN

itp2 = Interpolation(A, Linear(OnGrid()), ExtrapNaN())

for x in 1:.2:xmax
    @test ≈(f(x),itp2[x],atol=abs(0.1 * f(x)))
end

xlo, xhi = itp2[.9], itp2[xmax+.2]
@test isnan(xlo)
@test isnan(xhi)

## ExtrapConstant

itp3 = Interpolation(A, Linear(OnGrid()), ExtrapConstant())
for x in 3.1:.2:4.3
    @test ≈(f(x),itp3[x],atol=abs(0.1 * f(x)))
end

xlo, xhi = itp3[.9], itp3[xmax+.2]
@test xlo == A[1]
@test xhi == A[end]

# Rational element types
A = Rational{Int}[x//10+2 for x in 1:10]
itp = Interpolation(A, Linear(OnGrid()), ExtrapNaN())
@test itp[11//10] == (11//10)//10+2

end

module Linear2DTests
println("Testing Linear interpolation in 2D...")
using Interpolations, Base.Test

f(x,y) = sin(x/10)*cos(y/6)

xmax, ymax = 30,10

A = Float64[f(x,y) for x in 1:xmax, y in 1:ymax]

itp1 = Interpolation(A, Linear(OnGrid()), ExtrapError())

for x in 2.1:.2:xmax-1, y in 1.9:.2:ymax-.9
    @test ≈(f(x,y),itp1[x,y],atol=0.01)
end

end

# NOTE: create symlinks called "results_old.json" and "results_new.json" in this directory
# to the results files you want to compare

using BenchmarkTools, PyPlot, Unitful

const tref = 1000

function xycmp(results_old, results_new, filterstrs...)
    x, y = Float64[], Float64[]
    for (k, v) in results_new
        passes = true
        for str in filterstrs
            passes &= occursin(str, k)
        end
        passes || continue
        if haskey(results_old, k)
            push!(x, minimum(results_old[k]).time/tref)
            push!(y, minimum(v).time/tref)
        end
    end
    x, y
end

function plotcmp(results_old, results_new, keys, filterstrs...)
    for key in keys
        results_old = results_old[key]
        results_new = results_new[key]
    end
    x, y = xycmp(results_old, results_new, filterstrs...)
    maxxy = max(maximum(x), maximum(y))
    scatter(x, y)
    plot([0, maxxy], [0, maxxy], "--")
    # title(string(keys, filterstrs))
    title(string(keys))
end

function plotcmppanels(results_old, results_new, keys, filterstrs...)
    nrows = ceil(Int, sqrt(length(keys)))
    ncols = ceil(Int, length(keys)/nrows)
    figure()
    for k = 1:length(keys)
        subplot(nrows, ncols, k)
        plotcmp(results_old, results_new, keys[k], filterstrs...)
    end
    suptitle(string(filterstrs))
end

results_old = BenchmarkTools.load("results_old.json")[1]
results_new = BenchmarkTools.load("results_new.json")[1]

results_old = results_old["bsplines"]
results_new = results_new["bsplines"]

for filt in (("use",), ("construct",))
    # for keys in (("constant",), ("linear",), ("quadratic",), ("cubic",))
    #     plotcmp(results_old, results_new, keys, filt...)
    # end
    keys = (("constant",), ("linear",), ("quadratic",), ("cubic",))
    plotcmppanels(results_old, results_new, keys, filt...)
end

@testset "Mixed" begin
    N = 10

    for (constructor, copier) in ((interpolate, x->x), (interpolate!, copy))
        A2 = rand(Float64, N, N) * 100
        for BC in (Flat,Line,Free,Periodic,Reflect,Natural), GT in (OnGrid, OnCell)
            itp_a = @inferred(constructor(copier(A2), (BSpline(Linear()), BSpline(Quadratic(BC(GT()))))))
            itp_b = @inferred(constructor(copier(A2), (BSpline(Quadratic(BC(GT()))), BSpline(Linear()))))
            isfullsize = constructor == interpolate || BC==Periodic
            if isfullsize
                @test @inferred(size(itp_a)) == size(A2)
                @test @inferred(size(itp_b)) == size(A2)
                @test @inferred(axes(itp_a)) == axes(A2)
                @test @inferred(axes(itp_b)) == axes(A2)
            else
                @test @inferred(size(itp_a)) == (N, N-2)
                @test @inferred(size(itp_b)) == (N-2, N)
                @test @inferred(axes(itp_a)) == (1:N, 2:N-1)
                @test @inferred(axes(itp_b)) == (2:N-1, 1:N)
            end
            @test_throws ArgumentError parent(itp_a)
            @test_throws ArgumentError parent(itp_b)

            for i in eachindex(itp_a)
                @test itp_a[i] ≈ A2[i] atol=sqrt(eps(A2[i]))
            end
            for i in eachindex(itp_b)
                @test itp_b[i] ≈ A2[i] atol=sqrt(eps(A2[i]))
            end

            for i = 1:10
                dx, dy = rand(), rand()
                @test itp_a(2 + dx,2) ≈ (1 - dx) * A2[2,2] + dx * A2[3,2]
                @test itp_b(2,2 + dy) ≈ (1 - dy) * A2[2,2] + dy * A2[2,3]
            end
        end
    end

    # AbstractArrays
    makesharedarray(::Type{T}, dims; kwargs...) where {T} = SharedArray{T}(dims; kwargs...)
    function copyshared(A)
        B = makesharedarray(eltype(A), size(A))
        copyto!(B, A)
    end

    for (constructor, copier) in ((interpolate, x->x), (interpolate!, copyshared))
        A2 = makesharedarray(Float64, (N,N), init=A->rand!(A))
        for i = 1:length(A2)
            A2[i] *= 100
        end
        for BC in (Flat,Line,Free,Periodic,Reflect,Natural), GT in (OnGrid, OnCell)
            itp_a = @inferred(constructor(copier(A2), (BSpline(Linear()), BSpline(Quadratic(BC(GT()))))))
            itp_b = @inferred(constructor(copier(A2), (BSpline(Quadratic(BC(GT()))), BSpline(Linear()))))
            if constructor == interpolate!
                @test isa(itp_a.coefs, SharedArray)
                @test isa(itp_b.coefs, SharedArray)
            end
            isfullsize = constructor == interpolate || BC==Periodic
            if isfullsize
                @test @inferred(size(itp_a)) == size(A2)
                @test @inferred(size(itp_b)) == size(A2)
                @test @inferred(axes(itp_a)) == axes(A2)
                @test @inferred(axes(itp_b)) == axes(A2)
            else
                @test @inferred(size(itp_a)) == (N, N-2)
                @test @inferred(size(itp_b)) == (N-2, N)
                @test @inferred(axes(itp_a)) == (1:N, 2:N-1)
                @test @inferred(axes(itp_b)) == (2:N-1, 1:N)
            end

            for j = 2:N-1, i = 2:N-1
                @test ≈(itp_a[i,j],A2[i,j],atol=sqrt(eps(A2[i,j])))
                @test ≈(itp_b[i,j],A2[i,j],atol=sqrt(eps(A2[i,j])))
            end

            for i = 1:10
                dx, dy = rand(), rand()
                @test itp_a(2 + dx,2) ≈ (1 - dx) * A2[2,2] + dx * A2[3,2]
                @test itp_b(2,2 + dy) ≈ (1 - dy) * A2[2,2] + dy * A2[2,3]
            end
        end
    end
end

export Nearest, Previous, Next

abstract type ConstantInterpType end

"""
Default parameter for `Constant` that performs *nearest-neighbor* interpolation.
Can optionally be specified as
```
Constant() === Constant{Nearest}()
```
"""
struct Nearest <: ConstantInterpType end

"""
Parameter for `Constant` that performs *previous-neighbor* interpolations.
Applied through 
´´´
Constant{Previous}()
´´´
"""
struct Previous <: ConstantInterpType end

"""
Parameter for `Constant` that performs *next-neighbor* interpolations.
Applied through 
```
Constant{Next}()
```
"""
struct Next <: ConstantInterpType end

struct Constant{T<:ConstantInterpType,BC<:Union{Throw{OnGrid},Periodic{OnCell}}} <: DegreeBC{0}
    bc::BC
    function Constant{T, BC}(bc::BC=BC()) where {T<:ConstantInterpType, BC<:Union{Throw{OnGrid},Periodic{OnCell}}}
        new{T, BC}(bc)
    end
end

# Default to Nearest and Throw{OnGrid}
Constant() = Constant{Nearest}()
Constant(bc::BC) where {BC <: BoundaryCondition} = Constant{Nearest}(bc)
Constant(::Type{T}) where T <: ConstantInterpType = Constant{T}()
Constant{T}() where {T<:ConstantInterpType} = Constant{T,Throw{OnGrid}}(Throw(OnGrid()))
Constant{T}(bc::BC) where {T<:ConstantInterpType,BC<:BoundaryCondition} = Constant{T,BC}(bc)
Constant{T}(::Periodic{Nothing}) where {T<:ConstantInterpType} = Constant{T,Periodic{OnCell}}(Periodic(OnCell()))

function Base.show(io::IO, deg::Constant)
    print(io, nameof(typeof(deg)), '{', typeof(deg).parameters[1], '}', '(')
    show(io, deg.bc)
    print(io, ')')
end

function Base.show(io::IO, deg::Constant{T,Throw{OnGrid}}) where {T <: ConstantInterpType}
    print(io, nameof(typeof(deg)), '{', typeof(deg).parameters[1], '}', '(', ')')
end

"""
Constant b-splines are *nearest-neighbor* interpolations, and effectively
return `A[round(Int,x)]` when interpolating without scaling.
Scaling can lead to inaccurate position of the *neighbors* due to limited numerical precision.

`Constant{Previous}` interpolates to the previous value and is thus equivalent
to `A[floor(Int,x)]` without scaling.
`Constant{Next}` interpolates to the next value and is thus equivalent
to `A[ceil(Int,x)]` without scaling.
"""
Constant

function positions(c::Constant{Previous}, ax, x)  # discontinuity occurs at integer locations
    xm = floorbounds(x, ax)
    δx = x - xm
    fast_trunc(Int, xm), δx
end
function positions(c::Constant{Next}, ax, x)  # discontinuity occurs at integer locations
    xm = ceilbounds(x, ax)
    δx = x - xm
    fast_trunc(Int, xm), δx
end
function positions(c::Constant{Nearest}, ax, x)  # discontinuity occurs at half-integer locations
    xm = roundbounds(x, ax)
    δx = x - xm
    fast_trunc(Int, xm), δx
end

function positions(c::Constant{Previous,Periodic{OnCell}}, ax, x)
    # We do not use floorbounds because we do not want to add a half at
    # the lowerbound to round up.
    xm = floor(x)
    δx = x - xm
    modrange(fast_trunc(Int, xm), ax), δx
end
function positions(c::Constant{Next,Periodic{OnCell}}, ax, x)  # discontinuity occurs at integer locations
    xm = ceilbounds(x, ax)
    δx = x - xm
    modrange(fast_trunc(Int, xm), ax), δx
end

value_weights(::Constant, δx) = (1,)
gradient_weights(::Constant, δx) = (0,)
hessian_weights(::Constant, δx) = (0,)

padded_axis(ax::AbstractUnitRange, ::BSpline{<:Constant}) = ax

import Interpolations, Grid, Dierckx, GridInterpolations, ApproXD
using PyCall
@pyimport scipy.interpolate as py
include(joinpath(JULIA_HOME, "..", "..", "examples", "ndgrid.jl"))

# For the evaluation points, loop over 2:size(itp,d)-1.
# Since some interpolants are fast, we must ensure this call is type-stable.
@generated function iterrange(itp::AbstractArray{T,N}) where {T,N}
    min = ntuple(d->2, N)
    maxex = Expr(:tuple, Expr[:(size(itp,$d)-1) for d = 1:N]...)
    :(CartesianRange(CartesianIndex($min), CartesianIndex($maxex)))
end

# These have a function-barrier so are less critical
make_knots(A) = ntuple(d->collect(linspace(1,size(A,d),size(A,d))), ndims(A))
make_xi(A)    = ntuple(d->collect(linspace(2,size(A,d)-1,size(A,d)-2)), ndims(A))

## Interpolations and Grid
function evaluate_grid(itp::Union{Array,Interpolations.AbstractInterpolation,Grid.InterpGrid}, A)
    s = zero(eltype(itp)) + zero(eltype(itp))
    for I in iterrange(itp)
        s += itp[I]
    end
    s
end

# Fast approach for GriddedInterpolation
function evaluate_grid(itp::Interpolations.GriddedInterpolation, A)
    V = itp[make_xi(A)...]
    sum(V)
end

# Slow approach for GriddedInterpolation
function evaluate_grid_scalar(itp::Interpolations.GriddedInterpolation, A)
    s = zero(eltype(itp)) + zero(eltype(itp))
    for I in iterrange(itp)
        s += itp[I]
    end
    s
end

## Dierckx
dierckx_constr(A::AbstractVector, k) = Dierckx.Spline1D(collect(1:length(A)), A, k=k)
dierckx_constr(A::Matrix, k) = Dierckx.Spline2D(collect(1:size(A,1)), collect(1:size(A,2)), A, kx=k, ky=k)

Dierckx.evaluate(itp::Dierckx.Spline1D, I::CartesianIndex{1}) = Dierckx.evaluate(itp, I[1])
Dierckx.evaluate(itp::Dierckx.Spline2D, I::CartesianIndex{2}) = Dierckx.evaluate(itp, I[1], I[2])

# Fast approach for Dierckx
function evaluate_grid(itp::Dierckx.Spline1D, A)
    V = Dierckx.evaluate(itp, make_xi(A)...)
    sum(V)
end

function evaluate_grid(itp::Dierckx.Spline2D, A)
    V = Dierckx.evalgrid(itp, make_xi(A)...)
    sum(V)
end

# Slow approach for Dierckx
function evaluate_grid_scalar(itp::Union{Dierckx.Spline1D,Dierckx.Spline2D}, A)
    T = eltype(A)
    s = zero(T) + zero(T)
    for I in iterrange(A)
        s += Dierckx.evaluate(itp, I)
    end
    s
end

## GridInterpolations
gi_constr(A) = GridInterpolations.RectangleGrid(make_knots(A)...)

stuff!(x, index::CartesianIndex{1}) = (x[1] = index[1])
stuff!(x, index::CartesianIndex{2}) = (x[1] = index[1]; x[2] = index[2])
stuff!(x, index::CartesianIndex{3}) = (x[1] = index[1]; x[2] = index[2]; x[3] = index[3])
stuff!(x, index::CartesianIndex{4}) = (x[1] = index[1]; x[2] = index[2]; x[3] = index[3]; x[4] = index[4])

function evaluate_grid(grid::GridInterpolations.RectangleGrid, A)
    T = eltype(A)
    x = Array{eltype(T)}( ndims(A))  # in case T is RGB{Float32}
    s = zero(T) + zero(T)
    vA = vec(A)
    for I in iterrange(A)
        stuff!(x, I)
        s += GridInterpolations.interpolate(grid, vA, x)
    end
    s
end

## ApproXD
ax_constr(A) = ApproXD.Lininterp(A, Vector{Float64}[make_knots(A)...])

function evaluate_grid(grid::ApproXD.Lininterp, A)
    T = eltype(A)
    x = Array{eltype(T)}( ndims(A))  # in case T is RGB{Float32}
    s = zero(T) + zero(T)
    vA = vec(A)
    result = Array{T}(1)
    which = [1]
    for I in iterrange(A)
        stuff!(x, I)
        ApproXD.getValue!(result, grid, x, which)
        s += result[1]
    end
    s
end

## Python's RegularGridInterpolator
pyindexes(A::Vector) = collect(2:length(A)-1)
function pyindexes(A)
    g = ndgrid(make_xi(A)...)
    hcat(map(vec, g)...)
end

function evaluate_grid(itp::PyObject, A)
    indexes = pyindexes(A)
    V = pycall(itp, PyAny, indexes)
    sum(V)
end

## Error-handling
function msg(err)
    if isdefined(err, :msg)
        return err.msg
    end
    string(typeof(err))
end


## OK, let's do it!
const npoints = 10^6
const maxdims = 4
# const eltypes = (Float64,Float32, RGB{Float32})
const eltypes = (Float64,)
constr_eval_name_ord = ((A -> Interpolations.interpolate(A, Interpolations.BSpline(Interpolations.Constant()), Interpolations.OnCell()),evaluate_grid,"IBSpline",0),
                    (A -> Interpolations.interpolate(A, Interpolations.BSpline(Interpolations.Linear()), Interpolations.OnGrid()),evaluate_grid,"IBSpline",1),
                    (A -> Interpolations.interpolate(A, Interpolations.BSpline(Interpolations.Quadratic(Interpolations.Flat())), Interpolations.OnCell()),evaluate_grid,"IBSpline",2),
                    (A -> Grid.InterpGrid(A, Grid.BCnil, Grid.InterpNearest),evaluate_grid,"Grid",0),
                    (A -> Grid.InterpGrid(A, Grid.BCnil, Grid.InterpLinear),evaluate_grid,"Grid",1),
                    (A -> Grid.InterpGrid(A, Grid.BCnil, Grid.InterpQuadratic),evaluate_grid,"Grid",2),
                    (A -> Interpolations.interpolate(make_knots(A), A, Interpolations.Gridded(Interpolations.Constant())),evaluate_grid,"IGridded vec",0),
                    (A -> Interpolations.interpolate(make_knots(A), A, Interpolations.Gridded(Interpolations.Constant())),evaluate_grid_scalar,"IGridded scalar",0),
                    (A -> Interpolations.interpolate(make_knots(A), A, Interpolations.Gridded(Interpolations.Linear())),evaluate_grid,"IGridded vec",1),
                    (A -> Interpolations.interpolate(make_knots(A), A, Interpolations.Gridded(Interpolations.Linear())),evaluate_grid_scalar,"IGridded scalar",1),
                    (A -> dierckx_constr(A, 0),evaluate_grid,"Dierckx vec",0),
                    (A -> dierckx_constr(A, 1),evaluate_grid,"Dierckx vec",1),
                    (A -> dierckx_constr(A, 1),evaluate_grid_scalar,"Dierckx scalar",1),
                    (A -> dierckx_constr(A, 2),evaluate_grid,"Dierckx vec",2),
                    (A -> dierckx_constr(A, 2),evaluate_grid_scalar,"Dierckx scalar",2),
                    (A -> gi_constr(A),evaluate_grid,"GI",1),
                    (A -> ax_constr(A),evaluate_grid,"ApproXD",1),
                    (A -> py.RegularGridInterpolator(make_knots(A), A, method="nearest"),evaluate_grid,"Py vec",0),
                    (A -> py.RegularGridInterpolator(make_knots(A), A, method="linear"),evaluate_grid,"Py vec",1),
                    )
testnames = [c_e_v[3] for c_e_v in constr_eval_name_ord]
testord   = [c_e_v[4] for c_e_v in constr_eval_name_ord]
tconstr = fill(NaN, length(constr_eval_name_ord), maxdims, length(eltypes))
teval   = fill(NaN, length(constr_eval_name_ord), maxdims, length(eltypes))
for ieltype = 1:length(eltypes)
    etyp = eltypes[ieltype]
    println(etyp)
    for ndim = 1:maxdims
        println("  dimension ", ndim)
        n = round(Int, npoints^(1/ndim))
        sz = fill(n, ndim)
        A = rand(etyp, sz...)
        starget = evaluate_grid(A, A)
        for (i,c_e_n) in enumerate(constr_eval_name_ord)
            fc, ev, name, ord = c_e_n
            println("    ", name, " ", ord)
            try
                itp = fc(A)   # JIT-compile
                gc()
                tic(); fc(A); tconstr[i, ndim, ieltype] = toq()
                s = ev(itp, A)  # JIT-compile
                @assert abs(s - starget) < 1000*eps(abs(starget))
                gc()
                tic(); ev(itp, A); teval[i, ndim, ieltype] = toq()
            catch err
                warn("skipping because of error: ", msg(err))
            end
        end
    end
end

struct Linear{BC<:Union{Throw{OnGrid},Periodic{OnCell}}} <: DegreeBC{1}
    bc::BC
    function Linear{BC}(bc::BC=BC()) where BC<:Union{Throw{OnGrid},Periodic{OnCell}}
        new{BC}(bc)
    end
end

Linear() = Linear(Throw(OnGrid()))
Linear(::Periodic{Nothing}) = Linear(Periodic(OnCell()))
Linear(bc::BC) where BC<:Union{Throw{OnGrid},Periodic{OnCell}} = Linear{BC}(bc)

function Base.show(io::IO, deg::Linear{Throw{OnGrid}})
    print(io, nameof(typeof(deg)), '(', ')')
end

"""
    Linear()

Indicate that the corresponding axis should use linear interpolation.

# Extended help

Assuming uniform knots with spacing 1, the `i`th piece of linear b-spline
implemented here is defined as follows.

    y_i(x) = c p(x) + cp p(1-x)

where

    p(δx) = x

and the values `cX` for `X ∈ {_, p}` are the coefficients.

Linear b-splines are naturally interpolating, and require no prefiltering;
there is therefore no need for boundary conditions to be provided.

Also, although the implementation is slightly different in order to re-use
the framework built for general b-splines, the resulting interpolant is just
a piecewise linear function connecting each pair of neighboring data points.
"""
Linear

function positions(deg::Linear, ax::AbstractUnitRange{<:Integer}, x)
    f = floor(x)
    # When x == last(ax) we want to use the x-1, x pair
    f = ifelse(x == last(ax), f - oneunit(f), f)
    fi = fast_trunc(Int, f)
    expand_index(deg, fi, ax), x-f
end
expand_index(::Linear{Throw{OnGrid}}, fi::Number, ax::AbstractUnitRange) = fi
expand_index(::Linear{Periodic{OnCell}}, fi::Number, ax::AbstractUnitRange) =
    (modrange(fi, ax), modrange(fi+1, ax))

value_weights(::Linear, δx) = (1-δx, δx)
gradient_weights(::Linear, δx) = (-oneunit(δx), oneunit(δx))
hessian_weights(::Linear, δx) = (zero(δx), zero(δx))

padded_axis(ax::AbstractUnitRange, ::BSpline{<:Linear}) = ax

function interpolate(A::AbstractArray, ::NoInterp)
    interpolate(Int, eltype(A), A, NoInterp())
end

# How many non-NoInterp dimensions are there?
count_interp_dims(::Type{NoInterp}) = 0

interpdegree(::NoInterp) = NoInterp()

iscomplete(::NoInterp) = true

prefilter(::Type{TWeights}, ::Type{TC}, A::AbstractArray, ::NoInterp) where {TWeights, TC} = A

lbound(ax, ::NoInterp) = first(ax)
ubound(ax, ::NoInterp) = last(ax)

weightedindex_parts(fs, ::NoInterp, ax, x::Number) = Int(x)

# positions(::NoInterp, ax, x) = (Int(x),), 0

# value_weights(::NoInterp, δx) = (oneunit(δx),)
# gradient_weights(::NoInterp, δx) = (NoInterp(),)
# hessian_weights(::NoInterp, δx) = (NoInterp(),)

padded_axis(ax::AbstractUnitRange, ::NoInterp) = ax

export
    BSpline,

    NoInterp,
    Constant,
    Linear,
    Quadratic,
    Cubic

abstract type Degree{N} <: Flag end
abstract type DegreeBC{N} <: Degree{N} end  # degree type supporting a BoundaryCondition
(::Type{D})(::Type{BC}) where {D <: Degree, BC <: BoundaryCondition} = D(BC())

"""
    BSpline(degree)

A flag signaling `BSpline` (integer-grid b-spline) interpolation along the corresponding axis.
`degree` is one of [`Constant`](@ref), [`Linear`](@ref), [`Quadratic`](@ref), or [`Cubic`](@ref).
"""
struct BSpline{D<:Degree} <: InterpolationType
    degree::D
end

BSpline(::Type{D}) where D <: Degree = BSpline(D())
BSpline() = Linear |> BSpline

bsplinetype(::Type{BSpline{D}}) where {D<:Degree} = D
bsplinetype(::BS) where {BS<:BSpline} = bsplinetype(BS)

degree(mode::BSpline) = mode.degree
degree(::NoInterp) = NoInterp()

iscomplete(mode::BSpline) = iscomplete(degree(mode))
iscomplete(deg::DegreeBC) = _iscomplete(deg.bc.gt)
iscomplete(deg::Degree) = true
_iscomplete(::Nothing) = false
_iscomplete(::GridType) = true

function Base.show(io::IO, bs::BSpline)
    print(io, "BSpline(")
    show(io, degree(bs))
    print(io, ')')
end

function Base.show(io::IO, deg::DegreeBC)
    print(io, nameof(typeof(deg)), '(')
    show(io, deg.bc)
    print(io, ')')
end

"""
    BSplineInterpolation{T,N,TCoefs,IT,Axs}

An interpolant-type for b-spline interpolation on a uniform grid with integer nodes.
`T` indicates the element type for operations like `collect(itp)`, and may also agree with
the values obtained from `itp(x, y, ...)` at least for certain types of `x` and `y`.
`N` is the dimensionality of the interpolant. The remaining type-parameters
describe the types of fields:
- the `coefs` field holds the interpolation coefficients. Depending on prefiltering,
  these may or may not be the same as the supplied array of interpolant values.
- `parentaxes` holds the axes of the parent. Depending on prefiltering this may be
  "narrower" than the axes of `coefs`.
- `it` holds the interpolation type, e.g., `BSpline(Linear())` or `(BSpline(Quadratic(OnCell()),BSpline(Linear()))`.

`BSplineInterpolation` objects are typically created with [`interpolate`](@ref).
However, for customized control you may also construct them with

    BSplineInterpolation(TWeights, coefs, it, axs)

where `T` gets computed from the product of `TWeights` and `eltype(coefs)`.
(This is equivalent to indicating that you'll be evaluating at locations `itp(x::TWeights, y::TWeights, ...)`.)
"""
struct BSplineInterpolation{T,N,TCoefs<:AbstractArray,IT<:DimSpec{BSpline},Axs<:Indices{N}} <: AbstractInterpolation{T,N,IT}
    coefs::TCoefs
    parentaxes::Axs
    it::IT
end

function Base.:(==)(o1::BSplineInterpolation, o2::BSplineInterpolation)
    o1.it == o2.it &&
    o1.parentaxes == o2.parentaxes &&
    o1.coefs == o2.coefs
end

BSplineInterpolation{T,N}(A::AbstractArray, axs::Indices{N}, it::IT) where {T,N,IT} =
    BSplineInterpolation{T,N,typeof(A),IT,typeof(axs)}(A, axs, it)

function BSplineInterpolation(::Type{TWeights}, A::AbstractArray{Tel,N}, it::IT, axs) where {N,Tel,TWeights<:Real,IT<:DimSpec{BSpline}}
    # String interpolation causes allocation, noinline avoids that unless they get called
    @noinline err_concrete(IT) = error("The b-spline type must be a concrete type (was $IT)")
    @noinline warn_concrete(A) = @warn("For performance reasons, consider using an array of a concrete type (typeof(A) == $(typeof(A)))")
    @noinline err_incomplete(it) = error("OnGrid/OnCell is not supplied for some of the interpolation modes in $it")
    @noinline err_singleton(A, it) = throw(ArgumentError("size $(size(A)) is inconsistent with $it, use NoInterp along singleton dimensions"))

    isconcretetype(IT) || err_concrete(IT)
    isconcretetype(typeof(A)) || warn_concrete(A)
    iscomplete(it) || err_incomplete(it)

    # Check that dimensions of size 1 are NoInterp
    is_singleton_ok(A, it) || err_singleton(A, it)

    # Compute the output element type when positions have type TWeights
    if isempty(A)
        T = Base.promote_op(*, TWeights, eltype(A))
    else
        T = typeof(zero(TWeights) * first(A))
    end
    BSplineInterpolation{T,N}(A, fix_axis.(axs), it)
end

function BSplineInterpolation(A::AbstractArray{Tel,N}, it::IT, axs) where {N,Tel,IT<:DimSpec{BSpline}}
    @noinline err_axes(A, it, axs) = throw(ArgumentError("parentaxes $axs are inconsistent with coefficient array axes $(axes(A)) and interpolation type $it"))

    paxs = padded_axes(axs, it)
    all(map(⊆, paxs, axes(A))) || err_axes(A, it, axs)
    BSplineInterpolation(tweight(A), A, it, axs)
end

iscomplete(its::Tuple) = all(iscomplete, its)

is_singleton_ok(A, it) = is_singleton_ok(size(A), it)
@inline function is_singleton_ok(sz::Tuple, it)
    if sz[1] == 1
        it1 = getfirst(it)
        it1 isa NoInterp || return false
    end
    return is_singleton_ok(Base.tail(sz), getrest(it))
end
is_singleton_ok(::Tuple{}, it) = true

coefficients(itp::BSplineInterpolation) = itp.coefs
interpdegree(itp::BSplineInterpolation) = interpdegree(itpflag(itp))
interpdegree(::BSpline{T}) where T = T()
interpdegree(it::Tuple{Vararg{Union{BSpline,NoInterp},N}}) where N = interpdegree.(it)
itpflag(itp::BSplineInterpolation) = itp.it

size(itp::BSplineInterpolation) = map(length, itp.parentaxes)
axes(itp::BSplineInterpolation) = itp.parentaxes

lbounds(itp::BSplineInterpolation) = _lbounds(itp.parentaxes, itpflag(itp))
ubounds(itp::BSplineInterpolation) = _ubounds(itp.parentaxes, itpflag(itp))
_lbounds(axs, itp) = (lbound(axs[1], getfirst(itp)), _lbounds(Base.tail(axs), getrest(itp))...)
_ubounds(axs, itp) = (ubound(axs[1], getfirst(itp)), _ubounds(Base.tail(axs), getrest(itp))...)
_lbounds(::Tuple{}, itp) = ()
_ubounds(::Tuple{}, itp) = ()

lbound(ax::AbstractRange, bs::BSpline)   = lbound(ax, degree(bs))
lbound(ax::AbstractRange, deg::Degree)   = first(ax)
lbound(ax::AbstractRange, deg::DegreeBC) = lbound(ax, deg, deg.bc.gt)
ubound(ax::AbstractRange, bs::BSpline)   = ubound(ax, degree(bs))
ubound(ax::AbstractRange, deg::Degree)   = last(ax)
ubound(ax::AbstractRange, deg::DegreeBC) = ubound(ax, deg, deg.bc.gt)

lbound(ax::AbstractUnitRange, ::DegreeBC, ::OnCell) = first(ax) - 0.5
ubound(ax::AbstractUnitRange, ::DegreeBC, ::OnCell) = last(ax) + 0.5
lbound(ax::AbstractUnitRange, ::DegreeBC, ::OnGrid) = first(ax)
ubound(ax::AbstractUnitRange, ::DegreeBC, ::OnGrid) = last(ax)

fix_axis(r::Base.OneTo) = r
fix_axis(r::Base.Slice) = r
fix_axis(r::UnitRange) = Base.Slice(r)
fix_axis(r::AbstractUnitRange) = fix_axis(UnitRange(r))

count_interp_dims(::Type{BSI}, n) where BSI<:BSplineInterpolation = count_interp_dims(itptype(BSI), n)

function interpolate(::Type{TWeights}, ::Type{TC}, A, it::IT) where {TWeights,TC,IT<:DimSpec{BSpline}}
    Apad = prefilter(TWeights, TC, A, it)
    BSplineInterpolation(TWeights, Apad, it, axes(A))
end

function interpolate(::Type{TWeights}, ::Type{TC}, A, it::IT, λ::Real, k::Int) where {TWeights,TC,IT<:DimSpec{BSpline}}
    Apad = prefilter(TWeights, TC, A, it, λ, k)
    BSplineInterpolation(TWeights, Apad, it, axes(A))
end

"""
    itp = interpolate(A, interpmode)

Interpolate an array `A` in the mode determined by `interpmode`.
`interpmode` may be one of

- `NoInterp()`
- `BSpline(Constant())`
- `BSpline(Linear())`
- `BSpline(Quadratic(bc))` (see [`BoundaryCondition`](@ref))
- `BSpline(Cubic(bc))`

It may also be a tuple of such values, if you want to use different interpolation schemes along each axis.
"""
function interpolate(A::AbstractArray, it::IT) where {IT<:DimSpec{BSpline}}
    interpolate(tweight(A), tcoef(A), A, it)
end

"""
    itp = interpolate(A, interpmode, gridstyle, λ, k)

Interpolate an array `A` in the mode determined by `interpmode` and `gridstyle`
with regularization following [1], of order `k` and constant `λ`. 
`interpmode` may be one of

- `BSpline(NoInterp())`
- `BSpline(Linear())`
- `BSpline(Quadratic(BC()))` (see [`BoundaryCondition`](@ref))
- `BSpline(Cubic(BC()))`

It may also be a tuple of such values, if you want to use different interpolation schemes along each axis.

`gridstyle` should be one of `OnGrid()` or `OnCell()`.

`k` corresponds to the derivative to penalize. In the limit λ->∞, the interpolation function is
a polynomial of order `k-1`. A value of 2 is the most common.

`λ` is non-negative. If its value is zero, it falls back to non-regularized interpolation.

[1] https://projecteuclid.org/euclid.ss/1038425655.
"""
function interpolate(A::AbstractArray, it::IT, λ::Real, k::Int) where {IT<:DimSpec{BSpline}}
    interpolate(tweight(A), tcoef(A), A, it, λ, k)
end

# We can't just return a tuple-of-types due to julia #12500
tweight(A::AbstractArray) = Float64
tweight(A::AbstractArray{T}) where T<:AbstractFloat = T
tweight(A::AbstractArray{<:AbstractVector{T}}) where {T} = T
tweight(A::AbstractArray{Rational{Int}}) = Rational{Int}
tweight(A::AbstractArray{T}) where {T<:Integer} = typeof(float(zero(T)))

tcoef(A::AbstractArray) = eltype(A)
tcoef(A::AbstractArray{Float32}) = Float32
tcoef(A::AbstractArray{Rational{Int}}) = Rational{Int}
tcoef(A::AbstractArray{T}) where {T<:Integer} = typeof(float(zero(T)))

"In-place version of `interpolate`. It destroys input `A` and may trim the domain at the endpoints."
function interpolate!(::Type{TWeights}, A::AbstractArray, it::IT) where {TWeights,IT<:DimSpec{BSpline}}
    # Set the bounds of the interpolant inward, if necessary
    axsA = axes(A)
    axspad = padded_axes(axsA, it)
    BSplineInterpolation(TWeights, prefilter!(TWeights, A, it), it, fix_axis.(padinset.(axsA, axspad)))
end
function interpolate!(A::AbstractArray, it::IT) where {IT<:DimSpec{BSpline}}
    interpolate!(tweight(A), A, it)
end

function interpolate!(::Type{TWeights}, A::AbstractArray, it::IT, λ::Real, k::Int) where {TWeights,IT<:DimSpec{BSpline}}
    # Set the bounds of the interpolant inward, if necessary
    axsA = axes(A)
    axspad = padded_axes(axsA, it)
    BSplineInterpolation(TWeights, prefilter!(TWeights, A, it, λ, k), it, fix_axis.(padinset.(axsA, axspad)))
end
function interpolate!(A::AbstractArray, it::IT, λ::Real, k::Int) where {IT<:DimSpec{BSpline}}
    interpolate!(tweight(A), A, it, λ, k)
end

if VERSION >= v"1.7.0-beta1"
    # https://github.com/JuliaLang/julia/pull/40623
    lut!(dl, d, du) = lu!(Tridiagonal(dl, d, du), NoPivot())
else
    lut!(dl, d, du) = lu!(Tridiagonal(dl, d, du), Val(false))
end

include("constant.jl")
include("linear.jl")
include("quadratic.jl")
include("cubic.jl")
include("indexing.jl")
include("prefiltering.jl")
include("../filter1d.jl")

Base.parent(A::BSplineInterpolation{T,N,TCoefs,UT}) where {T,N,TCoefs,UT<:Union{BSpline{<:Linear},BSpline{<:Constant}}} = A.coefs
Base.parent(A::BSplineInterpolation{T,N,TCoefs,UT}) where {T,N,TCoefs,UT} =
    throw(ArgumentError("The given BSplineInterpolation does not serve as a \"view\" for a parent array. This would only be true for Constant and Linear b-splines."))

if !isdefined(Main, :InterpolationTestUtils)
    include("InterpolationTestUtils.jl")
    @eval using Main.InterpolationTestUtils
end

using Test, SharedArrays, Random, ColorVectorSpace
using StaticArrays, WoodburyMatrices
using Interpolations

@test isempty(detect_ambiguities(Interpolations))

const isci = get(ENV, "CI", "") in ("true", "True")

@testset "Interpolations" begin
    include("core.jl")
    # Hermite interpolation tests
    include("cubic_hermite.jl")
    # b-spline interpolation tests
    include("b-splines/runtests.jl")
    isci && println("finished b-spline")
    include("nointerp.jl")
    # extrapolation tests
    include("extrapolation/runtests.jl")

    # scaling tests
    include("scaling/runtests.jl")

    # monotonic tests
    include("monotonic/runtests.jl")

    # lanczos tests
    include("lanczos/runtests.jl")

    # test gradient evaluation
    include("gradient.jl")
    isci && println("finished gradient")
    # test hessian evaluation
    include("hessian.jl")
    isci && println("finished hessian")

    # gridded interpolation tests
    include("gridded/runtests.jl")

    # test interpolation with specific types
    include("typing.jl")

    include("issues/runtests.jl")

    include("io.jl")
    include("convenience-constructors.jl")
    include("readme-examples.jl")
    include("iterate.jl")
    include("pipes.jl")

    # Chain rules interaction
    include("chainrules.jl")

    if VERSION >= v"1.6"
        import Pkg
        Pkg.add("JLArrays")
        include("gpu_support.jl")
    end
end

using Interpolations
using Test, LinearAlgebra, StaticArrays, OffsetArrays

@testset "Scaling" begin
    # Model linear interpolation of y = -3 + .5x by interpolating y=x
    # and then scaling to the new x range

    itp = interpolate(1:1.0:10, BSpline(Linear()))

    sitp = @inferred(scale(itp, -3:.5:1.5))
    @test typeof(sitp) <: Interpolations.ScaledInterpolation
    @test parent(sitp) === itp

    for (x,y) in zip(-3:.05:1.5, 1:.1:10,)
        @test sitp(x) ≈ y
    end
    # trailing 1s, issue #301
    @test sitp(0.8, 1) == sitp(0.8)


    @test_throws ArgumentError scale(itp, reverse(-3:.5:1.5))

    # Model linear interpolation of y = -3 + .5x by interpolating y=x
    # and then scaling to the new x range, this time using a LinRange,
    # which should give the same values as with the StepRangeLen used previously

    itp = interpolate(1:1.0:10, BSpline(Linear()))

    sitp = @inferred(scale(itp, LinRange(-3,1.5,10)))
    @test typeof(sitp) <: Interpolations.ScaledInterpolation

    for (x,y) in zip(-3:.05:1.5, 1:.1:10,)
        @test sitp(x) ≈ y
    end

    # Verify that it works in >1D, with different types of ranges

    gauss(phi, mu, sigma) = exp(-(phi-mu)^2 / (2sigma)^2)
    testfunction(x,y) = gauss(x, 0.5, 4) * gauss(y, -.5, 2)

    xs = -5:.5:5
    ys = -4:.2:4
    zs = Float64[testfunction(x,y) for x in xs, y in ys]

    itp2 = interpolate(zs, BSpline(Quadratic(Flat(OnGrid()))))
    sitp2 = @inferred scale(itp2, xs, ys)

    for x in xs, y in ys
        @test testfunction(x,y) ≈ sitp2(x,y)
    end

    # Test gradients of scaled grids
    xs = -pi:.1:pi
    ys = map(sin, xs)
    itp = interpolate(ys, BSpline(Linear()))
    sitp = @inferred scale(itp, xs)

    for x in -pi:.1:pi
        g = @inferred(Interpolations.gradient(sitp, x))[1]
        @test cos(x) ≈ g atol=0.05
    end

    # Test Hessians of scaled grids
    xs = -pi:.1:pi
    ys = -pi:.2:pi
    zs = sin.(xs) .* sin.(ys')
    itp = interpolate(zs, BSpline(Cubic(Line(OnGrid()))))
    sitp = @inferred scale(itp, xs, ys)

    for x in xs[2:end-1], y in ys[2:end-1]
        h = @inferred(Interpolations.hessian(sitp, x, y))
        @test issymmetric(h)
        @test [-sin(x) * sin(y) cos(x) * cos(y)
                cos(x) * cos(y) -sin(x) * sin(y)] ≈ h atol=0.03
    end

    # Test Hessians of scaled grids with LinRange
    xs = LinRange(-pi, pi, 62)
    ys = LinRange(-pi, pi, 32)
    zs = sin.(xs) .* sin.(ys')
    itp = interpolate(zs, BSpline(Cubic(Line(OnGrid()))))
    sitp = @inferred scale(itp, xs, ys)

    for x in xs[2:end-1], y in ys[2:end-1]
        h = @inferred(Interpolations.hessian(sitp, x, y))
        @test issymmetric(h)
        @test [-sin(x) * sin(y) cos(x) * cos(y)
                cos(x) * cos(y) -sin(x) * sin(y)] ≈ h atol=0.03
    end

    # Verify that return types are reasonable
    @inferred(sitp2(-3.4, 1.2))
    @inferred(sitp2(-3, 1))
    @inferred(sitp2(-3.4, 1))

    sitp32 = @inferred scale(interpolate(Float32[testfunction(x,y) for x in -5:.5:5, y in -4:.2:4], BSpline(Quadratic(Flat(OnGrid())))), -5f0:.5f0:5f0, -4f0:.2f0:4f0)
    @test typeof(@inferred(sitp32(-3.4f0, 1.2f0))) == Float32

    # Iteration
    itp = interpolate(rand(3,3,3), BSpline(Quadratic(Flat(OnCell()))))
    knots = map(d->1:10:21, 1:3)
    sitp = @inferred scale(itp, knots...)

    iter = @inferred(eachvalue(sitp))

    function foo!(dest, sitp)
        i = 0
        for s in eachvalue(sitp)
            dest[i+=1] = s
        end
        dest
    end
    function bar!(dest, sitp)
        for I in CartesianIndices(size(dest))
            dest[I] = sitp(I)
        end
        dest
    end
    rfoo = Array{Float64}(undef, Interpolations.ssize(sitp))
    rbar = similar(rfoo)
    foo!(rfoo, sitp)
    bar!(rbar, sitp)
    @test rfoo ≈ rbar

    itp = scale(interpolate(ones(2,2), BSpline(Linear())), 1:2, 1:2)
    itp2 = scale(interpolate(ones(2,2), BSpline(Linear())), (1:2, 1:2))
    @test itp == itp2
end

@testset "eachvalue iteration" begin
    A = reshape(reinterpret(SVector{2,Float64}, collect(1.:12.)), 3, 2)
    sitp = scale(interpolate(A, BSpline(Cubic(Line(OnGrid())))), 1:3, 1:2)
    @test first(eachvalue(sitp)) ≈ @SVector [1.,2.]
end

@testset "axes" begin
    saxs = -50:10:50
    itp = interpolate(-5:5, BSpline(Linear()))
    sitp = @inferred(scale(itp, saxs))
    @test collect(eachvalue(sitp)) ≈ OffsetArray(-5:0.1:5, -50:50)
end

# verify examples from README.md run
using Interpolations, Test

@testset "Readme Examples" begin

    ## Bsplines
    a = randn(6)
    A = randn(5, 5)

    # Nearest-neighbor interpolation
    itp = interpolate(a, BSpline(Constant()))
    v = itp(5.4)   # returns a[5]
    @test v ≈ a[5]

    # (Multi)linear interpolation
    itp = interpolate(A, BSpline(Linear()))
    v = itp(3.2, 4.1)  # returns 0.9*(0.8*A[3,4]+0.2*A[4,4]) + 0.1*(0.8*A[3,5]+0.2*A[4,5])
    @test v ≈ (0.9*(0.8*A[3,4]+0.2*A[4,4]) + 0.1*(0.8*A[3,5]+0.2*A[4,5]))

    # Quadratic interpolation with reflecting boundary conditions
    # Quadratic is the lowest order that has continuous gradient
    itp = interpolate(A, BSpline(Quadratic(Reflect(OnCell()))))

    # Linear interpolation in the first dimension, and no interpolation (just lookup) in the second
    itp = interpolate(A, (BSpline(Linear()), NoInterp()))
    v = itp(3.65, 5)  # returns  0.35*A[3,5] + 0.65*A[4,5]
    @test v ≈ (0.35*A[3,5] + 0.65*A[4,5])


    ## Scaled Bsplines
    A_x = 1.:2.:40.
    A = [log(x) for x in A_x]
    itp = interpolate(A, BSpline(Cubic(Line(OnGrid()))))
    sitp = scale(itp, A_x)
    @test sitp(3.) ≈ log(3.) # exactly log(3.)
    @test sitp(3.5) ≈ log(3.5) atol=.1 # approximately log(3.5)

    # For multidimensional uniformly spaced grids
    A_x1 = 1:.1:10
    A_x2 = 1:.5:20
    f(x1, x2) = log(x1+x2)
    A = [f(x1,x2) for x1 in A_x1, x2 in A_x2]
    itp = interpolate(A, BSpline(Cubic(Line(OnGrid()))))
    sitp = scale(itp, A_x1, A_x2)
    @test sitp(5., 10.) ≈ log(5 + 10) # exactly log(5 + 10)
    @test sitp(5.6, 7.1) ≈ log(5.6 + 7.1) atol=.1 # approximately log(5.6 + 7.1)

    ## Gridded interpolation
    A = rand(8,20)
    knots = ([x^2 for x = 1:8], [0.2y for y = 1:20])
    itp = interpolate(knots, A, Gridded(Linear()))
    @test itp(4,1.2) ≈ A[2,6] atol=.1  # approximately A[2,6]

    ## extrapolate
    itp = interpolate(1:7, BSpline(Linear()))
    etpf = extrapolate(itp, Flat())
    @test etpf(0) == 1
    @test etpf(1) == 1
    @test etpf(7) == 7
    @test etpf(7.8) == 7
    etp0 = extrapolate(itp, 0)
    @test etp0(0) === 0.0
    @test etp0(1) === 1.0
    @test etp0(7) === 7.0
    @test etp0(7.8) === 0.0

    f(x) = log(x)
    xs = 1:0.2:5
    A = [f(x) for x in xs]
    extrap = linear_interpolation(xs, A, extrapolation_bc = Line())
    @test extrap(1 - 0.2) ≈ f(1) - (f(1.2) - f(1))
    @test extrap(5 + 0.2) ≈ f(5) + (f(5) - f(4.8))
    extrap = linear_interpolation(xs, A, extrapolation_bc = NaN)
    @test isnan(extrap(5.2))

end

using Test, Interpolations, DualNumbers, Unitful

@testset "ExtrapTypeStability" begin

    # Test type-stability of 1-dimensional extrapolation
    f(x) = sin((x-3)*2pi/9 - 1)
    xmax = 10
    A = Float64[f(x) for x in 1:xmax]
    itpg = interpolate(A, BSpline(Linear()))

    schemes = (
        Flat,
        Line,
        Reflect,
        Periodic
    )

    for etp in map(E -> @inferred(extrapolate(itpg, E())), schemes),
        x in (
            # In-bounds evaluation
            3.4, 3, dual(3.1),
            # Out-of-bounds evaluation
            -3.4, -3, dual(-3,1),
            13.4, 13, dual(13,1)
        )
        @inferred(etp(x))
    end

    # Test type-stability of 2-dimensional extrapolation with homogeneous scheme
    g(y) = (y/100)^3
    ymax = 4
    A = Float64[f(x)*g(y) for x in 1:xmax, y in 1:ymax]
    itp2 = interpolate(A, BSpline(Linear()))

    for (etp2,E) in map(E -> (extrapolate(itp2, E()), E), schemes),
        x in (
            # In-bounds evaluation
            3.4, 3, dual(3.1),
            # Out-of-bounds evaluation
            -3.4, -3, dual(-3,1),
            13.4, 13, dual(13,1)
        ),
        y in (
            # In-bounds evaluation
            2.1, 2, dual(2.3, 1),
            # Out-of-bounds evaluation
            -2.1, -2, dual(-2.3, 1),
            12.1, 12, dual(12.1, 1)
        )
        @inferred(etp2(x, y))
    end

    A = [1 2; 3 4]
    Af = Float64.(A)
    for B in (A, Af)
        itpg2 = interpolate(B, BSpline(Linear()))
        etp = extrapolate(itpg2, NaN)
        @test typeof(@inferred(etp(dual(1.5,1), dual(1.5,1)))) ==
              typeof(@inferred(etp(dual(6.5,1), dual(3.5,1))))
    end

    # issue #258
    t = [2017, 2018]
    u = u"V"
    y = [1.f0, 2.f0] .* u
    how = Interpolations.Gridded(Interpolations.Linear())
    itp = interpolate((t,), y, Gridded(Linear()))
    etp = extrapolate(itp, 1.f0 * u)
    @test @inferred(itp(2018)) === 2.0f0 * u
    @test @inferred(etp(2018)) === 2.0f0 * u
    @test @inferred(etp(2019)) === 1.0f0 * u

    # Unitful vector knots
    t = [0.0, 1.0] * u"m"
    itp = linear_interpolation(t, y)
    @test itp(0.5u"m") == 1.5f0 * u
    @test itp([0.5, 0.75]u"m") == [1.5f0, 1.75f0] * u

    # issues #370, #424
    itp = linear_interpolation([1.0, 2.0, 3.0], [1.0, 2.0, 3.0], extrapolation_bc=missing)
    @test ismissing(itp(4.0))
    @test @inferred(eltype(itp),itp(3.0)) === 3.0
    @test @inferred(eltype(itp),itp(4.0)) === missing
end

#=
    Interpolate using cubic Hermite splines. The breakpoints in arrays xbp and ybp are assumed to be sorted.
    Evaluate the function in all points of the array xeval.
    Methods:
        "Linear"                yuck
        "FiniteDifference"      classic cubic interpolation, no tension parameter
                                Finite difference can overshoot for non-monotonic data
        "Cardinal"              cubic cardinal splines, uses tension parameter which must be between [0,1]
                                cubin cardinal splines can overshoot for non-monotonic data
                                (increasing tension decreases overshoot)
        "Akima"                 monotonic - tangents are determined at each given point locally,
                                the curve obtained is close to a manually drawn curve, can overshoot for non-monotonic data
        "FritschCarlson"        monotonic - tangents are first initialized, then adjusted if they are not monotonic
                                can overshoot for non-monotonic data
        "FritschButland"        monotonic - faster algorithm (only requires one pass) but somewhat higher apparent "tension"
        "Steffen"               monotonic - also only one pass, results usually between FritschCarlson and FritschButland
    Sources:
        Akima (1970), "A New Method of Interpolation and Smooth Curve Fitting Based on Local Procedures", doi:10.1145/321607.321609
        Fritsch & Carlson (1980), "Monotone Piecewise Cubic Interpolation", doi:10.1137/0717021.
        Fritsch & Butland (1984), "A Method for Constructing Local Monotone Piecewise Cubic Interpolants", doi:10.1137/0905021.
        Steffen (1990), "A Simple Method for Monotonic Interpolation in One Dimension", http://adsabs.harvard.edu/abs/1990A%26A...239..443S

    Implementation based on http://bl.ocks.org/niclasmattsson/7bceb05fba6c71c78d507adae3d29417
=#

export
    LinearMonotonicInterpolation,
    FiniteDifferenceMonotonicInterpolation,
    CardinalMonotonicInterpolation,
    AkimaMonotonicInterpolation,
    FritschCarlsonMonotonicInterpolation,
    FritschButlandMonotonicInterpolation,
    SteffenMonotonicInterpolation

"""
    MonotonicInterpolationType

Abstract class for all types of monotonic interpolation.
"""
abstract type MonotonicInterpolationType <: InterpolationType end

"""
    LinearMonotonicInterpolation

Simple linear interpolation.
"""
struct LinearMonotonicInterpolation <: MonotonicInterpolationType
end

"""
    FiniteDifferenceMonotonicInterpolation

Classic cubic interpolation, no tension parameter.
Finite difference can overshoot for non-monotonic data.
"""
struct FiniteDifferenceMonotonicInterpolation <: MonotonicInterpolationType
end

"""
    CardinalMonotonicInterpolation(tension)

Cubic cardinal splines, uses `tension` parameter which must be between [0,1]
Cubin cardinal splines can overshoot for non-monotonic data
(increasing tension reduces overshoot).
"""
struct CardinalMonotonicInterpolation{TTension<:Number} <: MonotonicInterpolationType
    tension :: TTension # must be in [0, 1]
end

"""
    AkimaMonotonicInterpolation

Monotonic interpolation based on Akima (1970),
"A New Method of Interpolation and Smooth Curve Fitting Based on Local Procedures",
doi:10.1145/321607.321609.

Tagents are dertermined at each given point locally,
results are close to manual drawn curves
"""
struct AkimaMonotonicInterpolation <: MonotonicInterpolationType
end

"""
    FritschCarlsonMonotonicInterpolation

Monotonic interpolation based on Fritsch & Carlson (1980),
"Monotone Piecewise Cubic Interpolation", doi:10.1137/0717021.

Tangents are first initialized, then adjusted if they are not monotonic
can overshoot for non-monotonic data
"""
struct FritschCarlsonMonotonicInterpolation <: MonotonicInterpolationType
end

"""
    FritschButlandMonotonicInterpolation

Monotonic interpolation based on  Fritsch & Butland (1984),
"A Method for Constructing Local Monotone Piecewise Cubic Interpolants",
doi:10.1137/0905021.

Faster than FritschCarlsonMonotonicInterpolation (only requires one pass)
but somewhat higher apparent "tension".
"""
struct FritschButlandMonotonicInterpolation <: MonotonicInterpolationType
end

"""
    SteffenMonotonicInterpolation

Monotonic interpolation based on Steffen (1990),
"A Simple Method for Monotonic Interpolation in One Dimension",
http://adsabs.harvard.edu/abs/1990A%26A...239..443S

Only one pass, results usually between FritschCarlson and FritschButland.
"""
struct SteffenMonotonicInterpolation <: MonotonicInterpolationType
end

"""
    MonotonicInterpolation

Monotonic interpolation up to third order represented by type, knots and
coefficients.
"""
struct MonotonicInterpolation{T, TCoeffs1, TCoeffs2, TCoeffs3, TEl, TInterpolationType<:MonotonicInterpolationType,
    TKnots<:AbstractVector{<:Number}, TACoeff <: AbstractArray{TEl,1}} <: AbstractInterpolation{T,1,DimSpec{TInterpolationType}}

    it::TInterpolationType
    knots::TKnots
    A::TACoeff # constant parts of piecewise polynomials
    m::Vector{TCoeffs1} # coefficients of linear parts of piecewise polynomials
    c::Vector{TCoeffs2} # coefficients of quadratic parts of piecewise polynomials
    d::Vector{TCoeffs3} # coefficients of cubic parts of piecewise polynomials
end

function Base.:(==)(o1::MonotonicInterpolation, o2::MonotonicInterpolation)
    o1.it == o2.it &&
    o1.knots == o2.knots &&
    o1.A == o2.A &&
    o1.m == o2.m &&
    o1.c == o2.c &&
    o1.d == o2.d
end

size(A::MonotonicInterpolation) = size(A.knots)
axes(A::MonotonicInterpolation) = axes(A.knots)

itpflag(A::MonotonicInterpolation) = A.it
coefficients(A::MonotonicInterpolation) = A.A

function MonotonicInterpolation(::Type{TWeights}, it::TInterpolationType, knots::TKnots, A::AbstractArray{TEl,1},
    m::Vector{TCoeffs1}, c::Vector{TCoeffs2}, d::Vector{TCoeffs3}) where {TWeights, TCoeffs1, TCoeffs2, TCoeffs3, TEl, TInterpolationType<:MonotonicInterpolationType, TKnots<:AbstractVector{<:Number}}

    isconcretetype(TInterpolationType) || error("The spline type must be a leaf type (was $TInterpolationType)")
    isconcretetype(tcoef(A)) || @warn("For performance reasons, consider using an array of a concrete type (eltype(A) == $(eltype(A)))")

    check_monotonic(knots, A)

    cZero = zero(TWeights)
    if isempty(A)
        T = Base.promote_op(*, typeof(cZero), eltype(A))
    else
        T = typeof(cZero * first(A))
    end

    MonotonicInterpolation{T, TCoeffs1, TCoeffs2, TCoeffs3, TEl, TInterpolationType, TKnots, typeof(A)}(it, knots, A, m, c, d)
end

function interpolate(::Type{TWeights}, ::Type{TCoeffs1},::Type{TCoeffs2},::Type{TCoeffs3}, knots::TKnots,
    A::AbstractArray{TEl,1}, it::TInterpolationType) where {TWeights,TCoeffs1,TCoeffs2,TCoeffs3,TEl,TKnots<:AbstractVector{<:Number},TInterpolationType<:MonotonicInterpolationType}

    check_monotonic(knots, A)

    # first we need to determine tangents (m)
    n = length(knots)
    m, Δ = calcTangents(TCoeffs1, knots, A, it)
    c = Vector{TCoeffs2}(undef, n-1)
    d = Vector{TCoeffs3}(undef, n-1)
    for k ∈ eachindex(c)
        if TInterpolationType == LinearMonotonicInterpolation
            c[k] = zero(TCoeffs2)
            d[k] = zero(TCoeffs3)
        else
            xdiff = knots[k+1] - knots[k]
            c[k] = (3*Δ[k] - 2*m[k] - m[k+1]) / xdiff
            d[k] = (m[k] + m[k+1] - 2*Δ[k]) / (xdiff * xdiff)
        end
    end

    MonotonicInterpolation(TWeights, it, knots, A, m, c, d)
end

function interpolate(knots::AbstractVector{<:Number}, A::AbstractArray{TEl,1},
    it::TInterpolationType) where {TEl,TInterpolationType<:MonotonicInterpolationType}

    interpolate(tweight(A),typeof(oneunit(eltype(A)) / oneunit(eltype(knots))),
        typeof(oneunit(eltype(A)) / oneunit(eltype(knots))^2),
        typeof(oneunit(eltype(A)) / oneunit(eltype(knots))^3),knots,A,it)
end

function (itp::MonotonicInterpolation)(x::Number)
    @boundscheck (checkbounds(Bool, itp, x) || Base.throw_boundserror(itp, (x,)))
    k = searchsortedfirst(itp.knots, x)
    if k > 1
        k -= 1
    end
    xdiff = x - itp.knots[k]
    return itp.A[k] + itp.m[k]*xdiff + itp.c[k]*xdiff*xdiff + itp.d[k]*xdiff*xdiff*xdiff
end

function gradient(itp::MonotonicInterpolation, x::Number)
    return SVector(gradient1(itp, x))
end

function gradient1(itp::MonotonicInterpolation, x::Number)
    @boundscheck (checkbounds(Bool, itp, x) || Base.throw_boundserror(itp, (x,)))
    k = searchsortedfirst(itp.knots, x)
    if k > 1
        k -= 1
    end
    xdiff = x - itp.knots[k]
    return itp.m[k] + 2*itp.c[k]*xdiff + 3*itp.d[k]*xdiff*xdiff
end

function hessian(itp::MonotonicInterpolation, x::Number)
    return SVector(hessian1(itp, x))
end

function hessian1(itp::MonotonicInterpolation, x::Number)
    @boundscheck (checkbounds(Bool, itp, x) || Base.throw_boundserror(itp, (x,)))
    k = searchsortedfirst(itp.knots, x)
    if k > 1
        k -= 1
    end
    xdiff = x - itp.knots[k]
    return 2*itp.c[k] + 6*itp.d[k]*xdiff
end

@inline function check_monotonic(knots, A)
    axes(knots) == axes(A) || throw(DimensionMismatch("knot vector must have the same axes as the corresponding array"))
    issorted(knots) || error("knot-vector must be sorted in increasing order")
end

function calcTangents(::Type{TCoeffs}, x::AbstractVector{<:Number},
    y::AbstractVector{TEl}, method::LinearMonotonicInterpolation) where {TCoeffs, TEl}

    n = length(x)
    Δ = Vector{TCoeffs}(undef, n-1)
    m = Vector{TCoeffs}(undef, n)
    for k ∈ eachindex(Δ)
        Δ[k] = (y[k+1] - y[k]) / (x[k+1] - x[k])
        m[k] = Δ[k]
    end
    m[n] = Δ[n-1]
    return (m, Δ)
end

function calcTangents(::Type{TCoeffs}, x::AbstractVector{<:Number},
    y::AbstractVector{TEl}, method::FiniteDifferenceMonotonicInterpolation) where {TCoeffs, TEl}

    n = length(x)
    Δ = Vector{TCoeffs}(undef, n-1)
    m = Vector{TCoeffs}(undef, n)
    for k ∈ eachindex(Δ)
        Δ[k] = (y[k+1] - y[k]) / (x[k+1] - x[k])
        if k == 1   # left endpoint
            m[k] = Δ[k]
        else
            m[k] = (Δ[k-1] + Δ[k]) / 2
        end
    end
    m[n] = Δ[n-1]
    return (m, Δ)
end

function calcTangents(::Type{TCoeffs}, x::AbstractVector{<:Number},
    y::AbstractVector{TEl}, method::CardinalMonotonicInterpolation{TTension}) where {TTension, TCoeffs, TEl}

    n = length(x)
    Δ = Vector{TCoeffs}(undef, n-1)
    m = Vector{TCoeffs}(undef, n)
    for k ∈ eachindex(Δ)
        Δ[k] = (y[k+1] - y[k]) / (x[k+1] - x[k])
        if k == 1   # left endpoint
            m[k] = Δ[k]
        else
            m[k] = (oneunit(TTension) - method.tension) * (y[k+1] - y[k-1]) / (x[k+1] - x[k-1])
        end
    end
    m[n] = Δ[n-1]
    return (m, Δ)
end

function calcTangents(::Type{TCoeffs}, x::AbstractVector{<:Number},
    y::AbstractVector{TEl}, method::AkimaMonotonicInterpolation) where {TCoeffs, TEl}

    # based on Akima (1970),
    # "A New Method of Interpolation and Smooth Curve Fitting Based on Local Procedures",
    # doi:10.1145/321607.321609.

    n = length(x)
    Δ = Vector{TCoeffs}(undef, n-1)
    m = Vector{TCoeffs}(undef, n)
    for k ∈ eachindex(Δ)
        Δ[k] = (y[k+1] - y[k]) / (x[k+1] - x[k])
    end
    Γ = [3Δ[1] - 2Δ[2]; 2Δ[1] - Δ[2]; Δ; 2Δ[n-1] - Δ[n-2]; 3Δ[n-1] - 2Δ[n-2]]
    for k ∈ eachindex(m)
        δ = abs(Γ[k+3] - Γ[k+2]) + abs(Γ[k+1] - Γ[k])
        if δ > zero(δ)
            α = abs(Γ[k+1] - Γ[k]) / δ
            m[k] = (1-α) * Γ[k+1] + α * Γ[k+2]
        else
            m[k] = 0.5 * Γ[k+1] + 0.5 * Γ[k+2]
        end
    end
    return (m, Δ)
end

function calcTangents(::Type{TCoeffs}, x::AbstractVector{<:Number},
    y::AbstractVector{TEl}, method::FritschCarlsonMonotonicInterpolation) where {TCoeffs, TEl}

    n = length(x)
    Δ = Vector{TCoeffs}(undef, n-1)
    m = Vector{TCoeffs}(undef, n)
    buff = Vector{typeof(first(Δ)^2)}(undef, n)
    for k ∈ eachindex(Δ)
        Δ[k] = (y[k+1] - y[k]) / (x[k+1] - x[k])
        if k == 1   # left endpoint
            m[k] = Δ[k]
        else
            # If any consecutive secant lines change sign (i.e. curve changes direction), initialize the tangent to zero.
            # This is needed to make the interpolation monotonic. Otherwise set tangent to the average of the secants.
            if Δ[k-1] * Δ[k] <= zero(Δ[k]^2)
                m[k] = zero(TCoeffs)
            else
                m[k] =  (Δ[k-1] + Δ[k]) / 2.0
            end
        end
    end
    m[n] = Δ[n-1]
    #=
    Fritsch & Carlson derived necessary and sufficient conditions for monotonicity in their 1980 paper. Splines will be
    monotonic if all tangents are in a certain region of the alpha-beta plane, with alpha and beta as defined below.
    A robust choice is to put alpha & beta within a circle around origo with radius 3. The FritschCarlson algorithm
    makes simple initial estimates of tangents and then does another pass over data points to move any outlier tangents
    into the monotonic region. FritschButland & Steffen algorithms make more elaborate first estimates of tangents that
    are guaranteed to lie in the monotonic region, so no second pass is necessary.
    =#

    # Second pass of FritschCarlson: adjust any non-monotonic tangents.
    for k ∈ eachindex(Δ)
        if Δ[k] == zero(TCoeffs)
            m[k] = zero(TCoeffs)
            m[k+1] = zero(TCoeffs)
            continue
        end
        α = m[k] / Δ[k]
        β = m[k+1] / Δ[k]
        τ = 3.0 * oneunit(α) / sqrt(α^2 + β^2)
        if τ < 1.0   # if we're outside the circle with radius 3 then move onto the circle
            m[k] = τ * α * Δ[k]
            m[k+1] = τ * β * Δ[k]
        end
    end
    return (m, Δ)
end

function calcTangents(::Type{TCoeffs}, x::AbstractVector{<:Number},
    y :: AbstractVector{TEl}, method :: FritschButlandMonotonicInterpolation) where {TCoeffs, TEl}

    # based on Fritsch & Butland (1984),
    # "A Method for Constructing Local Monotone Piecewise Cubic Interpolants",
    # doi:10.1137/0905021.

    n = length(x)
    Δ = Vector{TCoeffs}(undef, n-1)
    m = Vector{TCoeffs}(undef, n)
    for k ∈ eachindex(Δ)
        Δ[k] = (y[k+1] - y[k]) / (x[k+1] - x[k])
        if k == 1   # left endpoint
            m[k] = Δ[k]
        elseif Δ[k-1] * Δ[k] <= zero(Δ[k]^2)
            m[k] = zero(TCoeffs)
        else
            α = (1.0 + (x[k+1] - x[k]) / (x[k+1] - x[k-1])) / 3.0
            m[k] = Δ[k-1] * Δ[k] / (α*Δ[k] + (1.0 - α)*Δ[k-1])
        end
    end
    m[n] = Δ[n-1]
    return (m, Δ)
end

function calcTangents(::Type{TCoeffs}, x::AbstractVector{<:Number},
    y::AbstractVector{TEl}, method::SteffenMonotonicInterpolation) where {TCoeffs, TEl}

    # Steffen (1990),
    # "A Simple Method for Monotonic Interpolation in One Dimension",
    # http://adsabs.harvard.edu/abs/1990A%26A...239..443S

    n = length(x)
    Δ = Vector{TCoeffs}(undef, n-1)
    m = Vector{TCoeffs}(undef, n)
    for k ∈ eachindex(Δ)
        Δ[k] = (y[k+1] - y[k]) / (x[k+1] - x[k])
        if k == 1   # left endpoint
            m[k] = Δ[k]
        else
            p = ((x[k+1] - x[k]) * Δ[k-1] + (x[k] - x[k-1]) * Δ[k]) / (x[k+1] - x[k-1])
            m[k] = (sign(Δ[k-1]) + sign(Δ[k])) *
                min(abs(Δ[k-1]), abs(Δ[k]), 0.5*abs(p))
        end
    end
    m[n] = Δ[n-1]
    return (m, Δ)
end

# How many non-NoInterp dimensions are there?
count_interp_dims(::Type{<:MonotonicInterpolationType}) = 1

lbounds(itp::MonotonicInterpolation) = (first(itp.knots),)
ubounds(itp::MonotonicInterpolation) = (last(itp.knots),)

using Interpolations: degree,
                      getknots,
                      coefficients,
                      itpflag,
                      DimSpec,
                      AbstractLanczos,
                      lbounds,
                      ubounds

@testset "Lanczos" begin

@testset "Lanczos($N)" for N in 2:4
    X = 1:100
    X = [X; reverse(X)[2:end]]
    itp = interpolate(X, Lanczos(N))

    # properties
    @test getknots(itp) == axes(itp) == axes(X)
    @test coefficients(itp)[axes(itp)...] == X
    @test itpflag(itp) isa Lanczos{N}
    @test size(itp) == size(X)
    @test lbounds(itp) == (firstindex(X),)
    @test ubounds(itp) == (lastindex(X),)

    # recovers input points exactly
    @test itp.(X) == X

    @test 1 < itp(1.5) < 2
    @test 99 < itp(99.5) < 100


    # symmetry check
    interpolant = itp.(X)
    @test interpolant ≈ reverse(interpolant)

end

@testset "Lanczos OpenCV4" begin
    X = 1:100
    X = [X; reverse(X)[2:end]]
    itp = interpolate(X, Lanczos4OpenCV())

    # properties
    @test getknots(itp) == axes(itp) == axes(X)
    @test coefficients(itp)[axes(itp)...] == X
    @test itpflag(itp) isa Lanczos4OpenCV
    @test size(itp) == size(X)
    @test lbounds(itp) == (firstindex(X),)
    @test ubounds(itp) == (lastindex(X),)

    # recovers input points exactly
    @test itp.(X) == X

    @test 1 < itp(1.5) < 2
    @test 99 < itp(99.5) < 100
    # Test precision of Lanczos OpenCV4 #451, test not NaN
    @test itp(nextfloat(1.0)) ≈ itp(1.0)


    # symmetry check
    interpolant = itp.(X)
    @test interpolant ≈ reverse(interpolant)

end

end

using Interpolations
using Test

@testset "IO" begin
    SPACE = " "

    @testset "BSpline" begin
        A = rand(8,20)

        itp = interpolate(A, BSpline(Constant()))
        @test summary(itp) == "8×20 interpolate(::Matrix{Float64}, BSpline(Constant{Nearest}())) with element type Float64" ||
              summary(itp) == "8×20 interpolate(::Array{Float64,2}, BSpline(Constant{Nearest}())) with element type Float64"

        itp = interpolate(A, BSpline(Constant()))
        @test summary(itp) == "8×20 interpolate(::Matrix{Float64}, BSpline(Constant{Nearest}())) with element type Float64" ||
              summary(itp) == "8×20 interpolate(::Array{Float64,2}, BSpline(Constant{Nearest}())) with element type Float64"

        itp = interpolate(A, BSpline(Linear()))
        @test summary(itp) == "8×20 interpolate(::Matrix{Float64}, BSpline(Linear())) with element type Float64" ||
              summary(itp) == "8×20 interpolate(::Array{Float64,2}, BSpline(Linear())) with element type Float64"

        itp = interpolate(A, BSpline(Quadratic(Reflect(OnCell()))))
        @test summary(itp) == "8×20 interpolate(OffsetArray(::Matrix{Float64}, 0:9, 0:21), BSpline(Quadratic(Reflect(OnCell())))) with element type Float64" ||
              summary(itp) == "8×20 interpolate(OffsetArray(::Array{Float64,2}, 0:9, 0:21), BSpline(Quadratic(Reflect(OnCell())))) with element type Float64"

        itp = interpolate(A, (BSpline(Linear()), NoInterp()))
        @test summary(itp) == "8×20 interpolate(::Matrix{Float64}, (BSpline(Linear()), NoInterp())) with element type Float64" ||
              summary(itp) == "8×20 interpolate(::Array{Float64,2}, (BSpline(Linear()), NoInterp())) with element type Float64"

        itp = interpolate!(copy(A), BSpline(Quadratic(InPlace(OnCell()))))
        @test summary(itp) == "8×20 interpolate(::Matrix{Float64}, BSpline(Quadratic(InPlace(OnCell())))) with element type Float64" ||
              summary(itp) == "8×20 interpolate(::Array{Float64,2}, BSpline(Quadratic(InPlace(OnCell())))) with element type Float64"
    end

    @testset "Gridded" begin
        A = rand(20)
        A_x = collect(1.0:2.0:40.0)
        knots = (A_x,)
        itp = interpolate(knots, A, Gridded(Linear()))
        @test summary(itp) == "20-element interpolate((::Vector{Float64},), ::Vector{Float64}, Gridded(Linear())) with element type Float64" ||
              summary(itp) == "20-element interpolate((::Array{Float64,1},), ::Array{Float64,1}, Gridded(Linear())) with element type Float64"

        A = rand(8,20)
        knots = ([x^2 for x = 1:8], [0.2y for y = 1:20])
        itp = interpolate(knots, A, Gridded(Linear()))
        @test summary(itp) == "8×20 interpolate((::Vector{Int64},::Vector{Float64}), ::Matrix{Float64}, Gridded(Linear())) with element type Float64" ||
              summary(itp) == "8×20 interpolate((::Array{Int64,1},::Array{Float64,1}), ::Array{Float64,2}, Gridded(Linear())) with element type Float64"

        itp = interpolate(knots, A, (Gridded(Linear()),Gridded(Constant())))
        @test summary(itp) == "8×20 interpolate((::Vector{Int64},::Vector{Float64}), ::Matrix{Float64}, (Gridded(Linear()), Gridded(Constant{Nearest}()))) with element type Float64" ||
              summary(itp) == "8×20 interpolate((::Array{Int64,1},::Array{Float64,1}), ::Array{Float64,2}, (Gridded(Linear()), Gridded(Constant{Nearest}()))) with element type Float64"

        # issue #260
        A = collect((1:4)/4)
        itp = interpolate((range(0.0, stop=0.3, length=4),), A, Gridded(Linear()))
        io = IOBuffer()
        show(io, MIME("text/plain"), itp)
        str1 = String(take!(io))
        str2 = "4-element interpolate((0.0:0.1:0.3,), ::Array{Float64,1}, Gridded(Linear())) with element type Float64:\n 0.25\n 0.5 \n 0.75\n 1.0"
        str3 = "4-elementinterpolate((0.0:0.1:0.3,),::Vector{Float64},Gridded(Linear()))withelementtypeFloat64:\n 0.25 \n 0.5 \n 0.75\n 1.0"
        @test filter(!isspace, str1) == filter(!isspace, str3) ||
              filter(!isspace, str1) == filter(!isspace, str2)
        io2 = IOBuffer()
        show(io2, itp)
        str1 = String(take!(io2))
        str2 = "4-element interpolate((0.0:0.1:0.3,), ::Array{Float64,1}, Gridded(Linear())) with element type Float64:\n 0.25\n 0.5 \n 0.75\n 1.0"
        str3 = "4-elementinterpolate((0.0:0.1:0.3,),::Vector{Float64},Gridded(Linear()))withelementtypeFloat64:\n 0.25\n 0.5\n 0.75\n 1.0"
        @test filter(!isspace, str1) == filter(!isspace, str3) ||
              filter(!isspace, str1) == filter(!isspace, str2)
    end

    @testset "scaled" begin
        itp = interpolate(1:1.0:10, BSpline(Linear()))
        sitp = scale(itp, -3:.5:1.5)
        @test summary(sitp) == "10-element scale(interpolate(::Vector{Float64}, BSpline(Linear())), (-3.0:0.5:1.5,)) with element type Float64" ||
              summary(sitp) == "10-element scale(interpolate(::Array{Float64,1}, BSpline(Linear())), (-3.0:0.5:1.5,)) with element type Float64"
        io = IOBuffer()
        show(io, MIME("text/plain"), sitp)
        str = String(take!(io))
        @test str == "10-element scale(interpolate(::Vector{Float64}, BSpline(Linear())), (-3.0:0.5:1.5,)) with element type Float64:\n  1.0\n  2.0\n  3.0\n  4.0\n  5.0\n  6.0\n  7.0\n  8.0\n  9.0\n 10.0" ||
              str == "10-element scale(interpolate(::Array{Float64,1}, BSpline(Linear())), (-3.0:0.5:1.5,)) with element type Float64:\n  1.0\n  2.0\n  3.0\n  4.0\n  5.0\n  6.0\n  7.0\n  8.0\n  9.0\n 10.0"
        io2 = IOBuffer()
        show(io2, sitp)
        str2 = String(take!(io2))
        @test str2 == "10-element scale(interpolate(::Vector{Float64}, BSpline(Linear())), (-3.0:0.5:1.5,)) with element type Float64:\n  1.0\n  2.0\n  3.0\n  4.0\n  5.0\n  6.0\n  7.0\n  8.0\n  9.0\n 10.0" ||
              str2 == "10-element scale(interpolate(::Array{Float64,1}, BSpline(Linear())), (-3.0:0.5:1.5,)) with element type Float64:\n  1.0\n  2.0\n  3.0\n  4.0\n  5.0\n  6.0\n  7.0\n  8.0\n  9.0\n 10.0"

        gauss(phi, mu, sigma) = exp(-(phi-mu)^2 / (2sigma)^2)
        testfunction(x,y) = gauss(x, 0.5, 4) * gauss(y, -.5, 2)
        xs = -5:.5:5
        ys = -4:.2:4
        zs = Float64[testfunction(x,y) for x in xs, y in ys]
        itp2 = interpolate(zs, BSpline(Quadratic(Flat(OnGrid()))))
        sitp2 = scale(itp2, xs, ys)
        teststring = "21×41 scale(interpolate(OffsetArray(::Array{Float64,2}, 0:22, 0:42), BSpline(Quadratic(Flat(OnGrid())))), (-5.0:0.5:5.0,$SPACE-4.0:0.2:4.0)) with element type Float64"
        teststring2 = "21×41 scale(interpolate(OffsetArray(::Matrix{Float64}, 0:22, 0:42), BSpline(Quadratic(Flat(OnGrid())))), (-5.0:0.5:5.0,$SPACE-4.0:0.2:4.0)) with element type Float64"
        @test summary(sitp2) == teststring2 ||
              summary(sitp2) == teststring
        io3 = IOBuffer()
        show(io3, sitp2)
        str3 = String(take!(io3))
        @test occursin(teststring2, str3) || occursin(teststring, str3)
    end

    @testset "Monotonic" begin
        A_x = collect(1.0:2.0:40.0)
        A = map(x->x^2, A_x)
        itp = interpolate(A_x, A, FritschButlandMonotonicInterpolation())
        teststring = "20-element interpolate(::Array{Float64,1}, ::Array{Float64,1}, FritschButlandMonotonicInterpolation()) with element type Float64"
        teststring2 = "20-element interpolate(::Vector{Float64}, ::Vector{Float64}, FritschButlandMonotonicInterpolation()) with element type Float64"
        @test summary(itp) == teststring2 || summary(itp) == teststring

        io = IOBuffer()
        show(io, itp)
        str = String(take!(io))
        @test occursin(teststring2, str) || occursin(teststring, str)

        io2 = IOBuffer()
        show(io2, MIME("text/plain"), itp)
        str = String(take!(io2))
        @test occursin(teststring2, str) || occursin(teststring, str)
    end

    @testset "Extrapolation" begin
        A = rand(8,20)

        itpg = interpolate(A, BSpline(Linear()))
        etpg = extrapolate(itpg, Flat())
        teststring = "8×20 extrapolate(interpolate(::Array{Float64,2}, BSpline(Linear())), Flat()) with element type Float64"
        teststring16 = "8×20 extrapolate(interpolate(::Matrix{Float64}, BSpline(Linear())), Flat()) with element type Float64"
        @test summary(etpg) == teststring16 || summary(etpg) == teststring
        io = IOBuffer()
        show(io, etpg)
        str = String(take!(io))
        @test occursin(teststring16, str) || occursin(teststring, str)

        etpf = extrapolate(itpg, NaN)
        teststring2 = "8×20 extrapolate(interpolate(::Array{Float64,2}, BSpline(Linear())), NaN) with element type Float64"
        teststring16 = "8×20 extrapolate(interpolate(::Matrix{Float64}, BSpline(Linear())), NaN) with element type Float64"
        @test summary(etpf) == teststring16 || summary(etpf) == teststring2
        io2 = IOBuffer()
        show(io2, etpf)
        str2 = String(take!(io2))
        @test occursin(teststring16, str2) || occursin(teststring2, str2)
    end

    @testset "Combinations" begin
        xs = 1.0:0.5:2.0
        ys = xs.^3
        interp_cubic = cubic_spline_interpolation(xs, ys)
        io = IOBuffer()
        show(io, MIME("text/plain"), interp_cubic)
        str = String(take!(io))
        @test occursin("3.375", str)
    end

    @testset "Issue #260" begin
        itp = scale(interpolate(zeros(3,3,3),BSpline(Cubic(Free(OnGrid())))),2:4,2:4,2:4)
        io = IOBuffer()
        show(io, MIME("text/plain"), itp)
        str = String(take!(io))
        @test str == "3×3×3 scale(interpolate(OffsetArray(::Array{Float64, 3}, 0:4, 0:4, 0:4), BSpline(Cubic(Free(OnGrid())))), (2:4, 2:4, 2:4)) with element type Float64:\n[:, :, 1] =\n 0.0  0.0  0.0\n 0.0  0.0  0.0\n 0.0  0.0  0.0\n\n[:, :, 2] =\n 0.0  0.0  0.0\n 0.0  0.0  0.0\n 0.0  0.0  0.0\n\n[:, :, 3] =\n 0.0  0.0  0.0\n 0.0  0.0  0.0\n 0.0  0.0  0.0" ||
              str == "3×3×3 scale(interpolate(OffsetArray(::Array{Float64,3}, 0:4, 0:4, 0:4), BSpline(Cubic(Free(OnGrid())))), (2:4, 2:4, 2:4)) with element type Float64:\n[:, :, 1] =\n 0.0  0.0  0.0\n 0.0  0.0  0.0\n 0.0  0.0  0.0\n\n[:, :, 2] =\n 0.0  0.0  0.0\n 0.0  0.0  0.0\n 0.0  0.0  0.0\n\n[:, :, 3] =\n 0.0  0.0  0.0\n 0.0  0.0  0.0\n 0.0  0.0  0.0"
    end
end # testset

module TypeInstantiationTests

using Interpolations, Test

# NO DIMSPECS
# tests that we forward types correctly to the instance constructors
const A1 = rand(15)
const A2 = rand(15, 10)

# B-splines
for GT in (OnCell, OnGrid)
    # ...without boundary conditions
    for D in (Constant, Linear)
        @inferred(interpolate(A1, BSpline(D), GT))
        @inferred(interpolate(A1, BSpline(D), GT()))
        @inferred(interpolate(A1, BSpline(D()), GT))
        @inferred(interpolate(A2, BSpline(D), GT))
        @inferred(interpolate(A2, BSpline(D), GT()))
        @inferred(interpolate(A2, BSpline(D()), GT))

        @inferred(interpolate!(copy(A1), BSpline(D), GT))
        @inferred(interpolate!(copy(A1), BSpline(D), GT()))
        @inferred(interpolate!(copy(A1), BSpline(D()), GT))
        @inferred(interpolate!(copy(A2), BSpline(D), GT))
        @inferred(interpolate!(copy(A2), BSpline(D), GT()))
        @inferred(interpolate!(copy(A2), BSpline(D()), GT))
    end

    # Quadratic
    for BC in (Flat, Line, Periodic, Reflect, Free)
        if BC != InPlace
            @inferred(interpolate(A1, BSpline(Quadratic(BC)), GT))
            @inferred(interpolate(A1, BSpline(Quadratic(BC())), GT))
            @inferred(interpolate(A1, BSpline(Quadratic(BC)), GT()))
            @inferred(interpolate(A2, BSpline(Quadratic(BC)), GT))
            @inferred(interpolate(A2, BSpline(Quadratic(BC())), GT))
            @inferred(interpolate(A2, BSpline(Quadratic(BC)), GT()))
        end

        @inferred(interpolate!(copy(A1), BSpline(Quadratic(BC)), GT))
        @inferred(interpolate!(copy(A1), BSpline(Quadratic(BC())), GT))
        @inferred(interpolate!(copy(A1), BSpline(Quadratic(BC)), GT()))
        @inferred(interpolate!(copy(A2), BSpline(Quadratic(BC)), GT))
        @inferred(interpolate!(copy(A2), BSpline(Quadratic(BC())), GT))
        @inferred(interpolate!(copy(A2), BSpline(Quadratic(BC)), GT()))
    end
end

# Gridded
const knots1 = (sort(rand(15)),)
const knots2 = (sort(rand(15)), sort(rand(10)))
for D in (Constant, Linear)
    @inferred(interpolate(knots1, A1, Gridded(D)))
    @inferred(interpolate(knots2, A2, Gridded(D)))

    @inferred(interpolate!(knots1, copy(A1), Gridded(D)))
    @inferred(interpolate!(knots2, copy(A2), Gridded(D)))
end

# DIMSPECS

# test that constructing dimspecs work
for T in (
    Tuple{OnGrid,OnCell},
    Tuple{BSpline{Linear},BSpline{Quadratic{Free}}}
    )
    @test isa(@inferred(Interpolations.construct_instance(T)), T)
end
# sample one dimspec for each interpolation constructor to see that it
# calls the construct_instance() function correctly
@inferred(interpolate(A2, Tuple{BSpline{Linear},BSpline{<:Constant}}, Tuple{OnGrid,OnCell}))
@inferred(interpolate!(copy(A2), Tuple{BSpline{Linear},BSpline{<:Constant}}, Tuple{OnGrid,OnCell}))
@inferred(interpolate(A2, Tuple{BSpline{Linear},BSpline{<:Constant}}, (OnGrid(),OnCell())))
@inferred(interpolate!(copy(A2), Tuple{BSpline{Linear},BSpline{<:Constant}}, (OnGrid(),OnCell())))
@inferred(interpolate(A2, (BSpline(Linear()),BSpline(Constant())), Tuple{OnGrid,OnCell}))
@inferred(interpolate!(copy(A2), (BSpline(Linear()),BSpline(Constant())), Tuple{OnGrid,OnCell}))

end

#=
Portion of the source code below, the _lanczos4_opencv method in particular,
are copyrights of the below and are licensed under the terms below with the following
disclaimers. The source code has been significantly modified and ported to Julia.

By downloading, copying, installing or using the software you agree to this license.
If you do not agree to this license, do not download, install,
copy or use the software.


                           License Agreement
                For Open Source Computer Vision Library

Copyright (C) 2000-2008, 2017, Intel Corporation, all rights reserved.
Copyright (C) 2009, Willow Garage Inc., all rights reserved.
Copyright (C) 2014-2015, Itseez Inc., all rights reserved.
Copyright (C) 2020-2021 Miles Lucas, Tim Holy, and Mark Kittisopikul, all rights reserved
Third party copyrights are property of their respective owners.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  * Redistribution's of source code must retain the above copyright notice,
    this list of conditions and the following disclaimer.

  * Redistribution's in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
  * The name of the copyright holders may not be used to endorse or promote products
    derived from this software without specific prior written permission.

This software is provided by the copyright holders and contributors "as is" and
any express or implied warranties, including, but not limited to, the implied
warranties of merchantability and fitness for a particular purpose are disclaimed.
In no event shall the Intel Corporation or contributors be liable for any direct,
indirect, incidental, special, exemplary, or consequential damages
including, but not limited to, procurement of substitute goods or services;
loss of use, data, or profits; or business interruption) however caused
and on any theory of liability, whether in contract, strict liability,
or tort (including negligence or otherwise) arising in any way out of
the use of this software, even if advised of the possibility of such damage.
=#
using StaticArrays

export Lanczos4OpenCV

"""
    Lanczos4OpenCV()

Alternative implementation of Lanczos resampling using algorithm `lanczos4` function of OpenCV:
https://github.com/opencv/opencv/blob/de15636724967faf62c2d1bce26f4335e4b359e5/modules/imgproc/src/resize.cpp#L917-L946
"""
struct Lanczos4OpenCV <: AbstractLanczos end

degree(::Lanczos4OpenCV) = 4

value_weights(::Lanczos4OpenCV, δx) = _lanczos4_opencv(δx)

# s45 = sqrt(2)/2
const s45 = 0.70710678118654752440084436210485

# l4_2d_cs is a lookup table that could be generated by
# x = (0:7)*45*5
# l4_2d_cs = [cosd.(x) sind.(x)]'
const l4_2d_cs = SA[1 0; -s45 -s45; 0 1; s45 -s45; -1 0; s45 s45; 0 -1; -s45 s45]


function _lanczos4_opencv(δx)
    p_4 = π / 4
    y0 = -(δx + 3) * p_4
    s0, c0 = sincos(y0)
    cs = ntuple(8) do i
        y = (δx + 4 - i) * p_4
        # Improve precision of Lanczos OpenCV4 #451, avoid NaN
        if iszero(y)
            y = eps(oneunit(y))/8
        end
        # Numerator is the sin subtraction identity
        # It is equivalent to the following
        # f(δx,i) = sin( π/4*( 5*(i-1)-δx-3 ) )
        (l4_2d_cs[i, 1] * s0 + l4_2d_cs[i, 2] * c0) / y^2
    end
    sum_cs = sum(cs)
    normed_cs = ntuple(i -> cs[i] / sum_cs, Val(8))
    return normed_cs
end

using Interpolations, Test, LinearAlgebra, Random

@testset "ScalingNoInterpTests" begin
    xs = -pi:2pi/10:pi
    f1(x) = sin(x)
    f2(x) = cos(x)
    f3(x) = sin(x) * cos(x)
    f(x,y) = y == 1 ? f1(x) : (y == 2 ? f2(x) : (y == 3 ? f3(x) : error("invalid value for y (must be 1, 2 or 3, you used $y)")))
    ys = 1:3

    A = hcat(map(f1, xs), map(f2, xs), map(f3, xs))

    itp = interpolate(A, (BSpline(Quadratic(Periodic(OnGrid()))), NoInterp()))
    sitp = scale(itp, xs, ys)

    for (ix,x0) in enumerate(xs[1:end-1]), y0 in ys
        x,y = x0, y0
        @test sitp(x,y) ≈ f(x,y) atol=0.05
    end

    @test length(Interpolations.gradient(sitp, pi/3, 2)) == 1

    xs = range(-pi, stop=pi, length=60)[1:end-1]
    A = hcat(map(f1, xs), map(f2, xs), map(f3, xs))
    itp = interpolate(A, (BSpline(Cubic(Periodic(OnGrid()))), NoInterp()))
    sitp = scale(itp, xs, ys)

    for x in xs, y in ys
        if y in (1,2)
            h = @inferred(Interpolations.hessian(sitp, x, y))
            @test h[1] ≈ -f(x, y) atol=0.01
        else # y==3
            h = @inferred(Interpolations.hessian(sitp, x, y))
            @test h[1] ≈ -4*f(x, y) atol=0.01
        end
    end

    @test length(Interpolations.hessian(sitp, pi/3, 2)) == 1

    A = hcat(map(f1, xs), map(f2, xs), map(f3, xs))
    itp = interpolate(A', (NoInterp(), BSpline(Cubic(Periodic(OnGrid())))))
    sitp = scale(itp, ys, xs)
    h(y, x) = Interpolations.hessian(sitp, y, x)
    h(1, xs[10])
    for x in xs[6:end-6], y in ys
        if y in (1,2)
            @test h(y, x)[1] ≈ -f(x, y) atol=0.05
        elseif y==3
            @test h(y, x)[1] ≈ -4*f(x, y) atol=0.05
        end
    end

    # check for case where initial/middle indices are NoInterp but later ones are <:BSpline
    isdefined(Random, :seed!) ? Random.seed!(1234) : srand(1234) # `srand` was renamed to `seed!`
    z0 = rand(10,10)
    za = copy(z0)
    zb = copy(z0')

    itpa = interpolate(za, (BSpline(Linear()), NoInterp()))
    itpb = interpolate(zb, (NoInterp(), BSpline(Linear())))

    rng = range(1.0, stop=19.0, length=10)
    sitpa = scale(itpa, rng, 1:10)
    sitpb = scale(itpb, 1:10, rng)
    @test Interpolations.gradient(sitpa, 3.0, 3) ==  Interpolations.gradient(sitpb, 3, 3.0)


end

module Interpolations

export
    interpolate,
    interpolate!,
    extrapolate,
    scale,
    bounds,

    AbstractInterpolation,
    AbstractExtrapolation,

    OnCell,
    OnGrid,

    Flat,
    Line,
    Free,
    Periodic,
    Reflect,
    Natural,
    InPlace,
    InPlaceQ,
    Throw,

    constant_interpolation,
    linear_interpolation,
    cubic_spline_interpolation,

    knots,
    knotsbetween

    # see the following files for further exports:
    # b-splines/b-splines.jl
    # extrapolation/extrapolation.jl
    # monotonic/monotonic.jl
    # scaling/scaling.jl

using LinearAlgebra, SparseArrays
using StaticArrays, WoodburyMatrices, Ratios, AxisAlgorithms, OffsetArrays
using ChainRulesCore, Requires

using Base: @propagate_inbounds, HasEltype, EltypeUnknown, HasLength, IsInfinite,
    SizeUnknown, Indices
import Base: convert, size, axes, promote_rule, ndims, eltype, checkbounds, axes1,
    iterate, length, IteratorEltype, IteratorSize, firstindex, getindex, LogicalIndex

abstract type Flag end
abstract type InterpolationType <: Flag end
"`NoInterp()` indicates that the corresponding axis must use integer indexing (no interpolation is to be performed)"
struct NoInterp <: InterpolationType end
abstract type GridType <: Flag end
"`OnGrid()` indicates that the boundary condition applies at the first & last nodes"
struct OnGrid <: GridType end
"`OnCell()` indicates that the boundary condition applies a half-gridspacing beyond the first & last nodes"
struct OnCell <: GridType end

const DimSpec{T} = Union{T,Tuple{Vararg{Union{T,NoInterp}}},NoInterp}

abstract type AbstractInterpolation{T,N,IT<:DimSpec{InterpolationType}} <: AbstractArray{T,N} end
abstract type AbstractInterpolationWrapper{T,N,ITPT,IT} <: AbstractInterpolation{T,N,IT} end
abstract type AbstractExtrapolation{T,N,ITPT,IT} <: AbstractInterpolationWrapper{T,N,ITPT,IT} end

function Base.:(==)(itp1::AbstractInterpolation, itp2::AbstractInterpolation)
    propertynames(itp1) == propertynames(itp2) || return false
    for pname in propertynames(itp1)
        getproperty(itp1, pname) == getproperty(itp2, pname) || return false
    end
    return true
end

"""
    BoundaryCondition

An abstract type with one of the following values (see the help for each for details):

- `Throw(gt)`
- `Flat(gt)`
- `Line(gt)`
- `Free(gt)`
- `Periodic(gt)`
- `Reflect(gt)`
- `InPlace(gt)`
- `InPlaceQ(gt)`

where `gt` is the grid type, e.g., [`OnGrid()`](@ref) or [`OnCell()`](@ref).
"""
abstract type BoundaryCondition <: Flag end
# Put the gridtype into the boundary condition, since that's all it affects (see issue #228)
# Nothing is used for extrapolation
"`Throw(gt)` causes beyond-the-edge extrapolation to throw an error"
struct Throw{GT<:Union{GridType,Nothing}} <: BoundaryCondition gt::GT end
"`Flat(gt)` sets the extrapolation slope to zero"
struct Flat{GT<:Union{GridType,Nothing}} <: BoundaryCondition gt::GT end
"`Line(gt)` uses a constant slope for extrapolation"
struct Line{GT<:Union{GridType,Nothing}} <: BoundaryCondition gt::GT end
struct Free{GT<:Union{GridType,Nothing}} <: BoundaryCondition gt::GT end
"`Periodic(gt)` applies periodic boundary conditions"
struct Periodic{GT<:Union{GridType,Nothing}} <: BoundaryCondition gt::GT end
"`Reflect(gt)` applies reflective boundary conditions"
struct Reflect{GT<:Union{GridType,Nothing}} <: BoundaryCondition gt::GT end
"`InPlace(gt)` is a boundary condition that allows prefiltering to occur in-place (it typically requires padding)"
struct InPlace{GT<:Union{GridType,Nothing}} <: BoundaryCondition gt::GT end
"""`InPlaceQ(gt)` is similar to `InPlace(gt)`, but is exact when the values being interpolated
arise from an underlying quadratic. It is primarily useful for testing purposes,
allowing near-exact (to machine precision) comparisons against ground truth."""
struct InPlaceQ{GT<:Union{GridType,Nothing}} <: BoundaryCondition gt::GT end
const Natural = Line

(::Type{BC})() where BC<:BoundaryCondition = BC(nothing)
function Base.show(io::IO, bc::BoundaryCondition)
    print(io, nameof(typeof(bc)), '(')
    bc.gt === nothing || show(io, bc.gt)
    print(io, ')')
end


Base.IndexStyle(::Type{<:AbstractInterpolation}) = IndexCartesian()

size(exp::AbstractExtrapolation) = size(exp.itp)
axes(exp::AbstractExtrapolation) = axes(exp.itp)

twotuple(r::AbstractUnitRange) = (first(r), last(r))
twotuple(x, y) = (x, y)

"""
    bounds(itp::AbstractInterpolation)

Return the `bounds` of the domain of `itp` as a tuple of `(min, max)` pairs for each coordinate. This is best explained by example:

```jldoctest; setup = :(using Interpolations)
julia> itp = interpolate([1 2 3; 4 5 6], BSpline(Linear()));

julia> bounds(itp)
((1, 2), (1, 3))

julia> data = 1:3;

julia> knots = ([10, 11, 13.5],);

julia> itp = interpolate(knots, data, Gridded(Linear()));

julia> bounds(itp)
((10.0, 13.5),)
```
"""
bounds(itp::AbstractInterpolation) = map(twotuple, lbounds(itp), ubounds(itp))
bounds(itp::AbstractInterpolation, d) = bounds(itp)[d]

itptype(::Type{<:AbstractInterpolation{T,N,IT}}) where {T,N,IT<:DimSpec{InterpolationType}} = IT
itptype(itp::AbstractInterpolation) = itptype(typeof(itp))
# The following have been defined by AbstractArray
# ndims(::Type{<:AbstractInterpolation{T,N,<:DimSpec{InterpolationType}}}) where {T,N} = N
# ndims(itp::AbstractInterpolation) = ndims(typeof(itp))
# eltype(::Type{<:AbstractInterpolation{T,N,<:DimSpec{InterpolationType}}}) where {T,N} = T
# eltype(itp::AbstractInterpolation) = eltype(typeof(itp))

"""
    n = count_interp_dims(ITP)

Count the number of dimensions along which type `ITP` is interpolating.
`NoInterp` dimensions do not contribute to the sum.
"""
count_interp_dims(::Type{ITP}) where {ITP<:AbstractInterpolation} = count_interp_dims(itptype(ITP), ndims(ITP))
count_interp_dims(::Type{IT}, n) where {IT<:InterpolationType} = n * count_interp_dims(IT)
count_interp_dims(it::Type{IT}, n) where IT<:Tuple{Vararg{InterpolationType,N}} where N =
    _count_interp_dims(0, it...)
@inline _count_interp_dims(c, ::IT1, args...) where IT1 =
    _count_interp_dims(c + count_interp_dims(IT1), args...)
_count_interp_dims(c) = c

"""
    BoundsCheckStyle(itp)

A trait to determine dispatch of bounds-checking for `itp`.
Can return `NeedsCheck()`, in which case bounds-checking is performed, or `CheckWillPass()`
in which case the check will return `true`.
"""
abstract type BoundsCheckStyle end
struct NeedsCheck <: BoundsCheckStyle end
struct CheckWillPass <: BoundsCheckStyle end

BoundsCheckStyle(itp) = NeedsCheck()

"""
    wi = WeightedIndex(indexes, weights)

Construct a weighted index `wi`, which can be thought of as a generalization of an
ordinary array index to the context of interpolation.
For an ordinary vector `a`, `a[i]` extracts the element at index `i`.
When interpolating, one is typically interested in a range of indexes and the output is
some weighted combination of array values at these indexes.
For example, for linear interpolation at a location `x` between integers `i` and `i+1`, we have

    ret = (1-f)*a[i] + f*a[i+1]

where `f = x-i` lies between 0 and 1. This can be represented as `a[wi]`, where

    wi = WeightedIndex(i:i+1, (1-f, f))

i.e.,

    ret = sum(a[indexes] .* weights)

Linear interpolation thus constructs weighted indices using a 2-tuple for `weights` and
a length-2 `indexes` range.
Higher-order interpolation would involve more positions and weights (e.g., 3-tuples for
quadratic interpolation, 4-tuples for cubic).

In multiple dimensions, separable interpolation schemes are implemented in terms
of multiple weighted indices, accessing `A[wi1, wi2, ...]` where each `wi` is the
`WeightedIndex` along the corresponding dimension.

For value interpolation, `weights` will typically sum to 1.
However, for gradient and Hessian computation this will not necessarily be true.
For example, the gradient of one-dimensional linear interpolation can be represented as

    gwi = WeightedIndex(i:i+1, (-1, 1))
    g1 = a[gwi]

For a three-dimensional array `A`, one might compute `∂A/∂x₂` (the second component
of the gradient) as `A[wi1, gwi2, wi3]`, where `wi1` and `wi3` are "value" weights
and `gwi2` "gradient" weights.

`indexes` may be supplied as a range or as a tuple of the same length as `weights`.
The latter is applicable, e.g., for periodic boundary conditions.
"""
abstract type WeightedIndex{L,W} end

# Type to use when array locations are adjacent. This may offer more opportunities
# for compiler optimizations (e.g., SIMD).
struct WeightedAdjIndex{L,W} <: WeightedIndex{L,W}
    istart::Int
    weights::NTuple{L,W}
end
# Type to use with non-adjacent locations. E.g., periodic boundary conditions.
struct WeightedArbIndex{L,W} <: WeightedIndex{L,W}
    indexes::NTuple{L,Int}
    weights::NTuple{L,W}
end

function WeightedIndex(indexes::AbstractUnitRange{<:Integer}, weights::NTuple{L,Any}) where L
    @noinline mismatch(indexes, weights) = throw(ArgumentError("the length of indexes must match weights, got $indexes vs $weights"))
    length(indexes) == L || mismatch(indexes, weights)
    WeightedAdjIndex(first(indexes), promote(weights...))
end
WeightedIndex(istart::Integer, weights::NTuple{L,Any}) where L =
    WeightedAdjIndex(istart, promote(weights...))
WeightedIndex(indexes::NTuple{L,Integer}, weights::NTuple{L,Any}) where L =
    WeightedArbIndex(indexes, promote(weights...))

weights(wi::WeightedIndex) = wi.weights
indexes(wi::WeightedAdjIndex) = wi.istart
indexes(wi::WeightedArbIndex) = wi.indexes
indextuple(wi::WeightedAdjIndex{L}) where L = ntuple(i->wi.istart+i-1, Val(L))
indextuple(wi::WeightedArbIndex{L}) where L = indexes(wi)

# Make them iterable just like numbers are
Base.iterate(x::WeightedIndex) = (x, nothing)
Base.iterate(x::WeightedIndex, ::Any) = nothing
Base.isempty(x::WeightedIndex) = false
Base.length(x::WeightedIndex) = 1

# Supporting arithmetic on the weights allows one to perform pre-scaling of gradient coefficients
Base.:(*)(wi::WeightedAdjIndex, x::Number) = WeightedAdjIndex(wi.istart, wi.weights .* x)
Base.:(/)(wi::WeightedAdjIndex, x::Number) = WeightedAdjIndex(wi.istart, wi.weights ./ x)
Base.:(*)(wi::WeightedArbIndex, x::Number) = WeightedArbIndex(wi.indexes, wi.weights .* x)
Base.:(/)(wi::WeightedArbIndex, x::Number) = WeightedArbIndex(wi.indexes, wi.weights ./ x)

### Indexing with WeightedIndex

# We inject `WeightedIndex` as a non-exported indexing point with a `InterpGetindex` wrapper.
# `InterpGetindex` is not a subtype of `AbstractArray`. This ensures that the overload applies to all array types.
struct InterpGetindex{N,A<:AbstractArray{<:Any,N}}
    coeffs::A
    InterpGetindex(itp::AbstractInterpolation) = InterpGetindex(coefficients(itp))
    InterpGetindex(A::AbstractArray) = new{ndims(A),typeof(A)}(A)
end
@inline Base.getindex(A::InterpGetindex{N}, I::Vararg{Union{Int,WeightedIndex},N}) where {N} =
    interp_getindex(A.coeffs, ntuple(_ -> 0, Val(N)), map(indexflag, I)...)
indexflag(I::Int) = I
@inline indexflag(I::WeightedIndex) = indextuple(I), weights(I)

# A recursion-based `interp_getindex`, which follows a "move processed indexes to the back" strategy
# `I` contains the processed index, and (wi1, wis...) contains the yet-to-be-processed indexes
# Here we meet a no-interp dim, just append the index to `I`'s end.
@inline interp_getindex(A, I, wi1::Int, wis...) =
    interp_getindex(A, (Base.tail(I)..., wi1), wis...)
# Here we handle the expansion of a single dimension.
@inline interp_getindex(A, I, wi1::NTuple{2,Tuple{Any,Vararg{Any,N}}}, wis...) where {N} =
    wi1[2][end] * interp_getindex(A, (Base.tail(I)..., wi1[1][end]), wis...) +
    interp_getindex(A, I, map(Base.front, wi1), wis...)
@inline interp_getindex(A, I, wi1::NTuple{2,Tuple{Any}}, wis...) =
    wi1[2][1] * interp_getindex(A, (Base.tail(I)..., wi1[1][1]), wis...)
# Termination
@inline interp_getindex(A::AbstractArray{T,N}, I::Dims{N}) where {T,N} =
    @inbounds A[I...] # all bounds-checks have already happened

"""
    w = value_weights(degree, δx)

Compute the weights for interpolation of the value at an offset `δx` from the "base" position.
`degree` describes the interpolation scheme.

# Example

```jldoctest; setup = :(using Interpolations)
julia> Interpolations.value_weights(Linear(), 0.2)
(0.8, 0.2)
```

This corresponds to the fact that linear interpolation at `x + 0.2` is `0.8*y[x] + 0.2*y[x+1]`.
"""
function value_weights end

"""
    w = gradient_weights(degree, δx)

Compute the weights for interpolation of the gradient at an offset `δx` from the "base" position.
`degree` describes the interpolation scheme.

# Example

```jldoctest; setup = :(using Interpolations)
julia> Interpolations.gradient_weights(Linear(), 0.2)
(-1.0, 1.0)
```

This defines the gradient of a linear interpolation at 3.2 as `y[4] - y[3]`.
"""
function gradient_weights end

"""
    w = hessian_weights(degree, δx)

Compute the weights for interpolation of the hessian at an offset `δx` from the "base" position.
`degree` describes the interpolation scheme.

# Example

```jldoctest; setup = :(using Interpolations)
julia> Interpolations.hessian_weights(Linear(), 0.2)
(0.0, 0.0)
```

Linear interpolation uses straight line segments, so the second derivative is zero.
"""
function hessian_weights end


gradient1(itp::AbstractInterpolation{T,1}, x) where {T} = gradient(itp, x)[1]
hessian1(itp::AbstractInterpolation{T,1}, x) where {T} = hessian(itp, x)[1]

### Supporting expansion of CartesianIndex

const UnexpandedIndexTypes = Union{Number, AbstractVector, CartesianIndex}
const ExpandedIndexTypes = Union{Number, AbstractVector}

Base.to_index(::AbstractInterpolation, x::Number) = x

# Commented out because you can't add methods to an abstract type.
# @inline function (itp::AbstractInterpolation)(x::Vararg{UnexpandedIndexTypes})
#     itp(to_indices(itp, x)...)
# end
function gradient(itp::AbstractInterpolation, x::Vararg{UnexpandedIndexTypes})
    xi = to_indices(itp, x)
    xi == x && error("gradient of $itp not supported for position $x")
    gradient(itp, xi...)
end
@propagate_inbounds function gradient!(dest, itp::AbstractInterpolation{T,N}, x::Vararg{Number,N}) where {T,N}
    dest .= gradient(itp, x...)
end
function gradient!(dest, itp::AbstractInterpolation, x::Vararg{UnexpandedIndexTypes})
    gradient!(dest, itp, to_indices(itp, x)...)
end
function hessian(itp::AbstractInterpolation, x::Vararg{UnexpandedIndexTypes})
    hessian(itp, to_indices(itp, x)...)
end
@propagate_inbounds function hessian!(dest, itp::AbstractInterpolation{T,N}, x::Vararg{Number,N}) where {T,N}
    dest .= hessian(itp, x...)
end
function hessian!(dest, itp::AbstractInterpolation, x::Vararg{UnexpandedIndexTypes})
    hessian!(dest, itp, to_indices(itp, x)...)
end

# @inline function (itp::AbstractInterpolation)(x::Vararg{ExpandedIndexTypes})
#     itp.(Iterators.product(x...))
# end
# function gradient(itp::AbstractInterpolation, x::Vararg{ExpandedIndexTypes})
#     map(y->tgradient(itp, y), Iterators.product(x...))
# end
# function hessian(itp::AbstractInterpolation, x::Vararg{ExpandedIndexTypes})
#     map(y->thessian(itp, y), Iterators.product(x...))
# end
#
# tgradient(itp, y) = gradient(itp, y...)
# thessian(itp, y) = hessian(itp, y...)

# getindex is supported only for Integer indices (deliberately)
import Base: getindex
@propagate_inbounds getindex(itp::AbstractInterpolation{T,N}, i::Vararg{Integer,N}) where {T,N} = itp(i...)
@propagate_inbounds function getindex(itp::AbstractInterpolation{T,1}, i::Integer, j::Integer) where T
    @boundscheck (j == 1 || Base.throw_boundserror(itp, (i, j)))
    itp(i)
end

@inline checkbounds(::Type{Bool}, itp::AbstractInterpolation, x::Vararg{ExpandedIndexTypes,N}) where N =
    _checkbounds(BoundsCheckStyle(itp), itp, x)

@inline checkbounds(::Type{Bool}, itp::AbstractInterpolation, x::LogicalIndex) =
    _checkbounds(BoundsCheckStyle(itp), itp, x)

@inline checkbounds(::Type{Bool}, itp::AbstractInterpolation, x::LogicalIndex{<:Any,<:AbstractArray{Bool,1}}) =
    _checkbounds(BoundsCheckStyle(itp), itp, x)

_checkbounds(::CheckWillPass, itp, x) = true
_checkbounds(::NeedsCheck, itp, x) = checklubounds(lbounds(itp), ubounds(itp), x)

checklubounds(ls, us, xs) = _checklubounds(true, ls, us, xs)
_checklubounds(tf::Bool, ls, us, xs::Tuple{Number, Vararg{Any}}) =
    _checklubounds(tf & (ls[1] <= xs[1] <= us[1]), Base.tail(ls), Base.tail(us), Base.tail(xs))
_checklubounds(tf::Bool, ls, us, xs::Tuple{AbstractVector, Vararg{Any}}) =
    _checklubounds(tf & allbetween(ls[1], xs[1], us[1]), Base.tail(ls), Base.tail(us), Base.tail(xs))
_checklubounds(tf::Bool, ::Tuple{}, ::Tuple{}, ::Tuple{}) = tf

maybe_clamp(itp, xs) = maybe_clamp(BoundsCheckStyle(itp), itp, xs)
maybe_clamp(::NeedsCheck, itp, xs) = map(clamp, xs, lbounds(itp), ubounds(itp))
maybe_clamp(::CheckWillPass, itp, xs) = xs

Base.hash(x::AbstractInterpolation, h::UInt = zero(UInt)) = Base.hash_uint(3h - objectid(x))
Base.hash(x::AbstractExtrapolation, h::UInt = zero(UInt)) = Base.hash_uint(3h - objectid(x))

include("nointerp/nointerp.jl")
include("b-splines/b-splines.jl")
include("gridded/gridded.jl")
include("monotonic/monotonic.jl")
include("extrapolation/extrapolation.jl")
include("scaling/scaling.jl")
include("utils.jl")
include("io.jl")
include("convenience-constructors.jl")
include("deprecations.jl")
include("lanczos/lanczos.jl")
include("lanczos/lanczos_opencv.jl")
include("iterate.jl")
include("chainrules/chainrules.jl")
include("hermite/cubic.jl")
if VERSION >= v"1.6"
    include("gpu_support.jl")
end

function __init__()
    @require Unitful="1986cc42-f94f-5a68-af5c-568840ba703d" include("requires/unitful.jl")
end

end # module

@testset "BSpline" begin
    include("constant.jl")
    include("linear.jl")
    include("quadratic.jl")
    include("cubic.jl")
    include("mixed.jl")
    include("multivalued.jl")
    include("non1.jl")
    include("regularization.jl")

    @test eltype(@inferred(interpolate(rand(Float16, 3, 3), BSpline(Linear())))) == Float16 # issue #308
end

using Test, Interpolations, DualNumbers, LinearAlgebra, ColorVectorSpace
using ColorVectorSpace: RGB, Gray, N0f8, Colorant

@testset "Gradients" begin
    nx = 10
    f1(x) = sin((x-3)*2pi/(nx-1) - 1)
    g1gt(x) = 2pi/(nx-1) * cos((x-3)*2pi/(nx-1) - 1)
    A1 = Float64[f1(x) for x in 1:nx]
    g1 = Array{Float64}(undef, 1)
    A2 = rand(Float64, nx, nx) * 100
    g2 = Array{Float64}(undef, 2)

    for (A, g) in ((A1, g1), (A2, g2))
        # Gradient of Constant should always be 0
        itp = interpolate(A, BSpline(Constant()))
        for x in InterpolationTestUtils.thirds(axes(A))
            @test all(iszero, @inferred(Interpolations.gradient(itp, x...)))
            @test all(iszero, @inferred(Interpolations.gradient!(g, itp, x...)))
        end

        itp = interpolate(A, BSpline(Linear()))
        check_gradient(itp, g)
        i = first(eachindex(itp))
        @test Interpolations.gradient(itp, i) == Interpolations.gradient(itp, Tuple(i)...)

        for BC in (Flat,Line,Free,Periodic,Reflect,Natural), GT in (OnGrid, OnCell)
            itp = interpolate(A, BSpline(Quadratic(BC(GT()))))
            check_gradient(itp, g)
            i = first(eachindex(itp))
            @test Interpolations.gradient(itp, i) == Interpolations.gradient(itp, Tuple(i)...)
        end

        for BC in (Line, Flat, Free, Periodic), GT in (OnGrid, OnCell)
            itp = interpolate(A, BSpline(Cubic(BC(GT()))))
            check_gradient(itp, g)
            I = first(eachindex(itp))
            @test Interpolations.gradient(itp, I) == Interpolations.gradient(itp, Tuple(I)...)
        end
    end

    # Since Linear is OnGrid in the domain, check the gradients between grid points
    itp1 = interpolate(Float64[f1(x) for x in 1:nx],
                BSpline(Linear()))
    itp2 = interpolate((1:nx-1,), Float64[f1(x) for x in 1:nx-1],
                Gridded(Linear()))
    for itp in (itp1, itp2)
        for x in 2.5:nx-1.5
            @test ≈(g1gt(x),(Interpolations.gradient(itp,x))[1],atol=abs(0.1 * g1gt(x)))
            @test ≈(g1gt(x),(Interpolations.gradient!(g1,itp,x))[1],atol=abs(0.1 * g1gt(x)))
            @test ≈(g1gt(x),g1[1],atol=abs(0.1 * g1gt(x)))
        end

        for i = 1:10
            x = rand()*(nx-2)+1.5
            checkbounds(Bool, itp, x) || continue
            gtmp = Interpolations.gradient(itp, x)[1]
            xd = dual(x, 1)
            @test epsilon(itp(xd)) ≈ gtmp
        end
    end

    # test gridded on a non-uniform grid
    knots = (1.0:0.3:nx-1,)
    itp_grid = interpolate(knots, Float64[f1(x) for x in knots[1]],
                           Gridded(Linear()))

    for x in 1.5:0.5:nx-1.5
        @test ≈(g1gt(x),(Interpolations.gradient(itp_grid,x))[1],atol=abs(0.5 * g1gt(x)))
        @test ≈(g1gt(x),(Interpolations.gradient!(g1,itp_grid,x))[1],atol=abs(0.5 * g1gt(x)))
        @test ≈(g1gt(x),g1[1],atol=abs(0.5 * g1gt(x)))
    end

    # Since Quadratic is OnCell in the domain, check gradients at grid points
    itp1 = interpolate(Float64[f1(x) for x in 1:nx-1],
                       BSpline(Quadratic(Periodic(OnCell()))))
    for x in 2:nx-1
        @test ≈(g1gt(x),(Interpolations.gradient(itp1,x))[1],atol=abs(0.05 * g1gt(x)))
        @test ≈(g1gt(x),(Interpolations.gradient!(g1,itp1,x))[1],atol=abs(0.05 * g1gt(x)))
        @test ≈(g1gt(x),g1[1],atol=abs(0.1 * g1gt(x)))
    end

    for i = 1:10
        x = rand()*(nx-2)+1.5
        gtmp = Interpolations.gradient(itp1, x)[1]
        xd = dual(x, 1)
        @test epsilon(itp1(xd)) ≈ gtmp
    end

    # For a quadratic function and quadratic interpolation, we expect an
    # "exact" answer
    # 1d
    c = 2.3
    a = 8.1
    o = 1.6
    qfunc = x -> a*(x .- c).^2 .+ o
    dqfunc = x -> 2*a*(x .- c)
    xg = Float64[1:5;]
    y = qfunc(xg)

    iq = interpolate(y, BSpline(Quadratic(Free(OnCell()))))
    x = 1.8
    @test iq(x) ≈ qfunc(x)
    @test (Interpolations.gradient(iq,x))[1] ≈ dqfunc(x)

    # 2d (biquadratic)
    p = [(x-1.75)^2 for x = 1:7]
    A = p*p'
    iq = interpolate(A, BSpline(Quadratic(Free(OnCell()))))
    @test iq[4,4] ≈ (4 - 1.75) ^ 4
    @test iq[4,3] ≈ (4 - 1.75) ^ 2 * (3 - 1.75) ^ 2
    g = Interpolations.gradient(iq, 4, 3)
    @test g[1] ≈ 2 * (4 - 1.75) * (3 - 1.75) ^ 2
    @test g[2] ≈ 2 * (4 - 1.75) ^ 2 * (3 - 1.75)

    iq = interpolate!(copy(A), BSpline(Quadratic(InPlace(OnCell()))))
    @test iq[4,4] ≈ (4 - 1.75) ^ 4
    @test iq[4,3] ≈ (4 - 1.75) ^ 2 * (3 - 1.75) ^ 2
    g = Interpolations.gradient(iq, 4, 3)
    @test ≈(g[1],2 * (4 - 1.75) * (3 - 1.75) ^ 2,atol=0.03)
    @test ≈(g[2],2 * (4 - 1.75) ^ 2 * (3 - 1.75),atol=0.2)

    # InPlaceQ is exact for an underlying quadratic
    iq = interpolate!(copy(A), BSpline(Quadratic(InPlaceQ(OnCell()))))
    @test iq[4,4] ≈ (4 - 1.75) ^ 4
    @test iq[4,3] ≈ (4 - 1.75) ^ 2 * (3 - 1.75) ^ 2
    g = Interpolations.gradient(iq, 4, 3)
    @test g[1] ≈ 2 * (4 - 1.75) * (3 - 1.75) ^ 2
    @test g[2] ≈ 2 * (4 - 1.75) ^ 2 * (3 - 1.75)

    A2 = rand(Float64, nx, nx) * 100
    gni = [1.0]
    for BC in (Flat,Line,Free,Periodic,Reflect,Natural), GT in (OnGrid, OnCell)
        itp_a = interpolate(A2, (BSpline(Linear()), BSpline(Quadratic(BC(GT())))))
        itp_b = interpolate(A2, (BSpline(Quadratic(BC(GT()))), BSpline(Linear())))
        itp_c = interpolate(A2, (NoInterp(), BSpline(Quadratic(BC(GT())))))
        itp_d = interpolate(A2, (BSpline(Quadratic(BC(GT()))), NoInterp()))

        for i = 1:10
            x = rand()*(nx-2)+1.5
            y = rand()*(nx-2)+1.5
            xd = dual(x, 1)
            yd = dual(y, 1)
            gtmp = Interpolations.gradient(itp_a, x, y)
            @test length(gtmp) == 2
            @test epsilon(itp_a(xd,y)) ≈ gtmp[1]
            @test epsilon(itp_a(x,yd)) ≈ gtmp[2]
            gtmp = Interpolations.gradient(itp_b, x, y)
            @test length(gtmp) == 2
            @test epsilon(itp_b(xd,y)) ≈ gtmp[1]
            @test epsilon(itp_b(x,yd)) ≈ gtmp[2]
            ix, iy = round(Int, x), round(Int, y)
            gtmp = Interpolations.gradient(itp_c, ix, y)
            @test length(gtmp) == 1
            @test epsilon(itp_c(ix,yd)) ≈ gtmp[1]
            gni[1] = NaN
            Interpolations.gradient!(gni, itp_c, ix, y)
            @test gni[1] ≈ gtmp[1]
            gtmp = Interpolations.gradient(itp_d, x, iy)
            @test length(gtmp) == 1
            @test epsilon(itp_d(xd,iy)) ≈ gtmp[1]
            gni[1] = NaN
            Interpolations.gradient!(gni, itp_d, x, iy)
            @test gni[1] ≈ gtmp[1]
        end
    end

    # issue #239
    f(x) = log(x)
    xs = 1:0.2:5
    A = [f(x) for x in xs]
    interp_linear = linear_interpolation(xs, A)
    g = Interpolations.gradient(interp_linear, 1.5)
    dest = Vector{Float64}(undef, 1)
    Interpolations.gradient!(dest, interp_linear, 1.5)
    @test dest == g

    @testset "Monotonic" begin
        x = [0.0, 0.2, 0.5, 0.6, 0.9, 1.0]
        ys = [[-3.0, 0.0, 5.0, 10.0, 18.0, 22.0],
              [10.0, 0.0, -5.0, 10.0, -8.0, -2.0]]
        grid = 0.0:0.1:1.0

        itypes = [LinearMonotonicInterpolation(),
            FiniteDifferenceMonotonicInterpolation(),
            CardinalMonotonicInterpolation(0.0),
            CardinalMonotonicInterpolation(0.5),
            CardinalMonotonicInterpolation(1.0),
            AkimaMonotonicInterpolation(),
            FritschCarlsonMonotonicInterpolation(),
            FritschButlandMonotonicInterpolation(),
            SteffenMonotonicInterpolation()]

        for y in ys
            for it in itypes
                itp = interpolate(x, y, it)
                for t in grid
                    gradval = epsilon(itp(dual(t, 1.0)))
                    @test Interpolations.gradient1(itp, t) ≈ gradval atol = 1.e-12
                    @test Interpolations.gradient(itp, t)[1] ≈ gradval atol = 1.e-12
                end
            end
        end
    end

    @testset "Extrapolations" begin
        # out of bounds extrapolation check where fillvalue=constant
        dims = [1, 2, 3]
        @testset "Constant Fillvalue" begin
            dtypes = [Float32, Float64, RGB{Float64}, RGB{Float32}, RGB{N0f8}, Gray{Float64}, Gray{N0f8}]
            for dt in dtypes
                for dm in dims
                    itp = interpolate(rand(dt, ntuple(_ -> 5, dm)...), BSpline(Linear()))
                    etp = extrapolate(itp, rand(dt))
                    cs = ntuple(_->3, dm)
                    @test @inferred(Interpolations.gradient(etp, cs...)) == @inferred(Interpolations.gradient(itp, cs...))
                    for ds in [ntuple(_->-0.5, dm), ntuple(_->5.5, dm), ntuple(_->6, dm)]
                        @test all(iszero, @inferred(Interpolations.gradient(etp, ds...)))
                        if dt <: Colorant
                            @test eltype(Interpolations.gradient(etp, ds...)) <: Colorant
                        else
                            @test eltype(Interpolations.gradient(etp, ds...)) <: AbstractFloat
                        end
                    end
                end
            end
        end
        @testset "Boundary Conditions" begin
            BC = (Flat, Line, Periodic, Reflect, Natural)
            for dm in dims
                for bc in BC
                    itp = interpolate(rand(5, 5), BSpline(Linear()))
                    etp = extrapolate(itp, bc())
                    cs = ntuple(_->3, 2)
                    @test @inferred(Interpolations.gradient(etp, cs...)) == @inferred(Interpolations.gradient(itp, cs...))
                    for ds in [ntuple(_->-0.5, 2), ntuple(_->5.5, 2), ntuple(_->6, 2)]
                        @test size(@inferred(Interpolations.gradient(etp, ds...))) == (2,)
                    end
                end
            end
        end
    end
end

@testset "Cubic" begin
    for (constructor, copier) in ((interpolate, identity), (interpolate!, copy))
        isinplace = constructor == interpolate!
        f0(x) = sin((x-3)*2pi/9 - 1)
        f1(x) = 1.0 + 0.1*x + 0.01*x^2 + 0.001*x^3

        xmax = 10
        A0 = Float64[f0(x) for x in 1:xmax]
        A1 = Float64[f1(x) for x in 1:xmax]

        f2(x, y) = sin(x/10)*cos(y/6)
        xmax2, ymax2 = 30, 10
        A2 = Float64[f2(x, y) for x in 1:xmax2, y in 1:ymax2]

        for BC in (Line, Flat, Free, Periodic), GT in (OnGrid, OnCell)
            for (A, f) in ((A0, f0), (A1, f1))
                itp1 = @inferred(constructor(copier(A), BSpline(Cubic(BC(GT())))))
                ax1 = axes(itp1)[1]
                @test Interpolations.lbounds(itp1) == (GT == OnGrid ? (first(ax1),) : (first(ax1) - 0.5,))
                @test Interpolations.ubounds(itp1) == (GT == OnGrid ? (last(ax1),) : (last(ax1) + 0.5,))
                @test_throws ArgumentError parent(itp1)
                check_axes(itp1, A, isinplace)
                check_inbounds_values(itp1, A)
                check_oob(itp1)
                can_eval_near_boundaries(itp1)

                # test that inner region is close to data
                for x in 3.1:.2:8.1
                    @test f(x) ≈ itp1(x) atol=abs(0.1 * f(x))
                end
            end

            itp2 = @inferred(constructor(copier(A2), BSpline(Cubic(BC(GT())))))
            @test_throws ArgumentError parent(itp2)
            check_axes(itp2, A2, isinplace)
            check_inbounds_values(itp2, A2)
            check_oob(itp2)
            can_eval_near_boundaries(itp2)

            for x in 3.1:.2:xmax2-3, y in 3.1:2:ymax2-3
                @test f2(x,y) ≈ itp2(x,y) atol=abs(0.1 * f2(x,y))
            end
        end
        # Issue 419: Incorrect results with BSpline(Cubic(Periodic(OnCell()))))
        let BC = Periodic, GT = OnCell
            for (A, f) in ((A0, f0), (A1, f1))
                itp1 = @inferred(constructor(copier(A), BSpline(Cubic(BC(GT())))))
                @test itp1(Interpolations.lbounds(itp1)...) ≈ itp1(Interpolations.ubounds(itp1)...)
            end
        end
    end

    # Test default constructor
    itp_type = Cubic |> BSpline
    itp = interpolate(1:5, itp_type)
    @test itp(1:0.5:5) ≈ 1:0.5:5

    ix = 1:15
    k = length(ix) - 1
    f(x) = cos((x-1)*2pi/k)
    g(x) = -2pi/k * sin((x-1)*2pi/k)

    A = map(f, ix)

    for (constructor, copier) in ((interpolate, identity), (interpolate!, copy))

        for BC in (Line, Flat, Free, Periodic), GT in (OnGrid,OnCell)

            itp = constructor(copier(A), BSpline(Cubic(BC(GT()))))
            # test that inner region is close to data
            for x in range(ix[5], stop=ix[end-4], length=100)
                @test g(x) ≈ Interpolations.gradient1(itp,x) atol=cbrt(cbrt(eps(g(x))))
            end
        end
        # Issue 419: Incorrect results with BSpline(Cubic(Periodic(OnCell()))))
        let BC = Periodic, GT = OnCell
            itp = @inferred(constructor(A[1:end-1], BSpline(Cubic(BC(GT())))))
            @test itp(Interpolations.lbounds(itp)...) ≈ itp(Interpolations.ubounds(itp)...)
        end
    end
    itp_flat_g = interpolate(A, BSpline(Cubic(Flat(OnGrid()))))
    @test Interpolations.gradient(itp_flat_g,1)[1] ≈ 0 atol=eps()
    @test Interpolations.gradient(itp_flat_g,ix[end])[1] ≈ 0 atol=eps()

    itp_flat_c = interpolate(A, BSpline(Cubic(Flat(OnCell()))))
    @test Interpolations.gradient(itp_flat_c,0.5)[1] ≈ 0 atol=eps()
    @test Interpolations.gradient(itp_flat_c,ix[end] + 0.5)[1] ≈ 0 atol=eps()

    # Can construct from coefficients
    itp = interpolate(rand(5, 9), BSpline(Cubic(Flat(OnGrid()))))
    @test itp == Interpolations.BSplineInterpolation(itp.coefs, itp.it, itp.parentaxes)
    @test_throws ArgumentError Interpolations.BSplineInterpolation(itp.coefs, itp.it, (2:3, 2:10))
end

using Test, Interpolations, OffsetArrays

@testset "ExtrapNon1" begin

    f(x) = sin((x-3)*2pi/9 - 1)
    xinds = -3:6
    A = OffsetArray(Float64[f(x) for x in xinds], xinds)
    itpg = interpolate(A, BSpline(Linear()))

    schemes = (
        Flat,
        Line,
        Reflect,
        Periodic
    )

    for etp in map(E -> extrapolate(itpg, E()), schemes), x in xinds
        @test parent(etp) === itpg
        @test @inferred(getindex(etp, x)) ≈ A[x]
    end

    g(y) = (y/100)^3
    yinds = 2:5
    A = OffsetArray(Float64[f(x)*g(y) for x in xinds, y in yinds], xinds, yinds)
    itp2 = interpolate(A, BSpline(Linear()))

    for (etp2,E) in map(E -> (extrapolate(itp2, E()), E), schemes)
        @test parent(etp2) === itp2
        E == Periodic && continue  # g isn't periodic
        for y in yinds, x in xinds
            @test @inferred(getindex(etp2, x, y)) ≈ A[x, y]
        end
    end

end

using Random
using Test

function cubic_hermite_test()
    # Need at least two samples:
    xs = ones(1)
    ys = ones(1)
    dydxs = ones(1)
    @test_throws DomainError CubicHermite(xs, ys, dydxs)

    # All vectors must be the same size:
    xs = ones(2)
    xs[2] = 2
    ys = ones(2)
    dydxs = ones(3)
    @test_throws DomainError CubicHermite(xs, ys, dydxs)

    xs = ones(5)
    for i = 2:length(xs)
        xs[i] = i
    end
    ys = ones(5)
    dydxs = zeros(5)
    ch = CubicHermite(xs, ys, dydxs)
    for i = 1:length(xs)-1
        x = Float64(i)
        @test ch(x) == 1.0
        @test gradient(ch, x) == 0.0
        @test hessian(ch, x) == 0.0
        x = x + 0.25
        @test ch(x) == 1.0
        @test gradient(ch, x) == 0.0
        @test hessian(ch, x) == 0.0
        x = x + 0.25
        @test ch(x) == 1.0
        @test gradient(ch, x) == 0.0
        @test hessian(ch, x) == 0.0
        x = x + 0.25
        @test ch(x) == 1.0
        @test gradient(ch, x) == 0.0
        @test hessian(ch, x) == 0.0
    end
    # Ensure that the ight endpoint query doesn't read past the end of the array:
    @test ch(5.0) == 1.0
    @test gradient(ch, 5.0) == 0.0
    @test hessian(ch, 5.0) == 0.0

    # Now linear functions:
    a = 7.2
    b = 9.6
    for i = 1:length(xs)
        ys[i] = a * xs[i] + b
        dydxs[i] = a
    end
    ch = CubicHermite(xs, ys, dydxs)
    for i = 1:length(xs)-1
        x = Float64(i)
        @test ch(x) ≈ a * x + b
        @test gradient(ch, x) ≈ a
        @test abs(hessian(ch, x)) < 3e-14
        x = x + 0.25
        @test ch(x) ≈ a * x + b
        @test gradient(ch, x) ≈ a
        @test abs(hessian(ch, x)) < 3e-14
        x = x + 0.25
        @test ch(x) ≈ a * x + b
        @test gradient(ch, x) ≈ a
        @test abs(hessian(ch, x)) < 3e-14
        x = x + 0.25
        @test ch(x) ≈ a * x + b
        @test gradient(ch, x) ≈ a
        @test abs(hessian(ch, x)) < 3e-14
    end
    @test ch(last(xs)) ≈ a * last(xs) + b
    @test gradient(ch, last(xs)) ≈ a
    @test abs(hessian(ch, last(xs))) < 3e-14

    # Now the interpolation condition:
    xs = zeros(50)
    ys = zeros(50)
    dydxs = zeros(50)
    xs[1] = 0.0
    ys[1] = randn()
    dydxs[1] = randn()
    for i = 2:50
        xs[i] = xs[i-1] + rand() + 0.1
        ys[i] = randn()
        dydxs[i] = randn()
    end

    ch = CubicHermite(xs, ys, dydxs)

    for i = 1:50
        @test ch(xs[i]) ≈ ys[i]
        @test gradient(ch, xs[i]) ≈ dydxs[i]
    end

    # Now quadratics:
    a = 1.0 / 8
    b = -3
    c = -2
    for i = 1:50
        ys[i] = a * xs[i] * xs[i] + b * xs[i] + c
        dydxs[i] = 2 * a * xs[i] + b
    end
    ch = CubicHermite(xs, ys, dydxs)
    for i = 1:200
        x = rand() * last(xs)
        @test ch(x) ≈ a * x * x + b * x + c
        @test gradient(ch, x) ≈ 2 * a * x + b
        @test hessian(ch, x) ≈ 2 * a
    end
    x = last(xs)
    @test ch(x) ≈ a * x * x + b * x + c
    @test gradient(ch, x) ≈ 2 * x * a + b
    @test hessian(ch, x) ≈ 2 * a
    # Cannot extrapolate:
    @test_throws DomainError ch(x + 0.1)
    @test_throws DomainError ch(xs[1] - 0.1)
end

@testset "Hermite" begin
    cubic_hermite_test()
end

@testset "Multivalued" begin
    # 1d
    A0 = rand(20)
    A = reinterpret(MyPair{Float64}, A0)
    a1, a2 = A0[1:2:end], A0[2:2:end]
    @test length(A) == 10
    itp = interpolate(A, BSpline(Constant()))
    @test itp(3.2) ≈ MyPair(A0[5],A0[6])
    itp = interpolate(A, BSpline(Linear()))
    @test itp(3.2) ≈ 0.8*MyPair(A0[5],A0[6]) + 0.2*MyPair(A0[7],A0[8])
    it = BSpline(Quadratic(Flat(OnGrid())))
    itp = interpolate(A, it)
    @test itp(3.2) ≈ MyPair(interpolate(a1, it)(3.2), interpolate(a2, it)(3.2))

    # 2d
    A0 = rand(100)
    A = reshape(reinterpret(MyPair{Float64}, A0), (10,5))
    a1, a2 = reshape(A0[1:2:end], (10,5)), reshape(A0[2:2:end], (10,5))
    for it in (BSpline(Constant()),
               BSpline(Linear()),
               BSpline(Quadratic(Flat(OnGrid()))))
        itp = interpolate(A, it)
        @test itp(3.2,1.8) ≈ MyPair(interpolate(a1, it)(3.2,1.8), interpolate(a2, it)(3.2,1.8))
    end
end

import Adapt: adapt_structure
using Adapt: adapt

function adapt_structure(to, itp::BSplineInterpolation{T,N}) where {T,N}
    coefs′ = adapt(to, itp.coefs)
    T′ = update_eltype(T, coefs′, itp.coefs)
    BSplineInterpolation{T′,N}(coefs′, itp.parentaxes, itp.it)
end

function update_eltype(T, coefs′, coefs)
    ET = eltype(coefs′)
    ET === eltype(coefs) && return T
    WT = tweight(coefs′)
    T′ = Base.promote_op(*, WT, ET)
    (isconcretetype(T′) || isempty(coefs)) && return T′
    return typeof(zero(WT) * convert(ET, first(coefs)))
end

function adapt_structure(to, itp::LanczosInterpolation{T,N}) where {T,N}
    coefs′ = adapt(to, itp.coefs)
    parentaxes′ = adapt(to, itp.parentaxes)
    LanczosInterpolation{eltype(coefs′),N}(coefs′, parentaxes′, itp.it)
end

function adapt_structure(to, itp::GriddedInterpolation{T,N}) where {T,N}
    coefs′ = adapt(to, itp.coefs)
    knots′ = adapt(to, itp.knots)
    T′ = update_eltype(T, coefs′, itp.coefs)
    GriddedInterpolation{T′,N,typeof(coefs′),itptype(itp),typeof(knots′)}(knots′, coefs′, itp.it)
end

function adapt_structure(to, itp::ScaledInterpolation{T,N,<:Any,IT,RT}) where {T,N,IT,RT<:NTuple{N,AbstractRange}}
    ranges = itp.ranges
    itp′ = adapt(to, itp.itp)
    ScaledInterpolation{eltype(itp′),N,typeof(itp′),IT,RT}(itp′, ranges)
end

function adapt_structure(to, itp::Extrapolation{T,N}) where {T,N}
    et = itp.et
    itp′ = adapt(to, itp.itp)
    Extrapolation{eltype(itp′),N,typeof(itp′),itptype(itp),typeof(et)}(itp′, et)
end

import Base.Broadcast: broadcasted, BroadcastStyle
using Base.Broadcast: broadcastable, combine_styles, AbstractArrayStyle
function broadcasted(itp::AbstractInterpolation, args...)
    args′ = map(broadcastable, args)
    # we overload BroadcastStyle here (try our best to do broadcast on GPU)
    style = combine_styles(Ref(itp), args′...)
    broadcasted(style, itp, args′...)
end

"""
    Interpolations.root_storage_type(::Type{<:AbstractInterpolation}) -> Type{<:AbstractArray}

This function returns the type of the root cofficients array of an `AbstractInterpolation`.
Some array wrappers, like `OffsetArray`, should be skipped.
"""
root_storage_type(::Type{T}) where {T<:AbstractInterpolation} = Array{eltype(T),ndims(T)} # fallback to `Array` by default.
root_storage_type(::Type{T}) where {T<:Extrapolation} = root_storage_type(fieldtype(T, 1))
root_storage_type(::Type{T}) where {T<:ScaledInterpolation} = root_storage_type(fieldtype(T, 1))
root_storage_type(::Type{T}) where {T<:BSplineInterpolation} = root_storage_type(fieldtype(T, 1))
root_storage_type(::Type{T}) where {T<:LanczosInterpolation} = root_storage_type(fieldtype(T, 1))
root_storage_type(::Type{T}) where {T<:GriddedInterpolation} = root_storage_type(fieldtype(T, 2))
root_storage_type(::Type{T}) where {T<:OffsetArray} = root_storage_type(fieldtype(T, 1))
root_storage_type(::Type{T}) where {T<:AbstractArray} = T

BroadcastStyle(::Type{<:Ref{T}}) where {T<:AbstractInterpolation} = _to_scalar_style(BroadcastStyle(T))
BroadcastStyle(::Type{T}) where {T<:AbstractInterpolation} = BroadcastStyle(root_storage_type(T))

_to_scalar_style(::S) where {S<:AbstractArrayStyle} = S(Val(0))
_to_scalar_style(S::AbstractArrayStyle{Any}) = S
_to_scalar_style(S) = S

using Interpolations, Test

@testset "MixedTests" begin
    A = rand(6,5)
    knots = (range(1, stop=size(A,1), length=size(A,1)), range(1, stop=size(A,2), length=size(A,2)))
    itp = @inferred(interpolate(knots, A, (Gridded(Linear()),NoInterp())))
    @inferred(itp(2, 2))
    @inferred(itp(CartesianIndex((2,2))))
    for j = 2:size(A,2)-1, i = 2:size(A,1)-1
        @test itp(i,j) ≈ A[i,j]
        @test itp(CartesianIndex(i,j)) ≈ A[i,j]
    end
    @inferred(itp(knots...)) ≈ A

    A = rand(8,20)
    knots = ([x^2 for x = 1:8], [0.2y for y = 1:20])
    itp = interpolate(knots, A, Gridded(Linear()))
    @test itp(4,1.2) ≈ A[2,6]

    @test_throws  ErrorException interpolate(knots, A, (Gridded(Linear()),NoInterp()))
end

struct Quadratic{BC<:BoundaryCondition} <: DegreeBC{2}
    bc::BC
end
# Default constructor
Quadratic() = Quadratic(Line(OnGrid()))
(deg::Quadratic)(gt::GridType) = Quadratic(deg.bc(gt))


"""
    Quadratic(bc::BoundaryCondition)

Indicate that the corresponding axis should use quadratic interpolation.

# Extended help

Assuming uniform knots with spacing 1, the `i`th piece of quadratic spline
implemented here is defined as follows:

    y_i(x) = cm p(x-i) + c q(x) + cp p(1-(x-i))

where

    p(δx) = (δx - 1)^2 / 2
    q(δx) = 3/4 - δx^2

and the values for `cX` for `X ∈ {m,_,p}` are the pre-filtered coefficients.

For future reference, this expands to the following polynomial:

    y_i(x) = cm * 1/2 * (x-i-1)^2 + c * (3/4 - x + i)^2 + cp * 1/2 * (x-i)^2

When we derive boundary conditions we will use derivatives `y_1'(x-1)` and
`y_1''(x-1)`
"""
Quadratic

function positions(deg::Quadratic, ax, x)
    xm = roundbounds(x, ax)
    δx = x - xm
    expand_index(deg, fast_trunc(Int, xm), ax, δx), δx
end

value_weights(::Quadratic, δx) = (
    sqr(δx - SimpleRatio(1,2))/2,
    SimpleRatio(3,4) - sqr(δx),
    sqr(δx + SimpleRatio(1,2))/2)

gradient_weights(::Quadratic, δx) = (
    δx - SimpleRatio(1,2),
    -2 * δx,
    δx + SimpleRatio(1,2))

hessian_weights(::Quadratic, δx) = (oneunit(δx), -2*oneunit(δx), oneunit(δx))

expand_index(::Quadratic, xi::Number, ax::AbstractUnitRange, δx) = xi-1  # uses WeightedAdjIndex
# Others use WeightedArbIndex
expand_index(::Quadratic{<:Periodic}, xi::Number, ax::AbstractUnitRange, δx) =
    (modrange(xi-1, ax), modrange(xi, ax), modrange(xi+1, ax))
expand_index(::Quadratic{BC}, xi::Number, ax::AbstractUnitRange, δx) where BC<:Union{InPlace,InPlaceQ} =
    (max(xi-1, first(ax)), xi, min(xi+1, last(ax)))

padded_axis(ax::AbstractUnitRange, ::BSpline{<:Quadratic}) = first(ax)-1:last(ax)+1
padded_axis(ax::AbstractUnitRange, ::BSpline{Quadratic{BC}}) where BC<:Union{Periodic,InPlace,InPlaceQ} = ax

# # Due to padding we can extend the bounds
# lbound(ax, ::BSpline{Quadratic{BC}}, ::OnGrid) where BC = first(ax) - 0.5
# ubound(ax, ::BSpline{Quadratic{BC}}, ::OnGrid) where BC = last(ax) + 0.5

function inner_system_diags(::Type{T}, n::Int, ::Quadratic) where {T}
    du = fill(convert(T, SimpleRatio(1,8)), n-1)
    d = fill(convert(T, SimpleRatio(3,4)), n)
    dl = copy(du)
    (dl,d,du)
end

"""
`Quadratic{Flat}` `OnCell` and `Quadratic{Reflect}` `OnCell` amounts to setting
`y_1'(x) = 0` at x=1/2. Applying this condition yields

    -cm + c = 0
"""
function prefiltering_system(::Type{T}, ::Type{TC}, n::Int, degree::Quadratic{BC}) where {T,TC,BC<:Union{Flat{OnCell},Reflect{OnCell}}}
    dl,d,du = inner_system_diags(T,n,degree)
    d[1] = d[end] = -1
    du[1] = dl[end] = 1
    lut!(dl, d, du), zeros(TC, n)
end

function prefiltering_system(::Type{T}, ::Type{TC}, n::Int, degree::Quadratic{InPlace{OnCell}}) where {T,TC}
    dl,d,du = inner_system_diags(T,n,degree)
    d[1] = d[end] = convert(T, SimpleRatio(7,8))
    lut!(dl, d, du), zeros(TC, n)
end

# InPlaceQ continues the quadratic at 2 all the way down to 1 (rather than 1.5)
function prefiltering_system(::Type{T}, ::Type{TC}, n::Int, degree::Quadratic{InPlaceQ{OnCell}}) where {T,TC}
    dl,d,du = inner_system_diags(T,n,degree)
    d[1] = d[end] = SimpleRatio(9,8)
    dl[end] = du[1] = SimpleRatio(-1,4)
    # Woodbury correction to add 1/8 for row 1, col 3 and row n, col n-2
    rowspec = spzeros(T, n, 2)
    colspec = spzeros(T, 2, n)
    valspec = zeros(T, 2, 2)
    valspec[1,1] = valspec[2,2] = SimpleRatio(1,8)
    rowspec[1,1] = rowspec[end,2] = 1
    colspec[1,3] = colspec[2,end-2] = 1
    Woodbury(lut!(dl, d, du), rowspec, valspec, colspec), zeros(TC, n)
end

"""
`Quadratic{Flat}` `OnGrid` and `Quadratic{Reflect}` `OnGrid` amount to setting
`y_1'(x) = 0` at `x=1`. Applying this condition yields

    -cm + cp = 0
"""
function prefiltering_system(::Type{T}, ::Type{TC}, n::Int, degree::Quadratic{BC}) where {T,TC,BC<:Union{Flat{OnGrid},Reflect{OnGrid}}}
    dl,d,du = inner_system_diags(T,n,degree)
    d[1] = d[end] = -1
    du[1] = dl[end] = 0

    specs = WoodburyMatrices.sparse_factors(T, n,
                                  (1, 3, oneunit(T)),
                                  (n, n-2, oneunit(T))
                                 )

    Woodbury(lut!(dl, d, du), specs...), zeros(TC, n)
end

"""
`Quadratic{Line}` `OnGrid` and `Quadratic{Line}` `OnCell` amount to setting
`y_1''(x) = 0` at `x=1` and `x=1/2` respectively. Since `y_i''(x)` is independent
of `x` for a quadratic b-spline, these both yield

    1 cm -2 c + 1 cp = 0
"""
function prefiltering_system(::Type{T}, ::Type{TC}, n::Int, degree::Quadratic{<:Line}) where {T,TC}
    dl,d,du = inner_system_diags(T,n,degree)
    d[1] = d[end] = 1
    du[1] = dl[end] = -2

    specs = WoodburyMatrices.sparse_factors(T, n,
                                  (1, 3, oneunit(T)),
                                  (n, n-2, oneunit(T)),
                                  )

    Woodbury(lut!(dl, d, du), specs...), zeros(TC, n)
end

"""
`Quadratic{Free}` `OnGrid` and `Quadratic{Free}` `OnCell` amount to requiring
an extra continuous derivative at the second-to-last cell boundary; this means
that `y_1''(3/2) = y_2''(3/2)`, yielding

    1 cm -3 c + 3 cp - cpp = 0
"""
function prefiltering_system(::Type{T}, ::Type{TC}, n::Int, degree::Quadratic{<:Free}) where {T,TC}
    dl,d,du = inner_system_diags(T,n,degree)
    d[1] = d[end] = 1
    du[1] = dl[end] = -3

    specs = WoodburyMatrices.sparse_factors(T, n,
                                    (1, 3, 3),
                                    (1, 4, -1),
                                    (n, n-2, 3),
                                    (n, n-3, -1))

    Woodbury(lut!(dl, d, du), specs...), zeros(TC, n)
end

"""
`Quadratic{Periodic}` `OnGrid` and `Quadratic{Periodic}` `OnCell` close the system
by looking at the coefficients themselves as periodic, yielding

    c0 = c(N+1)

where `N` is the number of data points.
"""
function prefiltering_system(::Type{T}, ::Type{TC}, n::Int, degree::Quadratic{<:Periodic}) where {T,TC}
    dl,d,du = inner_system_diags(T,n,degree)

    specs = WoodburyMatrices.sparse_factors(T, n,
                                  (1, n, du[1]),
                                  (n, 1, dl[end])
                                  )

    Woodbury(lut!(dl, d, du), specs...), zeros(TC, n)
end

using AxisAlgorithms, OffsetArrays

@testset "Unconventional axes" begin
    # At present, for a particular type of non-1 array you need to specialize this function
    function AxisAlgorithms.A_ldiv_B_md!(dest::OffsetArray, F, src::OffsetArray, dim::Integer, b::AbstractVector)
        indsdim = axes(parent(src), dim)
        indsF = axes(F)[2]
        if indsF == indsdim
            return A_ldiv_B_md!(parent(dest), F, parent(src), dim, b)
        end
        throw(DimensionMismatch("indices $(axes(parent(src))) do not match $(axes(F))"))
    end

    for (constructor, copier) in ((interpolate, x->x), (interpolate!, copy))
        isinplace = constructor == interpolate!
        f1(x) = sin((x-3)*2pi/9 - 1)
        inds = -3:6
        A1 = OffsetArray(Float64[f1(x) for x in inds], inds)

        f2(x,y) = sin(x/10)*cos(y/6) + 0.1
        xinds, yinds = -2:28,0:9
        A2 = OffsetArray(Float64[f2(x,y) for x in xinds, y in yinds], xinds, yinds)

        for O in (Constant, Linear)
            itp1 = @inferred(constructor(copier(A1), BSpline(O())))
            check_axes(itp1, A1, isinplace)
            check_inbounds_values(itp1, A1)
            check_oob(itp1)
            can_eval_near_boundaries(itp1)

            itp2 = @inferred(constructor(copier(A2), BSpline(O())))
            check_axes(itp2, A2, isinplace)
            check_inbounds_values(itp2, A2)
            check_oob(itp2)
            can_eval_near_boundaries(itp2)
        end

        for BC in (Flat,Line,Free,Periodic,Reflect,Natural), GT in (OnGrid, OnCell)
            itp1 = @inferred(constructor(copier(A1), BSpline(Quadratic(BC(GT())))))
            check_axes(itp1, A1, isinplace)
            check_inbounds_values(itp1, A1)
            check_oob(itp1)
            can_eval_near_boundaries(itp1)

            itp2 = @inferred(constructor(copier(A2), BSpline(Quadratic(BC(GT())))))
            check_axes(itp2, A2, isinplace)
            check_inbounds_values(itp2, A2)
            check_oob(itp2)
            can_eval_near_boundaries(itp2)
        end

        for BC in (Flat,Line,Free,Periodic), GT in (OnGrid, OnCell)
            itp1 = @inferred(constructor(copier(A1), BSpline(Cubic(BC(GT())))))
            check_axes(itp1, A1, isinplace)
            check_inbounds_values(itp1, A1)
            check_oob(itp1)
            can_eval_near_boundaries(itp1)

            itp2 = @inferred(constructor(copier(A2), BSpline(Cubic(BC(GT())))))
            check_axes(itp2, A2, isinplace)
            check_inbounds_values(itp2, A2)
            check_oob(itp2)
            can_eval_near_boundaries(itp2)
        end
    end

    let
        f(x) = sin((x-3)*2pi/9 - 1)
        inds = -7:2
        A = OffsetArray(Float64[f(x) for x in inds], inds)
        itp1 = interpolate!(copy(A), BSpline(Quadratic(InPlace(OnCell()))))
        check_axes(itp1, A)
        check_inbounds_values(itp1, A)
        check_oob(itp1)
        can_eval_near_boundaries(itp1)

        f(x,y) = sin(x/10)*cos(y/6) + 0.1
        xinds, yinds = -2:28,0:9
        A2 = OffsetArray(Float64[f(x,y) for x in xinds, y in yinds], xinds, yinds)
        itp2 = interpolate!(copy(A2), BSpline(Quadratic(InPlace(OnCell()))))
        check_axes(itp2, A2)
        check_inbounds_values(itp2, A2)
        check_oob(itp2)
        can_eval_near_boundaries(itp2)
    end
end

module InterpolationTestUtils

using Test, Interpolations, ForwardDiff, StaticArrays
using Interpolations: degree, itpflag, bounds, lbounds, ubounds

export check_axes, check_inbounds_values, check_oob, can_eval_near_boundaries,
       check_gradient, check_hessian
export MyPair

const failstore = Ref{Any}(nothing)   # stash the inputs to failing tests here

## Property accessors
coefs(itp) = itp.coefs

boundaryconditions(itp::AbstractInterpolation) = boundaryconditions(itpflag(itp))
boundaryconditions(bs::BSpline) = degree(bs)
boundaryconditions(ni::NoInterp) = ni

ndaccessor(x, d) = x
ndaccessor(x::Tuple, d) = x[d]

haspadding(itp) = haspadding(boundaryconditions(itp))
haspadding(::Union{Constant,Linear,NoInterp}) = false
haspadding(::Quadratic{BC}) where BC = haspadding(BC())
haspadding(::Cubic{BC})     where BC = haspadding(BC())
haspadding(::BC) where BC<:Interpolations.BoundaryCondition = !(BC <: Union{Periodic,InPlace,InPlaceQ})
haspadding(bcs::Tuple) = map(haspadding, bcs)
haspadding(::NoInterp) = false

getindexib(itp, i...) = @inbounds itp[i...]
callib(itp, i...)     = @inbounds itp(i...)

⊂(r1::AbstractRange, r2::AbstractRange) = first(r2) < first(r1) < last(r2) && first(r2) < last(r1) < last(r2)

function check_axes(itp, A, isinplace=false)
    @test ndims(itp) == ndims(A)
    axsi, axsA = @inferred(axes(itp)), axes(A)
    szi, szA = @inferred(size(itp)), size(A)
    haspad = haspadding(itp)
    for d = 1:ndims(A)
        if isinplace && ndaccessor(haspad, d)
            @test axsi[d] != axsA[d] && axsi[d] ⊂ axsA[d]
            @test szi[d] < szA[d]
        else
            @test axsi[d] == axsA[d]
            @test szi[d] == szA[d]
        end
    end
    nothing
end

function check_inbounds_values(itp, A)
    i = first(eachindex(itp))
    @test A[i] ≈ @inferred(itp[i]) == @inferred(itp[Tuple(i)...]) ≈ @inferred(itp(i)) ≈ @inferred(itp(float.(Tuple(i))...))
    for i in eachindex(itp)
        @test A[i] ≈ itp[i] == itp[Tuple(i)...] ≈ itp(i) ≈ itp(float.(Tuple(i))...)
    end
    cb = Base.JLOptions().check_bounds == 1
    if ndims(itp) == 1
        for i in eachindex(itp)
            @test itp[i,1] ≈ A[i]   # used in the AbstractArray display infrastructure
            @test_throws BoundsError itp[i,2]
            # if cb
            #     @test_throws BoundsError getindexib(itp, i, 2)
            #     @test_throws BoundsError callib(itp, i, 2)
            # else
            #     @test getindexib(itp, i, 2) ≈ A[i]
            #     @test callib(itp, i, 2) ≈ A[i]
            # end
        end
    end
    nothing
end

function check_oob(itp)
    widen(r) = first(r)-1:last(r)+1
    indsi = axes(itp)
    indsci = CartesianIndices(indsi)
    for i in CartesianIndices(widen.(indsi))
        i ∈ indsci && continue
        @test_throws BoundsError itp[i]
    end
    nothing
end

function can_eval_near_boundaries(itp::AbstractInterpolation{T,1}) where T
    l, u = bounds(itp, 1)
    @test isfinite(itp(l+0.1))
    @test isfinite(itp(u-0.1))
    @test_throws BoundsError itp(l-0.1)
    @test_throws BoundsError itp(u+0.1)
end

function can_eval_near_boundaries(itp::AbstractInterpolation)
    l, u = Float64.(lbounds(itp)), Float64.(ubounds(itp))
    for d = 1:ndims(itp)
        nearl = substitute(l, d, l[d]+0.1)
        # @show summary(itp) nearl
        @test isfinite(itp(nearl...))
        outl = substitute(l, d, l[d]-0.1)
        @test_throws BoundsError itp(outl...)
        nearu = substitute(u, d, u[d]-0.1)
        # @show nearu
        @test isfinite(itp(nearu...))
        outu = substitute(u, d, u[d]+0.1)
        @test_throws BoundsError itp(outu...)
    end
end

function substitute(default::NTuple{N,T}, d::Integer, val::T) where {T,N}
    ntuple(i->ifelse(i==d, val, default[i]), Val(N))
end


# Generate a grid of points [1.0, 1.3333, 1.6667, 2.0, 2.3333, ...] along each coordinate
thirds(axs) = Iterators.product(_thirds(axs...)...)

_thirds(a, axs...) =
    (sort(Float64[a; (first(a):last(a)-1) .+ 1/3; (first(a)+1:last(a)) .- 1/3]), _thirds(axs...)...)
_thirds() = ()

function check_gradient(itp::AbstractInterpolation, gtmp)
    val(x) = itp(Tuple(x)...)
    g!(gstore, x) = ForwardDiff.gradient!(gstore, val, x)
    gtmp2 = similar(gtmp)
    i = first(thirds(axes(itp)))
    @inferred(Interpolations.gradient(itp, i...))
    for i in thirds(axes(itp))
        @test Interpolations.gradient(itp, i...) ≈ g!(gtmp, SVector(i))
        @test Interpolations.gradient!(gtmp2, itp, i...) ≈ gtmp
    end
end

function check_hessian(itp::AbstractInterpolation, htmp)
    val(x) = itp(Tuple(x)...)
    h!(hstore, x) = ForwardDiff.hessian!(hstore, val, x)
    htmp2 = similar(htmp)
    i = first(thirds(axes(itp)))
    @inferred(Interpolations.hessian(itp, i...))
    for i in thirds(axes(itp))
        @test Interpolations.hessian(itp, i...) ≈ h!(htmp, SVector(i))
        @test Interpolations.hessian!(htmp2, itp, i...) ≈ htmp
    end
end

## A type used for multi-valued tests
import Base: +, -, *, /, ≈

struct MyPair{T}
    first::T
    second::T
end

# Here's the interface your type must define
(+)(p1::MyPair, p2::MyPair) = MyPair(p1.first+p2.first, p1.second+p2.second)
(-)(p1::MyPair, p2::MyPair) = MyPair(p1.first-p2.first, p1.second-p2.second)
(*)(n::Number, p::MyPair) = MyPair(n*p.first, n*p.second)
(*)(p::MyPair, n::Number) = n*p
(/)(p::MyPair, n::Number) = MyPair(p.first/n, p.second/n)
Base.zero(::Type{MyPair{T}}) where {T} = MyPair(zero(T),zero(T))
Base.promote_rule(::Type{MyPair{T1}}, ::Type{T2}) where {T1,T2<:Number} = MyPair{promote_type(T1,T2)}
≈(p1::MyPair, p2::MyPair) = (p1.first ≈ p2.first) & (p1.second ≈ p2.second)

end

# Indexing at a point
@inline function (itp::GriddedInterpolation{T,N})(x::Vararg{Number,N}) where {T,N}
    @boundscheck (checkbounds(Bool, itp, x...) || Base.throw_boundserror(itp, x))
    wis = weightedindexes((value_weights,), itpinfo(itp)..., x)
    InterpGetindex(itp)[wis...]
end
@propagate_inbounds function (itp::GriddedInterpolation{T,N})(x::Vararg{Number,M}) where {T,M,N}
    inds, trailing = split_trailing(itp, x)
    @boundscheck (check1(trailing) || Base.throw_boundserror(itp, x))
    @assert length(inds) == N
    itp(inds...)
end
@inline function (itp::GriddedInterpolation)(x::Vararg{UnexpandedIndexTypes})
    xis = to_indices(itp, x)
    xis == x && error("evaluation not supported for GriddedInterpolation at positions $x")
    itp(xis...)
end

@inline function gradient(itp::GriddedInterpolation{T,N}, x::Vararg{Number,N}) where {T,N}
    @boundscheck (checkbounds(Bool, itp, x...) || Base.throw_boundserror(itp, x))
    wis = weightedindexes((value_weights, gradient_weights), itpinfo(itp)..., x)
    SVector(map(inds->InterpGetindex(itp)[inds...], wis))
end

itpinfo(itp::GriddedInterpolation) = (tcollect(itpflag, itp), itp.knots)

roundbounds(x::Integer, knotvec::AbstractVector) = gridded_roundbounds(x, knotvec)
roundbounds(x::Number, knotvec::AbstractVector) = gridded_roundbounds(x, knotvec)
function gridded_roundbounds(x, knotvec::AbstractVector)
    i = find_knot_index(knotvec, x)
    iclamp = max(i, first(axes1(knotvec)))
    inext = min(iclamp+1, last(axes1(knotvec)))
    ifelse(i < iclamp, i+1, ifelse(x - knotvec[iclamp] < knotvec[inext] - x, i, inext))
end

floorbounds(x::Integer, knotvec::AbstractVector) = gridded_floorbounds(x, knotvec)
floorbounds(x, knotvec::AbstractVector) = gridded_floorbounds(x, knotvec)
function gridded_floorbounds(x, knotvec::AbstractVector)
    i = find_knot_index(knotvec, x)
    max(i, first(axes1(knotvec)))
end

ceilbounds(x::Integer, knotvec::AbstractVector) = gridded_ceilbounds(x, knotvec)
ceilbounds(x, knotvec::AbstractVector) = gridded_ceilbounds(x, knotvec)
function gridded_ceilbounds(x, knotvec::AbstractVector)
    i = find_knot_index(knotvec, x)
    iclamp = max(i, first(axes1(knotvec)))
    min(iclamp+1, last(axes1(knotvec)))
end

@inline find_knot_index(knotv, x) = searchsortedfirst(knotv, x, Base.Order.ForwardOrdering()) - 1
@inline find_knot_index(knotv, x::AbstractVector) = searchsortedfirst_vec(knotv, x) .- 1

@inline function weightedindex_parts(fs::F, mode::Gridded, knotvec::AbstractVector, x) where F
    i = find_knot_index(knotvec, x)
    weightedindex_parts2(fs, mode, knotvec, x, i)
end

@inline function weightedindex_parts2(fs::F, mode::Gridded, knotvec::AbstractVector, x, i) where F
    ax1 = axes1(knotvec)
    iclamp = clamp(i, first(ax1), last(ax1)-1)
    weightedindex(fs, degree(mode), knotvec, x, iclamp)
end

function weightedindex(fs::F, deg::Constant, knotvec, x, iclamp) where F
    pos, δx = positions(deg, knotvec,  x)
    (position=pos, coefs=fmap(fs, deg, δx))
end
function weightedindex(fs::F, deg::Degree, knotvec, x, iclamp) where F
    @inbounds l, u = knotvec[iclamp], knotvec[iclamp+1]
    δx = ratio(x - l, u - l)
    (position=iclamp, coefs=rescale_gridded(fs, fmap(fs, deg, δx), u-l))
end

rescale_gridded(fs::F, coefs, Δx) where F =
    (rescale_gridded(fs[1], coefs[1], Δx), rescale_gridded(Base.tail(fs), Base.tail(coefs), Δx)...)
rescale_gridded(::Tuple{}, ::Tuple{}, Δx) = ()
rescale_gridded(::typeof(value_weights), coefs, Δx) = coefs
rescale_gridded(::typeof(gradient_weights), coefs, Δx) = coefs./Δx
rescale_gridded(::typeof(hessian_weights), coefs, Δx) = coefs./Δx.^2

@inline function (itp::GriddedInterpolation{T,N})(x::Vararg{Union{Number,AbstractVector},N}) where {T,N}
    @boundscheck (checkbounds(Bool, itp, x...) || Base.throw_boundserror(itp, x))
    itps = tcollect(itpflag, itp)
    if x[1] isa AbstractVector
        wis = dimension_wis_vec(value_weights, itps, itp.knots, x)
    else
        wis = dimension_wis(value_weights, itps, itp.knots, x)
    end
    coefs = InterpGetindex(itp)
    ret = [coefs[i...] for i in Iterators.product(wis...)]
    reshape(ret, shape(wis...))
end

function dimension_wis(f::F, itps, knots, xs) where F
    itpflag, knotvec, x = itps[1], knots[1], xs[1]
    function makewi(y)
        pos, coefs = weightedindex_parts((f,), itpflag, knotvec, y)
        maybe_weightedindex(pos, coefs[1])
    end
    (makewi.(x), dimension_wis(f, Base.tail(itps), Base.tail(knots), Base.tail(xs))...)
end

function dimension_wis_vec(f::F, itps, knots, xs) where F
    itpflag, knotvec, x = itps[1], knots[1], xs[1]
    ivec = find_knot_index(knotvec, x)
    function makewi(y, i)
        pos, coefs = weightedindex_parts2((f,), itpflag, knotvec, y, i)
        maybe_weightedindex(pos, coefs[1])
    end
    (makewi.(x, ivec), dimension_wis(f, Base.tail(itps), Base.tail(knots), Base.tail(xs))...)
end

function dimension_wis(f::F, itps::Tuple{NoInterp,Vararg{Any}}, knots, xs) where F
    (Int.(xs[1]), dimension_wis(f, Base.tail(itps), Base.tail(knots), Base.tail(xs))...)
end
dimension_wis(f, ::Tuple{}, ::Tuple{}, ::Tuple{}) = ()


function getindex_return_type(::Type{GriddedInterpolation{T,N,TCoefs,IT,K}}, argtypes) where {T,N,TCoefs,IT<:DimSpec{Gridded},K}
    Tret = TCoefs
    for a in argtypes
        Tret = Base.promote_op(*, Tret, a)
    end
    Tret
end

Base.@propagate_inbounds function searchsortedfirst_exp_left(v, xx, lo, hi)
    for i in 0:4
        ind = lo + i
        ind > hi && return ind
        xx <= v[ind] && return ind
    end
    n = 3
    tn2 = 2^n
    tn2m1 = 2^(n-1)
    ind = lo + tn2
    while ind <= hi
        xx <= v[ind] && return searchsortedfirst(v, xx, lo + tn2 - tn2m1, ind, Base.Order.Forward)
        tn2 *= 2
        tn2m1 *= 2
        ind = lo + tn2
    end
    return searchsortedfirst(v, xx, lo + tn2 - tn2m1, hi, Base.Order.Forward)
end

function searchsortedfirst_vec(v::AbstractVector, x::AbstractVector)
    issorted(x) || return searchsortedfirst.(Ref(v), x)
    out = zeros(Int, length(x))
    lo = 1
    hi = length(v)
    @inbounds for i in 1:length(x)
        xx = x[i]
        y = searchsortedfirst_exp_left(v, xx, lo, hi)
        out[i] = y
        lo = min(y, hi)
    end
    return out
end

@inline sqr(x) = x*x
@inline cub(x) = x*x*x

ratio(num::Integer, denom::Integer) = SimpleRatio(promote(num, denom)...)
ratio(num, denom) = num/denom

modrange(x, r::AbstractUnitRange) = mod(x-first(r), length(r)) + first(r)
modrange(x, (l, u)::Tuple{Real,Real}) = mod(x-l, u-l+1) + l

fmap(fs, x...) = _fmap(x, fs...)
@inline _fmap(x, f, fs...) = (f(x...), _fmap(x, fs...)...)
@inline _fmap(x) = ()

split_flag(f::Flag) = f, f
split_flag(t::Tuple) = t[1], Base.tail(t)

getfirst(f::Flag) = f
getfirst(t::Tuple) = t[1]
getrest(f::Flag) = f
getrest(t::Tuple) = Base.tail(t)

tcollect(f, itp::AbstractInterpolation{T,N}) where {T,N} = _tcollect(ntuple(d->true, Val(N)), f(itp))
@inline _tcollect(ruler, prop) = (getfirst(prop), _tcollect(Base.tail(ruler), getrest(prop))...)
_tcollect(::Tuple{}, prop) = ()

split_trailing(::AbstractArray{T,N}, x) where {T,N} = Base.IteratorsMD.split(x, Val(N))
check1(args) = _check1(true, args...)
@inline _check1(tf, a, args...) = _check1(tf & (a == 1), args...)
_check1(tf) = tf

# These are not inferrable for mixed-type tuples, so when that's important use `getfirst`
# and `getrest` instead.
iextract(f::Flag, d) = f
iextract(t::Tuple, d) = t[d]

splitgrouped(prs::Tuple{Vararg{NTuple{2,Any}}}) = first.(prs), last.(prs)
splitgrouped(prs::Tuple{Vararg{NTuple{3,Any}}}) = first.(prs), middle.(prs), last.(prs)
middle(t::Tuple{Any,Any,Any}) = t[2]

fast_trunc(::Type{Int}, x) = unsafe_trunc(Int, x)
fast_trunc(::Type{Int}, x::Rational) = x.num ÷ x.den

# Slot-substitution guided by a `ruler` tuple. Substitution occurs when `default` has the same
# length as `ruler`.
@inline substitute_ruled(default, ruler, subst) = (default[1], substitute_ruled(Base.tail(default), ruler, Base.tail(subst))...)
@inline substitute_ruled(default::NTuple{N,Any}, ruler::NTuple{N,Any}, subst) where N =
    (subst[1], substitute_ruled(Base.tail(default), ruler, Base.tail(subst))...)
substitute_ruled(default::Tuple{}, ruler::NTuple{N,Any}, subst) where N = ()

@inline skip_nointerp(x, rest...) = (x, skip_nointerp(rest...)...)
@inline skip_nointerp(::NoInterp, rest...) = skip_nointerp(rest...)
skip_nointerp() = ()

skip_flagged_nointerp(itp::AbstractInterpolation, xs) = skip_flagged_nointerp(tcollect(itpflag, itp), xs)
skip_flagged_nointerp(itpflags::Tuple{NoInterp,Vararg{Any}}, xs) = skip_flagged_nointerp(Base.tail(itpflags), Base.tail(xs))
skip_flagged_nointerp(itpflags::Tuple, xs) = (xs[1], skip_flagged_nointerp(Base.tail(itpflags), Base.tail(xs))...)
skip_flagged_nointerp(::Tuple{}, ::Tuple{}) = ()

@inline sumvals(val, δval, args...) = sumvals(val+δval, args...)
@inline sumvals(val, ::Nothing, args...) = sumvals(val, args...)
sumvals(val) = val

@inline promote_typeof(a, b, args...) = _promote_typeof(promote_type(typeof(a), typeof(b)), args...)
@inline _promote_typeof(::Type{T}, a, args...) where T = _promote_typeof(promote_type(T, typeof(a)), args...)
_promote_typeof(::Type{T}) where T = T

## Vector indexing utilities
# Drop dimensions associated with "scalar" WeightedIndexes
shape(i::WeightedIndex, rest...)  = shape(rest...)
shape(i::Number, rest...)         = shape(rest...)
shape(v::AbstractVector, rest...) = (axes1(v), shape(rest...)...)
shape() = ()

@inline keepvectors(v::Vector{Int}, rest...) = (v, keepvectors(rest...)...)
@inline keepvectors(x, rest...) = keepvectors(rest...)
keepvectors() = ()

@inline lispyprod(p, v::AbstractVector{T}, rest...) where T = lispyprod(p*zero(T), rest...)
@inline lispyprod(p, x::Number, rest...) = lispyprod(p*x, rest...)
lispyprod(p) = p

const onevec = 1:1
const emptyvec = 1:0
@inline inbounds(itp::AbstractInterpolation, x...) = _inbounds.(bounds(itp), x)
_inbounds((l,u)::Tuple{Number,Number}, x::Number) = ifelse(l <= x <= u, onevec, emptyvec)
function _inbounds((l,u)::Tuple{Number,Number}, x::AbstractVector)
    ret = Int[]
    for i in eachindex(x)
        l <= x[i] <= u && push!(ret, i)
    end
    ret
end

function getindex!(dest, itp, xs::Vararg{AbstractArray,N}) where N
    for (i, x) in zip(eachindex(dest), Iterators.product(xs...))
        dest[i] = itp(x...)
    end
    return dest
end

function allbetween(l::Real, xs, u::Real)
    ret = true
    @inbounds for x in xs
        ret = ret & (l <= x) & (x <= u)
    end
    return ret
end
allbetween(l::Real, xs::AbstractRange, u::Real) = (l <= minimum(xs)) & (maximum(xs) <= u)

allisreal(x) = _allisreal(true, x...)
@inline _allisreal(ret, x1::Real, xs...) = _allisreal(ret, xs...)
@inline _allisreal(ret, x1, xs...) = _allisreal(false, xs...)
_allisreal(ret) = ret

# Similar to ExtrapDimSpec but for only a single dimension
const ExtrapSpec = Union{BoundaryCondition,Tuple{BoundaryCondition,BoundaryCondition}}

# Union over all BoundaryCondition that yield an infinite sequence of knots
# Note: Extrapolation must result in extrapolated knots, simply evaluating
# outside of the interpolation's bounds is not sufficient
const RepeatKnots = Union{Periodic,Reflect}

"""
    KnotIterator{T,ET}(k::AbstractArray{T}, bc::ET)

Defines an iterator over the knots in `k` based on the boundary conditions `bc`.

# Fields
- `knots::Vector{T}` The interpolated knots of the axis to iterate over
- `bc::ET` The Boundary Condition for the axis
- `nknots::Int` The number of interpolated knots (ie. `length(knots)`)

`ET` is `Union{BoundaryCondition,Tuple{BoundaryCondition,BoundaryCondition}}`

# Iterator Interface
The following methods defining Julia's iterator interface have been defined

`IteratorSize(::Type{KnotIterator})` -> Will return one of the following
- `Base.IsInfinite` if the iteration will produces an infinite sequence of knots
- `Base.HasLength` if iteration will produce a finite sequence of knots
- `Base.SizeUnknown` if we can't decided from only the type information

`length` and `size` -> Are defined if IteratorSize is HasLength, otherwise will
raise a MethodError.

`IteratorEltype` will always return `HasEltype`, as we always track the data
types of the knots

`eltype` will return the data type of the knots

`iterate` Defines iteration over the knots starting from the first one and
moving in the forward direction along the axis.

# Knots for Multi-dimensional Interpolants
Iteration over the knots of a multi-dimensional interpolant is done by wrapping
multiple KnotIterator within `Iterators.product`.

# Indexing
`KnotIterator` provides limited support for accessing knots via indexing
- `getindex` is provided for `KnotIterator` but does not support Multidimensional
  interpolations (As wrapped by `ProductIterator`) or non-Int indexes.
- A `BoundsError` will be raised if out of bounds and `checkbounds` has been
  implemented for `KnotIterator`

```jldoctest
julia> using Interpolations;

julia> etp = linear_interpolation([1.0, 1.2, 2.3, 3.0], rand(4); extrapolation_bc=Periodic());

julia> kiter = knots(etp);

julia> kiter[4]
3.0

julia> kiter[36]
24.3
```

"""
struct KnotIterator{T,ET <: ExtrapSpec}
    knots::Vector{T}
    bc::ET
    nknots::Int
    KnotIterator{T,ET}(k::AbstractArray{T}, bc::ET) where {T,ET} = new(k, bc, length(k))
end

# Dispatch on outputs of k = getknots and bc = etpflag to create one
# KnotIterator per interpolation axis
function KnotIterator(k::NTuple{N,AbstractArray}, bc::NTuple{N, ExtrapSpec}) where {N}
    # One ExtrapSpec per Axis
    map(KnotIterator, k, bc)
end
function KnotIterator(k::NTuple{N,AbstractArray}, bc::BoundaryCondition) where {N}
    # All Axes use the same BoundaryCondition
    map(x -> KnotIterator(x, bc), k)
end
function KnotIterator(k::AbstractArray{T}, bc::ET) where {T,ET <: ExtrapDimSpec}
    # Prior dispatches will end up here: Axis knots: k and boundary condition bc
    KnotIterator{T,ET}(k, bc)
end

IteratorSize(::Type{KnotIterator}) = SizeUnknown()
IteratorSize(::Type{KnotIterator{T}}) where {T} = SizeUnknown()

IteratorSize(::Type{KnotIterator{T,ET}}) where {T,ET} = _knot_iter_size(ET)
_knot_iter_size(::Type{<:BoundaryCondition}) = HasLength()
_knot_iter_size(::Type{<:RepeatKnots}) = IsInfinite()
_knot_iter_size(::Type{Tuple{RevBC, FwdBC}}) where {RevBC,FwdBC} = _knot_iter_size(FwdBC)

length(iter::KnotIterator) = _knot_length(iter, IteratorSize(iter))
_knot_length(iter::KnotIterator, ::HasLength) = iter.nknots
size(iter::KnotIterator) = (length(iter),)

IteratorEltype(::Type{KnotIterator}) = EltypeUnknown()
IteratorEltype(::Type{<:KnotIterator{T}}) where {T} = HasEltype()
eltype(::Type{<:KnotIterator{T}}) where {T} = T

"""
    knots(itp::AbstractInterpolation)
    knots(etp::AbstractExtrapolation)

Returns an iterator over knot locations for an AbstractInterpolation or
AbstractExtrapolation.

Iterator will yield scalar values for interpolations over a single dimension,
and tuples of coordinates for higher dimension interpolations. Iteration over
higher dimensions is taken as the product of knots along each dimension.

ie. Iterator.product(knots on first dim, knots on 2nd dim,...)

Extrapolations with Periodic or Reflect boundary conditions, will produce an
infinite sequence of knots.

# Example
```jldoctest
julia> using Interpolations;

julia> etp = linear_interpolation([1.0, 1.2, 2.3, 3.0], rand(4); extrapolation_bc=Periodic());

julia> Iterators.take(knots(etp), 5) |> collect
5-element $(Array{typeof(1.0),1}):
 1.0
 1.2
 2.3
 3.0
 3.2

```
"""
function knots(itp::AbstractInterpolation)
    # Construct separate KnotIterator for each dimension, and combine them using
    # Iterators.product
    k = getknots(itp)
    bc = Throw()
    iter = KnotIterator(k, bc)
    length(iter) == 1 ? iter[1] : Iterators.product(iter...)
end

function knots(etp::AbstractExtrapolation)
    # Construct separate KnotIterator for each dimension, and combine them using
    # Iterators.product
    k = getknots(etp)
    bc = etpflag(etp)
    iter = KnotIterator(k, bc)
    length(iter) == 1 ? iter[1] : Iterators.product(iter...)
end

# By default start iteration from the first knot, to start at a different index
# use knotsbetween
firstindex(::KnotIterator) = 1
iterate(iter::KnotIterator) = iterate(iter, firstindex(iter))

# Iterate over knots while checkbounds indicates the idx is still valid
function iterate(iter::KnotIterator{T,ET}, idx) where {T, ET}
    if checkbounds(Bool, iter, idx)
        iter[idx], idx+1
    else
        nothing
    end
end

# Split the ExtrapDimSpec into a tuple of left and right boundary conditions
splitExtrapDimSpec(::Type{ET}) where {ET <: BoundaryCondition} = (ET, ET)
splitExtrapDimSpec(::Type{<:Tuple{L,R}}) where {L,R} = (L,R)

# Checks if idx is a valid for the KnotIterator given it's boundary conditions
function checkbounds(::Type{Bool}, iter::KnotIterator{T,ET}, idx::Int) where {T,ET<:ExtrapDimSpec}
    # Get Left/Right Extrapolation Boundary Conditions for the KnotIterator
    left, right = splitExtrapDimSpec(ET)

    # Check Left/Right Boundary Limits -> If Left/Right is a repeating knot, the
    # checks is true as repeated knots generates an infinite sequence of knots
    leftcheck = left <: RepeatKnots ? true : 1 <= idx
    rightcheck = right <: RepeatKnots ? true : idx <= iter.nknots
    leftcheck && rightcheck
end

# Returns the knot given by idx, or raise a BoundsError
# Dispatches to getknotindex(ET, iter, idx) if idx is an extrapolated knot,
# where ET is the boundary conditions for the relevant side
function getindex(iter::KnotIterator{T, ET}, idx::Int) where {T, ET <: ExtrapDimSpec}
    # Get Left/Right Extrapolation Boundary Conditions for the KnotIterator
    left, right = splitExtrapDimSpec(ET)

    # Dispatch to getknotindex if idx is an extrapolated knot, otherwise pull
    # from iter.knots
    if idx < 1
        getknotindex(left, iter, idx)::T
    elseif idx <= iter.nknots
        iter.knots[idx]
    else
        getknotindex(right, iter, idx)::T
    end
end

# For Non-repeating Knots -> Raise BoundsError
function getknotindex(::Type{<:BoundaryCondition}, iter, idx)
    throw(BoundsError(iter, idx))
end

# Get Knots using a Periodic Boundary Condition
@inline function getknotindex(::Type{<:Periodic}, iter, idx)
    knotrange = iter.knots[end] - iter.knots[1]
    offset = knotrange * (cld(idx, iter.nknots-1)-1)
    iter.knots[periodic(idx, 1, iter.nknots)] + offset
end

# Get Knots using a Reflect Boundary Condition
@inline function getknotindex(::Type{<:Reflect}, iter, idx)
    # Get the current knot
    knotrange = iter.knots[end] - iter.knots[1]
    offset = 2*knotrange * (cld(idx, 2*iter.nknots-2)-1)
    cycleidx = mod(idx-1, 2*iter.nknots-2)+1

    if iter.nknots < cycleidx
        offset + 2*iter.knots[end] - iter.knots[2*iter.nknots-cycleidx]
    else
        iter.knots[cycleidx] + offset
    end
end

"""
    nextknotidx(iter::KnotIterator, x)

Returns the index of the first knot such that `x < k` or `nothing` if no such
knot exists.

New boundary conditions should define:

    nextknotidx(::Type{<:NewBoundaryCondition}, knots::Vector, x)

Where `knots` is `iter.knots` and `NewBoundaryCondition` is the new boundary
conditions. This method is expected to handle values of `x` that are both inbounds
or extrapolated.
"""
function nextknotidx(iter::KnotIterator{T,ET}, x) where {T, ET}
    left, right = splitExtrapDimSpec(ET)
    if x < iter.knots[end]
        # Next knot is inbounds or to the left
        nextknotidx(left, iter.knots, x)
    else
        # Next knot is to the right
        nextknotidx(right, iter.knots, x)
    end
end

"""
    priorknotidx(iter::KnotIterator, x)

Returns the index of the last knot such that `k < x` or `nothing` ig not such
knot exists.

New boundary conditions should define

    priorknotidx(::Type{<:NewBoundaryCondition}, knots::Vector, x)

Where knots is `iter.knots` and `NewBoundaryCondition` is the new boundary
condition. This method is expected to handle values of `x` that are both inbounds
or extrapolated.
"""
function priorknotidx(iter::KnotIterator{T,ET}, x) where {T, ET}
    left, right = splitExtrapDimSpec(ET)
    if x <= iter.knots[1]
        # Prior knot is to the left
        priorknotidx(left, iter.knots, x)
    else
        # prior knot is inbounds or to the right
        priorknotidx(right, iter.knots, x)
    end
end


# priorknotidx and nextknotidx for non-repeating knots
function nextknotidx(::Type{<:BoundaryCondition}, knots::Vector, x)
    knots[end] <= x ? nothing : findfirst(x .< knots)
end
function priorknotidx(::Type{<:BoundaryCondition}, knots::Vector, x)
    x <= knots[1] ? nothing : findlast(knots .< x)
end

# Starting iterator state for a periodic knots
function nextknotidx(::Type{<:Periodic}, knots::Vector, start)
    # Find starting offset
    knotrange = knots[end] - knots[1]
    cycle = floor(Int, (start-knots[1])/ knotrange)

    # Find starting index
    cyclepos = periodic(start, knots[1], knots[end])
    cycleidx = findfirst(cyclepos .< knots)::Int
    if cycleidx === length(knots)
        cycleidx = 1
        cycle += 1
    end

    idx = (length(knots)-1) * cycle + cycleidx

    return idx
end
function priorknotidx(::Type{<:Periodic}, knots::Vector, stop)
    # Find stopping offset
    knotrange = knots[end] - knots[1]
    cycle = floor(Int, (stop-knots[1])/ knotrange)

    # Find stopping index
    cyclepos = periodic(stop, knots[1], knots[end])
    if cyclepos == knots[1]
        cycleidx = length(knots) -1
        cycle -= 1
    else
        cycleidx = findlast(knots .< cyclepos)::Int
    end
    idx = (length(knots)-1) * cycle + cycleidx

    return idx
end

# Starting iterator state for a reflecting knots
function nextknotidx(::Type{<:Reflect}, knots::Vector, start)
    refknots = knots[end] .+ (cumsum∘reverse∘diff)(knots)
    knots = vcat(knots, refknots)
    nextknotidx(Periodic, knots, start)
end
function priorknotidx(::Type{<:Reflect}, knots::Vector, stop)
    refknots = knots[end] .+ (cumsum∘reverse∘diff)(knots)
    knots = vcat(knots, refknots)
    priorknotidx(Periodic, knots, stop)
end

"""
    KnotRange(iter::KnotIterator{T}, start, stop)

Defines an iterator over a range of knots such that `start < k < stop`.

# Fields
- `iter::KnotIterator{T}` Underlying `KnotIterator` providing the knots iterated
- `range::R` Iterator defining the range of knot indices iterated. Where
  `R <: Union{Iterators.Count, UnitRange}`

# Iterator Interface
The following methods defining the Julia's iterator interface have been defined

`Base.IteratorSize` -> Will return one of the following:
- `Base.HasLength` if `range` is of finite length
- `Base.IsInfinite` if `range` is of infinite length
- `Base.SizeUnknown` if the type of `range` is unspecified

`Base.IteratorEltype` -> Returns `Base.EltypeUnknown` if type parameter not
provided, otherwise `Base.HasEltype`

`length` and `size` -> Returns the number of knots to be iterated if
`IteratorSize !== IsInfinite`, otherwise will raise `MethodError`

# Multidimensional Interpolants
Iteration over the knots of a multi-dimensional interpolant is done by wrapping
multiple `KnotRange` iterators within `Iterators.product`.
"""
struct KnotRange{T, R <: Union{Iterators.Count, UnitRange}}
    iter::KnotIterator{T}
    range::R
    KnotRange(iter::KnotIterator{T}, range::R) where {T,R} = new{T,R}(iter, range)
end

function KnotRange(iter::KnotIterator, start, stop)
    # Get the index of the first knot larger than start or firstindex(iter) iff
    # start is missing
    sdx = start === nothing ? firstindex(iter) : nextknotidx(iter, start)

    # Generate knot index range from provided stop / start
    if sdx === nothing
        # Empty Iterator
        range = 1:0
    elseif stop === nothing
        if IteratorSize(iter) === IsInfinite()
            # Stop is missing and iter generates infinite knots
            range = Iterators.countfrom(sdx)
        else
            # Stop is missing and iter generates a finite number of knots
            range = sdx:iter.nknots
        end
    else
        # Stop is provided -> Iterate from start to stop
        edx = priorknotidx(iter, stop)
        range = edx === nothing ? (1:0) : sdx:edx
    end
    KnotRange(iter, range)
end

# Iterator Size is Unknown until we knot range's type
IteratorSize(::Type{KnotRange}) = SizeUnknown()
IteratorSize(::Type{KnotRange{T}}) where {T} = SizeUnknown()
IteratorSize(::Type{KnotRange{T,R}}) where {T, R <: UnitRange} = HasLength()
IteratorSize(::Type{KnotRange{T,R}}) where {T, R <: Iterators.Count} = IsInfinite()

# If type parameter is not provided -> Eltype is Unknown otherwise known
IteratorEltype(::Type{<:KnotRange}) = EltypeUnknown()
IteratorEltype(::Type{<:KnotRange{T}}) where {T} = HasEltype()
eltype(::Type{<:KnotRange{T}}) where {T} = T

# Dispatch length and size to range
length(iter::KnotRange) = length(iter.range)
size(iter::KnotRange) = size(iter.range)

"""
    knotsbetween(iter; start, stop)
    knotsbetween(iter, start, stop)

Iterate over all knots of `iter` such that `start < k < stop`.

`iter` can be an `AbstractInterpolation`, or the output of `knots`
(ie. a `KnotIterator` or `ProductIterator` wrapping `KnotIterator`)

If `start` is not provided, iteration will start from the first knot. An
`ArgumentError` will be raised if both `start` and `stop` are not provided.

If no such knots exists will return a KnotIterator with length 0

# Example
```jldoctest
julia> using Interpolations;

julia> etp = linear_interpolation([1.0, 1.2, 2.3, 3.0], rand(4); extrapolation_bc=Periodic());

julia> knotsbetween(etp; start=38, stop=42) |> collect
6-element $(Array{typeof(1.0),1}):
 38.3
 39.0
 39.2
 40.3
 41.0
 41.2

```
"""
knotsbetween(itp; start=nothing, stop=nothing) = knotsbetween(itp, start, stop)

# If AbstractInterpolation -> Get Knots -> Then Convert to Knot Range
knotsbetween(itp::AbstractInterpolation, start, stop) = knotsbetween(knots(itp), start, stop)

knotsbetween(::KnotIterator, ::Nothing, ::Nothing) =
    throw(ArgumentError("At least one of `start` or `stop` must be specified"))

knotsbetween(iter::KnotIterator, start, stop) = KnotRange(iter, start, stop)

# Expand Nothing on Start/Stop if tuples
function knotsbetween(iter::Iterators.ProductIterator, start::Union{Nothing, Tuple}, stop::Union{Nothing, Tuple})
    if start === stop === nothing
        throw(ArgumentError("At least one of `start` or `stop` must be specified"))
    else
        kiter = map_ranges(iter.iterators, start, stop)
        Iterators.product(kiter...)
    end
end

# Map iter, start and stop to N KnotRanges, handling start/stop being nothing
function map_ranges(iter, start::Tuple, ::Nothing)
    map((i, s) -> knotsbetween(i, s, nothing), iter, start)
end
function map_ranges(iter, ::Nothing, stop::Tuple)
    map((i, s) -> knotsbetween(i, nothing, s), iter, stop)
end
function map_ranges(iter, start::Tuple, stop::Tuple)
    map(knotsbetween, iter, start, stop)
end

iterate(iter::KnotRange) = iterate(iter, first(iter.range))

function iterate(iter::KnotRange{T,R}, state) where {T, R <: UnitRange}
    last(iter.range) < state && return nothing
    iter.iter[state], state+1
end

function iterate(iter::KnotRange{T,R}, state) where {T, R <: Iterators.Count}
    iter.iter[state], state+1
end

# Dispatch to KnotIterator for nextknotidx and priorknotidx
nextknotidx(iter::KnotRange, x) = nextknotidx(iter.iter, x)
priorknotidx(iter::KnotRange, x) = priorknotidx(iter.iter, x)

@testset "Periodic extrapolation" begin
    xmax = 7
    f(x) = sin((x-3)*2pi/xmax - 1)
    A = Float64[f(x) for x in 1:xmax] # Does not include the periodic image

    itp0 = interpolate(A, BSpline(Constant(Periodic())))
    itp1 = interpolate(A, BSpline(Linear(Periodic())))
    itp2 = interpolate(A, BSpline(Quadratic(Periodic(OnCell()))))
    itp3 = interpolate(A, BSpline(Cubic(Periodic(OnCell()))))

    etp0 = extrapolate(itp0, Periodic())
    etp1 = extrapolate(itp1, Periodic())
    etp2 = extrapolate(itp2, Periodic())
    etp3 = extrapolate(itp3, Periodic())

    for x in -xmax:.4:2*xmax
        @test etp0(x) ≈ f(x) atol=0.5
        @test etp1(x) ≈ f(x) atol=0.1
        @test etp2(x) ≈ f(x) atol=0.01
        @test etp3(x) ≈ f(x) atol=0.003
    end
end

@testset "Linear" begin
    xmax = 10
    g1(x) = sin((x-3)*2pi/(xmax-1)-1)
    f(x) = g1(x)
    A1 = Float64[f(x) for x in 1:xmax]
    fr(x) = (x^2) // 40 + 2

    ymax = 10
    g2(y) = cos(y/6)
    f(x,y) = g1(x)*g2(y)
    A2 = Float64[f(x,y) for x in 1:xmax, y in 1:ymax]

    for (constructor, copier) in ((interpolate, identity), (interpolate!, copy))
        isinplace = constructor == interpolate!
        itp1 = @inferred(constructor(copier(A1), BSpline(Linear())))
        itp2 = @inferred(constructor(copier(A2), BSpline(Linear())))

        @test parent(itp1) === itp1.coefs
        @test Interpolations.lbounds(itp1) == (1,)
        @test Interpolations.ubounds(itp1) == (xmax,)

        for (itp, A) in ((itp1, A1), (itp2, A2))
            check_axes(itp, A, isinplace)
            check_inbounds_values(itp, A)
            check_oob(itp)
            can_eval_near_boundaries(itp)
            I = first(eachindex(itp))
            @test itp(I) == itp(Tuple(I)...)
        end

        # Just interpolation
        for x in 1:.2:xmax
            @test f(x) ≈ itp1(x) atol=abs(0.1 * f(x))
        end

        # 2D
        for x in 2.1:.2:xmax-1, y in 1.9:.2:ymax-.9
            @test ≈(f(x,y),itp2(x,y),atol=abs(0.25 * f(x,y)))
        end

        # Rational element types
        A1R = Rational{Int}[fr(x) for x in 1:10]
        itp1r = @inferred(constructor(copier(A1R), BSpline(Linear())))
        @test @inferred(size(itp1r)) == size(A1R)
        @test itp1r(23 // 10) ≈ fr(23 // 10) atol=abs(0.1 * fr(23 // 10))
        @test typeof(itp1r(23//10)) == Rational{Int}
        @test eltype(itp1r) == Rational{Int}
    end

    # Issue #183
    x = rand(3,3,3)
    itp = interpolate(x, BSpline(Linear()))
    @test itp(1.5, CartesianIndex((2, 3))) === itp(1.5, 2, 3)
    @test itp(CartesianIndex((1, 2)), 1.5) === itp(1, 2, 1.5)

    # Issue #289
    for (x, it) in ((ones(1, 3), (NoInterp(), BSpline(Linear()))),
                    (ones(3, 1), (BSpline(Linear()), NoInterp())))
        @test_throws ArgumentError interpolate(x, BSpline(Linear()))
        itp = interpolate(x, it)
        etp = extrapolate(itp, Flat())
        @test sum(isnan.(etp)) == 0
    end

    @testset "Linear periodic" begin
        # Constructors
        @test Linear() === Linear(Throw(OnGrid())) === Linear{Throw{OnGrid}}()
        @test Linear() isa Linear{Throw{OnGrid}}
        @test Linear(Periodic()) === Linear(Periodic(OnCell())) == Linear{Periodic{OnCell}}()
        @test Linear(Periodic()) isa Linear{Periodic{OnCell}}

        xmax = 10
        f2(x) = sin((x-3)*2pi/xmax - 1) # Periodicity is xmax, not xmax-1
        A1 = Float64[f2(x) for x in 1:xmax]

        for (constructor, copier) in ((interpolate, identity), (interpolate!, copy))
            isinplace = constructor == interpolate!
            itp = @inferred(constructor(copier(A1), BSpline(Linear())))
            itp_periodic = @inferred(constructor(copier(A1), BSpline(Linear(Periodic()))))

            @test all(Interpolations.lbounds(itp_periodic) .≈ (0.5,))
            @test all(Interpolations.ubounds(itp_periodic) .≈ (10.5,))

            for x in 1:.2:xmax
                @test itp(x) ≈ itp_periodic(x)
            end

            # Interpolation range for periodic should be [0.5, xmax + 0.5]
            for x in 0.5:.1:0.9
                @test f2(x) ≈ itp_periodic(x) atol=abs(0.1 * f2(x))
                @test_throws BoundsError itp(x)
            end
            for x in xmax+0.1:.1:xmax+0.5
                @test f2(x) ≈ itp_periodic(x) atol=abs(0.1 * f2(x))
                @test_throws BoundsError itp(x)
            end
        end
    end
end

using Interpolations, Test, LinearAlgebra

@testset "Typing" begin
    nx = 10
    f(x) = convert(Float32, x^3/(nx-1))
    g(x) = convert(Float32, 3x^2/(nx-1))

    A = Float32[f(x) for x in 1:nx]

    itp = interpolate(A, BSpline(Quadratic(Flat(OnCell()))))

    # display(plot(
    #     layer(x=1:nx,y=[f(x) for x in 1:1//1:nx],Geom.point),
    #     layer(x=1:.1:nx,y=[itp[x] for x in 1:1//10:nx],Geom.path),
    # ))

    for x in 3.1:.2:4.3
        @test ≈(float(f(x)),float(itp(x)),atol=abs(0.1 * f(x)))
    end

    @test typeof(itp(3.5f0)) == Float32

    for x in 3.1:.2:4.3
        @test ≈([g(x)], Interpolations.gradient(itp,x),atol=abs(0.1 * g(x)))
    end

    @test typeof(Interpolations.gradient(itp, 3.5f0)[1]) == Float32

    # Rational element types
    R = Rational{Int}[x^2//10 for x in 1:10]
    itp = interpolate(R, BSpline(Quadratic(Free(OnCell()))))

    @test typeof(itp(11//10)) == Rational{Int}
    @test itp(11//10) == (11//10)^2//10
end

export Lanczos

abstract type AbstractLanczos <: InterpolationType end

"""
    Lanczos{N}(a=4)

Lanczos resampling via a kernel with scale parameter `a` and support over `N` neighbors.

This form of interpolation is merely the discrete convolution of the samples with a Lanczos kernel of size `a`. The size is directly related to how "far" the interpolation will reach for information, and has `O(N^2)` impact on runtime. An alternative implementation matching `lanczos4` from OpenCV is available as Lanczos4OpenCV.
"""
struct Lanczos{N} <: AbstractLanczos
    a::Int

    function Lanczos{N}(a) where N
        N < a && @warn "Using a smaller support than scale for Lanczos window. Proceed with caution."
        new{N}(a)
    end
end

Lanczos(a=4) = Lanczos{a}(a)

"""
    LanczosInterpolation
"""
struct LanczosInterpolation{T,N,IT <: DimSpec{AbstractLanczos},A <: AbstractArray{T,N},P <: Tuple{Vararg{AbstractArray,N}}} <: AbstractInterpolation{T,N,IT}
    coefs::A
    parentaxes::P
    it::IT
end

LanczosInterpolation{T,N}(coefs::AbstractArray{T,N}, parentaxes::NTuple{N,AbstractArray}, it::IT) where {T,N,IT} =
    LanczosInterpolation{T,N,IT,typeof(coefs),typeof(parentaxes)}(coefs, parentaxes, it)

@generated degree(::Lanczos{N}) where {N} = :($N)

getknots(itp::LanczosInterpolation) = axes(itp)
coefficients(itp::LanczosInterpolation) = itp.coefs
itpflag(itp::LanczosInterpolation) = itp.it

size(itp::LanczosInterpolation) = map(length, itp.parentaxes)
axes(itp::LanczosInterpolation) = itp.parentaxes
lbounds(itp::LanczosInterpolation) = map(first, itp.parentaxes)
ubounds(itp::LanczosInterpolation) = map(last, itp.parentaxes)

function interpolate(A::AbstractArray{T}, it::AbstractLanczos) where T
    Apad = copy_with_padding(float(T), A, it)
    return LanczosInterpolation(Apad, axes(A), it)
end

@inline function (itp::LanczosInterpolation{T,N})(x::Vararg{Number,N}) where {T,N}
    @boundscheck (checkbounds(Bool, itp, x...) || Base.throw_boundserror(itp, x))
    wis = weightedindexes((value_weights,), itpinfo(itp)..., x)
    InterpGetindex(itp)[wis...]
end

function weightedindex_parts(fs, it::AbstractLanczos, ax::AbstractUnitRange{<:Integer}, x)
    pos, δx = positions(it, ax, x)
    (position = pos, coefs = fmap(fs, it, δx))
end

function positions(it::AbstractLanczos, ax, x)
    xf = floorbounds(x, ax)
    δx = x - xf
    fast_trunc(Int, xf) - degree(it) + 1, δx
end

function value_weights(it::Lanczos, δx::S) where S
    N = degree(it)
    # short-circuit if integral
    isinteger(δx) && return ntuple(i->convert(float(S), i == N - δx), Val(2N))

    # LUTs
    #it.a === N === 4 && return _lanczos4(δx)

    cs = ntuple(i -> lanczos(N - i + δx, it.a, N), Val(2N))
    sum_cs = sum(cs)
    normed_cs = ntuple(i -> cs[i] / sum_cs, Val(length(cs)))
    return normed_cs
end

function padded_axis(ax::AbstractUnitRange, it::AbstractLanczos)
    N = degree(it)
    return first(ax) - N + 1:last(ax) + N
end

# precise implementations for fast evaluation of common kernels

"""
    lanczos(x, a, n=a)

Implementation of the [Lanczos kernel](https://en.wikipedia.org/wiki/Lanczos_resampling)
"""
lanczos(x::T, a::Integer, n=a) where {T} = abs(x) < n ? T(sinc(x) * sinc(x / a)) : zero(T)

# deprecate getindex for non-integer numeric indices
@deprecate getindex(itp::AbstractInterpolation{T,N}, i::Vararg{Number,N}) where {T,N} itp(i...)
@deprecate getindex(itp::AbstractInterpolation{T,N}, i::Vararg{ExpandedIndexTypes,N}) where {T,N} itp(i...)

for T in (:Throw, :Flat, :Line, :Free, :Periodic, :Reflect, :InPlace, :InPlaceQ)
    @eval begin
        # Support changing the gridtype for an instance
        (::$T)(gt::GridType) = $T(gt)
        $T{GT}() where GT<:GridType = $T(GT())
    end
end

@deprecate interpolate(A::AbstractArray, ::NoInterp, ::GridType) interpolate(A, NoInterp())
function interpolate(::Type{TWeights}, ::Type{TC}, A, it::IT, gt::GT) where {TWeights,TC,IT<:DimSpec{BSpline},GT<:DimSpec{GridType}}
    bcs = create_bcs(it, gt)
    Base.depwarn("interpolate($TWeights, $TC, A, $it, $gt) is deprecated, use interpolate($TWeights, $TC, A, $bcs)", :interpolate)
    interpolate(TWeights, TC, A, bcs)
end
function interpolate(A::AbstractArray, it::IT, gt::GT) where {IT<:DimSpec{BSpline},GT<:DimSpec{GridType}}
    bcs = create_bcs(it, gt)
    Base.depwarn("interpolate(A, $it, $gt) is deprecated, use interpolate(A, $bcs)", :interpolate)
    interpolate(A, bcs)
end

function interpolate!(::Type{TWeights}, A, it::IT, gt::GT) where {TWeights,IT<:DimSpec{BSpline},GT<:DimSpec{GridType}}
    bcs = create_bcs(it, gt)
    Base.depwarn("interpolate!($TWeights, A, $it, $gt) is deprecated, use interpolate!($TWeights, A, $bcs)", :interpolate)
    interpolate!(TWeights, A, bcs)
end
function interpolate!(A, it::IT, gt::GT) where {IT<:DimSpec{BSpline},GT<:DimSpec{GridType}}
    bcs = create_bcs(it, gt)
    Base.depwarn("interpolate!(A, $it, $gt) is deprecated, use interpolate!(A, $bcs)", :interpolate)
    interpolate!(A, bcs)
end

# extrapolate(A, Linear()) should probably have been extrapolate(A, Line())
# (Line<:BoundaryCondition but Linear<:Degree)
# @deprecate extrapolate(itp::AbstractInterpolation{T,N,IT}, ::Linear) where {T,N,IT} extrapolate(itp, Line())

const OldExtrapDimSpec = Union{Flag,Tuple{Vararg{Union{Flag,NTuple{2,Flag}}}}}
function extrapolate(itp::AbstractInterpolation{T,N,IT}, etpflag::OldExtrapDimSpec) where {T,N,IT}
    replacement = replace_linear_line(etpflag)
    io = IOBuffer()
    show(io, etpflag)
    etpstring = String(take!(io))
    show(io, replacement)
    repstring = String(take!(io))
    Base.depwarn("extrapolate(itp, $etpstring) is deprecated, use extrapolate(itp, $repstring) instead", :extrapolate)
    extrapolate(itp, replacement)
end

create_bcs(it::BSpline, gt::GridType) = BSpline(create_bcs(degree(it), gt))
create_bcs(it::NoInterp, gt::GridType) = it
create_bcs(it::Constant, gt::GridType) = it
create_bcs(it::Linear, gt::GridType) = it
create_bcs(it::Quadratic, gt::GridType) = it(gt)
create_bcs(it::Cubic, gt::GridType) = it(gt)
create_bcs(it::Tuple, gt::Tuple) = map((i,g)->i(g), it, gt)
create_bcs(it::Tuple, gt::GridType) = map(t->create_bcs(t, gt), it)
create_bcs(it::Flag, gt::Tuple) = map(t->it(t), gt)

replace_linear_line(::Linear) = Line()
replace_linear_line(bc::BoundaryCondition) = bc
replace_linear_line(etpflag::Tuple) = replace_linear_line.(etpflag)

# Old convenience constructors
@deprecate LinearInterpolation(args...; kwargs...) linear_interpolation(args...; kwargs...)
@deprecate ConstantInterpolation(args...; kwargs...) constant_interpolation(args...; kwargs...)
@deprecate CubicSplineInterpolation(args...; kwargs...) cubic_spline_interpolation(args...; kwargs...)

module InterpolationsUnitfulExt

if !isdefined(Base, :get_extension)
    import ..Unitful, ..Interpolations
else
    import Unitful, Interpolations
end

Interpolations.tweight(A::AbstractArray{T}) where T <: Unitful.Quantity = Interpolations.tweight(Unitful.ustrip(A))

end

import Base: getindex
import AxisAlgorithms: A_ldiv_B_md!, _A_ldiv_B_md!

### Tridiagonal inversion along a particular dimension, first offsetting the values by b

A_ldiv_B_md!(dest, ::Nothing, src, dim::Integer, ::Nothing) = dest

function A_ldiv_B_md!(dest, F, src, dim::Integer, b::AbstractVector)
    1 <= dim <= max(ndims(dest),ndims(src)) || throw(DimensionMismatch("The chosen dimension $dim is larger than $(ndims(src)) and $(ndims(dest))"))
    n = size(F, 1)
    n == size(src, dim) && n == size(dest, dim) || throw(DimensionMismatch("Sizes $n, $(size(src,dim)), and $(size(dest,dim)) do not match"))
    size(dest) == size(src) || throw(DimensionMismatch("Sizes $(size(dest)), $(size(src)) do not match"))
    check_matrix(F)
    length(b) == size(src,dim) || throw(DimensionMismatch("length(b) = $(length(b)), which does not match $(size(src,dim))"))
    R1 = CartesianIndices(size(dest)[1:dim-1])  # these are not type-stable, so let's use a function barrier
    R2 = CartesianIndices(size(dest)[dim+1:end])
    _A_ldiv_B_md!(dest, F, src, R1, R2, b)
end

# Filtering along the first dimension
function _A_ldiv_B_md!(dest, F::LU{T,<:Tridiagonal{T}}, src,  R1::CartesianIndices{0}, R2, b) where {T}
    n = size(F, 1)
    if n == 0
        return nothing
    end
    dl = F.factors.dl
    d  = F.factors.d
    du = F.factors.du
    dinv = 1 ./ d  # might not want to do this for small R2
    @inbounds for I2 in R2
        # Forward substitution
        dest[1, I2] = src[1, I2] + b[1]
        for i = 2:n  # Can't use @simd here
            dest[i, I2] = src[i, I2] + b[i] - dl[i-1]*dest[i-1, I2]
        end
        # Backward substitution
        dest[n, I2] *= dinv[n]
        for i = n-1:-1:1   # Can't use @simd here
            dest[i, I2] = (dest[i, I2] - du[i]*dest[i+1, I2])*dinv[i]
        end
    end
    nothing
end

# Filtering along any other dimension
function _A_ldiv_B_md!(dest, F::LU{T,<:Tridiagonal{T}}, src, R1, R2, b) where T
    n = size(F, 1)
    dl = F.factors.dl
    d  = F.factors.d
    du = F.factors.du
    dinv = 1 ./ d  # might not want to do this for small R1 and R2
    # Forward substitution
    @inbounds for I2 in R2
        @simd for I1 in R1
            dest[I1, 1, I2] = src[I1, 1, I2] + b[1]
        end
        for i = 2:n
            @simd for I1 in R1
                dest[I1, i, I2] = src[I1, i, I2] + b[i] - dl[i-1]*dest[I1, i-1, I2]
            end
        end
        # Backward substitution
        @simd for I1 in R1
            dest[I1, n, I2] *= dinv[n]
        end
        for i = n-1:-1:1
            @simd for I1 in R1
                dest[I1, i, I2] = (dest[I1, i, I2] - du[i]*dest[I1, i+1, I2])*dinv[i]
            end
        end
    end
    dest
end

### Woodbury solver with offset

function _A_ldiv_B_md!(dest, W::Woodbury, src,  R1, R2, b)
    _A_ldiv_B_md!(dest, W.A, src, R1, R2, b)
    tmp1 = AxisAlgorithms._A_mul_B_md(W.V, dest, R1, R2)
    tmp2 = AxisAlgorithms._A_mul_B_md(W.Cp, tmp1, R1, R2)
    tmp3 = AxisAlgorithms._A_mul_B_md(W.U, tmp2, R1, R2)
    # TODO?: would be nice to fuse the next two steps
    AxisAlgorithms._A_ldiv_B_md!(tmp3, W.A, tmp3, R1, R2)
    AxisAlgorithms.sub!(dest, tmp3)
end

function check_matrix(F::LU{T,<:Tridiagonal{T}}) where T
    for i = 1:size(F,1)
        F.ipiv[i] == i || error("For efficiency, pivoting is not supported")
    end
    du2 = F.factors.du2
    for i = 1:length(du2)
        du2[i] == 0 || error("For efficiency, du2 must be all zeros")
    end
end

check_matrix(F::Woodbury) = check_matrix(F.A)

check_matrix(M) = error("unsupported matrix type $(typeof(M))")

## Convenience notation

For constant, linear, and cubic spline interpolations, `constant_interpolation`, `linear_interpolation`, and `cubic_spline_interpolation`
can be used to create interpolating and extrapolating objects handily.

### Motivating Example
By using the convenience constructor one can simplify expressions. For example, the creation of an interpolation object
```julia
extrap_full = extrapolate(scale(interpolate(A, BSpline(Linear())), xs), Line())
```
can be written as the more readable
```julia
extrap = linear_interpolation(xs, A, extrapolation_bc = Line())
```
 by using the convenience constructor.

 ### Usage

```julia
f(x) = log(x)
xs = 1:0.2:5
A = [f(x) for x in xs]

# linear interpolation
interp_linear = linear_interpolation(xs, A)
interp_linear(3) # exactly log(3)
interp_linear(3.1) # approximately log(3.1)

# cubic spline interpolation
interp_cubic = cubic_spline_interpolation(xs, A)
interp_cubic(3) # exactly log(3)
interp_cubic(3.1) # approximately log(3.1)
```
which support multidimensional data as well:
```julia
f(x,y) = log(x+y)
xs = 1:0.2:5
ys = 2:0.1:5
A = [f(x,y) for x in xs, y in ys]

# linear interpolation
interp_linear = linear_interpolation((xs, ys), A)
interp_linear(3, 2) # exactly log(3 + 2)
interp_linear(3.1, 2.1) # approximately log(3.1 + 2.1)

# cubic spline interpolation
interp_cubic = cubic_spline_interpolation((xs, ys), A)
interp_cubic(3, 2) # exactly log(3 + 2)
interp_cubic(3.1, 2.1) # approximately log(3.1 + 2.1)
```
For extrapolation, i.e., when interpolation objects are evaluated in coordinates outside the range provided in constructors, the default option for a boundary condition is `Throw` so that they will return an error.
Interested users can specify boundary conditions by providing an extra parameter for `extrapolation_bc`:
```julia
f(x) = log(x)
xs = 1:0.2:5
A = [f(x) for x in xs]

# extrapolation with linear boundary conditions
extrap = linear_interpolation(xs, A, extrapolation_bc = Line())

@test extrap(1 - 0.2) # ≈ f(1) - (f(1.2) - f(1))
@test extrap(5 + 0.2) # ≈ f(5) + (f(5) - f(4.8))
```
You can also use a "fill" value, which gets returned whenever you ask for out-of-range values:

```julia
extrap = linear_interpolation(xs, A, extrapolation_bc = NaN)
@test isnan(extrap(5.2))
```

Irregular grids are supported as well; note that presently only `constant_interpolation` and `linear_interpolation` supports irregular grids.
```julia
xs = [x^2 for x = 1:0.2:5]
A = [f(x) for x in xs]

# linear interpolation
interp_linear = linear_interpolation(xs, A)
interp_linear(1) # exactly log(1)
interp_linear(1.05) # approximately log(1.05)
```

### Example with Plots.jl

An interpolated object is also easily capable of being plotted with [Plots.jl](https://github.com/JuliaPlots/Plots.jl). A simple example is as follows:

```julia
using Interpolations, Plots

# Lower and higher bound of interval
a = 1.0
b = 10.0
# Interval definition
x = a:1.0:b
# This can be any sort of array data, as long as
# length(x) == length(y)
y = @. cos(x^2 / 9.0) # Function application by broadcasting
# Interpolations
itp_linear = linear_interpolation(x, y)
itp_cubic = cubic_spline_interpolation(x, y)
# Interpolation functions
f_linear(x) = itp_linear(x)
f_cubic(x) = itp_cubic(x)
# Plots
width, height = 1500, 800 # not strictly necessary
x_new = a:0.1:b # smoother interval, necessary for cubic spline

scatter(x, y, markersize=10,label="Data points")
plot!(f_linear, x_new, w=3,label="Linear interpolation")
plot!(f_cubic, x_new, linestyle=:dash, w=3, label="Cubic Spline interpolation")
plot!(size = (width, height))
plot!(legend = :bottomleft)
```

And the generated plot is:
![interpolation plot example](assets/plotsjl_interpolation_example.png)

## Control of interpolation algorithm

### BSplines

The interpolation type is described in terms of *degree* and, if necessary, *boundary conditions*. There are currently four degrees available: `Constant`, `Linear`, `Quadratic`,  and `Cubic` corresponding to B-splines of degree 0, 1, 2, and 3 respectively.

B-splines of quadratic or higher degree require solving an equation system to obtain the interpolation coefficients, and for that you must specify a *boundary condition* that is applied to close the system. The following boundary conditions are implemented: `Flat`, `Line` (alternatively, `Natural`), `Free`, `Periodic` and `Reflect`; their mathematical implications are described in detail in their docstrings.
When specifying these boundary conditions you also have to specify whether they apply at the edge grid point (`OnGrid()`)
or beyond the edge point halfway to the next (fictitious) grid point (`OnCell()`).

Some examples:
```julia
# Nearest-neighbor interpolation
itp = interpolate(a, BSpline(Constant()))
v = itp(5.4)   # returns a[5]

# Previous-neighbor interpolation
itp = interpolate(a, BSpline(Constant(Previous)))
v = itp(1.8)   # returns a[1]

# Next-neighbor interpolation
itp = interpolate(a, BSpline(Constant(Next)))
v = itp(5.4)   # returns a[6]

# (Multi)linear interpolation
itp = interpolate(A, BSpline(Linear()))
v = itp(3.2, 4.1)  # returns 0.9*(0.8*A[3,4]+0.2*A[4,4]) + 0.1*(0.8*A[3,5]+0.2*A[4,5])

# Quadratic interpolation with reflecting boundary conditions
# Quadratic is the lowest order that has continuous gradient
itp = interpolate(A, BSpline(Quadratic(Reflect(OnCell()))))

# Linear interpolation in the first dimension, and no interpolation (just lookup) in the second
itp = interpolate(A, (BSpline(Linear()), NoInterp()))
v = itp(3.65, 5)  # returns  0.35*A[3,5] + 0.65*A[4,5]
```
There are more options available, for example:
```julia
# In-place interpolation
itp = interpolate!(A, BSpline(Quadratic(InPlace(OnCell()))))
```
which destroys the input `A` but also does not need to allocate as much memory.

### Scaled BSplines

BSplines assume your data is uniformly spaced on the grid `1:N`, or its multidimensional equivalent. If you have data of the form `[f(x) for x in A]`, you need to tell Interpolations about the grid `A`. If `A` is not uniformly spaced, you must use gridded interpolation described below. However, if `A` is a collection of ranges or linspaces, you can use scaled BSplines. This is more efficient because the gridded algorithm does not exploit the uniform spacing. Scaled BSplines can also be used with any spline degree available for BSplines, while gridded interpolation does not currently support quadratic or cubic splines.

Some examples,
```julia
A_x = 1.:2.:40.
A = [log(x) for x in A_x]
itp = interpolate(A, BSpline(Cubic(Line(OnGrid()))))
sitp = scale(itp, A_x)
sitp(3.) # exactly log(3.)
sitp(3.5) # approximately log(3.5)
```

For multidimensional uniformly spaced grids
```julia
A_x1 = 1:.1:10
A_x2 = 1:.5:20
f(x1, x2) = log(x1+x2)
A = [f(x1,x2) for x1 in A_x1, x2 in A_x2]
itp = interpolate(A, BSpline(Cubic(Line(OnGrid()))))
sitp = scale(itp, A_x1, A_x2)
sitp(5., 10.) # exactly log(5 + 10)
sitp(5.6, 7.1) # approximately log(5.6 + 7.1)
```
### Gridded interpolation

These use a very similar syntax to BSplines, with the major exception
being that one does not get to choose the grid representation (they
are all `OnGrid`). As such one must specify a set of coordinate arrays
defining the nodes of the array.

In 1D
```julia
A = rand(20)
A_x = 1.0:2.0:40.0
nodes = (A_x,)
itp = interpolate(nodes, A, Gridded(Linear()))
itp(2.0)
```

The spacing between adjacent samples need not be constant; indeed, if they
are constant, you'll get better performance with `scaled`.

The general syntax is
```julia
itp = interpolate(nodes, A, options...)
```
where `nodes = (xnodes, ynodes, ...)` specifies the positions along
each axis at which the array `A` is sampled for arbitrary ("rectangular") samplings.

For example:
```julia
A = rand(8,20)
nodes = ([x^2 for x = 1:8], [0.2y for y = 1:20])
itp = interpolate(nodes, A, Gridded(Linear()))
itp(4,1.2)  # approximately A[2,6]
```
One may also mix modes, by specifying a mode vector in the form of an explicit tuple:
```julia
itp = interpolate(nodes, A, (Gridded(Linear()),Gridded(Constant())))
```

Presently there are only three modes for gridded:
```julia
Gridded(Linear())
```
whereby a linear interpolation is applied between nodes,
```julia
Gridded(Constant())
```
whereby nearest neighbor interpolation is used on the applied axis,
```julia
NoInterp()
```
whereby the coordinate of the selected input vector MUST be located on a grid point. Requests for off grid
coordinates results in the throwing of an error.

For [`Constant`](@ref) there are additional parameters. Use `Constant{Previous}()` in order to perform a previous
neighbor interpolation. Use `Constant{Next}()` for a next neighbor interpolation.
Note that rounding can be an issue, see [#473](https://github.com/JuliaMath/Interpolations.jl/issues/473).

`missing` data will naturally propagate through the interpolation,
where some values will become missing. To avoid that, one can
filter out the missing data points and use a gridded interpolation.
For example:
```julia
x = 1:6
A = [i == 3 ? missing : i for i in x]
xf = [xi for (xi,a) in zip(x, A) if !ismissing(a)]
Af = [a for a in A if !ismissing(a)]
itp = interpolate((xf, ), Af, Gridded(Linear()))
```

In-place gridded interpolation is also possible:
```julia
x = 1:4
y = view(rand(4), :)
itp = interpolate!((x,), y, Gridded(Linear()))
y .= 0
@show itp(2.5) # 0
```

## Parametric splines

Given a set a knots with coordinates `x(t)` and `y(t)`, a parametric spline `S(t) = (x(t),y(t))` parametrized by `t in [0,1]` can be constructed with the following code adapted from a [post](http://julia-programming-language.2336112.n4.nabble.com/Parametric-splines-td37794.html#a37818) by Tomas Lycken:

```julia
using Interpolations

t = 0:.1:1
x = sin.(2π*t)
y = cos.(2π*t)
A = hcat(x,y)

itp = Interpolations.scale(interpolate(A, (BSpline(Cubic(Natural(OnGrid()))), NoInterp())), t, 1:2)

tfine = 0:.01:1
xs, ys = [itp(t,1) for t in tfine], [itp(t,2) for t in tfine]
```

We can then plot the spline with:

```julia
using Plots

scatter(x, y, label="knots")
plot!(xs, ys, label="spline")
```
![parametric spline](assets/parametric_spline.png)

## Monotonic interpolation

When you have some one-dimensional data that is monotonic, many standard interpolation methods may give an interpolating function that it is not monotonic. Monotonic interpolation ensures that the interpolating function is also monotonic.

Here is an example of making a cumulative distribution function for some data:

```julia
percentile_values = [0.0, 0.01, 0.1, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0, 10.0, 20.0, 30.0, 40.0, 50.0, 60.0, 70.0, 80.0, 90.0, 91.0, 92.0, 93.0, 94.0, 95.0, 96.0, 97.0, 98.0, 99.0, 99.9, 99.99, 100.0];

y = sort(randn(length(percentile_values))); # some random data

itp_cdf = extrapolate(interpolate(y, percentile_values, SteffenMonotonicInterpolation()), Flat());

t = -3.0:0.01:3.0 # just a range for calculating values of the interpolating function

interpolated_cdf = map(itp_cdf, t) # interpolating the CDF
```

There are a few different monotonic interpolation algorithms. Some guarantee that for non-monotonic data the interpolating function does not exceed the range of values between two successive points while other do not (this is called overshooting in the list below).

* [`LinearMonotonicInterpolation`](@ref) -- simple linear interpolation. Does not overshoot.
* [`FiniteDifferenceMonotonicInterpolation`](@ref) -- it may overshoot.
* [`CardinalMonotonicInterpolation`](@ref) -- it may overshoot.
* [`FritschCarlsonMonotonicInterpolation`](@ref) -- it may overshoot.
* [`FritschButlandMonotonicInterpolation`](@ref) -- it does not overshoot.
* [`SteffenMonotonicInterpolation`](@ref) -- it does not overshoot.

You can read about monotonic interpolation in the following sources:

* Fritsch & Carlson (1980), "Monotone Piecewise Cubic Interpolation", doi:10.1137/0717021.
* Fritsch & Butland (1984), "A Method for Constructing Local Monotone Piecewise Cubic Interpolants", doi:10.1137/0905021.
* Steffen (1990), "A Simple Method for Monotonic Interpolation in One Dimension", [URL](http://adsabs.harvard.edu/abs/1990A%26A...239..443S)

# Extrapolation behavior

## 1. Simple extrapolation

Extrapolation in `Interpolations.jl` takes several forms. The simplest, is when the extrapolation behavior can be described with the following pseudo-code:

    if (the coordinate is outside the domain) then
        do something that is
            * well defined without looking at the data set
            * decides the outcome (error/return value) of the indexing operation
    end

    proceed to inbounds interpolation

An example of this interpolation behavior is `ExtrapError`, which simply throws a bounds error if the coordinate is outside the domain. `Interpolations.jl` could support, for example, the following variants:

* `ExtrapError`: Throws a `BoundsError`, just like `Grid.jl`
* `ExtrapNaN`: Returns `convert(T, NaN)`, where `T` is `eltype(data)`
* `ExtrapNull`: Returns a value-less `Nullabel{T}`

## 2. Index transformation extrapolation

The next form is index transformation, which can be described as

    if (the coordinate is outside the domain) then
        calculate an index that is inside the domain, which gives
        the extrapolated value
    end

    proceed to inbounds interpolation (using the transformed index)

An example here is `ExtrapPeriodic`, which transforms the coordinate index to one which is inside the domain by means of modulo calculations. Another example is `ExtrapConstant`, which clamps out-of-bounds coordinates to their nearest inbounds data point.

For some of these, extra care needs to be taken in higher dimensions, when deciding what happens in the "outside corners":

              |               |     what happens here?
              |               |
    ----------+---------------+--------
              |               |
              |   the domain  |
              |               |
    ----------+---------------+--------
              |               |
              |               |    ...and here? 

## Public API
```@meta
DocTestSetup= quote
using Interpolations
end
```

```@autodocs
Modules = [Interpolations]
Private = false
Order = [:function, :type]
```

## Internal API
```@autodocs
Modules = [Interpolations]
Public = false
Order = [:function, :type]
```

# Developer documentation

Conceptually, `Interpolations.jl` supports two operations: construction and usage of interpolants.

## Interpolant construction

Construction creates the interpolant object. In some situations this is relatively trivial:
for example, when using only `NoInterp`, `Constant`, or `Linear` interpolation schemes,
construction essentially corresponds to recording the array of values and the "settings" (the interpolation scheme) specified at the time of
construction. This case is simple because interpolated values may be efficiently computed directly from the on-grid values supplied at construction time: ``(1-\Delta x) a_i  + \Delta x a_{i+1}`` reconstructs ``a_i`` when ``\Delta x = 0``.

For `Quadratic` and higher orders, efficient computation requires that the array of values be *prefiltered*.
This essentially corresponds to "inverting" the computation that will be performed during interpolation, so as to approximately reconstruct the original values at on-grid points. Generally speaking this corresponds to solving a nearly-tridiagonal system of equations, inverting an underlying interpolation
scheme such as ``p(\Delta x) \tilde a_{i-1} + q(\Delta x) \tilde a_i + p(1-\Delta x) \tilde a_{i+1}`` for some functions ``p`` and ``q`` (see [`Quadratic`](@ref) for further details).
Here ``\tilde a`` is the pre-filtered version of `a`, designed so that
substituting ``\Delta x = 0`` (for which one may *not* get 0 and 1 for the ``p`` and ``q`` calls, respectively) approximately recapitulates ``a_i``.

The exact system of equations to be solved depends on the interpolation order and boundary conditions.
Boundary conditions often introduce deviations from perfect tridiagonality; these "extras" are handled efficiently by the `WoodburyMatrices` package.
These computations are implemented independently along each axis using the `AxisAlgorithms` package.

In the `doc` directory there are some old files that give some of the mathematical details.
A useful reference is:

Thévenaz, Philippe, Thierry Blu, and Michael Unser. "Interpolation revisited." IEEE Transactions on Medical Imaging 19.7 (2000): 739-758.

!!! note
    As an application of these concepts, note that supporting quadratic or cubic interpolation for `Gridded` would
    only require that someone implement prefiltering schemes for non-uniform grids;
    it's just a question of working out a little bit of math.

## Interpolant usage

Usage occurs when evaluating `itp(x, y...)`, or `Interpolations.gradient(itp, x, y...)`, etc.
Usage itself involves two sub-steps: computation of the *weights* and then performing the *interpolation*.

### Weight computation

Weights depend on the interpolation scheme and the location `x, y...` but *not* the coefficients of the array we are interpolating.
Consequently there are many circumstances where one might want to reuse previously-computed weights, and `Interpolations.jl` has been carefully designed
with that kind of reuse in mind.

The key concept here is the [`Interpolations.WeightedIndex`](@ref), and there is
no point repeating its detailed docstring here.
It suffices to add that `WeightedIndex` is actually an abstract type, with two
concrete subtypes:

- `WeightedAdjIndex` is for indexes that will address *adjacent* points of the coefficient array (ones where the index increments by 1 along the corresponding dimension). These are used when prefiltering produces padding that can be used even at the edges, or for schemes like `Linear` interpolation which require no padding.
- `WeightedArbIndex` stores both the weight and index associated with each accessed grid point, and can therefore encode grid access patterns. These are used in specific circumstances--a prime example being periodic boundary conditions--where the coefficients array may be accessed at something other than adjacent locations.

`WeightedIndex` computation reflects the interpolation scheme (e.g., `Linear` or `Quadratic`) and also whether one is computing values, `gradient`s, or `hessian`s. The handling of derivatives will be described further below.

### Interpolation

General `AbstractArray`s may be indexed with `WeightedIndex` indices,
and the result produces the interpolated value. In other words, the end result
is just `itp.coefs[wis...]`, where `wis` is a tuple of `WeightedIndex` indices.
To make sure this overloading is effective, we wrap the `coefs` with `InterpGetindex`，
i.e. `InterpGetindex(itp.coefs)[wis...]`

Derivatives along a particular axis can be computed just by substituting a component of `wis` for one that has been designed to compute derivatives rather than values.

As a demonstration, let's see how the following computation occurs:

```jldoctest derivs; setup = :(using Interpolations)
julia> A = reshape(1:27, 3, 3, 3)
3×3×3 reshape(::UnitRange{Int64}, 3, 3, 3) with eltype Int64:
[:, :, 1] =
 1  4  7
 2  5  8
 3  6  9

[:, :, 2] =
 10  13  16
 11  14  17
 12  15  18

[:, :, 3] =
 19  22  25
 20  23  26
 21  24  27

julia> itp = interpolate(A, BSpline(Linear()));

julia> x = (1.2, 1.4, 1.7)
(1.2, 1.4, 1.7)

julia> itp(x...)
8.7
```

!!! note
    By using the debugging facilities of an IDE like Juno or VSCode,
    or using Debugger.jl from the REPL, you can easily step in to
    the call above and follow along with the description below.

Aside from details such as bounds-checking, the key call is to [`Interpolations.weightedindexes`](@ref):

```jldoctest derivs
julia> wis = Interpolations.weightedindexes((Interpolations.value_weights,), Interpolations.itpinfo(itp)..., x)
(Interpolations.WeightedAdjIndex{2, Float64}(1, (0.8, 0.19999999999999996)), Interpolations.WeightedAdjIndex{2, Float64}(1, (0.6000000000000001, 0.3999999999999999)), Interpolations.WeightedAdjIndex{2, Float64}(1, (0.30000000000000004, 0.7)))

julia> wis[1]
Interpolations.WeightedAdjIndex{2, Float64}(1, (0.8, 0.19999999999999996))

julia> wis[2]
Interpolations.WeightedAdjIndex{2, Float64}(1, (0.6000000000000001, 0.3999999999999999))

julia> wis[3]
Interpolations.WeightedAdjIndex{2, Float64}(1, (0.30000000000000004, 0.7))

julia> Interpolations.InterpGetindex(A)[wis...]
8.7
```

You can see that each of `wis` corresponds to a specific position: 1.2, 1.4, and 1.7 respectively. We can index `A` at `wis`, and it returns the value of `itp(x...)`, which here is just

      0.8 * A[1, wis[2], wis[3]] + 0.2 * A[2, wis[2], wis[3]]
    = 0.6 * (0.8 * A[1, 1, wis[3]] + 0.2 * A[2, 1, wis[3]]) +
      0.4 * (0.8 * A[1, 2, wis[3]] + 0.2 * A[2, 2, wis[3]])
    = 0.3 * (0.6 * (0.8 * A[1, 1, 1] + 0.2 * A[2, 1, 1]) +
             0.4 * (0.8 * A[1, 2, 1] + 0.2 * A[2, 2, 1])  ) +
      0.7 * (0.6 * (0.8 * A[1, 1, 2] + 0.2 * A[2, 1, 2]) +
             0.4 * (0.8 * A[1, 2, 2] + 0.2 * A[2, 2, 2])  )

This computed the value of `itp` at `x...` because we called `weightedindexes` with just a single function, [`Interpolations.value_weights`](@ref) (meaning, "the weights needed to compute the value").

!!! note
    Remember that prefiltering is not used for `Linear` interpolation.
    In a case where prefiltering is used, we would substitute `InterpGetindex(itp.coefs)[wis...]` for `InterpGetindex(A)[wis...]` above.

To compute derivatives, we *also* pass additional functions like [`Interpolations.gradient_weights`](@ref):

```
julia> wis = Interpolations.weightedindexes((Interpolations.value_weights, Interpolations.gradient_weights), Interpolations.itpinfo(itp)..., x)
((Interpolations.WeightedAdjIndex{2,Float64}(1, (-1.0, 1.0)), Interpolations.WeightedAdjIndex{2,Float64}(1, (0.6000000000000001, 0.3999999999999999)), Interpolations.WeightedAdjIndex{2,Float64}(1, (0.30000000000000004, 0.7))), (Interpolations.WeightedAdjIndex{2,Float64}(1, (0.8, 0.19999999999999996)), Interpolations.WeightedAdjIndex{2,Float64}(1, (-1.0, 1.0)), Interpolations.WeightedAdjIndex{2,Float64}(1, (0.30000000000000004, 0.7))), (Interpolations.WeightedAdjIndex{2,Float64}(1, (0.8, 0.19999999999999996)), Interpolations.WeightedAdjIndex{2,Float64}(1, (0.6000000000000001, 0.3999999999999999)), Interpolations.WeightedAdjIndex{2,Float64}(1, (-1.0, 1.0))))

julia> wis[1]
(Interpolations.WeightedAdjIndex{2,Float64}(1, (-1.0, 1.0)), Interpolations.WeightedAdjIndex{2,Float64}(1, (0.6000000000000001, 0.3999999999999999)), Interpolations.WeightedAdjIndex{2,Float64}(1, (0.30000000000000004, 0.7)))

julia> wis[2]
(Interpolations.WeightedAdjIndex{2,Float64}(1, (0.8, 0.19999999999999996)), Interpolations.WeightedAdjIndex{2,Float64}(1, (-1.0, 1.0)), Interpolations.WeightedAdjIndex{2,Float64}(1, (0.30000000000000004, 0.7)))

julia> wis[3]
(Interpolations.WeightedAdjIndex{2,Float64}(1, (0.8, 0.19999999999999996)), Interpolations.WeightedAdjIndex{2,Float64}(1, (0.6000000000000001, 0.3999999999999999)), Interpolations.WeightedAdjIndex{2,Float64}(1, (-1.0, 1.0)))

julia> Interpolations.InterpGetindex(A)[wis[1]...]
1.0

julia> Interpolations.InterpGetindex(A)[wis[2]...]
3.000000000000001

julia> Interpolations.InterpGetindex(A)[wis[3]...]
9.0
```
In this case you can see that `wis` is a 3-tuple-of-3-tuples. `A[wis[i]...]` can be used to compute the `i`th component of the gradient.

If you look carefully at each of the entries in `wis`, you'll see that
each "inner" 3-tuple copies two of the three elements in the `wis` we
obtained when we called `weightedindexes` with just `value_weights` above.
`wis[1]` replaces the first entry with
a weighted index having weights `(-1.0, 1.0)`, which corresponds to computing the *slope* along this dimension.
Likewise `wis[2]` and `wis[3]` replace the second and third value-index, respectively, with the same slope computation.

Hessian computation is quite similar, with the difference that one sometimes needs to replace two different indices or the same index with a set of weights corresponding to a second derivative.

Consequently derivatives along particular directions are computed simply by "weight replacement" along the corresponding dimensions.

The code to do this replacement is a bit complicated due to the need to support arbitrary dimensionality in a manner that allows Julia's type-inference to succeed.
It makes good use of *tuple* manipulations, sometimes called "lispy tuple programming."
You can search Julia's discourse forum for more tips about how to program this way.
It could alternatively be done using generated functions, but this would increase compile time considerably and can lead to world-age problems.

### GPU Support
At present, `Interpolations.jl` supports interpolant usage on GPU via broadcasting.

A basic work flow looks like:
```julia
julia> using Interpolations, Adapt, CUDA # Or any other GPU package

julia > itp = Interpolations.interpolate([1, 2, 3], (BSpline(Linear()))); # construct the interpolant object on CPU

julia> cuitp = adapt(CuArray{Float32}, itp); # adapt it to GPU memory

julia > cuitp.(1:0.5:2) # call interpolant object via broadcast

julia> gradient.(Ref(cuitp), 1:0.5:2)
```

To achieve this, an `ITP <: AbstractInterpolation` should define it's own `Adapt.adapt_structure(to, itp::ITP)`, which constructs a new `ITP` with the adapted
fields (`adapt(to, itp.fieldname)`) of `itp`. The field adaption could be skipped
if we know that it has been GPU-compatable, e.g. a `isbit` range.

!!! note
    Some adaptors may change the storage type. Please ensure that the adapted `itp`
    has the correct element type via the method `eltype`.

Also, all GPU-compatable `AbstractInterpolation`s should define their own `Interpolations.root_storage_type`. This function allows us to modify the broadcast mechanism by overloading the default `BroadcastStyle`. See [Customizing broadcasting](https://docs.julialang.org/en/v1/manual/interfaces/#man-interfaces-broadcasting) for more details.

# The math behind Interpolations.jl

Interpolations.jl uses [B-splines](http://en.wikipedia.org/wiki/B-spline#Definition), or *basis splines*, to interpolate a data set with a specified degree. In short, the idea is to use a set of basis functions with limited support, and in each interval between two data points, construct a linear combination of the basis functions which have support in that interval, each yielding a piece in a piecewise defined function with support across the entire data set. B-splines are defined to have the maximum degree of continuity, with minimal support. Specific details on the general mathematics of such interpolations can [this paper](http://dx.doi.org/10.1109/42.875199).

## The purpose of this document

There are a few core concepts one must understand in order to use `Interpolations.jl`:

1. Interpolation degree
2. Boundary conditions
3. Mid-point and on-grid interpolation
3. Extrapolation

Defining these three concepts, and how `Interpolations.jl` reasons about them, is the main focus of this document.

## 1. Interpolation degree

The interpolation degree decides what continuity properties the interpolant (i.e. the object which represents the interpolated data set) has; for example, a linear interpolation is a piecewise linear function, which is continuous but has discontinuous derivatives (or gradients, in higher dimensions).

Because of how B-splines are defined, the interpolation degree also decides the *support* of the *spline functions*. For a linear interpolation, the function value is decided by the value at *two* data points, so its support is two<sup>1.</sup>.

## 2. Boundary conditions

For higher interpolation degrees (specifically, from quadratic interpolation and up), the support of the B-splines is too large for the interpolating scheme to be able to figure out the values near the edges of the data sets. In order to close the equation systems at the edges, boundary conditions are used.

For quadratic interpolation, for example, a common boundary condition is to assume that the function is flat at the edges (i.e. the derivative there is 0). This lets us introduce an extra equation at each edge, through a finite approximation of the derivative, which closes the system. Another common way of terminating the interpolation is to extend the second-to-outermost all the way to the edge of the data set.

One subtlety concerns the location at which the boundary conditions are applied: at the edge grid point (`OnGrid()`) or at the halfway mark to the first beyond-the-edge index (`OnCell()`). `Interpolations.jl` supports both of these for interpolation schemes affected by boundary conditions (quadratic and cubic).

## Interlude: the `Interpolation` type hierarchy

All the above concepts fundamentally affect the behavior of an interpolating function, and in `Interpolations.jl` they therefore each have a representation in the type hierarchy.

Different types of interpolations are separated by *type parameters*, and each type of interpolation is a concrete type descending from
```julia
abstract InterpolationType{D<:Degree,BC<:BoundaryCondition,G<:GridRepresentation}
```
For example, a quadratic on-grid implementation with flat boundary conditions, is represented by an `Interpolation{Quadratic,Flat,OnGrid}`, where `Quadratic`, `Flat` and `OnGrid` are in turn concrete types implementing the abstract types indicated above.

## 4. Extrapolation behavior

Somewhat orthogonal<sup>2</sup> to the concepts outlined above, is the concept of *extrapolation*, i.e. evaluation of the interpolant outside the domain defined by the data set. For some types of extrapolation, this behavior is defined by a translation of the interpolation coordinate to somewhere inside the domain (e.g. periodic or reflecting boundaries), while for other types it entails a separate calculation entirely (e.g. linear extrapolation).

[Read more](/doc/Extrapolation.md)

## Supporting an `Interpolation` type in `Interpolations.jl`

Not all combinations of the above four concepts are supported in the library; for example, neither constant nor linear on-grid interpolations need andy boundary conditions, and therefore they don't support any.

An interpolation is represented by an object of a concrete type descending from
```julia
abstract Interpolation{IT<:InterpolationType,EB<:ExtrapolationBehavior}
```
----

<sup>

1. For this reason, linear B-splines are often referred to as *2nd order*, which may be a source of confusion since the interpolating function itself is linear, i.e. of first order. In `Interpolations.jl`, we will try to avoid this confusion by referring to interpolation degree by "linear", "quadratic" etc.

2. Although the separation of concepts 1-3 from extrapolation behavior is computationally sound, it does allow for some interesting, yet probably nonsensical, combinations of interpolation degrees, boundary conditions and extrapolation behavior. One could imagine for example a constant interpolation (which needs no boundary condition) with linear extrapolation, in which case the interpolating function is a sequence of "steps" with 0-derivative inside the domain, while suddenly having a nonzero derivative outside. Similarly, in most cases where the extrapolation behavior is defined as constant or reflecting, it will make sense to specify matching boundary conditions, but other combinations are entirely supported by `Interpolations.jl`; your mileage may vary, very much...

</sup>

## ChainRulesCore Integration

The `WeightedIndex` infrastructure has issues working with autodiff libraries. Autodiff is facilitate by integration with ChainRulesCore. A custom [rrule](https://juliadiff.org/ChainRulesCore.jl/dev/index.html) is defined such that

```julia
y, itp_pullback = rrule(itp, 1)
```
`itp_pullback` takes a perturbation on `y` and returns how it effects each `x` dimension. Since `Interpolations` already has a `gradient` function, `pullback` reuses it by scaling it by `Δy`.

This enables integration with autodiff libraries like Zygote, enabling

```julia
x = 1:10
y = sin.(x)
itp = interpolate(y,BSpline(Linear()))
Zygote.gradient(itp, 2)
#([-0.7681774187658145],)
```

# Knot Iteration

Given an `AbstractInterpolation` `itp` get an iterator over its knots using
`knots(itp)`

```julia
using Interpolations
itp = interpolate(rand(4), options...)
kiter = knots(itp) # Iterator over knots
collect(kiter) # Array of knots [1, 2, 3, 4]

```

For multiple dimensions, the iterator will return tuples of positions
(ie. `(x, y, ...)`),  with the first coordinate changing the fastest.

```jldoctest iterate-interpolate; setup = :(using Interpolations)
julia> itp = interpolate(ones(3,3), BSpline(Linear()));

julia> kiter = knots(itp);

julia> collect(kiter)
3×3 Matrix{Tuple{Int64, Int64}}:
 (1, 1)  (1, 2)  (1, 3)
 (2, 1)  (2, 2)  (2, 3)
 (3, 1)  (3, 2)  (3, 3)
```

The number of elements and size of the iterator can be found as shown:

```jldoctest iterate-interpolate; setup = :(using Interpolations)
julia> length(kiter)
9

julia> size(kiter)
(3, 3)

```


## Extrapolated Knots

Given an `AbstractExtrapolation` `etp`, `knots(etp)` will also iterate over the knots with the following behavior.

- For `Throw`, `Flat`, `Line` iterate the knots once
- For `Periodic` and `Reflect` generate an infinite sequence of knots starting
  at the first knot.

As `Periodic` and `Reflect` generate infinite sequences of knots, `length` and
`size` are undefined. For `Throw`, `Flat`, `Line`, `length` and `size` behave as
expected.

### Periodic

With Periodic boundary condition, knots repeat indefinitely with the first and
last knot being co-located. (ie. in the example below `etp(2.0) = 1.0` not
`4.0`).

```jldoctest periodic-demo; setup = :(using Interpolations)
julia> x = [1.0, 1.5, 1.75, 2.0];

julia> etp = linear_interpolation(x, x.^2, extrapolation_bc=Periodic());

julia> kiter = knots(etp);

julia> k = Iterators.take(kiter, 6) |> collect
6-element Vector{Float64}:
 1.0
 1.5
 1.75
 2.0
 2.5
 2.75

```

Extrapolating to the generated knots `etp.(k)`, confirms that the extrapolated
knots do map back to the correct inbound knots (ie. `etp(k[1]) == etp(k[4])`).

```jldoctest periodic-demo
julia> etp.(k)
6-element Vector{Float64}:
 1.0
 2.25
 3.0625
 1.0
 2.25
 3.0625

```

### Reflect

With the `Reflect` boundary condition knots repeat indefinitely, following the
pattern shown below (Offset terms are not shown for brevity).

```
k[1], k[2], ..., k[end-1], k[end], k[end+1], ... k[2], k[1], k[2], ...
```

```jldoctest reflect-demo; setup = :(using Interpolations)
julia> x = [1.0, 1.5, 1.75, 2.0];

julia> etp = linear_interpolation(x, x.^2, extrapolation_bc=Reflect());

julia> kiter = knots(etp);

julia> k = Iterators.take(kiter, 6) |> collect
6-element Vector{Float64}:
 1.0
 1.5
 1.75
 2.0
 2.25
 2.5

```

Evaluating the extrapolation at `etp.(k)` confirms that the extrapolated knots
correspond to the correct inbound knots.

```jldoctest reflect-demo
julia> etp.(k)
6-element Vector{Float64}:
 1.0
 2.25
 3.0625
 4.0
 3.0625
 2.25

```

### Multiple Dimensions

As with an `AbstractInterpolation`, iterating over knots for a
multi-dimensional extrapolation also supported.

```jldoctest; setup = :(using Interpolations)
julia> x = [1.0, 1.5, 1.75, 2.0];

julia> etp = linear_interpolation((x, x), x.*x');

julia> knots(etp) |> collect
4×4 Matrix{Tuple{Float64, Float64}}:
 (1.0, 1.0)   (1.0, 1.5)   (1.0, 1.75)   (1.0, 2.0)
 (1.5, 1.0)   (1.5, 1.5)   (1.5, 1.75)   (1.5, 2.0)
 (1.75, 1.0)  (1.75, 1.5)  (1.75, 1.75)  (1.75, 2.0)
 (2.0, 1.0)   (2.0, 1.5)   (2.0, 1.75)   (2.0, 2.0)

```

Because some boundary conditions generate an infinite sequence of knots,
iteration over knots can end up "stuck" iterating along a single axis:

```jldoctest; setup = :(using Interpolations)
julia> x = [1.0, 1.5, 1.75, 2.0];

julia> etp = linear_interpolation((x, x), x.*x', extrapolation_bc=(Periodic(), Throw()));

julia> knots(etp) |> k -> Iterators.take(k, 6) |> collect
6-element Vector{Tuple{Float64, Float64}}:
 (1.0, 1.0)
 (1.5, 1.0)
 (1.75, 1.0)
 (2.0, 1.0)
 (2.5, 1.0)
 (2.75, 1.0)

```

Rearranging the axes so non-repeating knots are first can address this issue:

```jldoctest; setup = :(using Interpolations)
julia> x = [1.0, 1.5, 1.75, 2.0];

julia> etp = linear_interpolation((x, x), x.*x', extrapolation_bc=(Throw(), Periodic()));

julia> knots(etp) |> k -> Iterators.take(k, 6) |> collect
6-element Vector{Tuple{Float64, Float64}}:
 (1.0, 1.0)
 (1.5, 1.0)
 (1.75, 1.0)
 (2.0, 1.0)
 (1.0, 1.5)
 (1.5, 1.5)

```

### Directional Boundary Conditions

If the boundary conditions are directional, the forward boundary condition is
used to determine if the iterator will generate an infinite sequence of knots.

For example the following extrapolation `etp`, will throw an error for values
less than `1.0`, but will use `Periodic` extrapolation for values above `2.0`. As a
result, the iterator will generate an infinite sequence of knots starting at `1.0`.

```jldoctest iterate-directional-unbounded; setup = :(using Interpolations)
julia> x = [1.0, 1.2, 1.3, 2.0];

julia> etp = linear_interpolation(x, x.^2, extrapolation_bc=((Throw(), Periodic()),));

julia> kiter = knots(etp);

julia> kiter |> k -> Iterators.take(k, 5) |> collect
5-element Vector{Float64}:
 1.0
 1.2
 1.3
 2.0
 2.2

```

We can also check if the iterator has a length using: `Base.IteratorSize`

```jldoctest iterate-directional-unbounded
julia> Base.IteratorSize(kiter)
Base.IsInfinite()

```

Swapping the boundary conditions, results in a finite sequence of knots from
`1.0` to `2.0`.

```jldoctest iterate-directional-bounded; setup = :(using Interpolations)
julia> x = [1.0, 1.2, 1.3, 2.0];

julia> etp = linear_interpolation(x, x.^2, extrapolation_bc=((Periodic(), Throw()),));

julia> kiter = knots(etp);

julia> collect(kiter)
4-element Vector{Float64}:
 1.0
 1.2
 1.3
 2.0

```

As expected the iterator now has a defined length:

```jldoctest iterate-directional-bounded; setup = :(using Interpolations)
julia> Base.IteratorSize(kiter)
Base.HasLength()

julia> length(kiter)
4

julia> size(kiter)
(4,)

```

## `knotsbetween`

Given an `AbstractInterpolation` `itp` or results of `knots(itp)` get an iterator
over knots between `start` and `stop`.

```julia
using Interpolations
itp = interpolate(rand(4), options...)
krange = knotsbetween(itp; start=1.2, stop=3.0)
collect(kiter) # Array of knots between 1.2 and 3.0

```

We can iterate over all knots greater than `start` by omitting `stop`

```jldoctest knotsbetween-usage; setup = :(using Interpolations)
julia> x = [1.0, 1.5, 1.75, 2.0];

julia> etp = linear_interpolation(x, x.^2, extrapolation_bc=Periodic());

julia> krange = knotsbetween(etp; start=4.0);

julia> Iterators.take(krange, 5) |> collect
5-element Vector{Float64}:
 4.5
 4.75
 5.0
 5.5
 5.75

```

If we omit `start`, iteration will range from the first knot to `stop`

```jldoctest knotsbetween-usage
julia> krange = knotsbetween(etp; stop=4.0);

julia> collect(krange)
9-element Vector{Float64}:
 1.0
 1.5
 1.75
 2.0
 2.5
 2.75
 3.0
 3.5
 3.75

```

It is an error to not provided `start` and `stop`

```jldoctest knotsbetween-usage
julia> knotsbetween(etp)
ERROR: ArgumentError: At least one of `start` or `stop` must be specified
[...]
```

### Multiple Dimensions

When used with a multi-dimensional interpolant, `knotsbetween` can be used to
iterate overall knots such that: `start[i] < k[i] stop[i]` where `i` indexes
dimensions.

```jldoctest; setup = :(using Interpolations)
julia> x = [1.0, 1.5, 1.75, 2.0];

julia> etp = linear_interpolation((x, x), x.*x');

julia> knotsbetween(etp; start=(1.2, 1.5), stop=(1.8, 3.0)) |> collect
2×2 Matrix{Tuple{Float64, Float64}}:
 (1.5, 1.75)   (1.5, 2.0)
 (1.75, 1.75)  (1.75, 2.0)

```

## General usage

Note: the current version of `Interpolations` supports interpolation evaluation using index calls `[]`, but this feature will be deprecated in future. We highly recommend function calls with `()` as follows.

Given an `AbstractArray` `A`, construct an "interpolation object" `itp` as
```julia
itp = interpolate(A, options...)
```
where `options...` (discussed below) controls the type of
interpolation you want to perform.  This syntax assumes that the
samples in `A` are equally-spaced.

To evaluate the interpolation at position `(x, y, ...)`, simply do
```julia
v = itp(x, y, ...)
```

Some interpolation objects support computation of the gradient, which
can be obtained as
```julia
g = Interpolations.gradient(itp, x, y, ...)
```
or as
```julia
Interpolations.gradient!(g, itp, x, y, ...)
```
where `g` is a pre-allocated vector.

Some interpolation objects support computation of the hessian, which
can be obtained as
```julia
h = Interpolations.hessian(itp, x, y, ...)
```
or
```julia
Interpolations.hessian!(h, itp, x, y, ...)
```
where `h` is a pre-allocated matrix.

`A` may have any element type that supports the operations of addition
and multiplication.  Examples include scalars like `Float64`, `Int`,
and `Rational`, but also multi-valued types like `RGB` color vectors.

Positions `(x, y, ...)` are n-tuples of numbers. Typically these will
be real-valued (not necessarily integer-valued), but can also be of types
such as [DualNumbers](https://github.com/JuliaDiff/DualNumbers.jl) if
you want to verify the computed value of gradients.
(Alternatively, verify gradients using [ForwardDiff](https://github.com/JuliaDiff/ForwardDiff.jl).)
You can also use
Julia's iterator objects, e.g.,

```julia
function ongrid!(dest, itp)
    for I in CartesianIndices(itp)
        dest[I] = itp(I)
    end
end
```
would store the on-grid value at each grid point of `itp` in the output `dest`.
Finally, courtesy of Julia's indexing rules, you can also use
```julia
fine = itp(range(1,stop=10,length=1001), range(1,stop=15,length=201))
```

There is also an abbreviated [Convenience notation](@ref).

# Other Interpolation Packages

Other interpolation packages for Julia include:

- [ApproXD.jl](https://github.com/floswald/ApproXD.jl) implements B-spline and linear interpolation in Julia.
- [BarycentricInterpolation.jl](https://github.com/dawbarton/BarycentricInterpolation.jl) implements the Barycentric formula for polynomial interpolation on equispaced points and Chebyshev points of the first and second kind.
- [BasicInterpolators.jl](https://github.com/markmbaum/BasicInterpolators.jl) provides a collection of common interpolation recipes for basic applications.
- [BSplineKit.jl](https://github.com/jipolanco/BSplineKit.jl) offers tools for B-spline based Galerkin and collocation methods, including for interpolation and approximation.
- [Curves.jl](https://github.com/lungben/Curves.jl) supports log-interpolation via immutable `Curve` objects.
- [DataInterpolations.jl](https://github.com/PumasAI/DataInterpolations.jl) is a library for performing interpolations of one-dimensional data.
- [Dierckx.jl](https://github.com/kbarbary/Dierckx.jl) is a wrapper for the dierckx Fortran library, which also underlies `scipy.interpolate`.
- [DIVAnd.jl](https://github.com/gher-ulg/DIVAnd.jl) for N-dimensional smoothing interpolation. 
- [FastChebInterp.jl](https://github.com/stevengj/FastChebInterp.jl) does fast multidimensional Chebyshev interpolation on a hypercube using separable grid of interpolation points.
- [FEMBasis.jl](https://github.com/JuliaFEM/FEMBasis.jl) contains interpolation routines for standard finite element function spaces.
- [FineShift.jl](https://github.com/emmt/FineShift.jl) does fast sub-sample shifting of multidimensional arrays.
- [FourierTools.jl](https://github.com/bionanoimaging/FourierTools.jl) includes sinc interpolation for up and down sampling.
- [GeoStats.jl](https://github.com/JuliaEarth/GeoStats.jl) provides interpolation and simulation methods over complex 2D and 3D meshes.
- [GridInterpolations.jl](https://github.com/sisl/GridInterpolations.jl) performs multivariate interpolation on a rectilinear grid.
- [InterpolationKernels.jl](https://github.com/emmt/InterpolationKernels.jl) provides a library of interpolation kernels.
- [KissSmoothing.jl](https://github.com/francescoalemanno/KissSmoothing.jl) implements denoising and a Radial Basis Function estimation procedure.
- [LinearInterpolations.jl](https://github.com/jw3126/LinearInterpolations.jl) allows for interpolation using weighted averages allowing probability distributions, rotations, and other Lie groups to be interpolated.
- [LinearInterpolators.jl](https://github.com/emmt/LinearInterpolators.jl) provides linear interpolation methods for Julia based on InterpolationKernels.jl, above.
- [LocalFunctionApproximation.jl](https://github.com/sisl/LocalFunctionApproximation.jl) provides local function approximators that interpolates a scalar-valued function across a vector space.
- [NaturalNeighbours.jl](https://github.com/DanielVandH/NaturalNeighbours.jl) provides natural neighbour interpolation methods for scattered two-dimensional point sets, with support for derivative generation.
- [PCHIPInterpolation.jl](https://github.com/gerlero/PCHIPInterpolation.jl) for monotonic interpolation.
- [PiecewiseLinearApprox.jl](https://github.com/RJDennis/PiecewiseLinearApprox.jl) performs piecewise linear interpolation over an arbitrary number of dimensions.
- [ScatteredInterpolation.jl](https://github.com/eljungsk/ScatteredInterpolation.jl) interpolates scattered data in arbitrary dimensions.

Some of these packages support methods that `Interpolations` does not,
so if you can't find what you need here, check one of them or submit a
pull request here.

If you would like to list a registered package that is related to interpolation, please create a Github issue.

## Extrapolation

The call to `extrapolate` defines what happens if you try to index into the interpolation object with coordinates outside of its
bounds in any dimension. The implemented boundary conditions are `Throw`, `Flat`, `Line`, `Periodic` and `Reflect`,
or you can pass a constant to be used as a "fill" value returned for any out-of-bounds evaluation.
`Periodic` and `Reflect` require that there is a method of `Base.mod` that can handle the indices used.

Examples:

```julia
itp = interpolate(1:7, BSpline(Linear()))
etpf = extrapolate(itp, Flat())   # gives 1 on the left edge and 7 on the right edge
etp0 = extrapolate(itp, 0)        # gives 0 everywhere outside [1,7]
```

### Periodic extrapolation

For uniformly sampled periodic data, one can perform periodic extrapolation for all types of
B-Spline interpolations. By using the `Periodic(OnCell())` boundary condition in `interpolate`,
one does not need to include the periodic image of the starting sample point.

Examples:

```julia
f(x) = sin((x-3)*2pi/7 - 1)
A = Float64[f(x) for x in 1:7] # Does not include the periodic image

# Constant(Periodic())) is an alias for Constant{Nearest}(Periodic(OnCell()))
itp0 = interpolate(A, BSpline(Constant(Periodic())))
# Linear(Periodic())) is an alias for Linear(Periodic(OnCell()))
itp1 = interpolate(A, BSpline(Linear(Periodic())))
itp2 = interpolate(A, BSpline(Quadratic(Periodic(OnCell()))))
itp3 = interpolate(A, BSpline(Cubic(Periodic(OnCell()))))

etp0 = extrapolate(itp0, Periodic())
etp1 = extrapolate(itp1, Periodic())
etp2 = extrapolate(itp2, Periodic())
etp3 = extrapolate(itp3, Periodic())
```

# Interpolations

[![version](https://juliahub.com/docs/Interpolations/version.svg)](https://juliahub.com/ui/Packages/Interpolations/VpKVx)
[![pkgeval](https://juliahub.com/docs/Interpolations/pkgeval.svg)](https://juliahub.com/ui/Packages/Interpolations/VpKVx)
[![Build Status](https://github.com/JuliaMath/Interpolations.jl/actions/workflows/CI.yml/badge.svg?branch=master)](https://github.com/JuliaMath/Interpolations.jl/actions/workflows/CI.yml?query=branch%3Amaster)
[![deps](https://juliahub.com/docs/Interpolations/deps.svg)](https://juliahub.com/ui/Packages/Interpolations/VpKVx?t=2)
[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](http://juliamath.github.io/Interpolations.jl/stable)
[![Latest](https://img.shields.io/badge/docs-latest-blue.svg)](http://juliamath.github.io/Interpolations.jl/latest)

The package [Interpolations.jl](https://github.com/JuliaMath/Interpolations.jl/)
implements a variety of interpolation schemes for the
Julia language.  It has the goals of ease-of-use, broad algorithmic
support, and exceptional performance.

Currently this package supports
[B-splines](https://en.wikipedia.org/wiki/B-spline) and
irregular grids.  The API has been designed with
intent to support more options. Pull-requests are more than welcome!
It should be noted that the API may continue to evolve over time.

There are many other interpolation packages implemented in Julia.
For a listing, see [Other Interpolation Packages](@ref).

Some of these packages support methods that `Interpolations` does not,
so if you can't find what you need here, check one of them or submit a
pull request here.

## Installation

Interpolations.jl can be installed via the following invocation
since it is a registered Julia package.

```julia
using Pkg
Pkg.add("Interpolations")
```

## Example Usage
Create a grid `xs` and an array `A` of values to be interpolated
```julia
xs = 1:0.2:5
A = log.(xs)
```
Create linear interpolation object without extrapolation
```julia
interp_linear = linear_interpolation(xs, A)
interp_linear(3) # exactly log(3)
interp_linear(3.1) # approximately log(3.1)
interp_linear(0.9) # outside grid: error
```
Create linear interpolation object with extrapolation
```julia
interp_linear_extrap = linear_interpolation(xs, A,extrapolation_bc=Line()) 
interp_linear_extrap(0.9) # outside grid: linear extrapolation
```


## Performant Example Usage

The above use of `LinearInterpolation` is actually a short hand for a
composition of `interpolate`, `scale`, and `extrapolate`. You may not need all
of the the scaling and extrapolation features.

```julia
interp_linear = extrapolate(scale(interpolate(A, BSpline(Linear())), xs))
```

If we know we do not need the extrapolation portion, we can use the following.

```julia
scaled_itp = scale(interpolate(A, BSpline(Linear())), xs)
```

We can also remove the scaling for further performance if integer valued knots
and regular grids are sufficient.

```julia
itp = interpolate(A, BSpline(Linear()))
```

Removing the scaling or extrapolation will help accelerate interpolation by
removing unneeded operations and branches. This can permit the use of advanced
processor Single Instruction/Multiple Data (SIMD) capabilities.

## Regular Grids

Interpolations.jl is optimized for use with regular grids with uniform spacing.
The highest performance is achieved when the knots are an `AbstractUnitRange`
such as `2:5` or `Base.OneTo(9)`. The default case if no knots are specified is to
assign the knots as a `UnitRange` starting at `1`.

## Scaling

If the knots are not unit spaced or start at a distinct value other than `1`,
then the `scale` function can be used. While this increases the flexibility of
the interpolation, some performance penalty is acquired.
See [Scaled BSplines](@ref) for further information.

## Irregular Grids

If the knots are irregularly spaced, then the ranges between knots will have to
be scaled as in the `Gridded` interpolation type. See [Gridded interpolation](@ref)
for additional details.

## Points outside the knots

For points not between knots, extrapolation can be used. This introduces a
branch into the code that checks whether the point to be queried is inside or
outside of the knots. This branch can inhibit the use of vectorized SIMD
computation, resulting in a reduction of performance. See [Extrapolation](@ref).
